function GetQueryVariable(variable) {
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i = 0, len = vars.length; i < len; i++) {
        var pair = vars[i].split("=");
        if (pair[0] === variable) {
            return pair[1];
        }
    }
    return false;
}

function GetCookie(name) {
    var value = "; " + document.cookie;
    var parts = value.split("; " + name + "=");
    if (parts.length === 2) return parts.pop().split(";").shift();
}

function AddEventListenerByClass(className, event, fn) {
    var list = document.getElementsByClassName(className);
    for (var i = 0, len = list.length; i < len; i++) {
        list[i].addEventListener(event, fn, false);
    }
}

var host = new URL(chrome.runtime.getManifest().homepage_url).hostname;

if (window.location.host === host || window.location.host.indexOf("localhost:") === 0 || window.location.host === "feedwalker.com") {
    // remove userId and token when remove account from newstab
    var token = GetCookie("TokenKey");
    if (token === undefined) {
        chrome.runtime.sendMessage({ dataType: "RemoveFromStorage", value: "TokenKey" });
    }

    var isInstalledNode = document.createElement("div");
    isInstalledNode.id = "extension-is-installed";
    isInstalledNode.setAttribute("data-extension-id", chrome.runtime.id);
    document.body.appendChild(isInstalledNode);

    window.chrome.storage.sync.get("NId", function (nid) {
        if (nid["NId"] !== undefined) {
            isInstalledNode.setAttribute("data-extension-nid", nid);
        }
    });

    document.addEventListener("extensionIdChanged", function () {
        chrome.runtime.sendMessage({ dataType: "ExchangeExtension", value: window.location });
    }, false);

    AddEventListenerByClass("open-new-tab", "click", function () {
        chrome.runtime.sendMessage({ dataType: "OpenNewTab" });
    });

    var ru = GetQueryVariable("RedirectUrl");
    if (ru === "newtab") {
        chrome.runtime.sendMessage({ dataType: "OpenNewTab", value: GetQueryVariable("TokenKey") });
    } else {
        var sharedArticlePreview = localStorage.getItem("ArticlePreview");
        if (sharedArticlePreview !== null) {
            localStorage.removeItem("ArticlePreview");
            var article = JSON.parse(sharedArticlePreview);
            chrome.runtime.sendMessage({ dataType: "OpenSharedArticleInstall", value: article });
        }
    }
}