var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.SearchWidget = {
    SearchProvider: "newstab",

    // Bing Search Data
    BingSearchApiID: "SY1000860",
    BingCustomNewTabSearchUrl: null,
    BingSuggestionsUrl: "https://api.bing.com/osjson.aspx?query=SEARCH_TERM&market=en_us",
    BingNId: "000001",

    Init: function () {
        var self = this;

        self.SearchProvider = NewsTab.Helpers.GetLocalStorageItem("Search_Provider");

        if (self.SearchProvider === null) {
            self.SearchProvider = "newstab";
            NewsTab.Helpers.SetLocalStorageItem("Search_Provider", self.SearchProvider);
        }

        self.SetUp_SearchProviderWidget();

        self.SetUp_Search(".newsTabProvider", $('#newstab_submit_input'), $('#newstab_search_icon'));
        self.SetUp_Search(".bingProvider", $('#bing_submit_input'), $('#bing_search_icon'));
        self.SetUp_Search(".googleProvider", $('#google_submit_input'), $('#google_search_icon'));
    },

    SetUp_SearchProviderWidget: function () {
        var self = this;
        if (self.SearchProvider === "google") {
            $(".bingProvider").hide();
            $(".newsTabProvider").hide();
            $(".googleProvider").show();
        } else if (self.SearchProvider === "bing") {
            $(".bingProvider").show();
            $(".newsTabProvider").hide();
            $(".googleProvider").hide();
        } else {
            $(".bingProvider").hide();
            $(".newsTabProvider").show();
            $(".googleProvider").hide();
        }
    },

    SetUp_Search: function (parentClass, $searchInputSelector, $searchIconSelecor) {
        var self = this;

        //if (parentClass !== ".googleProvider") {
        //    window.chrome.storage.sync.get(["NId", "BingSearchConfig"], function (data) {
        //        if (chrome.runtime.getManifest().homepage_url.indexOf("staging.") > 0) {
        //            self.BingNId = "999999";
        //        } else if (data["NId"] !== null && data["NId"] !== undefined && data["NId"] > 0) {
        //            self.BingNId = NewsTab.Extension.NId;
        //        }

        //        if (data["BingSearchConfig"] !== undefined) {
        //            self.BingCustomNewTabSearchUrl = data["BingSearchConfig"].customNewTabURL.replace("?q=", "");

        //            if (parentClass === ".bingProvider") {
        //                self.SetUp_BingSearchData(false);
        //            } else {
        //                self.SetUp_BingSearchData(true);
        //            }
        //        } else {
        //            $.ajax({
        //                dataType: "json",
        //                url: "https://feedapi.psccint.com/" + self.BingSearchApiID + "?N=" + self.BingNId,
        //                success: function (data) {
        //                    self.BingCustomNewTabSearchUrl = data.customNewTabURL.replace("?q=", "");
        //                    NewsTab.Helpers.SetSyncStorage("BingSearchConfig", data, function () { });

        //                    if (parentClass === ".bingProvider") {
        //                        self.SetUp_BingSearchData(false);
        //                    } else {
        //                        self.SetUp_BingSearchData(true);
        //                    }
        //                }
        //            });
        //        }
        //    });
        //}

        $searchIconSelecor.off("click").on("click", function () {
            NewsTab.TrackAnalyticsEvent("Search", self.SearchProvider, NewsTab.Extension.NameId);
            $(parentClass + " .search").submit();
        });

        $searchInputSelector.autocomplete({
            source: function (request, response) {
                if ($searchInputSelector[0].id === "newstab_submit_input") {
                    $.getJSON(self.BingSuggestionsUrl.replace("SEARCH_TERM", request.term),
                        function (data) {
                            var suggestions = [];
                            $.each(data[1], function (key, val) {
                                suggestions.push({ "value": val });
                            });
                            suggestions.length = 10; // prune suggestions list to only 5 items
                            response(suggestions);
                        }
                    );
                }
                else {
                    $.getJSON("https://suggestqueries.google.com/complete/search?callback=?",
                        {
                            "hl": "en", // Language                  
                            "jsonp": "suggestCallBack", // jsonp callback function name0
                            "q": request.term, // query term
                            "client": "youtube" // force youtube style response, i.e. jsonp
                        }
                    );
                }
                suggestCallBack = function (data) {
                    var suggestions = [];
                    $.each(data[1], function (key, val) {
                        suggestions.push({ "value": val[0] });
                    });
                    suggestions.length = 10; // prune suggestions list to only 5 items
                    response(suggestions);
                };
            },
            select: function (e, ui) {
                $searchInputSelector.val(ui.item.value);
                NewsTab.TrackAnalyticsEvent("Search", self.SearchProvider, NewsTab.Extension.NameId);
                $(parentClass + " .search").submit();
            }
        });

        $searchInputSelector.on("keyup", function (e) {
            if (e.keyCode === 13) {
                NewsTab.TrackAnalyticsEvent("Search", self.SearchProvider, NewsTab.Extension.NameId);
            } else {
                if ($searchInputSelector.val().length > 0) {
                    $searchInputSelector.addClass("focus");
                } else {
                    $searchInputSelector.removeClass("focus");
                }
            }
        });
    },

    SetUp_BingSearchData: function (isNewsTab) {
        var self = this;

        self.BingCustomNewTabSearchUrl = self.BingCustomNewTabSearchUrl.replace("&n=", "&n=" + self.BingNId);
        self.BingCustomNewTabSearchUrl = self.BingCustomNewTabSearchUrl.replace("?n=", "?n=" + self.BingNId);

        //var searchUtilInstalDate = localStorage.getItem("searchUtil.installDate");
        //var searchUtilConfig = localStorage.getItem("searchUtil.config");

        //if (searchUtilInstalDate && searchUtilConfig) {
        //    searchUtilConfig = JSON.parse(searchUtilConfig);

        //    console.log(self.BingCustomNewTabSearchUrl);
        //    var isid_s = self.BingCustomNewTabSearchUr.indexOf("ISID=") + 5;
        //    var isid_e = self.BingCustomNewTabSearchUr.indexOf("&", isid_s);

        //    self.BingCustomNewTabSearchUrl = self.BingCustomNewTabSearchUrl.substring(0, isid_s) + searchUtilConfig.ISID + self.BingCustomNewTabSearchUrl.substring(isid_e, self.BingCustomNewTabSearchUrl.length - 1);//"&SearchSource=69&D=" + searchUtilInstalDate;
        //}

        var form = isNewsTab === true ? $(".newsTabProvider form.search") : $(".bingProvider form.search");
        $(".hidden", form).remove();
        var params = NewsTab.Helpers.GetAllUrlParameters(self.BingCustomNewTabSearchUrl);

        for (var prop in params) {
            if (prop !== "q") {
                form.append("<input type=\"hidden\" name=\"" + prop + "\" value=\"" + params[prop] + "\" />");
            }
        }
        form.attr("action", self.BingCustomNewTabSearchUrl.substring(0, self.BingCustomNewTabSearchUrl.indexOf('?')));
    }
};