var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.SideMenu = {
    AboutMenu: [
        {
            Title: "Website",
            Url: NewsTab.EnviromentUrl,
            Show: true,
            Order: 0
        },
        {
            Title: "Privacy Policy",
            Url: NewsTab.EnviromentUrl + "/home/privacy",
            Show: true,
            Order: 1
        },
        {
            Title: "Terms of Use",
            Url: NewsTab.EnviromentUrl + "/home/terms",
            Show: true,
            Order: 2
        },
        {
            Title: "Uninstall",
            Url: null,
            Show: true,
            Order: 3
        },
        {
            Title: "FAQ",
            Url: NewsTab.EnviromentUrl + "/home/faq",
            Show: true,
            Order: 4
        },
        {
            Title: "Send Feedback",
            Url: null,
            Show: true,
            Order: 5
        },
        {
            Title: "Contact Us",
            Url: "info@newstab.com",
            Show: true,
            Order: 6
        }
    ],

    Init: function () {
        var self = this;
        if ($("#settingsButton").length === 0) {
            var $button = $("<button/>", {
                "id": "settingsButton",
                "class": "iconButton icon-menu settings_icon",
                "aria-hidden": "true"
            });

            $(document.body).append($button);

            $button.on("click", function (e) {
                e.stopPropagation();
                self.ToggleSideMenu();
            });
        }
    },

    ToggleSideMenu: function () {
        var self = this;

        $(".extension-link-popup").remove();

        if (!$(document.body).hasClass("show_menu")) {
            self.SetupSideMenu();
            $(document.body).addClass("show_menu");
            NewsTab.TrackAnalyticsEvent("Settings", "Extension", NewsTab.Extension.NameId);
        } else {
            $(document.body).removeClass("show_menu");
        }
    },


    _$sideMenu_AddNewContent: function (config) {
        if (NewsTab.Extension.Config.DisableAddNewContentFlow !== true) {
            var $addNewContent = $("<div/>", { "id": "addContentButton" });
            var html = [];
            html.push('+ Add news feed<div class="subAddMenu">');
            html.push('<button class="addContentItem" data-tab-select="#tabFeeds" data-tab-param="tabPublishers">News Source</button>');
            html.push('<button class="addContentItem" data-tab-select="#tabFeeds" data-tab-param="tabTopics">News Topic</button>');
            html.push('</div>');
            $addNewContent.html(html.join(""));

            return $addNewContent;
        }
        return null;
    },

    _$sideMenu_Header: function (config) {
        if (NewsTab.Extension.Config.HideSideMenuHeader !== true) {
            var $header = $("<div/>", { "class": "mianMenuPanel" });

            var html = [];
            html.push('<div class="availibleOn\">');

            html.push('<div class="penguin-circle"><img src="/Media/ExtensionImages/penguin-settings.png" /><span><span>Powered by</span><br>NewsTab Reader</span></div>');

            html.push('<div class="apps">');

            html.push('<a class="getApp clickable" href="#" data-url="https://play.google.com/store/apps/details?id=com.newstab" data-url-target="_blank">');
            html.push('<i class="icon icon-google-play" data-tooltip="tooltip" data-placement="bottom" title="Get&nbsp;the&nbsp;app"></i>');
            html.push('</a>');

            html.push('<a class="getApp clickable" href="#" data-url="https://itunes.apple.com/us/app/newstab/id1200774745" data-url-target="_blank">');
            html.push('<i class="icon icon-apple2" data-tooltip="tooltip" data-placement="bottom" title="Get&nbsp;the&nbsp;app"></i>');
            html.push('</a>');

            html.push('<a class="getApp clickable" href="#" data-url="https://chrome.google.com/webstore/detail/hilmacpagemdnkdfdkdfcgphlpceelge" data-url-target="_blank">');
            html.push('<i class="icon icon-google-chrome" data-tooltip="tooltip" data-placement="bottom" title="Get&nbsp;the&nbsp;app&nbsp;"></i>');
            html.push('</a>');

            html.push('<a class="getApp clickable" href="#" data-url="' + NewsTab.EnviromentUrl + '"  data-url-target="_blank">');
            html.push('<i class="icon icon-world" data-tooltip="tooltip" data-placement="bottom" title="Get&nbsp;the&nbsp;app&nbsp;"></i>');
            html.push('</a>');

            html.push('</div>');
            html.push('</div>');

            html.push('<div class="accountDetails">');

            if (NewsTab.Token === null) {
                html.push('<a class="signInModal" href="#">Sign in</a>');
            }
            else {
                html.push('<a class="signInUser" href="#">' + NewsTab.User.FullName + ' <span class="icon icon-angle-down"></span></a>');
                html.push('<div class="signInUserDetails"><a class="accountSettings clickable" href="#" data-url="' + NewsTab.EnviromentUrl + '/dashboard?action=accountsettings">Account Settings</a>');
                html.push('<a class="signOut" href="#">Sign out</a></div>');
            }

            html.push('</div>');

            $header.html(html.join(""));

            $(".signInModal", $header).on("click", function (e) {
                e.preventDefault();
                NewsTab.Modules.AccountManager.OpenSignInModal();
            });

            $(".signInUser", $header).on("click", function () {
                $(".signInUserDetails", $header).toggleClass("show");
            });

            $(".signOut", $header).on("click", function () {
                NewsTab.Extension.SignOut();
            });

            return $header;
        }
        return null;
    },

    _$sideMenu_AboutHelp: function (config) {
        var self = this;

        var $about = $("<div/>", { "id": "sideMenuAbout" });
        var html = [];

        html.push('<div class="settingsItem aboutLink">');
        html.push('<div class="settingsItemTitle">About & Help</div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');

        html.push('<div class="settingsItemDetails aboutDetails">');


        var menuItems = [];
        var tempMenuItems = [];

        if (NewsTab.Extension.Config.AboutMenu && NewsTab.Extension.Config.AboutMenu.length > 0) {
            tempMenuItems = tempMenuItems.concat(NewsTab.Extension.Config.AboutMenu);
            for (var i = 0, il = self.AboutMenu.length; i < il; i++) {
                var shared = false;
                for (var j = 0, jl = tempMenuItems.length; j < jl; j++)
                    if (tempMenuItems[j].Title == self.AboutMenu[i].Title) {
                        shared = true;

                        var updatedMenuItem = $.extend({}, self.AboutMenu[i], tempMenuItems[j]);
                        menuItems.push(updatedMenuItem);

                        tempMenuItems.splice(j, 1);
                        break;
                    }
                if (!shared) {
                    menuItems.push(self.AboutMenu[i]);
                }
            }

            for (var i = 0, l = tempMenuItems.length; i < l; i++) {
                menuItems.push(tempMenuItems[i]);
            }
        } else {
            menuItems = self.AboutMenu;
        }


        menuItems = menuItems.sort(function (a, b) { return (a.Order > b.Order) ? 1 : ((b.Order > a.Order) ? -1 : 0); });

        menuItems.forEach(function (menuItem) {
            if (menuItem.Show) {
                switch (menuItem.Title) {
                    case "Uninstall":
                        html.push('<div class="settingsDetailsItem uninstall-instructions">');
                        html.push('<span>');
                        html.push('<span class="uninstallSelf">Uninstall</span>');
                        html.push('</span>');
                        html.push('</div>');
                        break;
                    case "Send Feedback":
                        html.push('<div class="settingsDetailsItem">');
                        html.push('<div class="settingsDetailsItemHeader menuItemTitle">');
                        html.push('<span class="sendFeedback">Send Feedback</span>');
                        html.push('</div>');
                        html.push('</div>');
                        break;
                    case "Contact Us":
                        html.push('<div class="settingsDetailsItem">');
                        html.push('<div class="settingsDetailsItemHeader menuItemTitle">');
                        html.push('<span>Contact Us</span>');
                        html.push('<i class="icon-angle-right"></i>');
                        html.push('</div>');
                        html.push('<div class="aboutDetails-1">');
                        html.push('<span>Email us directly:</span>');
                        html.push('<span>');
                        html.push('<span class="clickable" data-url="mailto:' + menuItem.Url + '" style="margin-left: 5px; color: #00B8F5 !important;">' + menuItem.Url + '</span>');
                        html.push('</span>');
                        html.push('</div>');
                        html.push('</div>');
                        break;
                    default:
                        html.push('<div class="settingsDetailsItem">');
                        html.push('<span>');
                        html.push('<span class="clickable" data-url="' + menuItem.Url + '">' + menuItem.Title + '</span>');
                        html.push('</span>');
                        html.push('</div>');
                }
            }
        });

        html.push('</div>');

        $about.html(html.join(""))

        $(".uninstallSelf", $about).on("click", function () {
            NewsTab.Modules.Uninstall.OpenModal();
        });

        $(".sendFeedback", $about).on("click", function () {
            NewsTab.Modules.Feedback.OpenModal();
        });

        return $about;
    },

    _$sideMenu_Settings: function () {
        var $settings = $("<div/>", { "id": "sideMenuSettings" });
        var html = [];

        html.push('<div class="settingsItem settingsLink">');
        html.push('<div class="settingsItemTitle">Settings</div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');

        html.push('<div class="settingsItemDetails settingsDetails">');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Tab Focus</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails setSearchFocusDetails">');
        html.push('<div class="setSearchFocusItem" value="yes"><span>Search Bar</span></div>');
        html.push('<div class="setSearchFocusItem" value="no"><span>Omnibar</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Search Provider</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails searchProviderDetails">');
        html.push('<div class="searchProviderItem" value="bing"><span>Bing</span></div>');
        html.push('<div class="searchProviderItem" value="google"><span>Google</span></div>');
        html.push('<div class="searchProviderItem" value="newstab"><span>NewsTab</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Background Update</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails updateDetails">');
        html.push('<div class="updateItem" value="update-4"><span>Every 4h</span></div>');
        html.push('<div class="updateItem" value="update-8"><span>Every 8h</span></div>');
        html.push('<div class="updateItem" value="update-12"><span>Every 12h</span></div>');
        html.push('<div class="updateItem" value="update-24"><span>Every 24h</span></div>');
        html.push('<div class="updateItem" value="update-disabled"><span>Disabled</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Simplified Article</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails simplifiedArticleDetails">');
        html.push('<div class="simplifiedArticleItem" value="on"><span>On</span></div>');
        html.push('<div class="simplifiedArticleItem" value="off"><span>Off</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('</div>');
        $settings.html(html.join(""));
        return $settings;
    },

    _$sideMenu_Apperance: function () {
        var $apperance = $("<div/>", { "id": "sideMenuApperance" });
        var html = [];

        html.push('<div class="settingsItem appearanceSettingsLink active">');
        html.push('<div class="settingsItemTitle">Appearance</div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');

        html.push('<div class="settingsItemDetails appearanceSettingsDetails active">');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Theme</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails themeDetails">');
        html.push('<div class="themeItem" value="theme-light"><span>Light</span></div>');
        html.push('<div class="themeItem" value="theme-dark"><span>Dark</span></div>');
        html.push('<div class="themeItem" value="theme-white"><span>White</span></div>');
        html.push('<div class="themeItem" value="theme-black"><span>Black</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>News Feed</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails showNewsDetails">');
        html.push('<div class="showNewsItem" value="layout-cascading-grid""><span>Card View</span></div>');
        //html.push('<div class="showNewsItem" value="layout-grid"><span>Grid View</span></div>');
        html.push('<div class="showNewsItem" value="layout-list"><span>List View</span></div>');
        html.push('<div class="showNewsItem" value="layout-compact"><span>Text View</span></div>');
        html.push('<div class="showNewsItem" value="no"><span>Hide</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Time and Weather</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails timeWeatherDetails">');
        html.push('<div class="timeWeatherItem" value="on"><span>On</span></div>');
        html.push('<div class="timeWeatherItem" value="off"><span>Off</span></div>');
        html.push('</div>');
        html.push('</div>');

        if (NewsTab.Extension.Config.SportWidget !== undefined &&
            NewsTab.Extension.Config.SportWidget !== null &&
            $(".sport-widget-link").length === 0) {
            html.push('<div class="settingsDetailsItem">');
            html.push('<div class="menuItemTitle">');
            html.push('<span>Matches Widget</span>');
            html.push('<div class="menuItemSelected"></div>');
            html.push('<i class="icon-angle-right"></i>');
            html.push('</div>');
            html.push('<div class="menuDetails sportWidgetDetails">');
            html.push('<div class="sportWidgetItem" value="maxi"><span>Expand</span></div>');
            html.push('<div class="sportWidgetItem" value="mini"><span>Minimize</span></div>');
            html.push('<div class="sportWidgetItem" value="hide"><span>Hide</span></div>');
            html.push('</div>');
            html.push('</div>');
        }

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Top Sites</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails topSiteDetails">');
        html.push('<div class="topSiteItem" value="standard"><span>Standard</span></div>');
        html.push('<div class="topSiteItem" value="modern"><span>Modern</span></div>');
        html.push('<div class="topSiteItem" value="compact"><span>Compact</span></div>');
        html.push('<div class="topSiteItem" value="hide"><span>Hide</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem">');
        html.push('<div class="menuItemTitle">');
        html.push('<span>Wallpapers</span>');
        html.push('<div class="menuItemSelected"></div>');
        html.push('<i class="icon-angle-right"></i>');
        html.push('</div>');
        html.push('<div class="menuDetails wallpapersDetails">');
        html.push('<div class="wallpapersItem" value="on"><span>On</span></div>');
        html.push('<div class="wallpapersItem" value="off"><span>Off</span></div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="settingsDetailsItem" data-public-remove="true">');
        html.push('<span style="line-height: 40px; float: left;">Region</span>');
        html.push('<div class="regionBox">');
        html.push('<span class="editionDropdown" style="margin-right: 0;">');
        html.push('<select id="selectedRegion" name="selectedRegion"></select>');
        html.push('</span>');
        html.push('</div>');
        html.push('</div>');

        html.push('</div>');

        $apperance.html(html.join(""));
        return $apperance;
    },

    _$sideMenu_DefaultFeeds: function () {
        var $extensionSections = [];

        var defaultFeeds = "";
        var includedFeeds = "";
        if (NewsTab.Modules.SectionsManager.ExtensionSections[0].Feeds.length) {
            var classActive = NewsTab.Modules.SectionsManager.ExtensionSections[0].Id === NewsTab.Modules.SectionsManager.CurrentSection.Id ? "active" : "";
            defaultFeeds += '<div class="defaultFeeds sideMenuSection"><div class="settingsItem defaultFeeds ' + classActive + '" style="margin-top: 20px;">';
            defaultFeeds += NewsTab.Modules.SideMenu.RenderDefaultFeedContentTitle();
            defaultFeeds += '<i class="icon-angle-right"></i>';
            defaultFeeds += '</div>';
            defaultFeeds += '<ul class="settingsItemDetails feeds ' + classActive + '" data-section-id="' + NewsTab.Modules.SectionsManager.ExtensionSections[0].Id + '"></ul></div>';
        }
        if (NewsTab.Modules.SectionsManager.ExtensionSections[1].Feeds.length) {
            var classActive = NewsTab.Modules.SectionsManager.ExtensionSections[1].Id === NewsTab.Modules.SectionsManager.CurrentSection.Id ? "active" : "";
            includedFeeds += '<div class="includedFeeds sideMenuSection"><div class="settingsItem  ' + classActive + '" style="margin-top: 20px;">';
            includedFeeds += NewsTab.Modules.SideMenu.RenderPublisherFeedContentTitle();
            includedFeeds += '<i class="icon-angle-right"></i>';
            includedFeeds += '</div>';
            includedFeeds += '<ul class="settingsItemDetails feeds ' + classActive + '" data-section-id="' + NewsTab.Modules.SectionsManager.ExtensionSections[1].Id + '"></ul></div>';
        }

        if (NewsTab.Extension.Config.ReversOrderofIncludedAndDefaultFeeds === true) {
            $extensionSections.push($(defaultFeeds));
            $extensionSections.push($(includedFeeds));
        }
        else {
            $extensionSections.push($(includedFeeds));
            $extensionSections.push($(defaultFeeds));
        }

        return $extensionSections;
    },

    _$sideMenu_UserSection: function (section) {
        var self = this;

        var feedsToShow = $.grep(section.Feeds, function (x) { return x.ShowInList === true });
        var hasSectionOptions = false;

        var classActive = (section.Id === NewsTab.Modules.SectionsManager.CurrentSection.Id ? "active" : "");
        var $sideMenuSection = $("<div/>", {
            "class": "sideMenuSection",
            "data-section-id": section.Id
        });

        if (section.SectionTypeId === Section.TYPES.Normal ||
           section.SectionTypeId === Section.TYPES.Social ||
           (section.SectionTypeId === Section.TYPES.Home && feedsToShow.length > 1)) {
            hasSectionOptions = true;
        }

        var html = [];
        html.push('<div class="settingsItem userFeeds ' + (hasSectionOptions ? 'hasContextMenu ' : '') + classActive + '" style="margin-top: 10px; color:' + section.Color + '">');
        html.push('<div class="settingsItemTitle" style="margin-bottom: 5px;">');
        if (hasSectionOptions) {
            html.push('<span class="icon-more"></span>');
        }
        html.push('<span>' + section.Name + '</span>');
        html.push('</div>');
        html.push('<span class="icon-angle-right"></span>');
        html.push('</div>');
        html.push('<ul class="settingsItemDetails feeds ' + classActive + '" data-section-id="' + section.Id + '">');

        if (feedsToShow.length > 0) {
            var hasFeedOptions = false;
            $.each($.grep(section.Feeds, function (x) { return x.ShowInList === true || x.Type === Feed.TYPES.ALL }), function (index, feed) {
                if ((section.SectionTypeId === Section.TYPES.Normal || (section.SectionTypeId === Section.TYPES.Social && feed.Name !== "Timeline")) && feed.ShowInList) {
                    hasFeedOptions = true;
                } else {
                    hasFeedOptions = false;
                }

                if (feed.Type !== Feed.TYPES.ALL || feedsToShow.length > 1) {
                    html.push('<li data-feed-id="' + feed.Id + '" class="openFeed' + (hasFeedOptions ? ' hasContextMenu' : '') + (feed.Id === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? ' active' : '') + '" title="' + feed.Name + '">'); // feedsToShow.length < 2 ? ' fullwidth' : ''
                    html.push('<div>');
                    if (hasFeedOptions) {
                        html.push('<span class="icon-more"></span>');
                    }
                    html.push('<span>' + feed.Name.replace(" - Google News", "").replace(" (Google News)", "") + '</span></div>');
                    html.push('</li>');
                }
            });
        }

        if (section.SectionTypeId === Section.TYPES.Normal) {
            html.push('<li title="+ Add feed" class="addContentItem" data-tab-select="#tabFeeds">'); // feedsToShow.length < 2 ? ' fullwidth' : ''
            html.push('<div><span>+ Add feed</span></div>');
            html.push('</li>');
        } else if (section.SectionTypeId === Section.TYPES.Social) {
            html.push('<li title="+ Add filter" class="addContentItem" data-tab-select="#tabFeeds" data-tab-param="tabTwitter">'); // feedsToShow.length < 2 ? ' fullwidth' : ''
            html.push('<div><span>+ Add filter</span></div>');
            html.push('</li>');
        }

        html.push('</ul>');

        $sideMenuSection.html(html.join(""));


        $(".settingsItemTitle .icon-more", $sideMenuSection).on("click", function (event) {
            event.stopPropagation();
            NewsTab.Modules.SectionsManager.ContextMenu_Section(section, $(this).parent());
        });

        $(".settingsItem.hasContextMenu", $sideMenuSection).on("contextmenu", function (event) {
            event.stopPropagation();
            event.preventDefault();
            NewsTab.Modules.SectionsManager.ContextMenu_Section(section, $(this));
        });

        if (feedsToShow.length > 0) {
            $(".feeds .icon-more", $sideMenuSection).on("click", function (event) {
                event.stopPropagation();
                var id = $(this).closest("li").data("feed-id");
                var feed = $.grep(section.Feeds, function (x) { return x.Id === id });
                if (feed.length === 1) {
                    feed = feed[0];
                    NewsTab.Modules.SectionsManager.ContextMenu_Feed(section, feed, $(this).closest("li"));
                }
            });

            $(".feeds li.hasContextMenu", $sideMenuSection).on("contextmenu", function (event) {
                event.stopPropagation();
                event.preventDefault();
                var id = $(this).data("feed-id");
                var feed = $.grep(section.Feeds, function (x) { return x.Id === id });
                if (feed.length === 1) {
                    feed = feed[0];
                    NewsTab.Modules.SectionsManager.ContextMenu_Feed(section, feed, $(this));
                }
            });
        }

        return $sideMenuSection;
    },

    _$sideMenu_UserSections: function () {
        var self = this;

        var $sideMenuSections = [];

        var home = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.SectionTypeId === Section.TYPES.Home; });
        if (home.length) {
            $sideMenuSections.push(self._$sideMenu_UserSection(home[0]));
        }

        var pinned = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.SectionTypeId === Section.TYPES.Pinned; });
        if (pinned.length) {
            $sideMenuSections.push(self._$sideMenu_UserSection(pinned[0]));
        }

        $.each(NewsTab.Modules.SectionsManager.Sections, function (index, section) {
            if (section.Feeds.length &&
                section.SectionTypeId !== Section.TYPES.Home &&
                section.SectionTypeId !== Section.TYPES.Pinned) {
                $sideMenuSections.push(self._$sideMenu_UserSection(section));
            }

        });
        return $sideMenuSections;
    },


    SetupSideMenu: function () {
        var self = this;

        var $sideMenu = $("<div/>", { "id": "sideMenu", "class": "settings_menu ui-front" });

        var $asideMenu = $("<section/>", { "class": "asideMenu", "aria-hidden": "true" });
        $asideMenu.html('<div id="asideMenuContent"></div>');

        $("#asideMenuContent", $asideMenu).append(self._$sideMenu_Header());
        $("#asideMenuContent", $asideMenu).append(self._$sideMenu_AboutHelp());
        $("#asideMenuContent", $asideMenu).append(self._$sideMenu_Settings());
        $("#asideMenuContent", $asideMenu).append(self._$sideMenu_Apperance());

        if (NewsTab.Token === null) {
            $("#asideMenuContent", $asideMenu).append(self._$sideMenu_DefaultFeeds());
        }
        else {
            $("#asideMenuContent", $asideMenu).append(self._$sideMenu_UserSections());
        }
        
        var html = [];
        html.push('<div class="newTabRights">');
        html.push('<img class="allRightsLogo" src="' + (NewsTab.Extension.Config.OverrideCopyrightInfo_Img !== undefined && NewsTab.Extension.Config.OverrideCopyrightInfo_Img.length > 0 ? NewsTab.Extension.Config.OverrideCopyrightInfo_Img : '/Media/Images/allrightsreserved.png') + '" />');
        html.push('<p id="copyRight" class=\"float-left\">' + (NewsTab.Extension.Config.OverrideCopyrightInfo_Text !== undefined && NewsTab.Extension.Config.OverrideCopyrightInfo_Text.length > 0 ? NewsTab.Extension.Config.OverrideCopyrightInfo_Text : 'NewsTab &copy; 2017 All Rights Reserved</p>'));
        html.push('</div>');

        $("#asideMenuContent", $asideMenu).append(html.join(""));

        $sideMenu.append($asideMenu);
        $sideMenu.append(self._$sideMenu_AddNewContent());

        // Remove Old SideMenu
        $("#sideMenu").remove();
        // Add New Side Menu
        $(document.body).append($sideMenu);

        self.Populate_SideMenu();

        self.SideMenuEvents($sideMenu);
    },

    Populate_DefaultFeeds: function () {
        $(".defaultFeeds .feeds").html("");
        $(".includedFeeds .feeds").html("");

        var html = [];
        $.each(NewsTab.Modules.SectionsManager.ExtensionSections[0].Feeds, function (index, feed) {
            html.push('<li data-feed-id="' + feed.Id + '" class="openFeed' + (feed.Id === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? " active" : "") + '" title="' + feed.Name + '">');
            html.push('<div><span>' + feed.Name + '</span></div>');
            html.push('</li>');
        });
        $(".defaultFeeds .feeds").append(html.join(""));

        html = [];
        $.each(NewsTab.Modules.SectionsManager.ExtensionSections[1].Feeds, function (index, feed) {
            html.push('<li data-feed-id="' + feed.Id + '" class="openFeed' + (feed.Id === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? " active" : "") + '" title="' + feed.Name + '">');
            html.push('<div><span>' + feed.Name + '</span></div>');
            html.push('</li>');
        });
        $(".includedFeeds .feeds").append(html.join(""));
    },

    Populate_SideMenu: function () {
        var self = this;

        /* Settings */
        self.Set_SearchFocus();
        self.Set_SearchProvider();
        self.Set_BackgroundUpdatePeriod();
        self.Set_SimplifiedArticle();
        /* Appearance */
        self.Set_Theme();
        self.Set_ShowNewsFeed();
        self.Set_TimeWeather();
        self.Set_SportWidget();
        self.Set_TopSitesTemplate();
        self.Set_Wallpapers();
        /* Region */
        if (NewsTab.Token) {
            NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#selectedRegion"), false, NewsTab.Modules.RegionManager.Get_RegionCodeByCountyId(NewsTab.User.CountryId));
        } else {
            NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#selectedRegion"), false, NewsTab.Extension.Get_RegionCode());
        }
        /* Extension Feeds */
        self.Populate_DefaultFeeds();
    },


    SideMenuEvents: function ($sideMenu) {
        var self = this;

        $(document.body).off("click.sideMenu").on("click.sideMenu", function (e) {
            // Close SideMenu on outside click
            var sideMenu = $("#sideMenu");
            var target = $(e.target);

            if (!sideMenu.is(e.target) &&
                !target.is("#notificationsContainer") &&
                !target.is("#toastsContainer") &&
                !target.hasClass(".notificationModal") &&
                sideMenu.has(e.target).length === 0 &&
                target.closest("#notificationsContainer").length === 0 &&
                target.closest("#toastsContainer").length === 0 &&
                target.closest(".notificationModal").length === 0) {
                if ($(document.body).hasClass("show_menu")) {
                    $(document.body).removeClass("show_menu");
                }
            }
        });


        $(document.body).off("newcontent.sideMenu").on("newcontent.sideMenu", function (e, section) {
            self.SetupSideMenu();
        });


        $(document.body).off("setion:added.sideMenu").on("setion:added.sideMenu", function (e, section) {
            self.SetupSideMenu();
        });

        $(document.body).off("setion:updated.sideMenu").on("setion:updated.sideMenu", function (e, section) {
            $ssMenu = $(".sideMenuSection[data-section-id=" + section.Id + "]", $sideMenu);
            $ssMenu.replaceWith(self._$sideMenu_UserSection(section));
        });

        $(document.body).off("setion:removed.sideMenu").on("setion:removed.sideMenu", function (e, section) {
            $ssMenu = $(".sideMenuSection[data-section-id=" + section.Id + "]", $sideMenu);
            $ssMenu.remove();
        });


        $(document.body).off("feed:added.sideMenu").on("feed:added.sideMenu", function (e, section, feed) {
            self.SetupSideMenu();
        });

        $(document.body).off("feed:updated.sideMenu").on("feed:updated.sideMenu", function (e, section, feed) {
            $ssMenu = $(".sideMenuSection[data-section-id=" + section.Id + "]", $sideMenu);
            $ssMenu.replaceWith(self._$sideMenu_UserSection(section));
        });

        $(document.body).off("feed:removed.sideMenu").on("feed:removed.sideMenu", function (e, section, feed) {
            $ssMenu = $(".sideMenuSection[data-section-id=" + section.Id + "] .feeds li[data-feed-id=" + feed.Id + "]", $sideMenu);
            $ssMenu.remove();
        });


        $($sideMenu).on("click", ".settingsItem", function () {
            var control = $(this);
            if (!control.hasClass("active")) {
                control.addClass("active");
                control.next(".settingsItemDetails").addClass("active");
            } else {
                control.removeClass("active");
                control.next(".settingsItemDetails").removeClass("active");
            }
        });

        $($sideMenu).on("click", ".menuItemTitle", function () {
            var control = $(this);
            if (!control.closest(".settingsDetailsItem").hasClass("active")) {
                $(".settingsDetailsItem", $sideMenu).removeClass("active");
                control.closest(".settingsDetailsItem").addClass("active");
                control.closest(".settingsDetailsItem").find(".focus").focus();
            } else {
                control.removeClass("active");
                $(".settingsDetailsItem", $sideMenu).removeClass("active");
            }
        });

        /* Settings */
        $($sideMenu).on("click", ".setSearchFocusItem", function () {
            if ($(this).attr("value") !== "no") {
                NewsTab.Helpers.SetLocalStorageItem("FocusRedirect", true);
                NewsTab.TrackAnalyticsEvent("Set Search Focus ON", "Extension", NewsTab.Extension.NameId);
            } else {
                NewsTab.Helpers.SetLocalStorageItem("FocusRedirect", false);
                NewsTab.TrackAnalyticsEvent("Set Search Focus OFF", "Extension", NewsTab.Extension.NameId);
            }
            self.Set_SearchFocus();
        });

        $($sideMenu).on("click", ".searchProviderItem", function () {
            NewsTab.Modules.SearchWidget.SearchProvider = $(this).attr("value");
            NewsTab.Helpers.SetLocalStorageItem("Search_Provider", NewsTab.Modules.SearchWidget.SearchProvider);

            NewsTab.Modules.SideMenu.Set_SearchProvider();
            NewsTab.Modules.SearchWidget.SetUp_SearchProviderWidget();

            NewsTab.TrackAnalyticsEvent("Change Provider", "Extension", NewsTab.Extension.NameId);
        });

        $($sideMenu).on("click", ".updateItem", function () {
            var control = $(this);
            if (control.attr("value") === "update-4") {
                NewsTab.Extension.BackgroundUpdatePeriod = "Update-4";
            } else if (control.attr("value") === "update-12") {
                NewsTab.Extension.BackgroundUpdatePeriod = "Update-12";
            } else if (control.attr("value") === "update-24") {
                NewsTab.Extension.BackgroundUpdatePeriod = "Update-24";
            } else if (control.attr("value") === "update-disabled") {
                NewsTab.Extension.BackgroundUpdatePeriod = "Update-Disabled";
            } else {
                NewsTab.Extension.BackgroundUpdatePeriod = "Update-8";
            }

            NewsTab.Helpers.SetLocalStorageItem("Update_Period", NewsTab.Extension.BackgroundUpdatePeriod);
            self.Set_BackgroundUpdatePeriod();
        });

        $($sideMenu).on("click", ".simplifiedArticleItem", function () {
            if ($(this).attr("value") !== "off") {
                NewsTab.Helpers.SetLocalStorageItem("Show_Simplified_Article", true);
            } else {
                NewsTab.Helpers.SetLocalStorageItem("Show_Simplified_Article", false);
            }
            self.Set_SimplifiedArticle();
            NewsTab.Modules.SectionsManager.LoadCurrentFeed({ Refresh: true });
        });

        /* Appearance */
        $($sideMenu).on("click", ".themeItem", function () {
            var control = $(this);
            if (control.attr("value") === "theme-light") {
                NewsTab.Extension.Theme = "Light";
            } else if (control.attr("value") === "theme-white") {
                NewsTab.Extension.Theme = "White";
            } else if (control.attr("value") === "theme-black") {
                NewsTab.Extension.Theme = "Black";
            } else {
                NewsTab.Extension.Theme = "Dark";
            }

            NewsTab.Helpers.SetLocalStorageItem("Theme", NewsTab.Extension.Theme);
            self.Set_Theme();

            NewsTab.Extension.SetUp_Theme();
            NewsTab.Modules.TimeAndWeatherWidget.SetUp_TimeWeatherWidget();
        });

        $($sideMenu).on("click", ".showNewsItem", function () {
            var layout = $(this).attr("value");
            if (layout === "no") {
                NewsTab.Extension.ShowNewsFeed = false;
            } else {
                NewsTab.Extension.ShowNewsFeed = true;
                NewsTab.Modules.ArticleView.MASTER_LAYOUT = layout;
                NewsTab.Helpers.SetLocalStorageItem("Layout", NewsTab.Modules.ArticleView.MASTER_LAYOUT);
            }

            NewsTab.Helpers.SetLocalStorageItem("Hide_Articles", !NewsTab.Extension.ShowNewsFeed);

            NewsTab.TrackAnalyticsEvent("Hide/Show News", "Extension", NewsTab.Extension.NameId);
            self.Set_ShowNewsFeed();
            NewsTab.Extension.UpdateNewsFeedLayout();
        });

        $($sideMenu).on("click", ".timeWeatherItem", function () {
            if ($(this).attr("value") !== "off") {
                NewsTab.Helpers.SetLocalStorageItem("Show_Time_Weather", true);
            } else {
                NewsTab.Helpers.SetLocalStorageItem("Show_Time_Weather", false);
            }

            NewsTab.Modules.SideMenu.Set_TimeWeather();
            NewsTab.Modules.TimeAndWeatherWidget.SetUp_TimeWeatherWidget();
        });

        $($sideMenu).on("click", ".sportWidgetItem", function () {
            var sportData = NewsTab.Helpers.GetLocalStorageItem("SportWidgetData");

            if ($(this).attr("value") === "maxi") {
                sportData.VisibleMode = "maxi";
                NewsTab.TrackAnalyticsEvent("Matches Widget", "Expand", NewsTab.Extension.NameId);
            } else if ($(this).attr("value") === "mini") {
                sportData.VisibleMode = "mini";
                NewsTab.TrackAnalyticsEvent("Matches Widget", "Minimize", NewsTab.Extension.NameId);
            } else {
                sportData.VisibleMode = "hide";
                NewsTab.TrackAnalyticsEvent("Matches Widget", "Hide", NewsTab.Extension.NameId);
            }

            NewsTab.Helpers.SetLocalStorageItem("SportWidgetData", sportData);
            NewsTab.Modules.SideMenu.Set_SportWidget();
            NewsTab.Modules.SportWidget.SetUp_SportWidgetPlaceholder();
        });

        $($sideMenu).on("click", ".topSiteItem", function () {
            var control = $(this);
            if (control.attr("value") === "compact") {
                NewsTab.Modules.TopSitesWidget.TopSitesTemplate = "Compact";
            } else if (control.attr("value") === "hide") {
                NewsTab.Modules.TopSitesWidget.TopSitesTemplate = "Hide";
            } else if (control.attr("value") === "modern") {
                NewsTab.Modules.TopSitesWidget.TopSitesTemplate = "Modern";
            } else {
                NewsTab.Modules.TopSitesWidget.TopSitesTemplate = "Standard";
            }
            NewsTab.Helpers.SetLocalStorageItem("Top_Site", NewsTab.Modules.TopSitesWidget.TopSitesTemplate);
            NewsTab.Modules.SideMenu.Set_TopSitesTemplate();
            NewsTab.Modules.TopSitesWidget.SetUp_TopSitesTemplate();
        });

        $($sideMenu).on("click", ".wallpapersItem", function () {
            if ($(this).attr("value") !== "off") {
                NewsTab.Helpers.SetLocalStorageItem("Wallpapers", true);
            } else {
                NewsTab.Helpers.SetLocalStorageItem("Wallpapers", false);
            }

            NewsTab.Modules.SideMenu.Set_Wallpapers();
            NewsTab.Modules.TopMenu.AppendWallpapersSettings();
            NewsTab.Modules.TimeAndWeatherWidget.SetUp_TimeWeatherWidget();
        });

        /* Region */
        $($sideMenu).on("change", "#selectedRegion", function (e) {
            var code = $(this).closest(".editionDropdown").find(".selectboxit-option.selectboxit-focus").attr("data-countrycode");

            if (NewsTab.Token) {
                NewsTab.Modules.RegionManager.Modal_ChangeUserRegion($(this));
            }
            else {
                NewsTab.Extension.Set_RegionCode(code);
                NewsTab.Modules.SectionsManager.API_GetFeedsByRegion(NewsTab.Extension.Get_RegionCode(), function () {
                    NewsTab.Modules.SectionsManager.SetCurrentSectionAndFeed();
                    NewsTab.Modules.SectionsManager.LoadCurrentFeed({ Refresh: true });
                    self.Populate_SideMenu();
                });

            }
        });
    },

    // Settings
    Set_SearchFocus: function () {
        var searchFocuse = NewsTab.Helpers.GetLocalStorageItem("FocusRedirect");
        $(".setSearchFocusDetails").find(".setSearchFocusItem").removeClass("active");
        if (searchFocuse !== false) {
            $(".setSearchFocusDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Search Bar");
            $(".setSearchFocusDetails").find(".setSearchFocusItem[value='yes']").addClass("active");
        } else {
            $(".setSearchFocusDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Omnibar");
            $(".setSearchFocusDetails").find(".setSearchFocusItem[value='no']").addClass("active");
        }
    },

    Set_SearchProvider: function () {
        $(".searchProviderDetails").find(".searchProviderItem").removeClass("active");
        switch (NewsTab.Modules.SearchWidget.SearchProvider) {
            case "google":
                $(".searchProviderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Google");
                $(".searchProviderDetails").find(".searchProviderItem[value='google']").addClass("active");
                break;
            case "bing":
                $(".searchProviderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Bing");
                $(".searchProviderDetails").find(".searchProviderItem[value='bing']").addClass("active");
                break;
            default:
                $(".searchProviderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("NewsTab");
                $(".searchProviderDetails").find(".searchProviderItem[value='newstab']").addClass("active");
        }
    },

    Set_BackgroundUpdatePeriod: function () {
        $(".updateDetails").find(".updateItem").removeClass("active");
        switch (NewsTab.Extension.BackgroundUpdatePeriod) {
            case "Update-4":
                $(".updateDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("4h");
                $(".updateDetails").find(".updateItem[value='update-4']").addClass("active");
                break;
            case "Update-12":
                $(".updateDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("12h");
                $(".updateDetails").find(".updateItem[value='update-12']").addClass("active");
                break;
            case "Update-24":
                $(".updateDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("24h");
                $(".updateDetails").find(".updateItem[value='update-24']").addClass("active");
                break;
            case "Update-Disabled":
                $(".updateDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Disabled");
                $(".updateDetails").find(".updateItem[value='update-disabled']").addClass("active");
                break;
            default:
                $(".updateDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("8h");
                $(".updateDetails").find(".updateItem[value='update-8']").addClass("active");
        }

    },

    Set_SimplifiedArticle: function () {
        var simplifiedArticleView = NewsTab.Helpers.GetLocalStorageItem("Show_Simplified_Article");
        $(".simplifiedArticleDetails").find(".simplifiedArticleItem").removeClass("active");
        if (simplifiedArticleView !== false) {
            $(".simplifiedArticleDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("On");
            $(".simplifiedArticleDetails").find(".simplifiedArticleItem[value='on']").addClass("active");
        } else {
            $(".simplifiedArticleDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Off");
            $(".simplifiedArticleDetails").find(".simplifiedArticleItem[value='off']").addClass("active");
        }
    },

    // Appearance
    Set_Theme: function () {
        $(".themeDetails").find(".themeItem").removeClass("active");
        switch (NewsTab.Extension.Theme) {
            case "Dark":
                $(".themeDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Dark");
                $(".themeDetails").find(".themeItem[value='theme-dark']").addClass("active");
                break;
            case "White":
                $(".themeDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("White");
                $(".themeDetails").find(".themeItem[value='theme-white']").addClass("active");
                break;
            case "Black":
                $(".themeDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Black");
                $(".themeDetails").find(".themeItem[value='theme-black']").addClass("active");
                break;
            default:
                $(".themeDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Light");
                $(".themeDetails").find(".themeItem[value='theme-light']").addClass("active");
        }
    },

    Set_ShowNewsFeed: function () {
        $(".showNewsDetails").find(".showNewsItem").removeClass("active");
        if (NewsTab.Extension.ShowNewsFeed === true) {
            var $showNewsItem = $(".showNewsDetails").find(".showNewsItem[value='" + NewsTab.Modules.ArticleView.MASTER_LAYOUT + "']");
            $showNewsItem.addClass("active");
            $(".showNewsDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text($showNewsItem.text());
        } else {
            $(".showNewsDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Hide");
            $(".showNewsDetails").find(".showNewsItem[value='no']").addClass("active");
        }
    },

    Set_TimeWeather: function () {
        var timeWeatherView = NewsTab.Helpers.GetLocalStorageItem("Show_Time_Weather");
        $(".timeWeatherDetails").find(".timeWeatherItem").removeClass("active");
        if (timeWeatherView !== false) {
            $(".timeWeatherDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("On");
            $(".timeWeatherDetails").find(".timeWeatherItem[value='on']").addClass("active");
        } else {
            $(".timeWeatherDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Off");
            $(".timeWeatherDetails").find(".timeWeatherItem[value='off']").addClass("active");
        }
    },

    Set_SportWidget: function () {
        var sportWidget = NewsTab.Helpers.GetLocalStorageItem("SportWidgetData");
        $(".sportWidgetDetails").find(".sportWidgetItem").removeClass("active");
        if (sportWidget != undefined && (sportWidget.VisibleMode == undefined || sportWidget.VisibleMode === "maxi")) {
            $(".sportWidgetDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Expand");
            $(".sportWidgetDetails").find(".sportWidgetItem[value='maxi']").addClass("active");
        } else if (sportWidget != undefined && (sportWidget.VisibleMode != undefined && sportWidget.VisibleMode === "mini")) {
            $(".sportWidgetDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Minimize");
            $(".sportWidgetDetails").find(".sportWidgetItem[value='mini']").addClass("active");
        } else {
            $(".sportWidgetDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Hide");
            $(".sportWidgetDetails").find(".sportWidgetItem[value='hide']").addClass("active");
        }
    },

    Set_TopSitesTemplate: function () {
        $(".topSiteDetails").find(".topSiteItem").removeClass("active");
        switch (NewsTab.Modules.TopSitesWidget.TopSitesTemplate) {
            case "Compact":
                $(".topSiteDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Compact");
                $(".topSiteDetails").find(".topSiteItem[value='compact']").addClass("active");
                break;
            case "Hide":
                $(".topSiteDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Hide");
                $(".topSiteDetails").find(".topSiteItem[value='hide']").addClass("active");
                break;
            case "Modern":
                $(".topSiteDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Modern");
                $(".topSiteDetails").find(".topSiteItem[value='modern']").addClass("active");
                break;
            default:
                $(".topSiteDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Standard");
                $(".topSiteDetails").find(".topSiteItem[value='standard']").addClass("active");
        }
    },

    Set_Wallpapers: function () {
        var wallpapers = NewsTab.Helpers.GetLocalStorageItem("Wallpapers");
        $(".wallpapersDetails").find(".wallpapersItem").removeClass("active");
        if (wallpapers !== false) {
            $(".wallpapersDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("On");
            $(".wallpapersDetails").find(".wallpapersItem[value='on']").addClass("active");
        } else {
            $(".wallpapersDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Off");
            $(".wallpapersDetails").find(".wallpapersItem[value='off']").addClass("active");
        }
    },

    RenderDefaultFeedContentTitle: function () {
        var result;
        if (NewsTab.Extension.Config.Type === NewsTab.Extensions.Config.ExtensionType.Publisher ||
            NewsTab.Extension.Config.Type === NewsTab.Extensions.Config.ExtensionType.StandAlone) {
            result = '<div class="settingsItemTitle" style="margin-bottom: 10px;">';
            result += '<span>Popular Topics</span>';
            result += '<span class="byGoogleNewsTitle">';
            result += '<img src="https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png" /> by Google News</span>';
            result += '</div>';
        } else {
            result = '<div class="settingsItemTitle" style="margin-bottom: 10px;">';
            result += '<span>Default News Feeds</span>';
            result += '<span class="byGoogleNewsTitle">';
            result += '<img src="https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png" /> by Google News</span>';
            result += '</div>';
        }
        return result;
    },

    RenderPublisherFeedContentTitle: function () {
        var result = '<div class="settingsItemTitle" style="margin-bottom: 10px;">';
        if (NewsTab.Extension.Config.OverrideIncludedFeedsTitle !== undefined && NewsTab.Extension.Config.OverrideIncludedFeedsTitle.length > 0) {
            result += '<span>' + NewsTab.Extension.Config.OverrideIncludedFeedsTitle + '</span>';
        }
        else {
            result += '<span>' + NewsTab.Extension.Config.Name.toLowerCase() + ' News Feeds</span>';
        }

        if (NewsTab.Extension.Config.Type === NewsTab.Extensions.Config.ExtensionType.Publisher && NewsTab.Extension.Config.OverrideIconUrl !== "") {
            result += '<span class="byGoogleNewsTitle">';
            result += '<img src="' + NewsTab.Extension.Config.OverrideIconUrl + '" /> by ' + NewsTab.Extension.Config.Publisher.Domain + '</span>';
        }
        result += '</div>';
        return result;
    },

    RenderSectionFeedContentTitle: function (section) {
        var result = '<div class="settingsItemTitle" style="margin-bottom: 15px;">';
        result += '<span>' + section.SectionName + ' News Feeds</span>';
        result += '</div>';
        return result;
    }
}