var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.TimeAndWeatherWidget = {
    WeatherDataUpdateTimeout: null,
    WeatherDataUpdateInterval: 1000 * 60 * 60, //1h
    WeatherDataUpdateCounter: 0,

    Init: function () {
        var self = this;
        self.WeatherDataUpdateTimeout = null;
        self.WeatherDataUpdateCounter = 0;

        self.SetUp_TimeWeatherWidget();
    },

    Get_WeatherIcon_Img: function (weatherData) {
        var sr = 6 * 60;
        var ss = 20 * 60;
        if (weatherData.Sunrise !== 0) {
            var srDate = new Date(weatherData.Sunrise * 1000);
            sr = srDate.getHours() * 60 + srDate.getMinutes();
        }

        if (weatherData.Sunset !== 0) {
            var ssDate = new Date(weatherData.Sunset * 1000);
            ss = ssDate.getHours() * 60 + ssDate.getMinutes();
        }

        const dayTime = new Date().getHours() * 60 + new Date().getMinutes()
        const isDayTime = dayTime >= sr && dayTime < ss

        var name = "cloud";

        if (weatherData.WeatherCode === 781) {
            name = 'tornado';
        }
        else if (weatherData.WeatherCode >= 200 && weatherData.WeatherCode < 300) {
            name = 'thunderstorm';
        }
        else if (weatherData.WeatherCode === 511) {
            name = 'sleet';
        }
        else if (weatherData.WeatherCode >= 300 && weatherData.WeatherCode < 600) {
            name = 'rain';
        }
        else if (weatherData.WeatherCode >= 600 && weatherData.WeatherCode < 700) {
            name = 'snow';
        }
        else if (weatherData.WeatherCode === 731 || weatherData.WeatherCode === 751 || weatherData.WeatherCode === 761 || weatherData.WeatherCode === 762) {
            name = 'windy-dust';
        }
        else if (weatherData.WeatherCode === 771) {
            name = 'windy';
        }
        else if (weatherData.WeatherCode >= 700 && weatherData.WeatherCode < 800) {
            name = 'fog';
        }
        else if (weatherData.WeatherCode === 800) {
            if (isDayTime) {
                name = 'clear-d';
            }
            else {
                name = 'clear-n';
            }
        }
        else if (weatherData.WeatherCode === 801) {
            if (isDayTime) {
                name = 'partly-cloudy-d';
            }
            else {
                name = 'partly-cloudy-n';
            }
        }
        else if (weatherData.WeatherCode === 802) {
            if (isDayTime) {
                name = 'mostly-cloudy-d';
            }
            else {
                name = 'mostly-cloudy-n';
            }
        }

        var theme = NewsTab.Helpers.GetLocalStorageItem("Theme");
        var isWallpaper = $("body").hasClass("nt-bg-img");
        var themeType = (theme == "Dark" || theme == "Black" || isWallpaper) ? "Dark" : "Light";
        var icon = '/Media/ExtensionImages/Weather/' + themeType + '/' + name + '.png';
        return "<img class=\"tw-icon-" + name + "\" src=\"" + icon + "\" title=\"" + weatherData.WeatherDesc + "\" \>";
    },

    Get_Time: function (timeFormat) {
        return moment().format(timeFormat);
    },

    Get_TimeMeridiem: function () {
        return moment().format("A");
    },

    Get_Date: function () {
        day = moment().format("D");
        dayName = moment().format("dddd");
        month = moment().format("MMMM");

        return dayName + ", " + day + " " + month;
    },

    Get_TimeWeatherData: function () {
        var self = this;

        var tFormat = NewsTab.Helpers.GetLocalStorageItem("TimeFormat");
        var timeFormat = tFormat != undefined ? tFormat : "h:mm";

        if (timeFormat == "HH:mm") {
            $(".tw-time-24").addClass("active");
        } else {
            $(".tw-time-12").addClass("active");
        }

        var dFormat = NewsTab.Helpers.GetLocalStorageItem("DegreeFormat");
        var degreeFormat = dFormat != undefined ? dFormat : "c";

        if (degreeFormat == "c") {
            $(".tw-weather-c").addClass("active");
        } else {
            $(".tw-weather-f").addClass("active");
        }

        $(".provider").addClass("tw-provider");

        $(".tw-widget .tw-time-widget .tw-time .tw-time-value").text(self.Get_Time(timeFormat));
        if (timeFormat != "HH:mm") {
            $(".tw-widget .tw-time-widget .tw-time .tw-time-mediriem").text(self.Get_TimeMeridiem());
        } else {
            $(".tw-widget .tw-time-widget .tw-time .tw-time-mediriem").text("");
        }

        $(".tw-widget .tw-weather-widget .tw-date").text(self.Get_Date());

        window.tw_interval;
        if (typeof window.tw_interval != "number") {
            window.tw_interval = setInterval(function () {
                tFormat = NewsTab.Helpers.GetLocalStorageItem("TimeFormat");
                timeFormat = tFormat != undefined ? tFormat : "h:mm";

                $(".tw-widget .tw-time-widget .tw-time .tw-time-value").text(self.Get_Time(timeFormat));
                if (timeFormat != "HH:mm") {
                    $(".tw-widget .tw-time-widget .tw-time .tw-time-mediriem").text(self.Get_TimeMeridiem());
                } else {
                    $(".tw-widget .tw-time-widget .tw-time .tw-time-mediriem").text("");
                }

                if (moment().hour() == 0 && moment().minute() == 0) {
                    $(".tw-widget .tw-weather-widget .tw-date").text(self.Get_Date());
                }
            }, 10 * 1000);
        }

        $(".tw-settings .tw-time-format").off("click").on("click", function () {
            var value = $(this).data("value");
            timeFormat = "h:mm";

            $(".tw-time-format").removeClass("active");
            $(this).addClass("active");

            if (value === 24) {
                timeFormat = "HH:mm";
            }

            $(".tw-widget .tw-time-widget .tw-time .tw-time-value").text(self.Get_Time(timeFormat));
            if (timeFormat != "HH:mm") {
                $(".tw-widget .tw-time-widget .tw-time .tw-time-mediriem").text(self.Get_TimeMeridiem());
            } else {
                $(".tw-widget .tw-time-widget .tw-time .tw-time-mediriem").text("");
            }

            NewsTab.Helpers.SetLocalStorageItem("TimeFormat", timeFormat);
        });

        $(".tw-settings .tw-weather-format").off("click").on("click", function () {
            degreeFormat = $(this).data("value");

            $(".tw-weather-format").removeClass("active");
            $(this).addClass("active");

            NewsTab.Helpers.SetLocalStorageItem("DegreeFormat", degreeFormat);

            var weatherData = NewsTab.Helpers.GetLocalStorageItem("WeatherData");
            if (weatherData !== null) {
                $(".tw-degree .tw-degree-symbol").text("\260" + degreeFormat.toUpperCase());
                $(".tw-degree .tw-degree-value").text(Math.round(degreeFormat === "f" ? (weatherData.WeatherTemp * 9 / 5 + 32) : weatherData.WeatherTemp));
                $(".tw-max-temp-value").text(Math.round(degreeFormat === "f" ? (weatherData.WeatherMaxTemp * 9 / 5 + 32) : weatherData.WeatherMaxTemp) + "\260 / ");
                $(".tw-min-temp-value").text(Math.round(degreeFormat === "f" ? (weatherData.WeatherMinTemp * 9 / 5 + 32) : weatherData.WeatherMinTemp) + "\260");
            }
        });

        $(".tw-time-widget").off("click").on("click", function (e) {
            if (e.target.className != undefined && e.target.className.indexOf("tw-time-format") === -1) {
                window.open('https://www.timeanddate.com/worldclock/personal.html', '_self');
            }
        });

        $(".tw-weather-widget").off("click").on("click", function (e) {
            if (e.target.className != undefined && e.target.className.indexOf("tw-weather-format") === -1) {
                window.open('https://openweathermap.org', '_self');
            }
        });
    },

    SetUp_TimeWeatherWidget: function () {
        var self = this;

        var showTimeWeatherWidget = NewsTab.Helpers.GetLocalStorageItem("Show_Time_Weather");
        if (showTimeWeatherWidget !== false) {
            $(".provider").addClass("tw-provider");

            var weatherData = NewsTab.Helpers.GetLocalStorageItem("WeatherData");

            var dFormat = NewsTab.Helpers.GetLocalStorageItem("DegreeFormat");
            var degreeFormat = dFormat !== null ? dFormat : "c";

            self.Get_TimeWeatherData();
            if (weatherData !== null) {
                $(".tw-weather-widget").show();

                $(".tw-condition").html(self.Get_WeatherIcon_Img(weatherData));
                $(".tw-city-name").text(weatherData.CityName + ",");

                $(".tw-degree .tw-degree-symbol").text("\260" + degreeFormat.toUpperCase());
                $(".tw-degree .tw-degree-value").text(Math.round(degreeFormat === "f" ? (weatherData.WeatherTemp * 9 / 5 + 32) : weatherData.WeatherTemp));
                $(".tw-max-temp-value").text(Math.round(degreeFormat === "f" ? (weatherData.WeatherMaxTemp * 9 / 5 + 32) : weatherData.WeatherMaxTemp) + "\260 / ");
                $(".tw-min-temp-value").text(Math.round(degreeFormat === "f" ? (weatherData.WeatherMinTemp * 9 / 5 + 32) : weatherData.WeatherMinTemp) + "\260");
            } else {
                $(".tw-weather-widget").hide();
            }
        } else {
            $(".provider").removeClass("tw-provider");
        }
    },

    UpdateWeather: function () {
        var self = this;

        if (self.WeatherDataUpdateTimeout === null) {
            NewsTab.Modules.TimeAndWeatherWidget.API_GetWeatherDetailsByCity();
            self.WeatherDataUpdateTimeout = setTimeout(function () {
                clearTimeout(NewsTab.Modules.TimeAndWeatherWidget.WeatherDataUpdateTimeout);
                NewsTab.Modules.TimeAndWeatherWidget.WeatherDataUpdateTimeout = null;
                var timeWeatherView = NewsTab.Helpers.GetLocalStorageItem("Show_Time_Weather");
                if (timeWeatherView !== false) {
                    NewsTab.Modules.TimeAndWeatherWidget.UpdateWeather();
                }
            }, self.WeatherDataUpdateInterval);
        }
    },

    API_GetWeatherDetailsByCity: function (callback) {
        var city = NewsTab.Helpers.GetLocalStorageItem("City");
        if (city != null) {
            var url = NewsTab.EnviromentUrl + "/api/extresc/weather?city=" + city;

            $.ajax({
                type: "GET",
                url: url,
                timeout: 5000
            }).then(function (data) {
                NewsTab.Modules.TimeAndWeatherWidget.WeatherRepeatCounter = 0;
                NewsTab.Helpers.SetLocalStorageItem("WeatherData", data);

                if (typeof callback === "function") {
                    callback(data);
                }
            }).fail(function () {
                NewsTab.Modules.TimeAndWeatherWidget.WeatherRepeatCounter += 1;
                if (NewsTab.Modules.TimeAndWeatherWidget.WeatherRepeatCounter <= 5) {
                    setTimeout(function () {
                        NewsTab.Modules.TimeAndWeatherWidget.API_GetWeatherDetailsByCity(callback);
                    }, 10 * 1000);
                }
            });
        }
    }
}