var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.TopSitesWidget = {
    MAX_TOPSITES: 7,

    TopSites: [],
    TopSitesTemplate: [],
    NumberOfVisibleTopSites: 0,
    PredefinedTopSites: [
       { "title": "Alibaba", "url": "http://www.alibaba.com", "className": "alibaba", "color": "#FF6601" },
       { "title": "Aliexpress", "url": "https://www.aliexpress.com", "className": "aliexpress", "color": "#E52d02" },
       { "title": "Amazon", "url": "https://www.amazon.com", "className": "amazon", "color": "#FA9900" },
       { "title": "Baidu", "url": "http://www.baidu.com", "className": "baidu", "color": "#2C3CDD" },
       { "title": "Bing", "url": "http://www.bing.com", "className": "bing", "color": "#FFBA00" },
       { "title": "Google", "url": "https://google.com", "className": "google", "color": "#CE4E4E" },
       { "title": "Gmail", "url": "https://mail.google.com", "className": "gmail", "color": "#E84031" },
       { "title": "Google Calendar", "url": "https://calendar.google.com", "className": "google-calendar", "color": "#2B6DFC" },
       { "title": "Google Contacts", "url": "https://contacts.google.com", "className": "google-contacts", "color": "#2B6DFC" },
       { "title": "Google Contacts", "url": "http://google.com/contacts", "className": "google-contacts", "color": "#2B6DFC" },
       { "title": "Google Drive", "url": "https://drive.google.com", "className": "google-drive", "color": "#FFBC00" },
       { "title": "Google Photos", "url": "https://photos.google.com", "className": "google-photos", "color": "#FFBC00" },
       { "title": "Google Finance", "url": "https://www.google.com/finance", "className": "google-finance", "color": "#00A949" },
       { "title": "Google Plus", "url": "https://plus.google.com", "className": "google-plus", "color": "#DC4C40" },
       { "title": "Dropbox", "url": "https://dropbox.com", "className": "dropbox", "color": "#008AD2" },
       { "title": "Ebay", "url": "http://www.ebay.com", "className": "ebay", "color": "#F5AF02" },
       { "title": "Facebook", "url": "https://www.facebook.com", "className": "facebook", "color": "#3A589B" },
       { "title": "Instagram", "url": "https://www.instagram.com", "className": "instagram", "color": "#2E5E87" },
       { "title": "Linkedin", "url": "https://www.linkedin.com", "className": "linkedin", "color": "#007BB6" },
       { "title": "Msn", "url": "http://www.msn.com", "className": "msn", "color": "#0075DA" },
       { "title": "Onedrive", "url": "https://onedrive.live.com", "className": "onedrive", "color": "#004AB1" },
       { "title": "Outlook", "url": "https://outlook.live.com", "className": "outlook", "color": "#0070C8" },
       { "title": "Pinterest", "url": "https://www.pinterest.com", "className": "pinterest", "color": "#CC2128" },
       { "title": "Qq", "url": "http://www.qq.com", "className": "qq", "color": "#0199D6" },
       { "title": "Reddit", "url": "https://www.reddit.com", "className": "reddit", "color": "#FF4500" },
       { "title": "Sohu", "url": "http://www.sohu.com", "className": "sohu", "color": "#FFCF00" },
       { "title": "Taobao", "url": "https://www.taobao.com", "className": "taobao", "color": "#FF7500" },
       { "title": "Tmall", "url": "https://www.taobao.com", "className": "tmall", "color": "#C10000" },
       { "title": "Twitter", "url": "https://twitter.com/", "className": "twitter", "color": "#01ABED" },
       { "title": "Vk", "url": "https://vk.com", "className": "vk", "color": "#4D76A4" },
       { "title": "Wikipedia", "url": "https://www.wikipedia.org", "className": "wikipedia-w", "color": "#3B3839" },
       { "title": "Yahoo", "url": "https://www.yahoo.com", "className": "yahoo", "color": "#44008E" },
       { "title": "Yahoo Finance", "url": "http://finance.yahoo.com", "className": "yahoo-finance", "color": "#4E00A6" },
       { "title": "Yahoo Mail", "url": "https://mail.yahoo.com", "className": "yahoo-mail", "color": "#4D00A6" },
       { "title": "Yandex", "url": "https://yandex.ru", "className": "yandex", "color": "#EE2025" },
       { "title": "Youtube", "url": "https://www.youtube.com", "className": "youtube", "color": "#E62C23" }],

    Init: function () {
        var self = this;

        self.TopSitesTemplate = NewsTab.Helpers.GetLocalStorageItem("Top_Site");
        self.SetUp_TopSitesTemplate();

        self.Prepare_TopSites();

        $(document).ready(function () {
            self.DocumentReadyInit();
        });
    },

    DocumentReadyInit: function () {
        var self = this;

        $(document.body).on("click", ".most_visited_link_remove_wrapper", function (e) {
            e.preventDefault();
            e.stopPropagation();

            var linkToRemove = $(this).closest(".most_visited_link").find(".most_visited_link_title_body a").attr("href");
            $(this).closest(".most_visited_link").fadeTo(300, 0, function () {
                $(this).remove();
            });
            var linksRemovedArray = NewsTab.Helpers.GetLocalStorageItem("Top_Site_Removed_Items");
            if (linksRemovedArray == null) {
                linksRemovedArray = new Array();
            }
            linksRemovedArray.push(linkToRemove);
            NewsTab.Helpers.SetLocalStorageItem("Top_Site_Removed_Items", linksRemovedArray);

            $(".most_visited_container").empty();

            window.chrome.topSites.get(function (data) { self.SetUp_TopSites(data); });
            return false;
        });

        $(document.body).on("mousedown", ".most_visited_link", function (e) {
            var site = $(this).find(".tile_link").attr("href");
            if (site == undefined || e.target.className === "most_visited_link_remove_wrapper" || e.target.className === "most_visited_link_remove") {
                return false;
            }

            switch (e.which) {
                case 1:
                    NewsTab.TrackAnalyticsEvent("History Tile", "Extension", NewsTab.Extension.NameId);
                    break;
                case 2:
                    NewsTab.TrackAnalyticsEvent("History Tile", "Extension", NewsTab.Extension.NameId);
                    break;
                case 3:
                    NewsTab.TrackAnalyticsEvent("History Tile", "Extension", NewsTab.Extension.NameId);
                    break;
            }
            return true;
        });
    },

    SaveToLocalStorage: function (key, hostname, url, className, color) {
        var cacheMap = NewsTab.Helpers.GetLocalStorageItem(key);
        if (cacheMap == null) {
            cacheMap = {};
        }
        cacheMap[hostname] = {
            time: new Date(),
            active: false,
            full_url: url,
            className: className,
            color: color
        };
        NewsTab.Helpers.SetLocalStorageItem(key, cacheMap);
    },

    Prepare_TopSites: function (resize) {
        var self = this;

        if (NewsTab.Extension.ShowNewsFeed) {
            var containerSize = $(".most_visited_container_wrapper").innerWidth();
            var itemSize = 154;
            var margin = 16;

            var nots = parseInt(containerSize / (itemSize + margin));
            if (nots > self.MAX_TOPSITES) {
                nots = self.MAX_TOPSITES;
            }
            if (self.NumberOfVisibleTopSites === nots) {
                resize = false;
            }
            self.NumberOfVisibleTopSites = nots;
        } else {
            self.NumberOfVisibleTopSites = 8;
        }

        if (resize === false && $(".most_visited_link").length > 0) return;

        window.chrome.runtime.getBackgroundPage(function (a) {
            $(".most_visited_link").remove();
            window.chrome.topSites.get(function (data) { self.SetUp_TopSites(data); });

            var data = a.newTabData;
            if (typeof data == "undefined") {
                return false;
            }
        });
    },

    SetUp_TopSites: function (data) {
        var self = this;

        self.TopSites = data;

        var sitesShown = 0;

        var linksRemovedArray = NewsTab.Helpers.GetLocalStorageItem("Top_Site_Removed_Items");
        if (linksRemovedArray == null) {
            linksRemovedArray = new Array();
        }

        var images = NewsTab.Helpers.GetLocalStorageItem("Top_Site_Items");

        $(".most_visited_container").html("");

        for (var i = 0; i < self.TopSites.length && sitesShown < self.NumberOfVisibleTopSites; i++) {

            var url = new URL(self.TopSites[i].url);
            var hostname = url.hostname.replace("www.", "");
            var domain = "";

            if (url.pathname === "/finance" || url.pathname === "/contacts") {
                domain = url.href.replace("https://", "").replace("http://", "").replace("www.", "");
                hostname = hostname + url.pathname;
            } else {
                domain = url.origin.replace("https://", "").replace("http://", "").replace("www.", "");
            }

            if (images != undefined && images[hostname] != undefined) {
                self.TopSites[i].className = images[hostname].className;
                self.TopSites[i].color = images[hostname].color;
                self.SaveToLocalStorage("Top_Site_Items", hostname, self.TopSites[i].url, self.TopSites[i].className, self.TopSites[i].color);
            } else {
                var predefinedTopSite = $.grep(self.PredefinedTopSites, function (x) { return x.url.replace("https://", "").replace("http://", "").replace("www.", "") === domain });

                if (predefinedTopSite.length) {
                    predefinedTopSite = predefinedTopSite[0];
                    self.TopSites[i].className = predefinedTopSite.className;
                    self.TopSites[i].color = predefinedTopSite.color;
                    self.SaveToLocalStorage("Top_Site_Items", hostname, self.TopSites[i].url, self.TopSites[i].className, self.TopSites[i].color);
                } else {
                    NewsTab.Helpers.GetDominantColors('https://s2.googleusercontent.com/s2/favicons?domain_url=' + self.TopSites[i].url.replace('https:', 'http:') + '&alt=s&sz=16&origUrl=' + self.TopSites[i].url, function (data) {
                        var color = data.dominant;
                        if (color === "rgb()") {
                            color = "#000000";
                        }

                        if (tinycolor(color).isLight()) {
                            var darkColor = $.grep(data.palette, function (x) { return !tinycolor(x).isLight() });
                            if (darkColor.length) {
                                darkColor = darkColor[0];
                            } else {
                                darkColor = NewsTab.Extension.DEFAULT_COLORS[Math.floor(Math.random() * (NewsTab.Extension.DEFAULT_COLORS.length - 1))];
                            }
                            color = darkColor;
                        }

                        var urlParameter = NewsTab.Helpers.GetParameterFromUrl("origUrl", data.image);
                        var url = new URL(urlParameter);
                        var hostname = url.hostname.replace("www.", "");

                        var item = $.grep(self.TopSites, function (x) { return x.url === urlParameter });
                        if (item.length > 0) {
                            item = item[0];
                            self.SaveToLocalStorage("Top_Site_Items", hostname, item.url, null, color);
                        }
                    });
                }
            }

            if (linksRemovedArray.indexOf(self.TopSites[i].url) === -1) {
                var randomColor = NewsTab.Extension.DEFAULT_COLORS[Math.floor(Math.random() * (NewsTab.Extension.DEFAULT_COLORS.length - 1))];

                var html = [];
                html.push('<div id="tile_' + i + '" class="most_visited_link fullImage ' + (self.TopSites[i].className != undefined ? "predefined" : "") + '" style="background-color: ' + (self.TopSites[i].color != undefined ? self.TopSites[i].color : randomColor) + '">');
                html.push('<div class="most_visited_link_inner">');
                html.push('<div class="most_visited_link_remove_wrapper" title="Don\'t show on this page">');
                html.push('<div class="most_visited_link_remove"></div>');
                html.push('</div>');
                html.push('<div class="most_visited_link_letter" style="background-color: ' + (self.TopSites[i].color != undefined ? self.TopSites[i].color : randomColor) + '">');
                html.push('<div class="most_visited_link_letter_body_wrapper">');
                html.push('<div class="most_visited_link_letter_body">');

                if (self.TopSites[i].className != undefined) {
                    html.push('<i class="icon-' + self.TopSites[i].className + '"></i>');
                } else {
                    html.push('<span>' + domain[0] + '</span>');
                }

                html.push('</div>');
                html.push('</div>');
                html.push('</div>');
                html.push('<div class="most_visited_link_title">');
                html.push('<div class="most_visited_link_title_body_wrapper">');
                html.push('<div class="most_visited_link_title_body">');

                if (self.TopSites[i].className != undefined) {
                    html.push('<a class="tile_link" href="' + self.TopSites[i].url + '" title="' + domain + '" rel="nofollow">' + self.TopSites[i].title + '</a>');
                } else {
                    html.push('<a class="tile_link" href="' + self.TopSites[i].url + '" title="' + domain + '" rel="nofollow">' + domain + '</a>');
                }

                html.push('</div>');
                html.push('</div>');
                html.push('</div>');
                html.push('<div class="most_visited_link_main">');
                html.push('<div class="most_visited_link_main_body_wrapper">');
                html.push('<a class="most_visited_link_main_body tile_link" href="' + self.TopSites[i].url + '" title="' + domain + '" rel="nofollow"></a>');
                html.push('</div>');
                html.push('</div>');
                html.push('<img id="favicon_canvas' + i + '" width="16" height="16" class="most_visited_link_favicon" src="https://www.google.com/s2/favicons?domain=' + domain + '" />');
                html.push('</div>');
                html.push('</div>');

                $(".most_visited_container").append(html.join(""));

                self.API_GetTopSiteThumbnail(i, domain);

                sitesShown++;
            }
        }
    },

    SetUp_TopSitesTemplate: function () {
        var self = this;

        switch (self.TopSitesTemplate) {
            case "Compact":
                $("body").removeClass("hide-history").removeClass("modern").removeClass("standardH").addClass("compact");
                break;
            case "Hide":
                $("body").removeClass("compact").removeClass("modern").removeClass("standardH").addClass("hide-history");
                break;
            case "Modern":
                $("body").removeClass("hide-history").removeClass("compact").removeClass("standardH").addClass("modern");
                break;
            default:
                $("body").removeClass("hide-history").removeClass("modern").removeClass("compact").addClass("standardH");
        }
    },

    /* API */
    API_GetTopSiteThumbnail: function (index, domain) {
        var self = this;

        var img = null;
        chrome.storage.local.get("img_" + domain, function (result) {
            img = result[Object.keys(result)[0]];
            if (img === null || img === undefined) {
                $.ajax({
                    url: "https://www.googleapis.com/pagespeedonline/v5/runPagespeed?screenshot=true&url=" + encodeURIComponent(self.TopSites[index].url),
                    type: "GET",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                    success: function (data) {
                        var imgData = data['lighthouseResult']['audits']['final-screenshot']['details']['data'].replace(/_/g, "/").replace(/-/g, "+");
                        var obj = {};
                        obj["img_" + domain] = "url('" + imgData + "')";
                        chrome.storage.local.set(obj, function () { });
                        $("#tile_" + index + " .most_visited_link_main_body.tile_link").css("background-image", "url('" + imgData + "')");
                    }
                });
            }
            else {
                $("#tile_" + index + " .most_visited_link_main_body.tile_link").css("background-image", img);
            }
        });
    }
}