var NewsTab = NewsTab || {};
NewsTab.Extensions = NewsTab.Extensions || {};

NewsTab.Extensions.Common = {
    WeatherRepeatCounter: 0,

    SetUpRateArticleItem: function () {
        $("body").append("<div class=\"rate-overlay\" style=\"display:none;\"><div class=\"rate-holder-top-arrow-1\"></div><div class=\"rate-holder-top-arrow-2\"></div><div class=\"rate-holder\"></div></div>");
        var placeholder = $(".rate-holder");
        placeholder.addClass("rateContent");
        placeholder.addClass("rateContent-1");

        var emojiBad = "<span data-value=\"1\" class=\"rate-icon rate-bad\" title=\"Don't like\"><i class=\"em em-bad\"></i></span>";
        var emojiOk = "<span data-value=\"2\" class=\"rate-icon rate-ok\" title=\"It's OK\"><i class=\"em em-ok\"></i></span>";
        var emojiLove = "<span data-value=\"3\" class=\"rate-icon rate-love\" title=\"Love it\"><i class=\"em em-love\"></i></span>";

        var item = "<div class=\"info info-1\">";
        item += "<span class=\"shortdesc\">";
        item += "<p class=\"shortDescTitle readText\">How do you like " + chrome.runtime.getManifest().name + "?</p>";
        item += "<i class=\"icon icon-close closeArticle\"></i>";
        item += "</span>";
        item += "<div class=\"desc\">";
        item += "<span class=\"readText\">" + emojiBad + emojiOk + emojiLove + "<span class=\"rateHoverMsg\"></span></span>";
        item += "<div class=\"rate-submit-btn\">";
        item += "<button class=\"btn blue submit-rate\">Submit</button>";
        item += "</div>";
        item += "</div>";
        item += "</div>";

        item += "<div class=\"info info-2\">";
        item += "<span class=\"shortdesc\">";
        item += "<p class=\"shortDescTitle readText title-bad\">We're sorry to hear that... &#9785;</p>";
        item += "<p class=\"shortDescTitle readText title-ok\">Hmmm... Thanks for the feedback... &#9786;</p>";
        item += "<i class=\"icon icon-close closeArticle\"></i>";
        item += "</span>";
        item += "<div class=\"desc\">";
        item += "<textarea class=\"message-rate\" placeholder=\"How can we improve?\"></textarea>";
        item += "<input class=\"email-rate\" type=\"email\" placeholder=\"Your email (optional)\" />";
        item += "<div class=\"rate-submit-btn\">";
        item += "<button class=\"btn blue send-rate\" disabled>Send</button>";
        item += "<button class=\"btn blue switch-to-classic-rate\">Hide news (switch to Classic Chrome look)</button>";
        item += "<a class=\"how-to-uninstall-rate\">Show me how to uninstall</a>";
        item += "</div>";
        item += "</div>";
        item += "</div>";

        item += "<div class=\"info info-3\">";
        item += "<span class=\"shortdesc\">";
        item += "<p class=\"shortDescTitle readText\">Sweet!</p>";
        item += "<img src=\"/Media/ExtensionImages/harts.png\" class=\"love-us-img\" />";
        item += "</span>";
        item += "<div class=\"desc\">";
        item += "<span class=\"readText\">Would you mind rating us on the Chrome Store? (it takes seconds and means a lot to us...)</span>";
        item += "<div class=\"rate-submit-btn\">";
        item += "<a class=\"cancel-rate\">No thanks</a>";
        item += "<button class=\"btn blue rate-on-store\">Rate on Chrome Store</button>";
        item += "</div>";
        item += "</div>";
        item += "</div>";

        placeholder.append(item);
        $(".rate-overlay").fadeIn();
        $(".rate-icon").hover(function () {
            $(".rateHoverMsg").html($(this).attr("title"));
        }, function () {
            if ($(".rate-icon.selected").length === 0) {
                $(".rateHoverMsg").html("");
            } else {
                $(".rateHoverMsg").html($(".rate-icon.selected").attr("title"));
            }
        });

        $(".rate-icon").click(function () {
            $(".rate-icon").removeClass("selected");
            $(this).addClass("selected");
            $(this).closest(".desc").find(".rate-submit-btn").css({ "display": "block" });
            $(".rateHoverMsg").html($(this).attr("title"));
            $(".rate-overlay").addClass("noEvent");
        });

        $(".submit-rate").click(function () {
            var value = $(".rate-icon.selected").data("value");

            $(".rateUs-link").addClass("disabled");

            var action = "Love";
            if (value === 1) {
                action = "Don't Like";
                placeholder.find(".info-2").addClass("info-bad");
            } else if (value === 2) {
                action = "OK";
                placeholder.find(".info-2").addClass("info-ok");
            }

            if (value < 3) {
                placeholder.removeClass("rateContent-1").addClass("rateContent-2");
            } else {
                placeholder.removeClass("rateContent-1").removeClass("rateContent-2").addClass("rateContent-3");
            }

            $(".rate-on-store").off("click").on("click", function () {
                NewsTab.TrackAnalyticsEvent("Rate", "Rate on Chrome Store", NewsTab.Extension.NameId);
                var extensionId = window.chrome.runtime.id;
                var storeUrl = "https://chrome.google.com/webstore/detail/" + extensionId + "/reviews";
                open(storeUrl, "_blank");
                $(".rateUs-link").remove();
                $(".rate-overlay").removeClass("noEvent");
                $(".rate-overlay").hide();
            });

            $(".cancel-rate").off("click").on("click", function () {
                $(".rateUs-link").remove();
                $(".rate-overlay").removeClass("noEvent");
                $(".rate-overlay").hide();
            });

            NewsTab.Helpers.SetLocalStorageItem("Show_Rate_Link", false);
            NewsTab.Helpers.SetLocalStorageItem("Show_Rate_Article", false);


            NewsTab.TrackAnalyticsEvent("Rate", action, NewsTab.Extension.NameId);
        });

        $(".message-rate").keyup(function () {
            if ($(this).val().length > 0) {
                $(this).closest(".desc").find("button.blue[disabled]:visible").removeAttr("disabled");
            } else {
                $(this).closest(".desc").find("button.blue:visible").eq(0).attr("disabled", "disabled");
            }
        });

        $(".send-rate").click(function () {
            var rating = $(".rate-icon.selected").data("value");
            NewsTab.Extensions.Common.SendRating($(this), rating);
        });

        if ($("#newtab").hasClass("hideArticles")) {
            $(".switch-to-classic-rate").text("Show news feed");
        } else {
            $(".switch-to-classic-rate").text("Hide news (switch to Classic Chrome look)");
        }

        $(".switch-to-classic-rate").click(function () {
            NewsTab.TrackAnalyticsEvent("Rate", "Hide News", NewsTab.Extension.NameId);
            NewsTab.Extension.ToggleNewsFeed();

            if ($("#newtab").hasClass("hideArticles")) {
                $(".switch-to-classic-rate").text("Show news feed");
            } else {
                $(".switch-to-classic-rate").text("Hide news (switch to Classic Chrome look)");
            }
            $(".rateUs-link").remove();
            $(".rate-overlay").removeClass("noEvent");
            $(".rate-overlay").hide();
        });

        $(".how-to-uninstall-rate").click(function () {
            NewsTab.TrackAnalyticsEvent("Rate", "Show me how to uninstall", NewsTab.Extension.NameId);
            setTimeout(function () {
                $(".rateUs-link").remove();
                $(".rate-overlay").removeClass("noEvent");
                $(".rate-overlay").hide();
                $("#settingsButton").click();
                $(".aboutLink").click();
                $(".aboutDetails .uninstall-instructions span").addClass("blink_me");
            }, 10);
        });

        $(".closeArticle").off("click").on("click", function () {
            if (!$(".rate-overlay .rateContent").hasClass("rateContent-1")) {
                $(".rateUs-link").remove();

            }
            NewsTab.Helpers.SetLocalStorageItem("Show_Rate_Article", false);
            $(".rate-overlay").removeClass("noEvent");
            $(".rate-overlay").fadeOut();
        });

        setTimeout(function () {
            var arrowPosition = $(".rateUs-link").offset().left;
            if (arrowPosition > $(".rate-holder").outerWidth()) {
                arrowPosition = $(".rate-holder").outerWidth() / 2 - $(".todo-link").width() / 2;

                $(".rate-holder-top-arrow-1").css({ "left": arrowPosition + "px" });
                $(".rate-holder-top-arrow-2").css({ "left": arrowPosition + "px" });

                $(".rate-overlay").css({ left: $(".rateUs-link").offset().left - 160 });
            } else {
                $(".rate-holder-top-arrow-1").css({ "left": arrowPosition + 5 + "px" });
                $(".rate-holder-top-arrow-2").css({ "left": arrowPosition + 5 + "px" });
            }
        }, 100);

        return placeholder;
    },

    SetUpTodoList: function () {
        $("body").append("<div class=\"todo-placeholder extension-link-popup\"></div>");
        var placeholder = $(".todo-placeholder");
        window.chrome.storage.sync.get(["TodoList"], function (data) {
            var todoList = data["TodoList"];

            if (todoList == undefined || todoList.length === 0) {
                todoList = [];
            }

            NewsTab.Helpers.SetLocalStorageItem("TodoList", todoList);
            var completedTodo = $.grep(todoList, function (x) { return x.checked; });

            var arrowPosition = $(".todo-link").offset().left - $(".todo-link").width() / 2;
            if (arrowPosition > $(".todo-placeholder").outerWidth()) {
                arrowPosition = $(".todo-placeholder").outerWidth() / 2 - $(".todo-link").width() / 2;
                $(".todo-placeholder").css({ left: $(".todo-link").offset().left - 85 });
            }

            var item = "<div class=\"rate-holder-top-arrow-1\" style=\"left: " + arrowPosition + "px;\"></div>";
            item += "<div class=\"rate-holder-top-arrow-2\" style=\"left: " + arrowPosition + "px;\"></div>";
            item += "<div class=\"content\">";
            item += "<div class=\"todo-count\">";
            item += "<span class=\"todo-count-number\">" + completedTodo.length + "/" + todoList.length + "</span> completed";
            item += "<span class=\"todo-buttons\">";
            item += "<i class=\"icon-markasread check-all\" title=\"Check All\" data-tooltip=\"tooltip\" data-placement=\"top\"></i>";
            item += "<i class=\"icon-trash-o remove-all\"  title=\"Delete All\" data-tooltip=\"tooltip\" data-placement=\"top\"></i>";
            item += "</span>";
            item += "</div>";
            item += "<div class=\"todo-items\">";

            if (todoList.length === 0) {
                $(".todo-placeholder").addClass("empty");
            } else {
                todoList.forEach(function (todoItem) {
                    item += "<div class=\"todo-item\" data-id=\"" + todoItem.id + "\">";
                    item += "<input id=\"todo-item-" + todoItem.id + "\" type=\"checkbox\" " + (todoItem.checked == true ? "checked" : "") + " />";
                    item += "<label for=\"todo-item-" + todoItem.id + "\">" + todoItem.text + "</label>";
                    item += "<i class=\"icon-close remove\"></i>";
                    item += "</div>";
                });
            }
            item += "</div>";

            item += "<div class=\"todo-form\">";
            item += "<input class=\"todo-input\" type=\"text\" placeholder=\"New Todo\" />";
            item += "</div>";
            item += "</div>";

            placeholder.append(item);

            $(".todo-form input").keyup(function (event) {
                if (event.keyCode === 13) {
                    var $self = $(this);
                    var value = $self.val();

                    if (value == "") {
                        return;
                    }

                    var todoList = NewsTab.Helpers.GetLocalStorageItem("TodoList");
                    if (todoList == undefined) {
                        todoList = [];
                    }

                    todoItem = { id: NewsTab.Helpers.Guid(), text: value };
                    todoList.push(todoItem);

                    NewsTab.Helpers.SetLocalStorageItem("TodoList", todoList);
                    NewsTab.Helpers.SetSyncStorage("TodoList", todoList);

                    NewsTab.Extensions.Common.AppendTodoItems(todoItem);
                    var completedTodo = $.grep(todoList, function (x) { return x.checked; });
                    $(".todo-count .todo-count-number").text(completedTodo.length + "/" + todoList.length);
                    $(".todo-placeholder").removeClass("empty");
                    $self.val("");

                    NewsTab.Extensions.Common.TodoEvents();
                }
            });

            NewsTab.Extensions.Common.TodoEvents();

            return placeholder;
        });
    },

    AppendTodoItems: function (todoItem) {
        var item = "<div class=\"todo-item\" data-id=\"" + todoItem.id + "\">";
        item += "<input id=\"todo-item-" + todoItem.id + "\" type=\"checkbox\" />";
        item += "<label for=\"todo-item-" + todoItem.id + "\">" + todoItem.text + "</label>";
        item += "<i class=\"icon-close remove\"></i>";
        item += "</div>";

        $(".todo-items").append(item);

        NewsTab.TrackAnalyticsEvent("Todo", "New Task", NewsTab.Extension.NameId);
    },

    TodoEvents: function () {
        $(".todo-items .todo-item input[type=checkbox]").change(function () {
            $self = $(this);
            var isChecked = $self.is(":checked");
            var todoList = NewsTab.Helpers.GetLocalStorageItem("TodoList");

            var selectedItem = $.grep(todoList, function (x) { return x.id == $self.closest(".todo-item").data("id"); });

            if (selectedItem.length) {
                selectedItem = selectedItem[0];
                selectedItem.checked = isChecked;
                NewsTab.Helpers.SetLocalStorageItem("TodoList", todoList);
                NewsTab.Helpers.SetSyncStorage("TodoList", todoList);
            }

            var completedTodo = $.grep(todoList, function (x) { return x.checked; });
            $(".todo-count .todo-count-number").text(completedTodo.length + "/" + todoList.length);

            if (isChecked) {
                NewsTab.TrackAnalyticsEvent("Todo", "Mark as read", NewsTab.Extension.NameId);
            } else {
                NewsTab.TrackAnalyticsEvent("Todo", "Mark as unread", NewsTab.Extension.NameId);
            }
        });

        $(".todo-items .todo-item .remove").off("click").on("click", function () {
            $self = $(this);
            var todoList = NewsTab.Helpers.GetLocalStorageItem("TodoList");
            var selectedItem = $.grep(todoList, function (x) { return x.id == $self.closest(".todo-item").data("id"); });

            if (selectedItem.length) {
                selectedItem = selectedItem[0];
                NewsTab.Helpers.RemoveItemFromArray(todoList, selectedItem);
                NewsTab.Helpers.SetLocalStorageItem("TodoList", todoList);
                NewsTab.Helpers.SetSyncStorage("TodoList", todoList);

                $(".todo-items").find(".todo-item[data-id=" + selectedItem.id + "]").remove();
            }

            var completedTodo = $.grep(todoList, function (x) { return x.checked; });
            $(".todo-count .todo-count-number").text(completedTodo.length + "/" + todoList.length);

            if (todoList.length === 0) {
                $(".todo-placeholder").addClass("empty");
            }

            NewsTab.TrackAnalyticsEvent("Todo", "Delete", NewsTab.Extension.NameId);
        });

        $(".check-all").off("click").on("click", function () {
            var todoList = NewsTab.Helpers.GetLocalStorageItem("TodoList");
            todoList.forEach(function (item) {
                if (item.checked !== true) {
                    $(".todo-items").find(".todo-item[data-id=" + item.id + "]").find("label").click();
                }
                item.checked = true;
            });
            NewsTab.Helpers.SetLocalStorageItem("TodoList", todoList);
            NewsTab.Helpers.SetSyncStorage("TodoList", todoList);

            var completedTodo = $.grep(todoList, function (x) { return x.checked; });
            $(".todo-count .todo-count-number").text(completedTodo.length + "/" + todoList.length);
        });

        $(".remove-all").off("click").on("click", function () {
            if ($(".todo-confirm-message").length === 0) {
                var todoList = NewsTab.Helpers.GetLocalStorageItem("TodoList");
                var completedTodo = $.grep(todoList, function (x) { return x.checked; });

                $(".todo-count").after("<div class=\"todo-confirm-message\">"
                    + "<span>Permanently delete " + completedTodo.length + "/" + todoList.length + " todo itmes?</span>"
                    + "<span class=\"todo-confirm-btns\">"
                    + "<span class=\"todo-confirm-cancel\">Cancel</span>"
                    + "<span class=\"todo-confirm-delete\">Delete</span></span></div>");

                $(".todo-confirm-delete").off("click").on("click", function () {
                    var todoList = NewsTab.Helpers.GetLocalStorageItem("TodoList");

                    var completedTodo = $.grep(todoList, function (x) { return x.checked; });
                    completedTodo.forEach(function (item) {
                        NewsTab.Helpers.RemoveItemFromArray(todoList, item);
                        $(".todo-items").find(".todo-item[data-id=" + item.id + "]").find("label").remove();
                    });

                    NewsTab.Helpers.SetLocalStorageItem("TodoList", todoList);
                    NewsTab.Helpers.SetSyncStorage("TodoList", todoList);

                    completedTodo = $.grep(todoList, function (x) { return x.checked; });
                    $(".todo-count .todo-count-number").text(completedTodo.length + "/" + todoList.length);
                    $(".todo-confirm-message").remove();

                    if (todoList.length === 0) {
                        $(".todo-placeholder").addClass("empty");
                    }
                });

                $(".todo-confirm-cancel").off("click").on("click", function () {
                    $(".todo-confirm-message").remove();
                });

            }
        });
    },

    SetUpCustomSublinksMenu: function (customLink) {
        $(".custom-link_" + customLink.Order).after("<div class=\"extension-link-popup custom-sublinks custom_sublink_" + customLink.Order + "\" data-order=\"" + customLink.Order + "\" style=\"left: " + ($(".custom-link_" + customLink.Order).position().left + 15) + "px;\"><ul></ul></div>");
        var placeholder = $(".custom-sublinks");
        var html = "";

        customLink.Links.sort(function (a, b) { return a.Order - b.Order; }).forEach(function (link) {
            var mainLink = link.Url;
            var secondLink = null;
            var doublLinks = link.Url.split("#|#");
            if (doublLinks.length === 2) {
                mainLink = doublLinks[0];
                secondLink = doublLinks[1];
            }
            html += "<li>";
            html += "<a " + (secondLink !== null ? "class=\"doubleLink\"" : "") + " href=\"" + mainLink + "\" " + (secondLink !== null ? "data-second-link=\"" + secondLink + "\"" : "") + ">" + link.Name + "</a>";
            html += "<i class=\"icon-more\"></i>";
            html += "</li>";
        });

        if (NewsTab.Extension.Config.CustomLinks[customLink.Order].AddShortcut) {
            html += "<li class=\"add-shortcut-cl\">";
            html += "+ Add shortcut";
            html += "</li>";
        }

        placeholder.find("ul").append(html);

        $(".custom_sublink_" + customLink.Order + " li .icon-more").off("click").on("click", function () {
            $(".icon-more").removeClass("active");
            $(this).addClass("active");

            var openedSubmenu = $(this).closest("li").find(".custom-submenu").length;
            $(".custom-submenu").remove();
            if (openedSubmenu === 0) {
                NewsTab.Extensions.Common.SetUpCustomSublinksSubMenu($(this));
            }
        });

        $(".add-shortcut-cl").off("click").on("click", function () {
            NewsTab.Extensions.Common.AddSubmenuPopup();
        });

        // Analytics tracking
        $(".custom_sublink_" + customLink.Order + " li a").off("click").on("click", function () {
            var menuName = customLink.Name;
            var submenuName = $(this).text();
            NewsTab.TrackAnalyticsEvent("Custom Menu", menuName + ", " + submenuName, NewsTab.Extension.NameId);
        });

        $('.doubleLink').off("click").on("click", function () {
            var secondLink = $(this).data('second-link');
            var t;

            $(window).blur(function () {
                // The browser apparently responded, so stop the timeout.
                clearTimeout(t);
            });

            t = setTimeout(function () {
                window.open(secondLink);
            }, 500);
        });

        return placeholder;
    },

    SetUpCustomSublinksSubMenu: function ($selector) {
        $selector.after("<div class=\"custom-submenu\"><ul></ul></div>");
        var placeholder = $(".custom-submenu");
        var html = "<li><a class=\"custom-submenu-link menucustom-submenu-remove\" data-type=\"0\">Remove</a></li>";
        html += "<li><a class=\"custom-submenu-link custom-submenu-edit\" data-type=\"1\">Edit</a></li>";
        html += "<li><a class=\"custom-submenu-link custom-submenu-move\" data-type=\"2\">Move to top</a></li>";

        placeholder.find("ul").append(html);

        $(".custom-submenu-link").off("click").on("click", function () {
            var $self = $(this);
            var name = $selector.closest("li").find(">a").text();
            var link = $selector.closest("li").find(">a").attr("href");
            var position = $(".custom-sublinks").data("order");

            $(".custom-sublinks").remove();

            switch ($self.data("type")) {
                case 0:
                    NewsTab.Extensions.Common.RemoveSubmenuPopup(name, link, position);
                    break;
                case 1:
                    NewsTab.Extensions.Common.EditSubmenuPopup(name, link, position);
                    break;
                case 2:
                    NewsTab.Extensions.Common.MoveCustomLinkToTop(name, link, position);
                    break;
            }
        });

        return placeholder;
    },

    AddSubmenuPopup: function () {
        var position = $(".custom-sublinks").data("order") != undefined ? $(".custom-sublinks").data("order") : 0;

        $(".custom-sublinks").remove();

        var $form = "<div class=\"newItem\">";
        $form += "<div class=\"inputContainer\">";
        $form += "<label for=\"addNewLink-name\">Name: </label>";
        $form += "<input type=\"text\" class=\"customLink-name\" id=\"addNewLink-name\" />";
        $form += "</div>";
        $form += "<div class=\"inputContainer\">";
        $form += "<label for=\"addNewLink-link\">Link: </label>";
        $form += "<input type=\"text\" class=\"customLink-link\" id=\"addNewLink-link\" />";
        $form += "<div class=\"errorMessage\" style=\"text-align: left; margin-left: 85px;\"></div>";
        $form += "</div>";
        $form += "</div>";

        var $modal = $("<div/>", { "id": "extension-popup", "class": "extension-popup addNewLink" });
        $modal.html($form);

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Title: "<div class=\"title\"><h2>Add Shortcut</h2></div>",
            Width: "100%",
            Height: "auto",
            MaxWidth: "450",
            MaxHeight: "220",
            Text: $modal,
            Buttons: [
                {
                    Name: "Cancel",
                    Action: "Close",
                    Classes: ["cancel", "gray", "float-left"]
                },
                {
                    Name: "Save",
                    Action: function (e, $sender, $modal) {
                        var value = $(".customLink-link", $modal).val().trim();
                        if (value.indexOf("http") === -1 && value.indexOf("ftp") === -1) {
                            value = "http://" + value;
                        }
                        var isValid = NewsTab.Helpers.ValidateURL(value);
                        if (!isValid) {
                            $(".customLink-link", $modal).addClass("error");
                            $(".save", $modal).addClass("disabled");
                            return;
                        } else {
                            $(".customLink-link", $modal).removeClass("error");
                            $(".save", $modal).removeClass("disabled");
                        }

                        window.chrome.storage.sync.get(["CustomLinks"], function (data) {
                            var customLinks = data.CustomLinks[position];
                            var url = $(".customLink-link", $modal).val().trim();
                            if (url.indexOf("http") === -1 && url.indexOf("ftp") === -1) {
                                url = "http://" + url;
                            }

                            var linkExists = $.grep(customLinks.Links, function (x) { return x.Name == $(".customLink-link", $modal).val(); });

                            if (linkExists.length === 0) {
                                $(".errorMessage", $modal).html("");

                                customLinks.Links.push({
                                    Icon: "",
                                    Name: $(".customLink-name", $modal).val(),
                                    Url: url,
                                    Order: customLinks.Links.length
                                });

                                customLinks.Custom = true;
                                NewsTab.Helpers.SetSyncStorage("CustomLinks", data.CustomLinks);

                                NewsTab.Modules.NotificationsManager.Close_Modal($modal);

                                $(".custom-links").remove();
                                $(".custom-sublinks").remove();
                                NewsTab.Modules.TopMenu.AppendCustomLinks(data);
                            } else {
                                $(".errorMessage", $modal).html("Link exists!");
                            }
                        });
                    },
                    Classes: ["blue", "save"]
                }
            ],
            OnShow: function ($modal) {
                $(".customLink-link", $modal).blur(function () {
                    var value = $(this).val().trim();
                    if (value.indexOf("http") === -1 && value.indexOf("ftp") === -1) {
                        value = "http://" + value;
                    }
                    var isValid = NewsTab.Helpers.ValidateURL(value);
                    if (!isValid) {
                        $(".customLink-link", $modal).addClass("error");
                        $(".save", $modal).addClass("disabled");
                        return;
                    } else {
                        $(".customLink-link", $modal).removeClass("error");
                        $(".save", $modal).removeClass("disabled");
                    }
                });

                setTimeout(function () {
                    $(".customLink-name", $modal).focus();
                }, 500);
            }
        });
    },

    RemoveSubmenuPopup: function (name, link, position) {
        var $form = "<div class=\"newItem modular\">";
        $form += "<div class=\"contetnt-wrap\" data-name=\"" + name + "\" data-link=\"" + link + "\" style=\"padding: 10px 15px 25px 15px; font-size: 16px; overflow: hidden; display: inline-block; text-overflow: ellipsis; white-space: nowrap; width: 420px;\">";
        $form += "Are you sure you want to remove " + name + "?";
        $form += "</div>";
        $form += "</div>";

        var $modal = $("<div/>", { "id": "extension-popup", "class": "extension-popup removeLink" });
        $modal.html($form);

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Title: "<div class=\"title\"><h2>Remove " + name + "</h2></div>",
            Width: "100%",
            Height: "auto",
            MaxWidth: "450",
            MaxHeight: "165",
            Text: $modal,
            Buttons: [
                {
                    Name: "Cancel",
                    Action: "Close",
                    Classes: ["cancel", "gray", "float-left"]
                },
                {
                    Name: "Remove",
                    Action: function (e, $sender, $modal) {
                        window.chrome.storage.sync.get(["CustomLinks"], function (data) {
                            var customLinks = data.CustomLinks[position];

                            var currentLink = $.grep(customLinks.Links, function (x) {
                                return x.Name == $(".contetnt-wrap", $modal).data("name") && x.Url == $(".contetnt-wrap", $modal).data("link");
                            });
                            if (currentLink.length) {
                                currentLink = currentLink[0];
                                NewsTab.Helpers.RemoveItemFromArray(customLinks.Links, currentLink);
                            }

                            customLinks.Custom = true;
                            NewsTab.Helpers.SetSyncStorage("CustomLinks", data.CustomLinks);

                            NewsTab.Modules.NotificationsManager.Close_Modal($modal);

                            $(".custom-links").remove();
                            $(".custom-sublinks").remove();
                            NewsTab.Modules.TopMenu.AppendCustomLinks(data);
                        });
                    },
                    Classes: ["red", "remove"]
                }
            ],
            OnShow: function ($modal) {

            }
        });
    },

    EditSubmenuPopup: function (name, link, position) {
        var $form = "<div class=\"newItem modular\">";
        $form += "<div class=\"inputContainer\">";
        $form += "<label for=\"edit-name\">Name: </label>";
        $form += "<input type=\"text\" class=\"customLink-name\" id=\"edit-name\" data-name=\"" + name + "\" value=\"" + name + "\" />";
        $form += "</div>";
        $form += "<div class=\"inputContainer\">";
        $form += "<label for=\"edit-link\">Link: </label>";
        $form += "<input type=\"text\" class=\"customLink-link\" id=\"edit-link\" data-link=\"" + link + "\" value=\"" + link + "\" />";
        $form += "<div class=\"errorMessage\" style=\"text-align: left; margin-left: 85px;\"></div>";
        $form += "</div>";
        $form += "</div>";

        var $modal = $("<div/>", { "id": "extension-popup", "class": "extension-popup editLink" });
        $modal.html($form);

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Title: "<div class=\"title\"><h2>Edit " + name + "</h2></div>",
            Width: "100%",
            Height: "auto",
            MaxWidth: "450",
            MaxHeight: "220",
            Text: $modal,
            Buttons: [
                {
                    Name: "Cancel",
                    Action: "Close",
                    Classes: ["cancel", "gray", "float-left"]
                },
                {
                    Name: "Save",
                    Action: function (e, $sender, $modal) {
                        var value = $(".customLink-link", $modal).val().trim();
                        if (value.indexOf("http") === -1 && value.indexOf("ftp") === -1) {
                            value = "http://" + value;
                        }

                        var isValid = NewsTab.Helpers.ValidateURL(value);
                        if (!isValid) {
                            $(".customLink-link", $modal).addClass("error");
                            $(".save", $modal).addClass("disabled");
                            return;
                        } else {
                            $(".customLink-link", $modal).removeClass("error");
                            $(".save", $modal).removeClass("disabled");
                        }

                        window.chrome.storage.sync.get(["CustomLinks"], function (data) {
                            var customLinks = data.CustomLinks[position];

                            var url = $(".customLink-link", $modal).val().trim();
                            if (url.indexOf("http") === -1 && url.indexOf("ftp") === -1) {
                                url = "http://" + url;
                            }
                            var currentLink = $.grep(customLinks.Links, function (x) {
                                return x.Name === $(".customLink-name", $modal).val()
                                    && x.Url === url;
                            });

                            if (currentLink.length === 0) {
                                $(".errorMessage", $modal).html("");

                                currentLink = $.grep(customLinks.Links, function (x) {
                                    return x.Name == $(".customLink-name", $modal).data("name") && x.Url == $(".customLink-link", $modal).data("link");
                                });
                                if (currentLink.length) {
                                    currentLink = currentLink[0];
                                    currentLink.Name = $(".customLink-name", $modal).val();
                                    currentLink.Url = url;
                                }

                                customLinks.Custom = true;
                                NewsTab.Helpers.SetSyncStorage("CustomLinks", data.CustomLinks);

                                NewsTab.Modules.NotificationsManager.Close_Modal($modal);
                                $(".custom-links").remove();
                                $(".custom-sublinks").remove();
                                NewsTab.Modules.TopMenu.AppendCustomLinks(data);
                            } else {
                                $(".errorMessage", $modal).html("Link exists!");
                            }
                        });
                    },
                    Classes: ["blue", "save"]
                }
            ],
            OnShow: function ($modal) {
                $(".customLink-link", $modal).blur(function () {
                    var value = $(this).val().trim();
                    if (value.indexOf("http") === -1 && value.indexOf("ftp") === -1) {
                        value = "http://" + value;
                    }

                    var isValid = NewsTab.Helpers.ValidateURL(value);
                    if (!isValid) {
                        $(".customLink-link", $modal).addClass("error");
                        $(".save", $modal).addClass("disabled");
                        return;
                    } else {
                        $(".customLink-link", $modal).removeClass("error");
                        $(".save", $modal).removeClass("disabled");
                    }
                });

                setTimeout(function () {
                    $(".customLink-name", $modal).focus();
                }, 500);
            }
        });
    },

    MoveCustomLinkToTop: function (name, link, position) {
        window.chrome.storage.sync.get(["CustomLinks"], function (data) {
            var customLinks = data.CustomLinks[position];

            var currentLink = $.grep(customLinks.Links, function (x) { return x.Name == name && x.Url == link; });
            if (currentLink.length) {
                currentLink = currentLink[0];
                currentLink.Order = 0;
            }

            var pos = 1;
            customLinks.Links.forEach(function (cLink) {
                if (cLink.Name != name && cLink.Url != link) {
                    cLink.Order = pos;
                    pos++;
                }
            });

            customLinks.Links.sort(function (a, b) { return a.Order - b.Order; });
            customLinks.Custom = true;
            NewsTab.Helpers.SetSyncStorage("CustomLinks", data.CustomLinks);

            $(".custom-sublinks").remove();
            $(".custom-links").remove();
            NewsTab.Modules.TopMenu.AppendCustomLinks(data);
        });
    },

    SendRating: function (sender, rating) {
        var installTime = NewsTab.Helpers.GetLocalStorageItem("InstallTime");
        var message = sender.closest(".info-2").find(".message-rate");
        var email = sender.closest(".info-2").find(".email-rate");
        var key = "iCTr8XgE3AYyHmV2UzHL5JlXg0TqZpKkVF5W8ba1J5y3iFNP8dsnxlRYzOUvdk06";
        var appId = 3887;
        var url = "https://doorbell.io/api/applications/" + appId + "/submit";
        var sentiment;

        if (rating === 1) {
            sentiment = "negative";
        } else if (rating === 2) {
            sentiment = "neutral";
        } else {
            sentiment = "positive";
        }

        message.val().length === 0 ? message.addClass("error") : message.removeClass("error");
        if (message.val().length > 0) {
            $.ajax({
                type: "POST",
                url: url,
                data: {
                    message: "Install Time: " + installTime + " - " + message.val(),
                    email: email.val().length > 0 ? email.val() : "support@skyter.com",
                    key: key,
                    sentiment: "negative",
                    tags: "Rate,Extension,Rating: " + sentiment + "," + extensionName,
                    properties: {
                        Application: "Feedback",
                        Rating: rating
                    }
                },
                success: function () {
                    email.val("");
                    message.val("");
                    $(".rate-overlay").removeClass("noEvent");
                    sender.closest(".rate-overlay").hide();
                    $(".rateUs-link").remove();
                }
            });
        }
    },

    SetUpMobileAppPopup: function () {
        var name = NewsTab.Extension.Config.Name;
        if (name === "NewsTab") {
            name = "empty-string";
        }

        $("body").append("<div class=\"mobileApp-placeholder extension-link-popup\"></div>");
        var placeholder = $(".mobileApp-placeholder");
        placeholder.removeClass("sending");

        var item = "<div class=\"rate-holder-top-arrow-1\"></div>";
        item += "<div class=\"rate-holder-top-arrow-2\"></div>";

        item += "<div>";
        item += "<i class=\"icon-close\"></i>";

        item += "<div class=\"mobile-app-content\">";
        item += "<img src=\"/Media/ExtensionImages/icon48.png\" />";
        item += "</div>";

        item += "<div class=\"mobile-app-content\">";
        item += "<span class=\"mobile-app-content-title\">" + (name !== "empty-string" ? name : "") + " NewsTab mobile app</span><br/>";
        item += "<span class=\"mobile-app-content-subtitle\">Send download link to your email and open it on your phone</span>";
        item += "</div>";

        item += "<div class=\"mobile-app-form\">";
        item += "<input type=\"email\" id=\"mobile-app-email\" placeholder=\"Enter your email address\" />";
        item += "<button id=\"mobile-app-email-send\" class=\"btn blue save\">Send</button>";
        item += "<p>Email is not valid</p>";
        item += "</div>";

        item += "<div class=\"mobile-app-content mobile-app-success-message\">";
        item += "<span class=\"mobile-app-success-sent\">Email sent.</span><br/>";
        item += "<span>Please open it on your smartphone to download the app</span>";
        item += "</div>";

        item += "<div class=\"mobile-app-available\">";
        item += "<span>Available for:</span>";
        item += "<div>";
        item += "<i class=\"icon icon-android\"></i>";
        item += "<i class=\"icon icon-apple\"></i>";
        item += "</div>";
        item += "</div>";

        item += "</div>";

        placeholder.append(item);

        setTimeout(function () {
            var arrowPosition = $(".mobileApp-link").offset().left;
            if (arrowPosition > $(".mobileApp-placeholder").outerWidth()) {
                arrowPosition = $(".mobileApp-placeholder").outerWidth() / 2 - $(".mobileApp-link").width() / 2;

                $(".rate-holder-top-arrow-1").css({ "left": arrowPosition + "px" });
                $(".rate-holder-top-arrow-2").css({ "left": arrowPosition + "px" });

                $(".mobileApp-placeholder").css({ left: $(".mobileApp-link").offset().left - 150 });
            } else {
                $(".rate-holder-top-arrow-1").css({ "left": arrowPosition + 25 + "px" });
                $(".rate-holder-top-arrow-2").css({ "left": arrowPosition + 25 + "px" });
            }

            $("#mobile-app-email").focus();
        }, 10);

        $("#mobile-app-email-send").off("click").on("click", function () {
            var $self = $(this);
            var email = $("#mobile-app-email").val();
            var isValid = NewsTab.Helpers.ValidateEmail(email);

            if (isValid) {
                $self.addClass("disabled");
                $(".mobileApp-placeholder").addClass("sending");
                $self.html("<span class=\"spinner\"></span> Sending...");

                var link = NewsTab.EnviromentUrl.indexOf("staging.newstab.com") > -1
                    ? "https://h8826.app.goo.gl/?link=http://staging.newstab.com?ext_id%3D" + NewsTab.Helpers.PadStart(NewsTab.Extension.NId, 6) + "&isi=1200774745&ibi=com.newstab.staging&apn=com.newstab.staging"
                    : "https://y37yw.app.goo.gl/?link=https://www.newstab.com?ext_id%3D" + NewsTab.Helpers.PadStart(NewsTab.Extension.NId, 6) + "&isi=1200774745&ibi=com.newstab&apn=com.newstab";

                NewsTab.Extension.API_SendEmailFromExtension(email, name, encodeURIComponent(link), function () {
                    $(".mobile-app-form").find("p").hide();
                    $(".mobileApp-placeholder").removeClass("sending").addClass("sent");
                    NewsTab.TrackAnalyticsEvent("Mobile App", "Email Sent", NewsTab.Extension.NameId);
                });

            } else {
                $(".mobile-app-form").find("p").show();
            }
        });

        $(".mobileApp-placeholder").find(".icon-close").off("click").on("click", function () {
            $(".mobileApp-placeholder").remove();
        });

        NewsTab.TrackAnalyticsEvent("Mobile App", "Open pop", NewsTab.Extension.NameId);

        return placeholder;
    },

    API_BackgroundImages: function (nid, callback) {
        $.ajax({
            url: NewsTab.ApiUrl_Global + "get/extensionbgimages/" + nid,
            type: "GET",
            success: function (data) {
                if (typeof callback === "function") {
                    callback(data);
                }
            }
        });
    },

    API_AllConfigs: function (callback) {
        $.ajax({
            url: NewsTab.ApiUrl_Global + "get/extensions/",
            type: "GET",
            success: function (data) {
                if (typeof callback === "function") {
                    callback(data);
                }
            }
        });
    },

    Get_BackgroundImages: function (callback) {
        var folder = NewsTab.Extensions.Config.BgCollections.Nature;

        var bgData = [];
        bgData.push(data);
        //NewsTab.Helpers.SetLocalStorageItem("BackgroundImages", data);

        if (typeof callback === "function") {
            callback(data);
        }
        //var nid = NewsTab.Helpers.GetLocalStorageItem("NId");
        //NewsTab.Extensions.Common.API_BackgroundImages(nid, function (data) {
        //    var bgData = [];
        //    bgData.push(data);
        //    NewsTab.Helpers.SetLocalStorageItem("BackgroundImages", data);
        //    if (typeof callback === "function") {
        //        callback(data);
        //    }
        //});
    },

    Get_BgImage: function () {
        var folder = NewsTab.Extensions.Config.BgCollections.Nature;
        var favoritImages = NewsTab.Helpers.GetLocalStorageItem("Bg-Images-Favorites");
        var nextPosition = parseInt(NewsTab.Helpers.GetLocalStorageItem("Bg-Images-Position") != undefined ? NewsTab.Helpers.GetLocalStorageItem("Bg-Images-Position") : -1) + 1;

        if (nextPosition >= folder.Count) nextPosition = 0;
        var nextImage = "bg-" + nextPosition + ".jpg";

        if (NewsTab.Helpers.GetLocalStorageItem("Bg-Images-Shuffle-All") == true) {
            nextPosition = Math.floor(Math.random() * folder.Count) + 1;
            nextImage = "bg-" + nextPosition + ".jpg";
        }

        if (favoritImages != undefined && favoritImages.length > 0 && NewsTab.Helpers.GetLocalStorageItem("Bg-Images-Shuffle-Favorite") === true) {
            nextPosition = Math.floor(Math.random() * favoritImages.length);
            nextImage = favoritImages[nextPosition];
        }

        NewsTab.Helpers.SetLocalStorageItem("Bg-Images-Position", nextPosition);
        $("#newtab").attr("bg-name", nextImage);
        return folder.Path + nextImage;

    }
};

chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {
    if (msg.command) {
        if (msg.command === "update_weather") {
            if (msg.type === "full_update") {
                NewsTab.Modules.TimeAndWeatherWidget.API_GetWeatherDetailsByCity(function (data) {
                    NewsTab.Modules.TimeAndWeatherWidget.SetUp_TimeWeatherWidget();
                });
            } else {
                NewsTab.Modules.TimeAndWeatherWidget.SetUp_TimeWeatherWidget();
            }
        } else if (msg.command === "update_sport_data") {
            NewsTab.Modules.SportWidget.SetUp_SportWidgetPlaceholder();
        }
    }
});