﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.AccountManager = {
    /// <field name='ExternalLogins' type='Array'>External logins to be used for SignIn.</field>  
    ExternalLogins: [],

    Init: function () {
        /// <summary>
        /// Initialize AccountManager. This Calls the API_GetExternalLogin in case that the ExternalLogins Array is empty
        /// </summary>
        var self = this;
        if (self.ExternalLogins.length === 0) {
            self.API_GetExternalLogin();
        }
    },

    _$cookieModal: function () {
        var $modal = $("<div/>");

        var html = [];

        html.push('<h3>Accept Terms to continue</h3>');
        html.push('<div class="verical15"></div>');
        html.push('<p>By using NewsTab, you accept our use of cookis, <a href="' + NewsTab.EnviromentUrl + '/home/privacy">Privacy Policy</a> and <a href="' + NewsTab.EnviromentUrl + '/home/terms">Terms</a>.</p>');

        return $modal.html(html.join(""));
    },

    WebOnlyInit: function () {
        var self = this;

        $(".signin-form-btn").on("click", function () {
            var $btn = $(this);

            var match = document.cookie.match(new RegExp('(^| ).AspNet.Consent=([^;]+)'));
            if (match && match[2] === "yes") {
                var $form = $btn.closest("form");

                if ($btn.hasClass("externalLogin")) {
                    var tempElement = $("<input type='hidden'/>");
                    tempElement.attr("name", "provider").val($btn.val()).appendTo($form);

                    $form.submit();
                    tempElement.remove();
                }
                else {
                    $form.submit();
                }
            }
            else {
                NewsTab.Modules.NotificationsManager.Open_Modal({
                    Id: "cookieAcceptModal",
                    ShowTitle: false,
                    HeaderType: 1,
                    Height: "auto",
                    MaxHeight: "100vh",
                    Text: self._$cookieModal(),
                    FullscreenOption: false,
                    Buttons: [{ Name: "Close", Classes: ["btn gray closeNotification float-left"] }, { Name: "Accept", Classes: ["btn blue accept float-right"] }],
                    OnShow: function ($modal) {
                        $(".accept", $modal).on("click", function () {
                            document.cookie = $("#cookie-consent button").data("cookie-string");

                            var $form = $btn.closest("form");

                            if ($btn.hasClass("externalLogin")) {
                                var tempElement = $("<input type='hidden'/>");
                                tempElement.attr("name", "provider").val($btn.val()).appendTo($form);

                                $form.submit();
                                tempElement.remove();
                            }
                            else {
                                $form.submit();
                            }
                        });
                    }
                });
            }
        });
    },

    _$signInModal: function () {
        /// <summary>
        /// Creates and returns a new SignIn Modal DOM Element
        /// </summary>
        /// <returns type="Element"></returns>
        var $modal = $("<div/>");

        var html = [];

        html.push('<img src="' + window.chrome.extension.getURL('/Media/ExtensionImages/penguin-signin.png') + '"/>');
        html.push('<h3>Sign in to continue</h3>');

        for (var i = 0; i < this.ExternalLogins.length; i++) {
            if (this.ExternalLogins[i].Name === "Twitter") {
                continue;
            }

            html.push('<a data-provider="' + this.ExternalLogins[i].Name + '" href="' + NewsTab.ApiUrl_Base + this.ExternalLogins[i].Url.replace("api/", "") + '" class="btn signin externalLogin clickable ' + this.ExternalLogins[i].Name.toLowerCase() + '">');
            if (this.ExternalLogins[i].Name === "Google") {
                html.push('<i class="icon icon-google"></i>');
                html.push('<span>Sign in with ' + this.ExternalLogins[i].Name + '</span>');
            }
            else {
                html.push('<i class="icon icon-' + this.ExternalLogins[i].Name.toLowerCase() + '"></i>');
                html.push('<span>Sign in with ' + this.ExternalLogins[i].Name + '</span>');
            }
            html.push('</a>');
        }

        html.push('<div class="separator"><p>Or with your email account</p></div>');
        html.push('<input type="text" id="userEmail" placeholder="Email" class="clearable" />');
        html.push('<input type="password" id="userPassword" placeholder="Password" class="clearable" />');
        html.push('<div class="verical1"></div>');
        html.push('<div class="errorMessage">');
        html.push('<span>You are using incorrect user name or password.<br/>Please verify your credentials and try again.</span>');
        html.push('<div class="verical15"></div>');
        html.push('</div>');
        html.push('<a href="#" class="btn blue signin signin-email"><span>Sign in with your email</span></a>');
        html.push('<div class="extraLinks"><a class="clickable forgotPassword" href="#" data-url="' + NewsTab.EnviromentUrl + '/landingpage/forgotpassword">Forgot Password</a>');
        html.push('<a class="clickable createAnAccount" href="#" data-url="' + NewsTab.EnviromentUrl + '/landingpage/signup">Create an account</a>');
        html.push('<label>By using NewsTab I agree to the <a class="clickable" href="#" data-url="' + NewsTab.EnviromentUrl + '/home/terms">Terms</a> and <a class="clickable" href="#" data-url="' + NewsTab.EnviromentUrl + '/home/privacy">Privacy Policy</a></label></div>');

        $modal.html(html.join(""));

        $(".externalLogin", $modal).on("click", function (e) {
            NewsTab.TrackAnalyticsEvent("Extension SignIn", $(this).data("provider"), NewsTab.Extension.NameId);
            $(this).addClass("disabled");
        });

        $(".signin-email", $modal).on("click", function () {
            NewsTab.TrackAnalyticsEvent("Extension SignIn", "Email", NewsTab.Extension.NameId);
            NewsTab.Modules.AccountManager.API_SignInWithEmail();
        });
        return $modal;
    },

    _$userDataLoading: function () {
        var $modal = $("<div/>", { "class": "text-center" });

        var html = [];

        html.push('<br />');
        html.push('<img src="/Media/Images/LoadingGiff.gif" alt="Loading User Data..." />');
        html.push('<h3>Loading User Data...</h3>');

        $modal.html(html.join(""));

        return $modal;
    },

    _$signInSuccessMessage: function (synced) {
        var $modal = $("<div/>", { "class": "text-center" });

        var html = [];
        html.push('<br />');
        html.push('<br />');
        html.push('<img src="/Media/ExtensionImages/penguin-signin.png" width="128" height="128" />');


        if (synced) {
            html.push('<br /><br /><p><span class="icon-check blue"></span> Successfully signed in</p>');
        } else {
            html.push('<h2>Welcome <span>' + NewsTab.User.FullName + '</span></h2>');
            html.push('<p><span class=\"spinner blue\"></span> Preparing your account:<br /><span id="syncInfo"></span><br /><br /></p>');
        }

        $modal.html(html.join(""));
        return $modal;
    },

    _$signUpSuccessMessage: function () {
        var $modal = $("<div/>", { "class": "text-center" });

        var html = [];
        html.push('<br />');
        html.push('<br />');
        html.push('<img src="/Media/ExtensionImages/penguin-signin.png" width="128" height="128" />');
        html.push('<h2>Hello <span>' + NewsTab.User.FullName + '</span></h2>');
        html.push('<p>Welcome to NewsTab - a single place to read and share the news you care about from the publishers you love.</p>');
        html.push('<br />');
        html.push('<hr />');
        html.push('<br />');
        html.push('<p><b>Please confirm or modify your preferred region.</b></p>');

        html.push('<div class="regionBox">');
        html.push('<span class="editionDropdown">');
        html.push('<select id="selectedRegionSignUp" name="selectedRegionSignUp"></select>');
        html.push('</span>');
        html.push('</div>');
        html.push('<br />');
        html.push('<br />');
        html.push('<p>We automatically identified your region as indicated above.<br />');
        html.push('Your region settings will influence the default content we suggest.<br />');
        html.push('You may always change this later from the settings menu.</p>');
        html.push('<br />');

        $modal.html(html.join(""));

        return $modal;
    },

    OpenSignInModal: function (retry) {
        /// <summary>
        /// Open the SignIn Modal
        /// </summary>
        /// <param name="retry" type="Boolean">In case of missing ExternalLogins, try to get them and retry opening the Sign in Modal. Default: true</param>
        var self = this;
        if (retry === undefined) {
            retry = true;
        }

        if (self.ExternalLogins.length === 0) {
            if (retry === true) {
                self.API_GetExternalLogin(function () {
                    self.OpenSignInModal(false);
                });
                return false;
            }
        }

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Id: "signInModal",
            Title: "NewsTab - My smart newsreader",
            HeaderType: 1,
            Height: "auto",
            MaxHeight: "100vh",
            Text: self._$signInModal(),
            FullscreenOption: false,
            Buttons: []
        });
    },

    OpenSignInSuccessfull: function (isReTry) {
        var self = this;

        if (NewsTab.User.Id !== "0") {
            if (isReTry === true) {
                NewsTab.Modules.NotificationsManager.Close_Modal($("#signInLoadUserData"));
            }

            if (NewsTab.User.FtsDone === true) {
                var buttons = [];
                var synced = (NewsTab.User.SyncedExtensionNIds && NewsTab.User.SyncedExtensionNIds.indexOf(NewsTab.Extension.NId) > -1);
                if (synced) {
                    buttons.push({
                        Name: "Continue",
                        Action: "Close",
                        Classes: ["btn", "blue", "center"]
                    });
                }

                NewsTab.Modules.NotificationsManager.Open_Modal({
                    Id: "signInNotif",
                    ShowTitle: false,
                    Height: "auto",
                    MaxHeight: "100vh",
                    Text: self._$signInSuccessMessage(synced),
                    Buttons: buttons,
                    CenterButtons: true,
                    OnClose: function () {
                        NewsTab.Extension.LogedIn = true;
                        NewsTab.Helpers.SetLocalStorageItem("LogedIn", NewsTab.Extension.LogedIn);
                    },
                    OnShow: function () {
                        if (!synced) {
                            NewsTab.Modules.SectionsManager.API_AddExtensonSectionsToUser({
                                SuccessCallback: function (section) {
                                    $("#syncInfo").html("Done!");
                                    localStorage.removeItem("UserData");
                                    window.location.reload(true);
                                }
                            });
                        }
                    }
                });
            } else {
                NewsTab.Modules.NotificationsManager.Open_Modal({
                    Id: "signInNotif",
                    ShowTitle: false,
                    Height: "auto",
                    MinHeight: "500px",
                    MaxHeight: "100vh",
                    Text: self._$signUpSuccessMessage(),
                    Buttons: [{
                        Name: "Ok",
                        Action: function (e, $sender, $modal) {
                            $(".notificationBody div.text-center", $modal).append('<p><span class=\"spinner blue\"></span> Preparing your account: <br /><br /><span id="syncInfo"></span><br /></p>');
                            $modal.addClass("disabled");
                            $(".save", $modal).html("<i class=\"icon\"><span class=\"spinner\"></span></i>");

                            var name = $(".regionBox", $modal).find(".selectboxit-option.selectboxit-selected").data("val");
                            var code = $(".regionBox", $modal).find(".selectboxit-option.selectboxit-selected").data("countrycode");
                            var gnCode = $(".regionBox", $modal).find(".selectboxit-option.selectboxit-selected").data("googlenewscode");

                            NewsTab.Modules.RegionManager.MainEdition = code;
                            NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.AddFeedEdition;
                            NewsTab.Modules.RegionManager.MainEditionGnValue = gnCode !== "" ? gnCode : "US";
                            NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;

                            var settings = {
                                CountryCode: code,
                                Sections: []
                            };

                            $.ajax({
                                type: "POST",
                                url: NewsTab.ApiUrl_Global + "post/initialdata",
                                headers: { Authorization: "Bearer " + NewsTab.Token },
                                contentType: "application/json; charset=utf-8",
                                data: JSON.stringify(settings)
                            }).done(function (data) {
                                if (data === true) {
                                    localStorage.removeItem("UserData");

                                    NewsTab.Modules.SectionsManager.API_AddExtensonSectionsToUser({
                                        SuccessCallback: function (section) {
                                            window.location.reload(true);
                                        }
                                    });
                                } else {
                                    $modal.removeClass("disabled");
                                    $(".save", $modal).html("Ok");
                                }
                            }).fail(function (request, textStatus) {
                                $modal.removeClass("disabled");
                                $(".save", $modal).html("Ok");
                            });
                        },
                        Classes: ["blue", "save"]
                    }],
                    OnShow: function ($modal) {
                        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#selectedRegionSignUp"), false, NewsTab.Extension.Get_RegionCode());
                        $("#selectedRegionSignUp").on("change", function (e) {
                            $modal.addClass("disabled");
                            $(".save", $modal).html("<i class=\"icon\"><span class=\"spinner\"></span></i>");

                            var code = $(this).closest(".regionBox").find(".selectboxit-option.selectboxit-focus").attr("data-countrycode");

                            NewsTab.Modules.SectionsManager.API_GetFeedsByRegion(code, function () {
                                $modal.removeClass("disabled");
                                $(".save", $modal).html("Ok");
                            });
                        });
                    }
                });
            }
        }
        else {
            if (isReTry === true) {
                setTimeout(function () {
                    self.OpenSignInSuccessfull(true);
                }, 100);
            } else {
                NewsTab.Modules.NotificationsManager.Open_Modal({
                    Id: "signInLoadUserData",
                    ShowTitle: false,
                    Width: "350px",
                    Height: "auto",
                    MaxHeight: "100vh",
                    Text: self._$userDataLoading(),
                    Buttons: [],
                    OnShow: function ($modal) {
                        setTimeout(function () {
                            self.OpenSignInSuccessfull(true);
                        }, 100);
                    }
                });
            }
        }

    },

    OpenDeleteAccountModal: function () {
        var html = [];
        html.push('<div class="text-center"><h3>Warning!</h3>');
        html.push('<p>Deleting your NewsTab account will cause a loss of all your current data including your pinned stories and the list of topics and feeds you follow. Are you sure you want to delete your account?</p></div>');

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Title: "<div class=\"title\"><h2>Delete Your Account?</h2></div>",
            Width: "100%",
            Height: "auto",
            MaxWidth: "450",
            MaxHeight: "165",
            IsTopModal: true,
            Text: $(html.join("")),
            Buttons: [
                {
                    Name: "Cancel",
                    Action: "Close",
                    Classes: ["cancel", "blue", "float-left"]
                },
                {
                    Name: "Delete",
                    Action: function (e, $sender, $modal) {
                        $modal.addClass("disabled");
                        $(".delete", $modal).html("<span class=\"spinner\"></span>");
                        SocialTab.DeleteUserAccount();
                    },
                    Classes: ["red"]
                }
            ]
        });
    },

    API_GetExternalLogin: function (callback) {
        /// <summary>
        /// Get the external logins from the API
        /// </summary>
        /// <param name="callback" type="Function">Function to call on ajax success & fail</param>
        $.ajax({
            type: "GET",
            url: NewsTab.ApiUrl_Base + "auth/externallogins?returnUrl=" + encodeURIComponent(NewsTab.ApiUrl_Base + "auth/externallogincallback?signIn=true&redirectUrl=newtab") + "&generateState=true",
            dataType: "json",
            cache: true,
            error: function (error) {
                console.error("API_GetExternalLogin", error);
            },
            success: function (response) {
                if (Array.isArray(response)) {
                    NewsTab.Modules.AccountManager.ExternalLogins = response;
                }
            },
            complete: function () {
                if (callback) {
                    callback();
                }
            }
        });
    },

    API_SignInWithEmail: function () {
        var email = $("#userEmail").val();
        var pass = $("#userPassword").val();
        var options = {
            trigger: "manual",
            placement: "right",
            template: "<div class=\"tooltip error\" role=\"tooltip\"><div class=\"tooltip-arrow\"></div><div class=\"tooltip-inner\"></div></div>"
        };
        $("#userEmail").attr("title", "");
        $("#userPassword").attr("title", "");

        if (NewsTab.Helpers.ValidateEmail(email)) {
            $("#userEmail").tooltip("hide");
            if (pass.length > 7) {
                $("#signInModal").addClass("disabled");
                $("#userPassword").tooltip("hide");
                $("#signInModal .signin-email").find("span").after("<i class=\"icon\"><span class=\"spinner\"></span></i>");

                var loginData = {
                    grant_type: 'password',
                    username: unescape(encodeURIComponent(email)),
                    password: unescape(encodeURIComponent(pass))
                };
                $.ajax({
                    type: 'POST',
                    headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                    url: NewsTab.ApiUrl_Base + 'token',
                    data: loginData
                }).done(function (data, textStatus, request) {
                    if (NewsTab.IsExtension) {
                        NewsTab.Helpers.SetLocalStorageItem("TokenKey", data.access_token);

                        window.location.reload();
                    }
                    //window.location = NewsTab.EnviromentUrl + "Dashboard?TokenKey=" + data.access_token + "&RedirectUrl=newtab";
                }).fail(function (request, textStatus, errorThrown) {
                    var response = request.responseJSON;
                    if (response && response.error_description) {
                        $(".input-wrapper").tooltip("destroy");
                        $(".input-wrapper").attr("title", response.error_description);
                        $(".input-wrapper").tooltip(options);
                        $(".input-wrapper").tooltip("show");
                    }
                    console.error(textStatus);
                    console.error(errorThrown);
                    $("#signInModal").removeClass("disabled");
                    $("#signInModal .spinner").closest("i.icon").remove();
                });
            } else {
                $("#userPassword").attr("title", "Password must consist of at least 8 characters!");
                $("#userPassword").tooltip(options);
                $("#userPassword").tooltip("show");
            }
        } else {
            $("#userEmail").attr("title", "Please use a valid email!");
            $("#userEmail").tooltip(options);
            $("#userEmail").tooltip("show");
        }
    }
};