﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.AddNewContent = {


    $NewContentModal: null,

    SelectedPublishers: [],
    SelectedTopics: [],

    GoogleNewsAlertType: "",
    GoogleNewsAlertTitle: "",
    GoogleNewsAlertUrl: "",

    //Organizer
    SelectedSectionInOrganizer: null,
    DragedSectionInOrganizer: null,
    PlaceAtSectionInOrganizer: null,
    DragedFeedInOrganizer: null,
    PlaceAtFeedInOrganizer: null,

    ActiveTab: "#tabSections",
    ActiveSecondTab: null,
    AdditionalAction: null,

    // SearchResultPager
    Page: 0,
    ItemsPerPage: 10,
    SearchUrl: null,
    SearchType: null,
    SearchEventComplete: true,
    SearchDataAvailible: true,

    AutocompleteSearchType: null,
    PublisherSearchType: null,
    TopicSearchType: null,

    BackLevel: 0,

    // Preview
    LastPreviewSelector: null,

    Init: function () {
        var self = this;

        $(document).ready(function () {
            self.DocumentReadyInit();
        });
    },

    DocumentReadyInit: function () {
        var self = this;

        self.Validation_GoogleNewsForm();

        // GLOBAL EVENTS
        // Open AddNewContent Form
        $(document.body).on("click", ".addContentItem", function (e) {
            if (NewsTab.Token) {
                if (NewsTab.IsExtension && $(this).parent().hasClass("subAddMenu")) {
                    NewsTab.TrackAnalyticsEvent("Add feed", $(this).data("tab-param") === "tabPublishers" ? "News Source" : "News Topic", NewsTab.Extension.NameId);
                }
                self.Open_AddNewContent($(this).data("tab-select"), $(this).data("tab-param"));
            }
            else {
                if (NewsTab.IsExtension && $(this).parent().hasClass("subAddMenu")) {
                    NewsTab.TrackAnalyticsEvent("Add feed", "Sign In - " + $(this).data("tab-param") === "tabPublishers" ? "News Source" : "News Topic", NewsTab.Extension.NameId);
                }
                NewsTab.Modules.AccountManager.OpenSignInModal();
            }
        });

        var res;

        $(window).on('resize.addnewcontent', function () {
            if (res) { clearTimeout(res) };
            res = setTimeout(function () {
                self.Calculate_FeedPrevirew_ItemSize();
            }, 100);
        });
    },

    // DOM Elements
    $_FeedsSearchHeader: function () {
        var $searchHeader = $("<header>", {
            "id": "searchHeader"
        });

        var html = [];
        html.push('<div class="autocomplete urlContainer uk-autocomplete uk-form" id="autocomplete">');
        html.push('<div id="backToPopularBtn" class="backPopularBtn" tabindex="1008">');
        html.push('<img src="' + NewsTab.EnviromentUrl + '/Media/Images/back-icon.png" /><span>Back</span>');
        html.push('</div>');
        html.push('<div id="backToUsBtn" class="backPopularBtn" tabindex="1008">');
        html.push('<img src="' + NewsTab.EnviromentUrl + '/Media/Images/back-icon.png" /><span>Back</span>');
        html.push('</div>');
        html.push('<input class="clearable" id="feedSearchInput" type="text" placeholder="Search publisher (e.g. “cnn”), domain (e.g. “cnn.com”), topic (e.g. “sports”) or RSS URL (e.g. “http://rss.cnn.com/rss”)" tabindex="1009" />');
        html.push('<a id="feedSearchButton" href="#" class="disabled"><i class="icon-search icon-2x"></i></a>');
        html.push('<span class="searchLoader"><i class="icon"><span class="spinner"></span></i></span>');
        html.push('</div>');

        $searchHeader.html(html.join(""));

        $searchHeader.on("click", "#feedSearchButton", function (e) {
            SocialTab.HTML_Event_SearchFeedsClick($(this), e);
        });

        $searchHeader.on("keyup paste", "#feedSearchInput", function (e) {
            SocialTab.HTML_Event_SearchFeedsClick($(this), e);
        });

        return $searchHeader;
    },

    // START - Tabs
    $_FeedsCustomContent: function () {
        var self = this;

        var $tab = $("<div/>", {
            "id": "contentCustom",
            "role": "tabpanel",
            "class": "feedsPanel tab-pane"
        });

        var html = [];
        html.push('<div class="main">');
        html.push('<div class="rssInstructions open">');
        html.push('<a class="rssInstructionsLink iaru selected" tabindex="1010" data-tab-id="contentFeedMain">');
        html.push('<i class="icon-rss icon-2x" style="width: 70px; text-align: center;"></i> Import any RSS URL');
        html.push('</a>');
        html.push('<a class="rssInstructionsLink crf" tabindex="1011" data-tab-id="gnKwdForm">');
        html.push('<i class="icon-search icon-2x" style="width: 70px; text-align: center;"></i> Create Google Alert');
        html.push('</a>');
        html.push('<a class="rssInstructionsLink clf" tabindex="1012" data-tab-id="gnLctForm">');
        html.push('<i class="icon-map-marker icon-2x" style="width: 70px; text-align: center;"></i> Create Location Feed');
        html.push('</a>');
        html.push('<a class="rssInstructionsLink iof" tabindex="1013" data-tab-id="contentImportOPML">');
        html.push('<i class="icon-cloud-upload icon-2x" style="width: 70px; text-align: center;"></i> Import OPML File');
        html.push('</a>');
        html.push('<a class="rssInstructionsLink eof" tabindex="1014" data-tab-id="contentExportOPML">');
        html.push('<i class="icon-cloud-download icon-2x" style="width: 70px; text-align: center;"></i> Export OPML File');
        html.push('</a>');
        html.push('</div>');
        html.push('<div class="contentFeedResults close"></div>');

        html.push('<ul class="searchResults"></ul>');
        html.push('</div>');

        $tab.html(html.join(""));

        $(".rssInstructionsLink", $tab).on("click", function (e) {
            self.Setup_Custom($(this).data("tab-id"));
        });

        return $tab;
    },

    $_FeedsTwitterContent: function () {
        var $tab = $("<div/>", {
            "id": "contentTwitterFeed",
            "role": "tabpanel",
            "class": "feedsPanel tab-pane"
        });

        var html = [];

        html.push('<div class="table">');
        html.push('<div class="content">');
        html.push('<div class="twitterFeedForm"><span class="icon-twitter"></span></div>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div id="addTwitterFeedBtnField">');
        html.push('<a class="btn btn-back" tabindex="1200">Cancel</a>');
        html.push('<a class="btn addTwitterFeed btn-primary" tabindex="1201">Apply</a>');
        html.push('</div>');

        $tab.html(html.join(""));

        $(".btn-back", $tab).on("click", function (e) {
            SocialTab.CancelTwitterFilter();
        });

        $(".addTwitterFeed", $tab).on("click", function (e) {
            var selectedTags = $("li.selected", "#contentTwitterFeed .searchTagResult");
            if (selectedTags.length > 0) {
                for (var i = 0, l = selectedTags.length; i < l; i++) {
                    var type = selectedTags.eq(i).attr("data-type");
                    var value = selectedTags.eq(i).attr("data-value");
                    if (type === "hashtag") {
                        NewsTab.Modules.SectionsManager.API_AddTwitterFeed("#" + value, i + 1 === l ? true : false);
                    }
                    else {
                        NewsTab.Modules.SectionsManager.API_AddTwitterFeed("@" + value, i + 1 === l ? true : false);
                    }
                    selectedTags.addClass("disabled");
                    selectedTags.removeClass("selected");
                }
                $(".searchTagResult").height($(".searchTagResult").height() + 50);
                $("#addTwitterFeedBtnField").hide();
            }
            else {
                $("#contentTwitterFeed .addTwitterFeed").addClass("disabled");
            }
        });

        return $tab;
    },

    $_FeedsOrganizeContent: function () {
        var self = this;

        var $tab = $("<div/>", {
            "id": "organizerSectionFeeds",
            "role": "tabpanel",
            "class": "feedsPanel tab-pane"
        });

        var html = [];

        html.push('<ul class="sectionManager gridList">');
        html.push('<li class="newItem item">');
        html.push('<img src="' + NewsTab.PlaceholderImage + '"/>');
        html.push('<div class="flipItem">');
        html.push('<figure class="front" tabindex="1010"><i class="icon icon-add"></i><h3>Create New Section</h3></figure>');
        html.push('<figure class="back">');
        html.push('<div class="inputContainer">');
        html.push('<input type="text" class="newSectionName autoclear clearable" placeholder="Section Name" value="" tabindex="1011" />');
        html.push('<span class="iconPreview"></span>');
        html.push('</div>');
        html.push('<ul class="colors"></ul>');
        html.push('<div class="btnContainer">');
        html.push('<a class="btn cancel" tabindex="1023">Cancel</a>');
        html.push('<a class="btn save blue add disabled" tabindex="1024">Create</a>');
        html.push('</div>');
        html.push('</figure>');
        html.push('</div>');
        html.push('</li>');
        html.push('</ul>');
        html.push('<div class="feedManager"><div class="selectedSection"></div><ul class="feeds"></ul></div>');

        $tab.html(html.join(""));

        NewsTab.Setup_SectionColors($(".newItem", $tab), NewsTab.DEFAULT_COLOR);

        $tab.on("click", ".front", function (e) {
            SocialTab.HTML_Event_FlipNewSectionClick($(this), "flip");
        });

        $tab.on("keyup paste", ".newSectionName", function (e) {
            SocialTab.HTML_Event_SectionName_KeyUp($(this));
        });

        $tab.on("click", ".cancel", function (e) {
            SocialTab.HTML_Event_FlipNewSectionClick($(this));
        });

        $tab.on("click", ".add", function (e) {
            SocialTab.HTML_Event_SaveSectionClick($(this), true);
        });

        return $tab;
    },
    // END - Tabs



    // HTML of Section Items
    $_CreateSectionItem: function (section, connected, tabIndex) {
        var self = this;

        var $item = $("<li/>", {
            "data-section-id": section.Id,
            "class": "item " + (connected ? "connected" : ""),
            "tabindex": tabIndex
        });

        var html = [];
        html.push('<img src="/Media/Images/scratch_back.png"  style="background-color:' + section.Color + '"/>');
        html.push("<div><div><i class=\"icon-statusIcon\"></i>");
        if (section.ClassName) {
            html.push("<i class=\"iconName icon-" + section.ClassName + "\"></i>");
        } else {
            html.push("<span class=\"iconName\">" + section.Name.substring(0, 2) + "</span>");
        }
        html.push("<h3><span class=\"name\">" + section.Name + "</span></h3>");
        html.push("</div></div>");

        $item.html(html.join(""));

        $item.on("click", function () {
            if (connected) {
                SocialTab.UnCheckSection(section.Id);
            } else {
                SocialTab.CheckSection(section.Id);
            }
        });
        return $item;
    },

    $_CreateSocialSectionItem: function (section, connected, tabIndex) {
        var self = this;

        var $item = $("<li/>", {
            "data-section-id": section.Id,
            "class": "item " + (connected ? "connected" : "") + " " + section.ClassName + " socialNetworks",
            "tabindex": tabIndex
        });;
        $item.on("click", function () {
            SocialTab.AddTwitter();
        });

        var html = [];
        html.push('<img src="/Media/Images/scratch_back.png"  style="background-color:' + section.Color + '"/>');
        html.push("<div><i class=\"icon-statusIcon\"></i>");

        if (section.ClassName) {
            html.push("<i class=\"iconName icon-" + section.ClassName + "\"></i>");
        } else {
            html.push("<span class=\"iconName\">" + section.Name.substring(0, 2) + "</span>");
        }

        html.push("<h3><span class=\"name\">" + section.Name + "</span></h3></div>");
        $item.html(html.join(""));

        return $item;
    },

    $_CreateSectionItemCopyMove: function (section, action, tabIndex) {
        var $item = $("<li/>", {
            "data-section-id": section.Id,
            "class": "item",
            "style": "background-color:" + section.Color
        });
        $item.on("click", function (e) {
            e.stopPropagation();
            if (action === "COPY" || action === "COPY_ALL") {
                $item.toggleClass("selected");
            }
            else {
                if ($item.hasClass("selected")) {
                    $item.removeClass("selected");
                }
                else {
                    $("li", $item.parent()).removeClass("selected");
                    $item.addClass("selected");
                }
            }

            if ($("li.selected", $item.parent()).length === 0) {
                $item.closest(".copyMoveModal").find(".save").addClass("disabled");
            }
            else {
                $item.closest(".copyMoveModal").find(".save").removeClass("disabled");
            }
        });

        var html = [];
        html.push("<div><i class=\"icon-statusIcon\"></i>");
        if (section.ClassName) {
            html.push("<i class=\"iconName icon-" + section.ClassName + "\"></i>");
        } else {
            html.push("<span class=\"iconName\">" + section.Name.substring(0, 2) + "</span>");
        }
        html.push("<h3><span class=\"name\">" + section.Name + "</span></h3></div>");

        $item.html(html.join(""));
        return $item;
    },

    $_CreateGoogleNewsItem: function (topic) {
        var $item = $("<li/>", {
            "class": "overflow",
            "data-feed-id": topic.Id,
            "rssurl": topic.RssUrl,
            "domain": topic.SiteUrl
        });
        var html = [];

        html.push('<section class="mainInfo">');
        html.push('<div class="itemImageContainer">');
        if (topic.ArtichleType === "Topic") {
            html.push('<img class="itemImage" src="https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png" />');
        } else {
            html.push('<img class="itemImage" src="http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_' + topic.ArtichleType + '.png" />');
        }
        html.push('</div>');

        html.push('<div class="information">');
        html.push('<span class="headline" tabindex="' + topic.TabIndex + '">' + topic.Title + '</span>');
        html.push('<span class="title">GOOGLE NEWS / ' + topic.SiteUrl + '</span>');
        if (topic.ArtichleType === "Topic") {
            html.push('<span class="googleNewsEdition"><img class="imgEditionLabel" /><label class="labelEditionLabel"></label></span>');
        }

        html.push('<div class="popularity-star"><span class="popularity-star-full"></span></div>');

        html.push('<div class="additionalBtns">');
        html.push('<a href="#" class="btn arrow" data-tooltip="tooltip" title="" data-original-title="More&nbsp;Details" tabindex="' + (topic.TabIndex + 90) + '">');
        html.push('<i class="icon-angle-down"></i>');
        html.push('</a>');
        html.push('</div>');
        html.push('<div class="feedPreview"></div>');
        html.push('</div>');

        html.push('<div class="plusIcon" style="position: relative; margin-top: 0;" tabindex="' + (topic.TabIndex + 1) + '"><i class="icon-add button"></i></div>');
        html.push('</section>');

        html.push('<section class="additionalInfo">');
        html.push('<span class="addpop title">Popularity: </span>');
        html.push('<div class="popularity-star"><span class="popularity-star-full"></span></div><br />');
        html.push('<span class="title">Feed Url: </span>');
        html.push('<span class="feedUrl"><a href="' + topic.RssUrl + '" target="_blank" tabindex="' + (topic.TabIndex + 91) + '">' + topic.RssUrl + '</a></span><br />');
        html.push('<span class="title">Feed Description: </span>');
        html.push('<span>' + topic.Description + '</span>');
        html.push('<div class="previewBtn"><a href="#" class="btn blue preview" tabindex="' + (topic.TabIndex + 92) + '">Preview</a></div>');
        html.push('</section>');

        $item.html(html.join(""));

        $item.on("error", ".itemImage", function () {
            this.onerror = null;
            this.src = "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/rss-logo.png";
        });
        $item.on("click", ".headline", function (e) {
            SocialTab.HTML_OpenFeedPreview($(this));
        });
        $item.on("click", ".arrow", function (e) {
            SocialTab.HTML_Event_RenderAdditionalInfoArrowClick($(this));
        });

        $item.on("click", ".plusIcon", function (e) {
            NewsTab.Modules.AddNewContent.Setup_SideSections($(this), topic.Id);
        });

        $item.on("click", ".preview", function (e) {
            SocialTab.HTML_OpenFeedPreview($(this));
        });

        return $item;
    },

    // START - Autocomplete for Add New Content
    HTML_AutocompleteTemplate: function () {
        var html = [];

        html.push('<ul class="uk-nav uk-nav-autocomplete uk-autocomplete-results">');
        html.push('{{~items}}');
        html.push('{{#$item.Type == "GOOGLENEWS"}}');
        html.push('<li class="clicked acGoogleNewsItem" data-value="{{ $item.Value }}" data-id="{{ $item.Id }}" data-type="{{ $item.Type }}">');
        html.push('<a>');
        html.push('<div><img src="{{ $item.IconUrl }}" style="background-color: {{ $item.Color }}" onerror="this.onerror = null;  this.src = \'http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/rss-logo.png\';" /></div>');
        html.push('<div class="autocompleteItemDetails"><div class="autocompleteTitle">{{ $item.Name }} - Create Google Alert</div></div>');
        html.push('</a>');
        html.push('</li>');
        html.push('{{/$item.Type}}');
        html.push('{{/items}}');

        html.push('{{~items}}');
        html.push('{{#$item.Type == "TOPIC" || $item.Type == "SITE" || $item.Type == "PUBLISHER" }}');
        html.push('<li class="clicked" data-value="{{ $item.Name }}" data-id="{{ $item.Id }}" data-type="{{ $item.Type }}">');
        html.push('<a>');
        html.push('{{#$item.Type == "TOPIC"}}');
        html.push('<div style="color: #fff; width: 30px; height: 30px; float: left; text-align: center; background-image: url(\'/Media/Images/scratch_back.png\'); background-color: {{#$item.Color != null}} {{$item.Color}} {{/$item.Color}} {{#$item.Color == null}} #00B8F5 {{/$item.Color}}">');
        html.push('<i class="iconName icon-{{SocialTab.HTML_RemoveEmptySpace($item.Name)}}" style="position: relative; top: 7px;"></i>');
        html.push('</div>');
        html.push('{{/$item.Type}}');
        html.push('{{#$item.Type == "SITE"}}');
        html.push('<div><img src="{{ $item.IconUrl }}" style="background-color: {{ $item.Color }}" onerror="this.onerror = null; this.src = \'http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/rss-logo.png\';" /></div>');
        html.push('{{/$item.Type}}');
        html.push('{{#$item.Type == "PUBLISHER"}}');
        html.push('<div><img src="{{ $item.IconUrl }}" style="background-color: {{ $item.Color }}" onerror="this.onerror = null; this.src = \'http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/rss-logo.png\';" /></div>');
        html.push('{{/$item.Type}}');
        html.push('<div class="autocompleteItemDetails"><div class="autocompleteTitle">{{ $item.Name }} ({{ $item.Type.charAt(0).toUpperCase() + $item.Type.substr(1).toLowerCase() }})</div></div>');
        html.push('</a>');
        html.push('</li>');
        html.push('{{/$item.Type}}');
        html.push('{{/items}}');
        html.push('</ul>');

        return html.join("");
    },

    Mark_AutocompleteText: function (term) {
        $.each($("#autocomplete .autocompleteTitle"), function () {
            var str = $(this).html();
            term = term.replace(/(\s+)/, "(<[^>]+>)*$1(<[^>]+>)*");
            var pattern = new RegExp("(" + term + ")", "gi");
            str = str.replace(pattern, "<strong>$1</strong>");
            str = str.replace(/(<strong>[^<>]*)((<[^>]+>)+)([^<>]*<\/strong>)/, "$1</strong>$2<strong>$4");
            $(this).html(str);
        });
    },

    Select_AutocompleteItem: function (sender, value, type, url) {
        var self = this;
        self.Page = 0;

        if (type === "BESTFEED") {
            value = url;
        }

        self.GetFeedsList({
            $Container: $('#addNewContent .feedsPanel.active .gridList'),
            Url: value,
            Type: type,
            SkipRecords: 0,
            Reset: true
        });
    },

    API_GetAutocompleteData: function (release) {
        var search = this.value, items = [];
        if (NewsTab.Modules.AddNewContent.Xhr_GetAutocompleteData &&
            NewsTab.Modules.AddNewContent.Xhr_GetAutocompleteData.readystate !== 4) {
            NewsTab.Modules.AddNewContent.Xhr_GetAutocompleteData.abort();
        }

        if (search[0] === "\"" || search[0] === "'") {
            items.push(
                {
                    Query: search,
                    TopicSize: 0,
                    SiteSize: 0,
                    Id: -1,
                    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png",
                    NumberOfFeeds: -1,
                    Name: search,
                    Type: "GOOGLENEWS",
                    Value: search
                });
            release(items);
        } else {
            var callUrl = NewsTab.ApiUrl_Feeds + "suggestions?query=" + encodeURIComponent(search);
            $("#contentFeeds").removeClass("showSideSections");

            NewsTab.Modules.AddNewContent.Xhr_GetAutocompleteData = $.ajax({
                url: callUrl,
                timeout: 25000,
                error: function (error) {
                    if (error.statusText != "abort") {
                        console.error("ERROR - Autocomplete:", error);
                    }
                }
            });

            NewsTab.Modules.AddNewContent.Xhr_GetAutocompleteData.then(function (response) {
                items.push({
                    Query: search
                });

                if (search.indexOf("http://") === -1 && search.indexOf("https://") === -1 && search.indexOf("www.") === -1) {
                    items.push({
                        Id: -1,
                        IconUrl: "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_Keyword.png",
                        NumberOfFeeds: -1,
                        Name: search,
                        Type: "GOOGLENEWS",
                        Value: search
                    });
                }

                response.forEach(function (item) {
                    items.push(item);
                });

                release(items);

                NewsTab.Modules.AddNewContent.Mark_AutocompleteText(search);
            });
        }
    },
    // END - Autocomplete for Add New Content

    Validation_GoogleNewsForm: function () {


        jQuery.validator.addMethod("createGNLctLocation", function (value, element) {
            return SocialTab.HTML_Event_GoogleNewsKwd_Blur(value, element);
        }, "Can't recognise location");

        $("#gnLctForm").validate({
            rules: {
                createGNLctTitle: {
                    required: true,
                    minlength: 1,
                    maxlength: 350
                },
                createGNLctLocation: {
                    required: true
                }
            },
            messages: {
                createGNLctTitle: {
                    required: "Please provide a title",
                    minlength: "Title must be at least 1 characters long",
                    maxlength: "Title must be at maximum 350 characters long"
                },
                createGNLctLocation: {
                    required: "Please provide a location",
                    minlength: "Can't recognise location"
                }
            },
            errorElement: "div",
            errorLabelContainer: ".errorLct",
            onkeyup: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNLctTitle").val().trim().length > 0 && $("#createGNLctTitle").val().trim().length <= 350 && $("#createGNLctLocation").val().trim().length > 0 && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isValid;
            },
            onfocusout: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNLctTitle").val().trim().length > 0 && $("#createGNLctLocation").val().trim().length > 0 && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isValid;
            }
        });
    },


    Setup_SectionsInOrganizer: function (newSection) {
        if (NewsTab.Modules.OpmlImportExport.HasUnsavedChanges()) {
            $("#organizerSectionFeeds").addClass("importState");
            $("#nbrNewSections").html(NewsTab.Modules.OpmlImportExport.NewImportedSections);
            $("#nbrEditSections").html(NewsTab.Modules.OpmlImportExport.OldSectionsWithNewImportedFeeds);
            $("#nbrNewFeeds").html(NewsTab.Modules.OpmlImportExport.NewImportedFeeds);
        }
        else {
            $("#organizerSectionFeeds").removeClass("importState");
        }
        if (this.SelectedSectionInOrganizer == null) {
            var sec = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.SectionTypeId == Section.TYPES.Normal || s.SectionTypeId == Section.TYPES.Social; });
            if (sec.length > 0) {
                this.SelectedSectionInOrganizer = sec[0];
            }
        }
        else {
            var sec = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return (s.SectionTypeId == Section.TYPES.Normal || s.SectionTypeId === Section.TYPES.Social) && s.Id == NewsTab.Modules.AddNewContent.SelectedSectionInOrganizer.Id });
            if (sec.length == 0) {
                var sec = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.SectionTypeId == Section.TYPES.Normal || s.SectionTypeId === Section.TYPES.Social; });
                if (sec.length > 0) {
                    this.SelectedSectionInOrganizer = sec[0];
                }
            }
        }
        if (this.SelectedSectionInOrganizer) {
            if (newSection) {
                if ($("#organizerSectionFeeds .sectionManager .chromeSection").last().length === 1) {
                    $("#organizerSectionFeeds .sectionManager .chromeSection").last().after(this._$sectionManagerItem(newSection, true, 1020));
                }
                else {
                    $("#organizerSectionFeeds .sectionManager .newItem").after(this._$sectionManagerItem(newSection, true, 1020));
                }

            } else {
                $("#organizerSectionFeeds .sectionManager").find(".item:not(.newItem)").remove();
                var tabIndex = 0;


                //if (NewsTab.IsExtension) {
                //    for (var i = 0, len = NewsTab.Modules.SectionsManager.ExtensionSections.length; i < len; i++) {
                //        if (NewsTab.Modules.SectionsManager.ExtensionSections[i].Feeds.length > 0) {
                //            $("#organizerSectionFeeds .sectionManager").append(this._$sectionManagerItem(NewsTab.Modules.SectionsManager.ExtensionSections[i], true, (1070 - tabIndex), { IsExtensionSection: true }));
                //        }
                //    }
                //}

                for (var i = 0, len = NewsTab.Modules.SectionsManager.Sections.length; i < len; i++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Normal || NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Social) {
                        $("#organizerSectionFeeds .sectionManager").append(this._$sectionManagerItem(NewsTab.Modules.SectionsManager.Sections[i], true, (1070 - tabIndex)));
                    }
                }

            }

            this.SelectSectionToManage(this.SelectedSectionInOrganizer);
        }
        else {
            this.SelectSectionToManage(null);
        }
    },

    Setup_RegionPublishers: function () {
        var self = this;

        $("#autocomplete .uk-dropdown").removeClass("topicAutocomplete");
        self.ShowLoader($("#contentFeeds"), false);
        $(".regionPublishers").html("");

        var tabIndex = 1010;
        NewsTab.Modules.SectionsManager.RegionPublishers.forEach(function (connector) {
            connector.TabIndex = tabIndex;
            $("#contentFeeds .searchResults .regionPublishers").append(self.$_CreatePublishersItem(connector));
            tabIndex++;
        });

        $("#contentFeeds #regionPublishersTabSection .item").hover(function () {
            $(this).find(".popularItemDetails").stop().fadeIn(300);
        }, function () {
            $(this).find(".popularItemDetails").stop().fadeOut(300);
        }).focus(function () {
            $(this).find(".popularItemDetails").stop().fadeIn(300);
        }).blur(function () {
            $(this).find(".popularItemDetails").stop().fadeOut(300);
        });

        $(".popularHeader").hide();
        if ($("#tabRegionPublishers").hasClass("active")) {
            $("#contentFeeds .tabMenu").show();
            $(".searchItems").html("");
            $(".onSearch").removeClass("onSearch");
            $(".searchResults").removeClass("showSearchItems");
        }
    },

    Setup_SelectedPublishers: function () {
        var self = this;

        $("#contentFeeds").find(".popularHeaderTitle").text("Feeds by Publishers");
        $("#autocomplete .uk-dropdown").addClass("topicAutocomplete");

        self.Setup_SearchSectionForItems(".popularPublishers", ".popularPublishersSection");
        self.ShowLoader($("#contentFeeds"), false);
        $(".popularPublishers").html("");
        $(".popularTopics").html("");
        self.SelectedPublishers.forEach(function (connector) {
            $(".searchResults .popularPublishers").append(self.$_CreatePublishersItem(connector));
        });

        $("#contentFeeds #popularPublishersTabSection .item").hover(function () {
            $(this).find(".popularItemDetails").stop().fadeIn(300);
        }, function () {
            $(this).find(".popularItemDetails").stop().fadeOut(300);
        }).focus(function () {
            $(this).find(".popularItemDetails").stop().fadeIn(300);
        }).blur(function () {
            $(this).find(".popularItemDetails").stop().fadeOut(300);
        });

        $("#popularTopicsTabSection").removeClass("active");
        $("#popularPublishersTabSection").addClass("active");
        $(".searchResults").removeClass("showSearchItems");
    },

    Setup_SelectedTopics: function () {
        var self = this;

        $("#contentFeeds").find(".popularHeaderTitle").text("Feeds by Topics");
        $("#autocomplete .uk-dropdown").addClass("topicAutocomplete");

        self.Setup_SearchSectionForItems(".popularTopics", ".popularTopicsSection");
        self.ShowLoader($("#contentFeeds"), false);
        $(".popularPublishers").html("");
        $(".popularTopics").html("");
        self.SelectedTopics.forEach(function (connector) {
            $(".searchResults .popularTopics").append(self.$_CreateTopicsItem(connector));
        });

        $("#contentFeeds #popularTopicsTabSection .item").hover(function () {
            $(this).find(".popularItemDetails").stop().fadeIn(300);
            $(this).closest("li").find("i.iconName").addClass("popularTopicIconZoom");
            $(this).closest("li").find("h3").hide();
        },
            function () {
                $(this).find(".popularItemDetails").stop().fadeOut(300);
                $(this).closest("li").find("i.iconName").removeClass("popularTopicIconZoom");
                $(this).closest("li").find("h3").show();
            }).focus(function () {
                $(this).find(".popularItemDetails").stop().fadeIn(300);
                $(this).closest("li").find("i.iconName").addClass("popularTopicIconZoom");
                $(this).closest("li").find("h3").hide();
            }).blur(function () {
                $(this).find(".popularItemDetails").stop().fadeOut(300);
                $(this).closest("li").find("i.iconName").removeClass("popularTopicIconZoom");
                $(this).closest("li").find("h3").show();
            });

        $("#popularPublishersTabSection").removeClass("active");
        $("#popularTopicsTabSection").addClass("active");
        $(".searchResults").removeClass("showSearchItems");
    },

    Setup_UsStates: function () {
        var self = this;

        var $gridList = $(".tab-pane.active .gridList");

        $("#contentFeeds").find(".popularHeaderTitle").text("US States");
        $gridList.html("");

        var tabIndex = 1010;
        NewsTab.Modules.RegionManager.UsStates.forEach(function (state) {
            state.TabIndex = tabIndex;
            $gridList.append(self._$usStateItem(state));
            tabIndex++;
        });
    },

    Setup_SearchSectionForItems: function (one, two) {
        $("#contentFeeds .searchResults").find(one).find(".item").remove();
        $("#contentFeeds .searchResults").find(two).show();
        $("#contentFeeds .tabMenu").hide();
        $("#contentFeeds .popularHeader").show();
        $("#contentFeeds").removeClass("onSearch");
    },

    Setup_ClearSectionPreview: function () {
        this.Setup_CleanSearchSection("#contentFeeds");
        this.ShowBackButton(false);
        this.PublisherSearchType = "popular";
        this.TopicSearchType = 'popular';
        this.Setup_PopularPublishers();
        this.Setup_PopularTopics();
        if (NewsTab.Modules.RegionManager.AddFeedEdition === "US") {
            this.Setup_UsStates();
        } else {
            this.Setup_RegionPublishers();
        }
        NewsTab.Modules.RegionManager.PreviousEdition = undefined;
        $("#tabRegionPublishers").removeClass("active");
        $("#tabTopics").removeClass("active");
        $("#tabPublishers").addClass("active");
        $("#contentFeeds .searchResults").unbind();
        $("#contentFeeds .searchTagResult").remove();
        $("#contentFeeds #contentTwitterFeed").removeClass("withSearchResults");
    },

    Setup_CleanSearchSection: function (sender) {
        $(sender).removeClass("showSideSections");
        $(sender).removeClass("onSearch");
        $(".searchItems").html("");
    },



    Setup_SelectedCustomLink: function (sender) {
        $(".showSideSections").removeClass("showSideSections");
        $.each($(".rssInstructions a"), function () {
            $(this).removeClass("selected");
        });
        $(sender).addClass("selected");
    },


    Select_TopicsTab: function () {
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabTopics").addClass("active");
        $("#addNewContent").find("#popularTopicsTabSection").addClass("active");

        $("#addNewContent").find("#tabTopics").focus();
    },

    Select_TwitterFeedTab: function () {
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabTwitter").addClass("active");
        $("#addNewContent").find("#contentTwitterFeed").addClass("active");

        $("#addNewContent").addClass("selected_tabTwitter");
        $("#contentFeeds.active").addClass("selected_tabTwitter");

        $("#addNewContent").find("#tabTwitter").focus();
    },

    Select_ImportOpmlTab: function () {
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabCustom").addClass("active");
        $("#addNewContent").find("#contentCustom").addClass("active");

        $("#addNewContent").addClass("selected_tabCustom");
        $("#contentFeeds.active").addClass("selected_tabCustom");

        this.Setup_ImportOpml();
        $("#addNewContent").find("#tabCustom").focus();
    },

    Select_ExportOpmlTab: function () {
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabCustom").addClass("active");
        $("#addNewContent").find("#contentCustom").addClass("active");

        $("#addNewContent").addClass("selected_tabCustom");
        $("#contentFeeds.active").addClass("selected_tabCustom");

        this.Setup_ExportOpml();
        $("#addNewContent").find("#tabCustom").focus();
    },

    Select_OrganizeTab: function () {
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabOrganizer").addClass("active");
        $("#addNewContent").find("#organizerSectionFeeds").addClass("active");

        $("#addNewContent").addClass("selected_tabOrganizer");
        $("#contentFeeds.active").addClass("selected_tabOrganizer");
        $("#addNewContent").find("#tabOrganizer").focus();
    },

    Select_LocalPublisherTab: function () {
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabRegionPublishers").addClass("active");
        $("#addNewContent").find("#regionPublishersTabSection").addClass("active");

        $("#addNewContent").find("#tabRegionPublishers").focus();
    },


    SearchFeedsFromUrl: function (sender, url, type, skipRekords, resetPage) {
        var self = this;
        if (resetPage) {
            self.Page = 0;
        }
        if (self.Page === 0) {
            self.SearchUrl = url;
            self.AutocompleteSearchType = type;

            NewsTab.Modules.RegionManager.PreviousEdition = undefined;

            SocialTab.HTML_SetupSearchSection("#contentFeeds");

            self.ShowLoader($("#contentFeeds"), true);
            self.ShowBackButton(true);

            //$(".gridList").hide();
        }

        switch (type) {
            case "GOOGLENEWS":
                this.SearchType = "3";
                if (this.Page === 0) {
                    self.SearchGoogleNewsFromUrl(sender, url);
                }
                break;
            case "TOPIC":
                this.SearchType = "1";
                NewsTab.Modules.SectionsManager.API_SearchFeed(sender, url, skipRekords);
                if (this.Page === 0) {
                    self.SearchGoogleNewsFromUrl(sender, url);
                }
                break;
            case "SITE":
                this.SearchType = "2";
                if (url === "news.google.com") {
                    SocialTab.GetGoogleNewsCategories();
                } else {
                    NewsTab.Modules.SectionsManager.API_SearchFeed(sender, url, skipRekords);
                }
                break;
            case "PUBLISHER":
                this.SearchType = "3";
                NewsTab.Modules.SectionsManager.API_SearchFeed(sender, url, skipRekords);
                if (this.Page === 0) {
                    self.SearchGoogleNewsFromUrl(sender, url);
                }
                break;
            case "ALL":
                this.SearchType = "3";
                NewsTab.Modules.SectionsManager.API_SearchFeed(sender, url, skipRekords);
                if (url.indexOf("http://") > -1 || url.indexOf("https://") > -1 || url.indexOf("www.") > -1) {
                    SocialTab.GetFeedsFromUrl(sender, url);
                } else if (this.Page === 0) {
                    self.SearchGoogleNewsFromUrl(sender, url);
                }
                break;
            default:
                this.SearchType = "3";
                NewsTab.Modules.SectionsManager.API_SearchFeed(sender, url, skipRekords);
                if (this.Page === 0) {
                    self.SearchGoogleNewsFromUrl(sender, url);
                }
        }

        setTimeout(function () {
            $("#autocomplete").removeClass("uk-open");
        }, 500);
    },

    SearchGoogleNewsFromUrl: function (url, edition, from) {
        var self = this;

        if (NewsTab.Modules.XhrManager.Xhr_SearchGoogleNews && NewsTab.Modules.XhrManager.Xhr_SearchGoogleNews.readystate !== 4) {
            NewsTab.Modules.XhrManager.Xhr_SearchGoogleNews.abort();
        }

        if ($("#contentFeeds").find(".searchItems").find("#googleNewsItemKeyword").length === 0) {
            SocialTab.HTML_SeatupGoogleNewsSearchSection($("#contentFeeds"));
        }
        edition = edition != undefined ? edition : NewsTab.Modules.RegionManager.AddFeedEditionGnValue != undefined ? NewsTab.Modules.RegionManager.AddFeedEditionGnValue : NewsTab.Modules.RegionManager.MainEditionGnValue;

        var callUrl = NewsTab.ApiUrl_Global + "get/googlenewsfeeds?query=" + encodeURIComponent(url) + "&edition=" + edition;
        NewsTab.Modules.XhrManager.Xhr_SearchGoogleNews = $.ajax({
            url: callUrl,
            headers: { Authorization: "Bearer " + NewsTab.Token },
            timeout: 10000,
            crossDomain: true,
            error: function (error) {
                NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
                console.error("ERROR - SearchFeedsFromUrl:", error);
            },
            beforeSend: function () {
                $("#contentFeeds .errorScreen").remove();
            }
        });

        NewsTab.Modules.XhrManager.Xhr_SearchGoogleNews.then(function (data) {
            if (data.Topics != null && data.Topics.Channel != null && data.Topics.Channel.Items.length > 0) {
                data.Topics.TabIndex = 1010;

                $("#contentFeeds").find(".searchResults").find("#googleNewsItemTopic").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Topics));

                var gnCode = $("#mainEditionsDropdown").find("option:selected").attr("data-googlenewscode");
                if (gnCode === "") {
                    $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
                    $(".labelEditionLabel").text("United States");
                } else {
                    $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
                    $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
                }

                //$("#googleNewsItemTopic").find(".feedPreview").html('');
                //$("#googleNewsItemTopic").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                //    Title: data.Topics.Title,
                //    EncodedTitle: encodeURIComponent(data.Topics.Title),
                //    FeedUrl: data.Topics.RssUrl,
                //    Id: data.Topics.Id,
                //    Domain: data.Topics.SiteUrl,
                //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                //}));
            }

            if (data.Keywords != null && data.Keywords.Title != null) {
                data.Keywords.TabIndex = 1110;
                $("#contentFeeds").find(".searchResults").find("#googleNewsItemKeyword").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Keywords));

                //$("#googleNewsItemKeyword").find(".feedPreview").html('');
                //$("#googleNewsItemKeyword").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                //    Title: data.Topics.Title,
                //    EncodedTitle: encodeURIComponent(data.Topics.Title),
                //    FeedUrl: data.Topics.RssUrl,
                //    Id: data.Topics.Id,
                //    Domain: data.Topics.SiteUrl,
                //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                //}));
            }

            if (data.Locations != null && data.Locations.Channel != null && data.Locations.Channel.Items.length > 0) {
                data.Locations.TabIndex = 1210;
                $("#contentFeeds").find(".searchResults").find("#googleNewsItemLocation").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Locations));

                //$("#googleNewsItemLocation").find(".feedPreview").html('');
                //$("#googleNewsItemLocation").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                //    Title: data.Topics.Title,
                //    EncodedTitle: encodeURIComponent(data.Topics.Title),
                //    FeedUrl: data.Topics.RssUrl,
                //    Id: data.Topics.Id,
                //    Domain: data.Topics.SiteUrl,
                //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                //}));
            }

            if (self.Page === 0) {
                if ($(".showingResults").length === 0) {
                    $("#addNewContent .feedsPanel.active").prepend(NewsTab.Modules.AddNewContent._$feedCountItem({ Query: url, TotalResults: SocialTab.CalculateNumberOfFeeds(url, 0, "GN"), Type: self.SearchType }));
                } else {
                    $(".showingResults .numberOfFeeds", "#addNewContent .feedsPanel.active").html(SocialTab.CalculateNumberOfFeeds(url, 0, "GN"));
                }
            }

            self.ShowLoader($("#contentFeeds"), false);
        });
    },


    SelectSectionToManage: function (section) {
        var self = this;

        if (section == null) {
            $(".feedManager").fadeOut();
        }
        else {
            $organizerSectionFeeds = $("#organizerSectionFeeds");
            $(".sectionManager li", $organizerSectionFeeds).removeClass("selected");
            var t = $(".sectionManager", $organizerSectionFeeds).find(".item[data-section-id=" + section.Id + "]");
            t.addClass("selected");

            var tabIndex = parseInt($(".sectionManager.topics", $organizerSectionFeeds).find("li:last").attr("tabindex")) + 10;

            self.SelectedSectionInOrganizer = section;
            $(".feedManager .selectedSection", $organizerSectionFeeds).css("background-color", section.Color);

            var sectionHtml = "";
            if (section.ClassName) {
                sectionHtml += "<span class=\"sIcon\" style=\"background-color:" + section.Color + "\"><i class=\"icon-" + section.ClassName + "\"></i></span>";
            } else {
                sectionHtml += "<span class=\"sIcon\" style=\"background-color:" + section.Color + "\">" + section.Name.substring(0, 2) + "</span>";
            }
            sectionHtml += "<span class=\"sName\">" + section.Name + "</span>";
            if (section.ClassName !== "googlechrome") {
                sectionHtml += "<div class=\"sControls\" data-section-id=\"" + section.Id + "\">";
                if (section.SectionTypeId == Section.TYPES.Social) {
                    sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Delete\" class=\"icon-trash-o sectionSocialRemove\"></i>";
                }
                else {
                    sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Edit\" data-item class=\"icon-pencil sectionEdit\"></i>";
                    sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Delete\" class=\"icon-trash-o sectionRemove\"></i>";
                    sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"More\" class=\"icon-more sectionMoreOptions\"></i>";
                }
                sectionHtml += "</div>";
            }
            $(".feedManager .selectedSection", $organizerSectionFeeds).html(sectionHtml);


            $(".sectionEdit", $organizerSectionFeeds).on("click", function () {
                NewsTab.Modules.SectionsManager.Modal_EditSection(section);
            });

            $(".sectionRemove", $organizerSectionFeeds).on("click", function () {
                NewsTab.Modules.SectionsManager.Modal_RemoveSection(section);
            });

            $(".sectionMoreOptions", $organizerSectionFeeds).on("click", function (e) {
                e.stopPropagation();
                NewsTab.Modules.SectionsManager.ContextMenu_Section(section, $(this).parent(), 1);
            });

            $(".feedManager ul", $organizerSectionFeeds).html("");
            $(".feedManager ul", $organizerSectionFeeds).css("border-color", section.Color);

            var empty = true;

            var timeline = $.grep(section.Feeds, function (e) { return e.Name == "Timeline" });
            if (timeline.length) {
                timeline = timeline[0];

                var feedItemHtml = "<li class=\"feed timeline" + (NewsTab.Modules.SectionsManager.CurrentSection != null && timeline.Id == NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? " active" : "") + "\" data-feed-id=\"" + timeline.Id + "\" data-section-id=\"" + section.Id + "\"  tabindex=\"" + (tabIndex + 4) + "\">";

                feedItemHtml += "<span  class=\"feedName\">" + (timeline.NewImport || section.NewImport ? "[New] " : "") + timeline.Name + "</span>";
                feedItemHtml += "<div class=\"feedControls\" data-feed-id=\"" + timeline.Id + "\" data-section-id=\"" + section.Id + "\">";

                feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Delete\" class=\"icon-trash-o deleteSpecialFeedClick " + ((timeline.Name.indexOf("#") == 0 || timeline.Name.indexOf("@") == 0) ? "" : "disabled") + "\" tabindex=\"" + (tabIndex + 6) + "\"></i>";

                feedItemHtml += "</div></li>";

                $(".feedManager ul", $organizerSectionFeeds).append(feedItemHtml);
                empty = false;
                tabIndex++;
            }

            for (var i = 0, l = section.Feeds.length; i < l; i++) {
                var feed = section.Feeds[i];
                if (feed.Id.length == 36 && (section.SectionTypeId != Section.TYPES.Social || feed.Name != "Timeline")) {
                    var selectedClass = feed.OrganizeFeedSelected ? " selected" : "";
                    var activeClass = NewsTab.Modules.SectionsManager.CurrentSection != null && feed.Id == NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? " active" : "";
                    var $feed = $("<li/>", {
                        "class": "feed" + selectedClass + activeClass,
                        "data-feed-id": feed.Id,
                        "data-section-id": section.Id,
                        "tabindex": tabIndex + 4
                    });
                    $feed.attr("draggable", "true");
                    var feedItemHtml = "";

                    if (section.SectionTypeId !== Section.TYPES.Social) {
                        if (feed.Type !== Feed.TYPES.SOCIALTRENDING) {
                            feedItemHtml += "<div class=\"checkContainer\">";
                            feedItemHtml += "<input type=\"checkbox\" name=\"feed_" + feed.Id + "\" id=\"feed_" + feed.Id + "\" " + (feed.OrganizeFeedSelected ? "checked=\"\"" : "") + "><label  data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Select\"  for=\"feed_" + feed.Id + "\"></label>";
                            feedItemHtml += "</div>";
                        }

                        if (feed.Icon != null && feed.Icon.indexOf(".") > 0) {
                            feedItemHtml += "<img draggable=\"false\" src=\"" + feed.Icon + "\" class=\"feedIcon\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" title=\"" + feed.Name + "\" />";
                        } else if (feed.FavIcon) {
                            feedItemHtml += "<img draggable=\"false\" class=\"feedIcon\" src=\"" + feed.FavIcon + "\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" title=\"" + feed.Name + "\"/>";
                        }
                        else {
                            feedItemHtml += "<img draggable=\"false\" class=\"feedIcon\" src=\"/Media/ExtensionImages/rss.png\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" title=\"" + feed.Name + "\"/>";
                        }
                    }
                    if (section.ClassName !== "googlechrome") {
                        feedItemHtml += "<span  class=\"feedName\">" + (feed.NewImport || section.NewImport ? "[New] " : "") + feed.Name + "</span>";
                    } else {
                        var existingFeed = NewsTab.Modules.SectionsManager.GetFeedById(feed.Id, null, false);
                        if (existingFeed !== null) {
                            feedItemHtml += "<span  class=\"feedName\">" + feed.Name + "</span>";
                        }
                        else {
                            feedItemHtml += "<span  class=\"feedName\">[New] " + feed.Name + "</span>";
                        }
                    }
                    feedItemHtml += "<div class=\"feedControls\" data-feed-id=\"" + feed.Id + "\" data-section-id=\"" + section.Id + "\">";
                    if (section.ClassName !== "googlechrome") {
                        if (feed.Type === Feed.TYPES.SOCIALTRENDING) {
                            if (feed.ShowInList) {
                                feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Hide\" class=\"icon-eye hideSTFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                            }
                            else {
                                feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Show\" class=\"icon-eye-slash hideSTFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                            }
                        } else if (section.SectionTypeId != Section.TYPES.Social) {
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Copy&nbsp;Mode&nbsp;On/Off\" class=\"icon-copy feedCopyDrag " + (feed.OrganizeCopyMode ? "selected" : "") + "\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Delete\" class=\"icon-trash-o feedRemove\" tabindex=\"" + (tabIndex + 6) + "\"></i>";
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"More\" class=\"icon-more feedMoreOptions\" data-feed-id=\"" + feed.Id + "\" data-section-id=\"" + section.Id + "\" tabindex=\"" + (tabIndex + 7) + "\"></i>";
                        }
                        else {
                            if (feed.ShowInList) {
                                feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Hide\" class=\"icon-eye hideSpecialFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                            }
                            else {
                                feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Show\" class=\"icon-eye-slash hideSpecialFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                            }

                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Delete\" class=\"icon-trash-o deleteSpecialFeedClick " + ((feed.Name.indexOf("#") == 0 || feed.Name.indexOf("@") == 0) ? "" : "disabled") + "\" tabindex=\"" + (tabIndex + 6) + "\"></i>";
                        }
                    }
                    feedItemHtml += "</div>";

                    $feed.html(feedItemHtml);

                    $(".feedRemove", $feed).on("click", function (e) {
                        NewsTab.Modules.SectionsManager.Modal_RemoveFeed(section, feed);
                    });

                    $(".feedMoreOptions", $feed).on("click", function (e) {
                        e.stopPropagation();
                        NewsTab.Modules.SectionsManager.ContextMenu_Feed(section, feed, $(this).parent());
                    });

                    $feed.on("dragstart", function (e) {
                        SocialTab.FeedManagerDragStart(e.originalEvent);
                    });

                    if (section.ClassName !== "googlechrome") {
                        $feed.on("dragend", function (e) {
                            SocialTab.FeedManagerDragEnd(e.originalEvent);
                        });

                        $feed.on("dragenter", function (e) {
                            SocialTab.FeedManagerFeedDragEnter(e.originalEvent);
                        });
                    }
                    $(".feedManager ul", $organizerSectionFeeds).append($feed);
                    empty = false;
                    tabIndex++;
                }
            }

            if (empty) {
                var feedItemHtml = "<li class=\"empty\"><span>This Section is empty!</span></li>";
                $(".feedManager ul", $organizerSectionFeeds).append(feedItemHtml);
            }
            $(".feedManager").fadeIn();
        }
    },

    ShowLoader: function (sender, show) {
        if (show) {
            sender.find(".searchLoader").show();
            sender.find(".urlContainer .icon-search").hide();
        } else {
            sender.find(".searchLoader").hide();
            sender.find(".urlContainer .icon-search").show();
            this.LoadingAnimation_Stop();
        }
    },
    /*********************************/
    /********** Sections Tab *********/
    /*********************************/
    _$sections: function () {
        var self = this;

        var $sections = $("<div/>", {
            "id": "contentSections",
            "role": "tabpanel",
            "class": "mainPanel tab-pane"
        });

        var html = [];
        html.push("<div id=\"socialTopicsTabSection\" role=\"tabpanel\" class=\"sectionsPanel tab-pane active\">");
        html.push("<ul class=\"topics gridList\">");
        html.push("<li class=\"item newItem\">");
        html.push('<img src="' + NewsTab.PlaceholderImage + '"/>');
        html.push("<div class=\"flipItem\">");
        html.push("<figure class=\"front\" tabindex=\"1003\"><i class=\"icon icon-add\"></i><h3>Create New Section</h3></figure>");
        html.push("<figure class=\"back\">");
        html.push("<div class=\"inputContainer\">");
        html.push("<input type=\"text\" class=\"newSectionName autoclear clearable\" placeholder=\"Section Name\" value=\"\" tabindex=\"1003\" />");
        html.push("<span class=\"iconPreview\"></span>");
        html.push("</div>");
        html.push("<ul class=\"colors\"></ul>");
        html.push("<div class=\"btnContainer\">");
        html.push("<button class=\"btn cancel\" tabindex=\"1013\">Cancel</button>");
        html.push("<button class=\"btn blue add disabled\" tabindex=\"1014\">Create</button>");
        html.push("</div>");
        html.push("</figure>");
        html.push("</div>");
        html.push("</li>");
        html.push("</ul>");
        html.push("</div>");
        html.push("<div id=\"addSectionsBtnField\">");
        html.push("<button class=\"btn gray\" tabindex=\"1201\">Cancel</button>");
        html.push("<button class=\"btn btn-primary\" tabindex=\"1202\">Apply</button>");
        html.push("</div>");

        $sections.html(html.join(""));

        NewsTab.Setup_SectionColors($(".newItem", $sections), NewsTab.DEFAULT_COLOR);

        $(".front", $sections).on("click", function () {
            var $flipItem = $(this).closest(".flipItem");
            $flipItem.addClass("flipped");
            $("input", $flipItem).val("").change().removeClass("onX").removeClass("x");
            $(".colors li", $flipItem).first().click();
        });

        $(".newSectionName", $sections).on("keyup paste change", function (e) {
            var $control = $(this);
            setTimeout(function () {
                self.VerifySectionNameChange($control, $(".newItem .add", $sections))
            }, 100);
        });

        $(".cancel", $sections).on("click", function () {
            $(this).closest(".flipItem").removeClass("flipped");
        });

        $(".add", $sections).on("click", function () {
            var $newItem = $(this).closest(".newItem");

            $newItem.addClass("disabled");
            var name = $(".newSectionName", $newItem).val().trim();
            var color = $(".colors li.selected", $newItem).data("color");

            $(".add", $newItem).html('<i class="icon"><span class="spinner"></span></i>');
            NewsTab.Modules.SectionsManager.API_AddNewSection(
                {
                    Name: name,
                    Color: (color !== undefined ? color : NewsTab.Modules.SectionsManager.DEFAULT_SECTION_COLOR)
                },
                {
                    SuccessCallback: function () {
                        $(".flipItem", $newItem).removeClass("flipped");
                    },
                    CompleteCallback: function () {
                        $newItem.removeClass("disabled");
                        $(".add", $newItem).html('Create');
                    }
                });
        });

        $(".gray", $sections).on("click", function () {
            var $newSections = $(".newAdd", $sections);
            var $removedSections = $(".newRemove", $sections);

            $.each($newSections, function () {
                if ($(this).hasClass("newAdd")) {
                    $(this).removeClass("connected").removeClass("newAdd");
                }
            });
            $.each($removedSections, function () {
                if ($(this).hasClass("newRemove")) {
                    $(this).removeClass("newRemove").addClass("connected");
                }
            });

            $("#addSectionsBtnField", $sections).removeClass("show");
        });

        $(".btn-primary", $sections).on("click", function () {
            var $newSections = $(".newAdd", $sections);
            var $removedSections = $(".newRemove", $sections);

            $.each($newSections, function () {
                $(this).removeClass("newAdd");
                NewsTab.Modules.SectionsManager.API_AddSection($(this).data("section-id"));
            });
            $.each($removedSections, function () {
                $(this).removeClass("newRemove");
                NewsTab.Modules.SectionsManager.API_RemoveSectionById($(this).data("section-id"));
            });

            $("#addSectionsBtnField", $sections).removeClass("show");
        });

        return $sections;
    },

    _$sectionItem: function (section, connected) {
        var self = this;

        var $item = $("<li/>", {
            "data-section-id": section.Id,
            "class": "item " + (connected ? "connected" : ""),
            "tabindex": 0
        });

        var html = [];
        html.push('<img src="' + NewsTab.PlaceholderImage + '"/>');
        html.push('<div style="background-image: url(\'/Media/Images/scratch_back.png\');background-color:' + section.Color + '">');
        html.push('<i class=\"icon-statusIcon\"></i>');

        if (section.ClassName) {
            html.push("<i class=\"iconName icon-" + section.ClassName + "\"></i>");
        } else {
            html.push("<span class=\"iconName\">" + section.Name.substring(0, 2) + "</span>");
        }
        html.push("<h3><span class=\"name\">" + section.Name + "</span></h3>");
        html.push("</div>");

        $item.html(html.join(""));

        if (section.SectionTypeId === Section.TYPES.Social) {
            $item.addClass(section.ClassName);

            $item.on("click", function () {
                SocialTab.AddTwitter();
            });
        }
        else {
            $item.on("click", function () {
                if (connected) {
                    //if ($item.hasClass("newRemove")) {
                    //    $item.addClass("connected").removeClass("newRemove");
                    //} else {
                    //    $item.removeClass("connected").addClass("newRemove");
                    //}
                } else {
                    if ($item.hasClass("newAdd")) {
                        $item.removeClass("connected").removeClass("newAdd");
                    }
                    else {
                        $item.addClass("connected").addClass("newAdd");
                    }
                }

                if ($(".newAdd").length > 0 || $(".newRemove").length > 0) {
                    $("#addSectionsBtnField").addClass("show");
                } else {
                    $("#addSectionsBtnField").removeClass("show");
                }
            });
        }
        return $item;
    },

    Setup_Sections: function () {
        var self = this;

        NewsTab.Modules.SectionsManager.AppSections = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.ClassName == null; }).concat(NewsTab.Modules.SectionsManager.SysSections);

        $("#contentSections .gridList").find(".item:not(.newItem)").remove();
        var temp = [];

        for (var i = 0, len = NewsTab.Modules.SectionsManager.AppSections.length; i < len; i++) {
            if (NewsTab.Modules.SectionsManager.AppSections[i] != null && NewsTab.Modules.SectionsManager.AppSections[i].SectionTypeId === Section.TYPES.Normal) {
                var s = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) {
                    return (s.EnglishName === NewsTab.Modules.SectionsManager.AppSections[i].EnglishName);
                });

                if (s.length === 1) {
                    $("#contentSections .newItem").parent().append(self._$sectionItem(s[0], true));
                } else {
                    temp.push(NewsTab.Modules.SectionsManager.AppSections[i]);
                }
            }
        }
        for (var j = 0, len1 = temp.length; j < len1; j++) {
            $("#contentSections .newItem").parent().append(self._$sectionItem(temp[j], false));
        }

        self.Setup_SocialSections();
    },

    Setup_SocialSections: function () {
        var self = this;

        var sections = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.ClassName == null; }).concat(NewsTab.Modules.SectionsManager.SysSections);
        var temp = [];
        for (var i = 0, len = sections.length; i < len; i++) {
            if (sections[i].SectionTypeId === Section.TYPES.Social) {
                if ($.grep(NewsTab.Modules.SectionsManager.Sections, function (s) {
                    return (s.Name === sections[i].Name);
                }).length === 1) {
                    $("#contentSections .newItem").after(this._$sectionItem(sections[i], true));
                }
                else {
                    temp.push(sections[i]);
                }
            }
        }
        for (var j = 0, len1 = temp.length; j < len1; j++) {
            $("#contentSections .newItem").after(self._$sectionItem(temp[j], false));
        }
    },
    /*********************************/
    /*********** Tabs Setup **********/
    /*********************************/
    /* Popular Publishers */
    _$publisherItem: function (publisher) {
        var self = this;

        var tryLoadPublisherIcon = false;

        var $item = $("<li/>", {
            "class": "item",
            "publisher-id": publisher.Id,
            "tabindex": publisher.TabIndex
        });

        var html = [];

        html.push('<img src="' + NewsTab.PlaceholderImage + '"/>');
        html.push('<div class="liContent">');

        if (publisher.DisplayType !== "SITE") {
            html.push('<div class="regionItemDetails">');
            if (publisher.PublisherName) {
                html.push('<div class="popularItemName">&nbsp;' + publisher.PublisherName + '</div>');
            } else {
                html.push('<div class="popularItemName">&nbsp;' + publisher.SiteUrl + '</div>');
            }
            html.push('<div class="popularItemDomain">www.' + publisher.SiteUrl + '</div>');
            html.push('</div>');
        }

        html.push('<div class="popularItemDetails">');
        if (publisher.PublisherName) {
            html.push('<div class="popularItemName">&nbsp;' + publisher.PublisherName + '</div>');
        } else {
            html.push('<div class="popularItemName">&nbsp;' + publisher.SiteUrl + '</div>');
        }
        html.push('<div class="popularItemDomain">www.' + publisher.SiteUrl + '</div>');
        html.push('<div class="popularItemLink">View ' + (publisher.NumberOfFeeds < 100 ? publisher.NumberOfFeeds : "99+") + ' feeds</div>');
        html.push('</div>');

        html.push('</div>');

        $item.html(html.join(""));

        if (publisher.IconUrl.indexOf("publisher") >= 0 || (publisher.IconUrlWidth > 120 && publisher.IconUrlHeight > 120)) {
            tryLoadPublisherIcon = true;
            $(".liContent", $item).css("background-image", "url('" + publisher.IconUrl + "')");
        }

        if (publisher.DisplayType !== "SITE") {
            $(".liContent", $item).css("background-color", publisher.Color);
        }


        $item.on("click", function () {
            self.GetFeedsList({
                $Container: $(this).closest('.gridList'),
                Url: publisher.SiteUrl,
                Type: "SITE",
                SkipRecords: 0,
                Reset: true
            });
        });

        if (tryLoadPublisherIcon) {
            var image = new Image();
            $(image).on("error", function () {
                $(".liContent", $item).css("background-image", "url('/Media/Images/scratch_back.png')");
                if (publisher.DisplayType === "SITE") {
                    $(".liContent", $item).css("background-color", publisher.Color);

                    var ri = [];
                    ri.push('<div class="regionItemDetails">');
                    if (publisher.PublisherName) {
                        ri.push('<div class="popularItemName">&nbsp;' + publisher.PublisherName + '</div>');
                    } else {
                        ri.push('<div class="popularItemName">&nbsp;' + publisher.SiteUrl + '</div>');
                    }
                    ri.push('<div class="popularItemDomain">www.' + publisher.SiteUrl + '</div>');
                    ri.push('</div>');
                    $(".liContent", $item).prepend(ri.join(""));
                }
            });

            $(image).attr("src", publisher.IconUrl);
        }

        return $item;
    },

    Setup_PopularPublishersTab: function (isRetry) {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.addClass("selected_popularPublishers");

        var $popularPublishersTabSection = $("#popularPublishersTabSection", $addNewContent);

        $popularPublishersTabSection.html('');

        var tabIndex = 1010;

        if (NewsTab.Modules.SectionsManager.PopularPublishers.length > 0) {
            $popularPublishersTabSection.html('<ul class="gridList"></ul>');

            var $gridList = $(".gridList", $popularPublishersTabSection);
            NewsTab.Modules.SectionsManager.PopularPublishers.forEach(function (item) {
                item.TabIndex = tabIndex;
                $gridList.append(self._$publisherItem(item));
                tabIndex++;
            });
        }
        else if (isRetry !== true) {
            NewsTab.Modules.SectionsManager.API_GetPopularPublishersTopics(
                function () {
                    self.LoadingAnimation_Start();
                    $(".errorScreen", $popularPublishersTabSection).remove();
                }, function () {
                    self.SearchType = "popular";
                    self.Setup_PopularPublishersTab(true);
                    self.LoadingAnimation_Stop();
                }, function () {
                    self.DisplayErrorScreen($popularPublishersTabSection, function () { self.Setup_PopularPublishersTab(); });
                    self.LoadingAnimation_Stop();
                });
        }
    },

    /* Region Publishers */
    _$usStateItem: function (state) {
        var self = this;

        var $item = $("<li/>", {
            "class": "item usState",
            "publisher-id": state.Id,
            "tabindex": state.TabIndex
        });

        var html = [];
        html.push('<img src="' + NewsTab.PlaceholderImage + '" style="background-image:url(\'' + state.IconUrl + '\')"/>');
        html.push('<div class="popularItemDetails"><div class="popularItemLink">View ' + (state.NumberOfPublishers < 100 ? state.NumberOfPublishers : '99+') + ' publishers</div></div>');
        html.push('<div class="popularItemName">' + state.Name + '</div>');

        $item.html(html.join(""));

        $item.on("click", function () {
            var $addNewContent = $("#addNewContent");
            $addNewContent.addClass("selected_regionPublishers");

            var $regionPublishersTabSection = $("#regionPublishersTabSection", $addNewContent);

            $regionPublishersTabSection.html("");

            //NewsTab.Modules.RegionManager.AddFeedEdition = state.Code;
            NewsTab.Modules.SectionsManager.API_GetPublishersByRegion({
                Region: state.Code,
                BeforeSendCallback: function () {
                    self.LoadingAnimation_Start();
                    $(".errorScreen", $regionPublishersTabSection).remove();
                },
                ErrorCallback: function (error) {
                    self.DisplayErrorScreen($regionPublishersTabSection, function () { self.Setup_RegionPublishersTab(); });
                    self.LoadingAnimation_Stop();
                },
                SuccessCallback: function (data) {
                    self.SearchType = "popular";
                    self.Setup_RegionPublishersTab(true);
                    self.LoadingAnimation_Stop();

                }
            });
        });

        return $item;
    },

    Setup_RegionPublishersTab: function (isRetry) {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.addClass("selected_regionPublishers");

        var $regionPublishersTabSection = $("#regionPublishersTabSection", $addNewContent);

        $regionPublishersTabSection.html("");
        $regionPublishersTabSection.html('<ul class="gridList"></ul>');
        var $gridList = $(".gridList", $regionPublishersTabSection);

        var tabIndex = 1010;

        if (NewsTab.Modules.SectionsManager.RegionPublishers.length > 0 &&
            (NewsTab.Modules.RegionManager.AddFeedEdition !== "US" || NewsTab.Modules.RegionManager.UsStates > 0)) {

            if (NewsTab.Modules.RegionManager.AddFeedEdition === "US") {
                NewsTab.Modules.RegionManager.UsStates.forEach(function (state) {
                    state.TabIndex = tabIndex;
                    $gridList.append(self._$usStateItem(state));
                    tabIndex++;
                });
            } else {
                NewsTab.Modules.SectionsManager.RegionPublishers.forEach(function (item) {
                    item.TabIndex = tabIndex;
                    $gridList.append(self._$publisherItem(item));
                    tabIndex++;
                });
            }
        }
        else if (isRetry !== true) {
            if (NewsTab.Modules.RegionManager.AddFeedEdition === "US") {
                if (NewsTab.Modules.RegionManager.UsStates <= 0) {
                    var options = {
                        BeforeSendCallback: null,
                        ErrorCallback: null,
                        SuccessCallback: function () {
                            self.Setup_UsStates();
                        }
                    };
                    NewsTab.Modules.RegionManager.API_GetUsStates(options);
                } else {
                    self.Setup_UsStates();
                }
            }
            else {
                NewsTab.Modules.SectionsManager.API_GetPublishersByRegion({
                    Region: NewsTab.Modules.RegionManager.AddFeedEdition,
                    BeforeSendCallback: function () {
                        self.LoadingAnimation_Start();
                        $(".errorScreen", $regionPublishersTabSection).remove();
                    },
                    ErrorCallback: function (error) {
                        self.DisplayErrorScreen($regionPublishersTabSection, function () { self.Setup_RegionPublishersTab(); });
                        self.LoadingAnimation_Stop();
                    },
                    SuccessCallback: function (data) {
                        self.SearchType = "popular";
                        self.Setup_RegionPublishersTab(true);
                        self.LoadingAnimation_Stop();

                    }
                });
            }
        }
    },

    /* Topics */
    _$topicsItem: function (topic) {
        var self = this;

        var tryLoadPublisherIcon = false;

        var $item = $("<li/>", {
            "class": "item",
            "data-section-id": topic.Id,
            "tabindex": topic.TabIndex
        });

        var html = [];

        html.push('<img src="' + NewsTab.PlaceholderImage + '"/>');

        html.push('<div class="liContent">');

        html.push('<div class="popularItemDetails">');
        html.push('<div class="popularItemLink">View ' + (topic.NumberOfFeeds < 100 ? topic.NumberOfFeeds : '99+') + ' feeds</div>');
        html.push('<div class="popularItemName">' + topic.Name + '</div>');
        html.push('</div>');

        html.push('</div>');

        $item.html(html.join(""));

        if (topic.IconUrl) {
            tryLoadPublisherIcon = true;
            $(".liContent", $item).css("background-image", "url('" + topic.IconUrl + "')");
        }

        $item.on("click", function () {
            self.GetFeedsList({
                $Container: $(this).closest('.gridList'),
                Url: topic.Name,
                Type: "TOPIC",
                SkipRecords: 0,
                Reset: true
            });
        });

        if (tryLoadPublisherIcon) {
            var image = new Image();
            $(image).on("error", function () {
                $(".liContent", $item).css("background-image", "url('/Media/Images/scratch_back.png')");
            });

            $(image).attr("src", topic.IconUrl);
        }

        return $item;
    },

    _$newGoogleAlertItem: function () {
        var self = this;

        var $item = $("<li>", { "class": "item newItem" });

        var html = [];
        html.push('<img src="' + NewsTab.PlaceholderImage + '"/>');
        html.push("<div class=\"newGoogleAlert\">");
        html.push("<div class=\"flipItem\">");
        html.push("<figure class=\"front\" tabindex=\"1010\">");
        html.push("<i class=\"icon icon-add\"></i>");
        html.push("<h3>Create Google Alert</h3>");
        html.push("<h5><img src=\"/Media/Images/google-icon.png\" />Powered by Google News</h5>");
        html.push("</figure>");
        html.push("<figure class=\"back\">");
        html.push("<form id=\"addNewGnTopic\">");
        html.push("<div class=\"inputContainer\">");
        html.push("<input type=\"text\" id=\"topicName\" class=\"topicName autoclear clearable\" placeholder=\"Topic name (optional)\" name=\"topicName\" style=\"height: 35px;\" tabindex=\"1011\" />");
        html.push("<input type=\"text\" id=\"searchTerm\" class=\"searchTerm autoclear clearable\" placeholder=\"Search terms (Separate by comma)\" name=\"searchTerm\" style=\"height: 35px;\" tabindex=\"1012\" />");
        html.push("<select id=\"edition_topicGnKwdRegion\" name=\"edition_topicGnKwdRegion\" tabindex=\"1013\"></select>");
        html.push("<div class=\"errorMessage errorTpc\"></div>");
        html.push("</div>");
        html.push("<div class=\"btnContainer\">");
        html.push("<button type=\"button\" class=\"btn cancel\" tabindex=\"1014\">Cancel</button>");
        html.push("<button type=\"button\" class=\"btn save blue disabled\" tabindex=\"1015\">Create</button>");
        html.push("</div>");
        html.push("</form>");
        html.push("</figure>");
        html.push("</div>");
        html.push("</div>");

        $item.html(html.join(""));

        $(".front", $item).on("click", function () {
            var $flipItem = $(this).closest(".flipItem");
            $flipItem.addClass("flipped");
            $("#topicName", $flipItem).val("").change().removeClass("onX").removeClass("x").removeClass("error");
            $("#searchTerm", $flipItem).val("").change().removeClass("onX").removeClass("x").removeClass("error");
            $(".errorMessage", $flipItem).html("");

            $("#addNewGnTopic", $item).validate({
                rules: {
                    topicName: {
                        required: true,
                        minlength: 1,
                        maxlength: 350
                    },
                    searchTerm: {
                        required: true,
                        minlength: 1,
                        maxlength: 50
                    }
                },
                messages: {
                    topicName: {
                        required: "Please provide a title",
                        minlength: "Title must be at least 1 characters long",
                        maxlength: "Title must be at maximum 350 characters long"
                    },
                    searchTerm: {
                        required: "Please provide a search term",
                        minlength: "Search term must be at least 1 characters long",
                        maxlength: "Search term must be at maximum 50 characters long"
                    }
                },
                errorElement: "div",
                errorLabelContainer: ".errorTpc",
                onkeyup: function (element) {
                    var isValid = $(element).valid();
                    if (isValid == 1 &&
                        $("#topicName").val().trim().length > 0 &&
                        $("#topicName").val().trim().length <= 350 &&
                        $("#searchTerm").val().trim().length > 0 &&
                        $("#searchTerm").val().trim().length <= 350) {
                        $(element).closest("form").find(".save.disabled").removeClass("disabled");
                    } else {
                        $(element).closest("form").find(".save").addClass("disabled");
                    }
                },
                onfocusout: function (element) {
                    var isValid = $(element).valid();
                    if (isValid == 1 &&
                        $("#topicName").val().trim().length > 0 &&
                        $("#topicName").val().trim().length <= 350 &&
                        $("#searchTerm").val().trim().length > 0 &&
                        $("#searchTerm").val().trim().length <= 350) {
                        $(element).closest("form").find(".save.disabled").removeClass("disabled");
                    } else {
                        $(element).closest("form").find(".save").addClass("disabled");
                    }
                }
            });
        });

        $(".cancel", $item).on("click", function () {
            $(this).closest(".flipItem").removeClass("flipped");
        });

        $item.on("change", "#edition_topicGnKwdRegion", function () {
            SocialTab.HTML_RenderGoogleNewsEdition($(this));
        });

        $(".save", $item).on("click", function () {
            var title = $(".topicName", $item).val().trim();
            var term = $(".searchTerm", $item).val().trim();
            var region = $("#googleNewsKwdEditionValue", $item).val() != undefined ? $("#googleNewsKwdEditionValue", $item).val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            var url = "https://news.google.com/news/rss/search/section/q/" + term + "?ned=" + region.toLowerCase() + "&num=30";

            if (title.length > 350) {
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Google News",
                    Color: "red",
                    Text: "Title is too long."
                });
            } else {
                $(this).closest(".flipItem").removeClass("flipped");
                self.Setup_SideSectionMenu({
                    FeedId: NewsTab.EMPTY_GUID,
                    Title: title,
                    FeedUrl: url,
                    Domain: "news.google.com",
                    IconUrl: "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_Keyword.png"
                });
            }
        });

        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_topicGnKwdRegion", $item), false);

        return $item;
    },

    Setup_TopicsTab: function (isRetry) {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.addClass("selected_topics");

        var $popularTopicsTabSection = $("#popularTopicsTabSection", $addNewContent);

        $popularTopicsTabSection.html("");

        var tabIndex = 1116;

        if (NewsTab.Modules.SectionsManager.PopularTopics.length > 0) {
            $popularTopicsTabSection.html('<ul class="gridList"></ul>');
            var $gridList = $(".gridList", $popularTopicsTabSection);

            $gridList.append(self._$newGoogleAlertItem());

            NewsTab.Modules.SectionsManager.PopularTopics.forEach(function (item) {
                item.TabIndex = tabIndex;
                $gridList.append(self._$topicsItem(item));
                tabIndex++;
            });
        }
        else if (isRetry !== true) {
            NewsTab.Modules.SectionsManager.API_GetPopularPublishersTopics(
                function () {
                    self.LoadingAnimation_Start();
                    $(".errorScreen", $popularTopicsTabSection).remove();
                }, function () {
                    self.SearchType = "topic";
                    self.Setup_TopicsTab(true);
                    self.LoadingAnimation_Stop();
                }, function () {
                    self.DisplayErrorScreen($popularTopicsTabSection, function () { self.Setup_TopicsTab(); });
                    self.LoadingAnimation_Stop();
                });
        }
    },

    /* Custome */
    Setup_Custom: function (subTab, initialSetup) {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.addClass("selected_custom");

        $("#contentCustom .rssInstructions a", $addNewContent).removeClass("selected");
        $("#contentCustom .contentFeedResults", $addNewContent).html("");
        $("#contentCustom .searchResults", $addNewContent).html("");

        $("#contentCustom", $addNewContent).removeClass("onSearch");

        if (initialSetup !== true) {
            $("#contentBackButton", $addNewContent).show();
            $("#contentCustom .rssInstructions", $addNewContent).removeClass("open").addClass("close");
            $("#contentCustom .contentFeedResults", $addNewContent).removeClass("close").addClass("open");
        } else {
            $("#contentBackButton", $addNewContent).hide();
            $("#contentCustom .rssInstructions", $addNewContent).removeClass("close").addClass("open");
            $("#contentCustom .contentFeedResults", $addNewContent).removeClass("open").addClass("close");
        }

        switch (subTab) {
            case "gnKwdForm":
                $("#contentCustom .rssInstructionsLink.crf", $addNewContent).addClass("selected");
                self.Setup_GoogleNewsKeyword();
                break;
            case "gnLctForm":
                $("#contentCustom .rssInstructionsLink.clf", $addNewContent).addClass("selected");
                self.Setup_GoogleNewsLocation();
                break;
            case "contentImportOPML":
                $("#contentCustom .rssInstructionsLink.iof", $addNewContent).addClass("selected");
                self.Setup_ImportOpml();
                break;
            case "contentExportOPML":
                $("#contentCustom .rssInstructionsLink.eof", $addNewContent).addClass("selected");
                self.Setup_ExportOpml();
                break;
            default:
                $("#contentCustom .rssInstructionsLink.iaru", $addNewContent).addClass("selected");
                self.Setup_ImportRss();
                break;
        }
    },

    Setup_ImportRss: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        var $form = $("<div/>", { id: "contentFeedMain" });

        var html = [];
        html.push('<p style="font-weight: 600; margin: 20px 10px 10px 10px; font-size: 18px;">Enter RSS URL</p>');
        html.push('<div style="background-color: #DEDEDE; height: 100%; position: relative; width: 88%; padding: 10px;">');
        html.push('<div class="urlContainer">');
        html.push('<input id="customFeedUrlInput" type="text" class="autoclear clearable" placeholder="Enter RSS URL (example: http://rss.cnn.com/rss/)" tabindex="1019" autofocus />');
        html.push('<a id="customFeedUrlButton" href="#" class="disabled"><i class="icon-search icon-2x"></i></a>');
        html.push('<span class="searchLoader"><i class="icon"><span class="spinner"></span></i></span>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div class="contentCustomMainDesc">');
        html.push('<p style="font-weight: 600;">How to find RSS URLs:</p><br />');
        html.push('<p>Locate the RSS feed URL in the website you whish to follow. It is typically found in the footer of the relevant website and represented with the universal feed icon:<img src="' + NewsTab.EnviromentUrl + '/Media/Images/feedIcon-small.png" width="16" /></p><br/>');
        html.push('<p>You can also search via Google for a combination of the website you whish to follow and the word “RSS”. For example: search Google for “cnn.com rss”</p><br/>');
        html.push('<p>Once you found the RSS page of the website you wish to follow, select a specific feed within this page and click on it (for example: CNN top news). Now copy the feed URL from your browser URL bar, paste it into the search bar above and hit enter.</p>');
        html.push('</div>');

        $form.html(html.join(""));
        $("#contentCustom .contentFeedResults", $addNewContent).append($form);


        $("#customFeedUrlInput", $form).on("keyup paste", function (e) {
            SocialTab.HTML_Event_GetFeedsClick($(this), event);
        });

        $("#customFeedUrlButton", $form).on("click", function (e) {
            SocialTab.HTML_Event_GetFeedsClick($(this), event);
        });
    },

    Setup_GoogleNewsKeyword: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        var $form = $("<form/>", { id: "gnKwdForm" });

        var html = [];
        html.push('<div id="googleNewsKwdSection" class="googleNewsSections">');
        html.push('<p style="font-weight: 600; margin: 20px 10px 10px 10px; font-size: 18px;">Create Google Alert</p>');
        html.push('<br/>');
        html.push('<div class="inputContainer">');
        html.push('<input type="text" class="createGNKwdTitle autoclear clearable" id="createGNKwdTitle" name="createGNKwdTitle" placeholder="Set feed title" value="" tabindex="1020" autofocus />');
        html.push('</div>');
        html.push('<br/>');
        html.push('<div class="inputContainer">');
        html.push('<textarea type="text" class="createGNKwdTerm autoclear clearable" id="createGNKwdTerm" name="createGNKwdTerm" placeholder="Enter search terms" value="" tabindex="1021"></textarea>');
        html.push('<p style="font-size: 9px;">Separate search terms with a comma</p>');
        html.push('</div>');
        html.push('<br/>');
        html.push('<div class="front"><h3>Select region</h3></div>');
        html.push('<div class="back">');
        html.push('<div class="inputContainer inputContainerDropdown" style="width: 252px;">');
        html.push('<select id="edition_GnKwdRegion" name="edition_GnKwdRegion" tabindex="1022"></select>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="errorMessage errorKwd" style="display: none;"></div>');

        html.push('<div class="buttonGroup">');
        html.push('<a href="#" class="cancel" style="margin-right: 20px;" tabindex="1023">Cancel</a>');
        html.push('<a href="#" class="btn blue preview disabled" tabindex="1024">Preview</a>');
        html.push('<a href="#" class="btn blue add disabled" tabindex="1025">Create</a>');
        html.push('</div>');
        html.push('</div>');

        $form.html(html.join(""));
        $("#contentCustom .contentFeedResults", $addNewContent).append($form);

        $(".createGNKwdTitle", $form).focus();
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnKwdRegion"), false);

        $form.validate({
            rules: {
                createGNKwdTitle: {
                    required: true,
                    minlength: 1,
                    maxlength: 350
                },
                createGNKwdTerm: "required"
            },
            messages: {
                createGNKwdTitle: {
                    required: "Please provide a title",
                    minlength: "Title must be at least 1 characters long",
                    maxlength: "Title must be at maximum 350 characters long"
                },
                createGNKwdTerm: {
                    required: "Please provide a search term"
                }
            },
            errorElement: "div",
            errorLabelContainer: ".errorKwd",
            onkeyup: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNKwdTitle").val().trim().length > 0 && $("#createGNKwdTitle").val().trim().length <= 350 && $("#createGNKwdTerm").val().trim().length > 0) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
            },
            onfocusout: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNKwdTitle").val().trim().length > 0 && $("#createGNKwdTerm").val().trim().length > 0) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
            }
        });

        $("#edition_GnKwdRegion", $form).on("change", function (e) {
            SocialTab.HTML_RenderGoogleNewsEdition($(this));
        });

        $(".cancel", $form).on("click", function (e) {
            self.Setup_Custom(null, true);
        });

        $(".preview", $form).on("click", function (e) {
            var title = $("#createGNKwdTitle", $form).val().trim();
            var term = $("#createGNKwdTerm", $form).val().trim();
            var region = $("#googleNewsKwdEditionValue", $form).val() != undefined ? $("#googleNewsKwdEditionValue", $form).val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            var url = "https://news.google.com/news/rss/headlines/section/q/" + term + "?ned=" + region.toLowerCase() + "&num=30";

            self.Open_GoogleNewsPreview({
                FeedId: NewsTab.EMPTY_GUID,
                Title: title,
                FeedUrl: url,
                Domain: "news.google.com",
                IconUrl: "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_Keyword.png"
            });
        });

        $(".add", $form).on("click", function (e) {
            var title = $("#createGNKwdTitle", $form).val().trim();
            var term = $("#createGNKwdTerm", $form).val().trim();
            var region = $("#googleNewsKwdEditionValue", $form).val() != undefined ? $("#googleNewsKwdEditionValue", $form).val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            var url = "https://news.google.com/news/rss/headlines/section/q" + term + "?ned=" + region.toLowerCase() + "&num=30";

            if (title.length > 350) {
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Google News",
                    Color: "red",
                    Text: "Title is too long."
                });
            } else {
                self.Setup_SideSectionMenu({
                    FeedId: NewsTab.EMPTY_GUID,
                    Title: title,
                    FeedUrl: url,
                    Domain: "news.google.com",
                    IconUrl: "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_Keyword.png"
                });
            }
        });
    },

    Setup_GoogleNewsLocation: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        var $form = $("<form/>", { id: "gnLctForm" });

        var html = [];
        html.push('<div id="googleNewsLctSection" class="googleNewsSections">');
        html.push('<p style="font-weight: 600; margin: 20px 10px 10px 10px; font-size: 18px;">Create Google News Location Feed</p>');
        html.push('<br/>');
        html.push('<div class="inputContainer">');
        html.push('<input type="text" class="createGNLctTitle autoclear clearable clearable" id="createGNLctTitle" name="createGNLctTitle" placeholder="Set feed title" value="" tabindex="1020" autofocus />');
        html.push('</div>');
        html.push('<br/>');
        html.push('<div class="inputContainer">');
        html.push('<input type="text" class="createGNLctLocation autoclear clearable clearable" id="createGNLctLocation" name="createGNLctLocation" placeholder="Enter location (City, State or Zip Code)" value="" tabindex="1021"/>');
        html.push('</div>');
        html.push('<br/>');
        html.push('<div class="front"><h3>Select region</h3></div>');
        html.push('<div class="back">');
        html.push('<div class="inputContainer inputContainerDropdown" style="width: 252px;">');
        html.push('<select id="edition_GnLctRegion" name="edition_GnLctRegion" tabindex="1022"></select>');
        html.push('</div>');
        html.push('</div>');

        html.push('<div class="errorMessage errorLct" style="display: none;"></div>');

        html.push('<div class="buttonGroup">');
        html.push('<a href="#" class="cancel" style="margin-right: 20px;" tabindex="1023">Cancel</a>');
        html.push('<a href="#" class="btn blue preview disabled" tabindex="1024">Preview</a>');
        html.push('<a href="#" class="btn blue add disabled" tabindex="1025">Create</a>');
        html.push('</div>');
        html.push('</div>');

        $form.html(html.join(""));
        $("#contentCustom .contentFeedResults", $addNewContent).append($form);

        $(".createGNLctTitle", $form).focus();
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnLctRegion"), false);

        jQuery.validator.addMethod("createGNLctLocation", function (value, element) {
            return SocialTab.HTML_Event_GoogleNewsKwd_Blur(value, element);
        }, "Can't recognise location");

        $("#gnLctForm").validate({
            rules: {
                createGNLctTitle: {
                    required: true,
                    minlength: 1,
                    maxlength: 350
                },
                createGNLctLocation: {
                    required: true
                }
            },
            messages: {
                createGNLctTitle: {
                    required: "Please provide a title",
                    minlength: "Title must be at least 1 characters long",
                    maxlength: "Title must be at maximum 350 characters long"
                },
                createGNLctLocation: {
                    required: "Please provide a location",
                    minlength: "Can't recognise location"
                }
            },
            errorElement: "div",
            errorLabelContainer: ".errorLct",
            onkeyup: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNLctTitle").val().trim().length > 0 && $("#createGNLctTitle").val().trim().length <= 350 && $("#createGNLctLocation").val().trim().length > 0 && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isValid;
            },
            onfocusout: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNLctTitle").val().trim().length > 0 && $("#createGNLctLocation").val().trim().length > 0 && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isValid;
            }
        });


        $("#edition_GnLctRegion", $form).on("change", function (e) {
            SocialTab.HTML_RenderGoogleNewsEdition($(this));
        });

        $(".cancel", $form).on("click", function (e) {
            self.Setup_Custom(null, true);
        });

        $(".preview", $form).on("click", function (e) {
            var title = $("#createGNLctTitle", $form).val().trim();
            var term = $("#createGNLctLocation", $form).val().trim();
            var region = $("#googleNewsLctEditionValue", $form).val() != undefined ? $("#googleNewsLctEditionValue", $form).val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            var url = "https://news.google.com/news/rss/headlines/section/geo/" + term + "?ned=" + region.toLowerCase() + "&num=30";

            self.Open_GoogleNewsPreview({
                FeedId: NewsTab.EMPTY_GUID,
                Title: title,
                FeedUrl: url,
                Domain: "news.google.com",
                IconUrl: "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_Keyword.png"
            });
        });

        $(".add", $form).on("click", function (e) {
            var title = $("#createGNKwdTitle", $form).val().trim();
            var term = $("#createGNKwdTerm", $form).val().trim();
            var region = $("#googleNewsLctEditionValue", $form).val() != undefined ? $("#googleNewsLctEditionValue", $form).val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            var url = "https://news.google.com/news/rss/headlines/section/geo/" + term + "?ned=" + region.toLowerCase() + "&num=30";

            if (title.length > 350) {
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Google News",
                    Color: "red",
                    Text: "Title is too long."
                });
            } else {
                self.Setup_SideSectionMenu({
                    FeedId: NewsTab.EMPTY_GUID,
                    Title: title,
                    FeedUrl: url,
                    Domain: "news.google.com",
                    IconUrl: "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_Keyword.png"
                });
            }
        });
    },

    Setup_ImportOpml: function () {

        var self = this;

        var $addNewContent = $("#addNewContent");
        var $form = $("<div/>", { id: "contentImportOPML" });

        var html = [];

        html.push('<h3>Import OPML file</h3>');
        html.push('<div class="importOPMLWrapper">');
        html.push('<div class="uploadOpmlFileContainer btn blue">');
        html.push('<div class="progressBar"><span></span></div>');
        html.push('<input id="uploadOpmlFile" type="file" class="uploadOpmlFile" tabindex="1020" autofocus />');
        html.push('<span class="opmlFileName">Select OPML file</span>');
        html.push('</div>');
        html.push('<br />');
        html.push('<a class="btn blue importOPML disabled" style="display:none" title="Import OPML to NewsTab"><i class="icon"><span class="spinner"></span></i>Import OPML to NewsTab</a>');
        html.push('</div>');
        html.push('<div class="contentCustomMainDesc">');
        html.push('<p style="font-weight: 600;">How to import OPML file:</p><br /><p>Note: This is not going to remove any feeds you already have into your account. Just add the additional feeds and categories.</p><br /><p>Note that the OPML import will only import your feeds and won\'t be importing any tag or pinned articles.</p>');
        html.push('</div>');

        $form.html(html.join(""));
        $("#contentCustom .contentFeedResults", $addNewContent).append($form);
    },

    Setup_ExportOpml: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        var $form = $("<div/>", { id: "contentExportOPML" });

        var html = [];

        html.push('<h3>Export OPML file</h3>');
        html.push('<div class="importOPMLWrapper"><a class="btn blue exportOPML disabled" href="#" target="_blank" tabindex="1020">Export OPML</a></div>');
        html.push('<div class="contentCustomMainDesc">');
        html.push('<p style="font-weight: 600;">About OPML Export:</p><br /><p>OPML is a standard allowing you to export your feeds and sections to another account or a different NewsReader. Please note that OPML export won\'t be exporting your Pinned items.</p>');
        html.push('</div>');

        $form.html(html.join(""));
        $("#contentCustom .contentFeedResults", $addNewContent).append($form);

        $.ajax({
            url: NewsTab.ApiUrl_Global + "generateOpmlFileToken",
            type: "POST",
            headers: {
                Authorization: 'Bearer ' + NewsTab.Token
            },
            error: function (error) {
                console.error(error);
                $("a.exportOPML", $form).addClass("disabled");
            }
        }).then(function (data) {
            $("a.exportOPML", $form).attr("href", NewsTab.ApiUrl_Global + "downloadOpmlFile?opmlToken=" + encodeURIComponent(data));
            $("a.exportOPML", $form).removeClass("disabled");
        });
    },
    /**/
    _$sectionManagerItem: function (section, connected, tabIndex, options) {
        var self = this;

        var opt = $.extend({}, { IsExtensionSection: false }, options);

        var $item = $("<li/>", {
            "data-section-id": section.Id,
            "class": "item connected",
            "tabindex": tabIndex
        });

        if (opt.IsExtensionSection) {
            $item.addClass("chromeSection");
        }

        $item.on("click", function () {
            self.SelectSectionToManage(section);
        });

        $draggable = $("<div/>", {
            "style": "background-image: url(\'/Media/Images/scratch_back.png\'); background-color:" + section.Color
        });

        if (!opt.IsExtensionSection) {
            $draggable.attr("draggable", "true");

            $draggable.on("drop", function (e) {
                SocialTab.FeedManagerDrop(e.originalEvent);
            });
            $draggable.on("dragstart", function (e) {
                SocialTab.FeedManagerSectionDragStart(e.originalEvent);
            });
            $draggable.on("dragend", function (e) {
                SocialTab.FeedManagerSectionDragEnd(e.originalEvent);
            });
            $draggable.on("dragenter", function (e) {
                SocialTab.FeedManagerSectionDragEnter(e.originalEvent);
            });
            $draggable.on("dragleave", function (e) {
                SocialTab.FeedManagerDragLeave(e.originalEvent);
            });
            $draggable.on("dragover", function (e) {
                SocialTab.FeedManagerDragOver(e.originalEvent);
            });
        }

        var html = [];
        html.push("<i class=\"icon-statusIcon\"></i>");
        html.push("<span class=\"feedCount\">" + ($.grep(section.Feeds, function (e) { return e.ShowInList === true }).length) + "</span>");

        if (section.ClassName) {
            html.push("<i class=\"iconName icon-" + section.ClassName + "\"></i>");
        } else {
            html.push("<span class=\"iconName\">" + section.Name.substring(0, 2) + "</span>");
        }

        html.push("<h3><span class=\"name\">" + (section.NewImport ? "[New] " : section.NewFeedsImported ? "[Edited] " : "") + (opt.IsExtensionSection ? "[Local] " : "") + section.Name + "</span></h3>");

        $draggable.html(html.join(""));

        $item.append('<img src="' + NewsTab.PlaceholderImage + '"/>');
        $item.append($draggable);

        return $item;
    },

    Setup_Organizer: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.addClass("selected_organizer");

        self.Setup_SectionsInOrganizer();
    },

    Setup_Twitter: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.addClass("selected_twitter");

        $("#contentTwitterFeed .connectTwitter", $addNewContent).remove();
        $("#contentTwitterFeed .addTwitter", $addNewContent).remove();
        $("#contentTwitterFeed .searchTagResult", $addNewContent).remove();

        $("#contentTwitterFeed", $addNewContent).removeClass("withSearchResults");

        $("#feedSearchInput", $addNewContent).removeClass("disabled");
        $("#feedSearchInput", $addNewContent).removeClass("disabled");

        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Name === "Twitter" });
        if (section.length > 0) {
            section = section[0];
            if (!Feed.Linked(section.CurrentFeed.Type)) {
                var $btn = $("<button class=\"btn border connectTwitter\">Connect to Twitter</button>");
                $btn.on("click", function () {
                    NewsTab.Modules.TwitterManager.Connect();
                });
                $("#contentTwitterFeed .twitterFeedForm", $addNewContent).append($btn);
                $("#feedSearchInput", $addNewContent).addClass("disabled");
            }
        } else {
            var $btn = $("<button class=\"btn border addTwitter\">Add Twitter Section</button>");
            $btn.on("click", function () {
                NewsTab.Modules.TwitterManager.AddAndConnectTwitter();
            });
            $("#contentTwitterFeed .twitterFeedForm", $addNewContent).append($btn);
            $("#feedSearchInput", $addNewContent).addClass("disabled");
        }
        self.SearchType = "twitter";

        $(document.body).off("setion:added.twitter").on("setion:added.twitter", function (e, s) {
            self.Setup_Twitter();
        });
        $(document.body).off("setion:removed.twitter").on("setion:removed.twitter", function (e, s) {
            self.Setup_Twitter();
        });
    },


    /* Side Sections */
    _$sideSectionItem: function (section, feed, tabIndex) {
        if (section.Connected === true) {
            var added = false;
            for (var i = 0, len = section.Feeds.length; i < len; i++) {
                if (section.Feeds[i].Id === feed.Id) {
                    added = true;
                }
            }
            var $item = $("<li/>", {
                "data-section-id": section.Id,
                "class": (added ? "added" : "") + ((NewsTab.Modules.SectionsManager.CurrentSection != undefined && NewsTab.Modules.SectionsManager.CurrentSection.Id === section.Id) ? " selected" : ""),
                "tabindex": tabIndex
            });
            $item.html("<h3><span class=\"name\">" + section.Name + "</span></h3>");


            return $item;
        }
        return null;
    },

    Setup_SideSectionMenu: function (feed) {
        var self = this;

        var $addNewContent = $("#addNewContent");
        var $sideSectionMenu = $("#sideSectionMenu");
        $sideSectionMenu.html("");

        var tabIndex;
        if ($(".searchResults li.selected").find(".plusIcon").length > 0) {
            tabIndex = parseInt($(".searchItems li.selected").find(".plusIcon").attr("tabindex")) + 1;
        } else {
            tabIndex = 1021;
        }

        var html = [];
        html.push('<div class="siteContainer">');
        html.push('<div class="inputContainer">');
        html.push('<img src="' + feed.IconUrl + '" class="siteImage imgWithOnError" data-error-src="/Media/ExtensionImages/rss.png" />');
        html.push('<input type="text" class="siteName clearable" placeholder="CNN.com" value="' + feed.Title + '" tabindex="' + tabIndex + '" />');
        html.push('<i class="icon-pencil"></i>');
        html.push('</div>');
        html.push('<h3>Add feed to:</h3>');
        html.push('</div>');
        html.push('<div class="firstItem">');
        html.push('<ul class="topics">');
        html.push('<li class="newItem">');
        html.push('<div class="front" tabindex="' + (tabIndex + 1) + '">');
        html.push('<i class="icon-plus"></i> <h3>New section</h3>');
        html.push('</div>');
        html.push('<div class="back">');
        html.push('<div class="inputContainer"><input type="text" class="newSectionName autoclear clearable" placeholder="Section Name" value="" tabindex="' + (tabIndex + 2) + '" /><span class="iconPreview"></span></div>');
        html.push('<ul class="colors"></ul>');
        html.push('</div>');
        html.push('</li>');
        html.push('</ul>');
        html.push('</div>');
        html.push('<ul class="sideSections"></ul>');
        html.push('<div class="buttonGroup">');
        html.push('<a href="#" class="cancel" tabindex="' + (tabIndex + 80) + '">Cancel</a>');
        html.push('<a href="#" class="btn blue add disabled"  tabindex="' + (tabIndex + 81) + '">Add</a>');
        html.push('</div>');

        $sideSectionMenu.append(html.join(""));

        NewsTab.Setup_SectionColors($(".newItem", $sideSectionMenu), NewsTab.DEFAULT_COLOR);

        var $sideSectionList = $(".sideSections", $sideSectionMenu);
        tabIndex += 15;

        NewsTab.Modules.SectionsManager.Sections.forEach(function (s) {
            if (s.ShowInSourceList && s.Id === NewsTab.Modules.SectionsManager.CurrentSection.Id) {
                $sideSectionList.prepend(self._$sideSectionItem(s, feed, tabIndex));
            } else if (s.ShowInSourceList) {
                $sideSectionList.append(self._$sideSectionItem(s, feed, tabIndex));
            }
            tabIndex++;
        });

        if ($("li.selected", $sideSectionList).length === 1) {
            $(".buttonGroup .add", $sideSectionMenu).removeClass("disabled");
        }

        $addNewContent.addClass("showSideSectionMenu");


        $(".front", $sideSectionMenu).on("click", function () {
            $(this).parent().addClass("selected");
            $(".sideSections", $sideSectionMenu).addClass("selected");

            $(".sideSections li", $sideSectionMenu).removeClass("selected");

            $(".buttonGroup .add", $sideSectionMenu).addClass("disabled");
        });

        $(".newSectionName", $sideSectionMenu).on("keyup paste", function (e) {
            var $control = $(this);
            setTimeout(function () {
                self.VerifySectionNameChange($control, $(".buttonGroup .add", $sideSectionMenu))
            }, 100);
        });

        $(".sideSections li", $sideSectionMenu).on("click", function (e) {
            $(".newItem", $sideSectionMenu).removeClass("selected");
            $(".sideSections", $sideSectionMenu).removeClass("selected");

            $(this).siblings("li").removeClass("selected");
            $(this).addClass("selected");

            $(".buttonGroup .add", $sideSectionMenu).removeClass("disabled");
        });

        $(".cancel", $sideSectionMenu).on("click", function () {
            $(".feedsPanel.active .gridList li").removeClass("selected");
            $addNewContent.removeClass("showSideSectionMenu");
        });

        $(".add", $sideSectionMenu).on("click", function () {
            $(".feedsPanel.active .gridList li.added.new").removeClass("new");
            $(".feedsPanel.active .gridList li.selected").addClass("added").addClass("new");

            var sectionId = $("li.selected", $sideSectionList).attr("data-section-id");

            var siteName = decodeURIComponent($(".siteContainer .siteName", $sideSectionMenu).val());
            var $newSection = $(".newItem.selected", $sideSectionMenu);

            if (siteName.length > 0) {
                if (sectionId) {
                    NewsTab.Modules.SectionsManager.API_AddFeedToSection({
                        SectionId: sectionId,
                        Id: feed.FeedId,
                        Name: siteName,
                        SiteUrl: feed.Domain,
                        RssUrl: feed.FeedUrl,
                        IconUrl: feed.IconUrl
                    });
                } else if ($newSection.length) {
                    NewsTab.Modules.SectionsManager.API_AddFeedToNewSection({
                        Id: feed.FeedId,
                        Name: siteName,
                        SiteUrl: feed.Domain,
                        RssUrl: feed.FeedUrl,
                        IconUrl: feed.IconUrl
                    },
                        {
                            Name: $newSection.find(".newSectionName").val().trim(),
                            Color: $newSection.find(".colors li.selected").data("color")
                        });
                }
            }

            $(".feedsPanel.active .gridList li").removeClass("selected");
            $addNewContent.removeClass("showSideSectionMenu");
        });

        if (NewsTab.Modules.Context !== undefined) {
            NewsTab.Modules.Context.inputFocusKeys();
        }
    },

    _$feedListItem: function (feed) {
        var self = this;

        var $item = $("<li/>", {
            "class": feed.FeedExist,
            "data-feed-id": feed.FeedId,
            "data-feed-url": feed.FeedUrl,
            "data-domain": feed.Domain
        });

        var html = [];

        html.push('<section class="mainInfo">');
        if (feed.IconUrlWidth > 120 && feed.IconUrlHeight > 120) {
            html.push('<div class="itemImageContainer" style="background: url(\'' + feed.IconUrl + '\'), url(\'/Media/ExtensionImages/rss.png\'); background-repeat: no-repeat; background-size: cover; background-position: center;">');
            html.push('<img class="itemImage" src="' + feed.IconUrl + '" style="visibility: hidden;" />');
            html.push('</div>');
        } else {
            html.push('<div class="itemImageContainer">');
            html.push('<img class="itemImage" src="/Media/ExtensionImages/rss.png" />');
            html.push('</div>');
        }

        html.push('<div class="information">');
        html.push('<span class="headline" tabindex="' + feed.TabIndex + '">' + feed.Title + '</span>');
        html.push('<span class="title">' + feed.Domain + '</span>');
        html.push('<div class="popularity-star">');
        html.push('<span class="popularity-star-full ' + SocialTab.HTML_PopularityRating(feed.TotalSubscribers) + '"></span>');
        html.push('</div>');
        html.push('<div class="additionalBtns">');
        html.push('<a href="#" class="btn arrow" data-tooltip="tooltip" title="" data-original-title="More&nbsp;Details" tabindex="' + (feed.TabIndex + 90) + '">');
        html.push('<i class="icon-angle-down"></i>');
        html.push('</a>');
        html.push('</div>');
        html.push('<div class="feedPreview"></div>');
        html.push('</div>');

        html.push('<div class="plusIcon" tabindex="' + (feed.TabIndex + 1) + '">');
        html.push('<i class="icon-add button"></i>');
        html.push('</div>');
        html.push('</section>');

        html.push('<section class="additionalInfo">');
        html.push('<span class="addpop title">Popularity: </span>');
        html.push('<div class="popularity-star">');
        html.push('<span class="popularity-star-full ' + SocialTab.HTML_PopularityRating(feed.TotalSubscribers) + '"></span>');
        html.push('</div>');
        html.push('<br />');
        html.push('<span class="title">Feed Url: </span>');
        html.push('<span class="feedUrl"><a href="' + feed.FeedUrl + '" target="_blank" tabindex="' + (feed.TabIndex + 91) + '">' + feed.FeedUrl + '</a></span>');
        html.push('<br />');
        html.push('<span class="title">Feed Description: </span>');
        html.push('<span>' + feed.Description + '</span>');
        html.push('<div class="previewBtn">');
        html.push('<a href="#" class="btn blue preview" tabindex="' + (feed.TabIndex + 92) + '">Preview</a>');
        html.push('</div>');
        html.push('</section>');

        $item.html(html.join(""));

        $item.on("click", ".headline", function () {
            self.Open_FeedPreview(feed, $item);
        });

        $item.on("click", ".arrow", function () {
            SocialTab.HTML_Event_RenderAdditionalInfoArrowClick($(this));
        });

        $item.on("click", ".plusIcon", function () {
            $(this).closest(".gridList").children("li").removeClass("selected");
            $(this).closest("li").addClass("selected");

            self.Setup_SideSectionMenu(feed);
        });

        $item.on("click", ".preview", function () {
            self.Open_FeedPreview(feed, $item);
        });

        return $item;
    },

    _$googleNewsItem: function (topic) {
        var self = this;

        var $item = $("<li/>", {
            "class": "overflow",
            "data-feed-id": topic.Id,
            "data-feed-url": topic.RssUrl,
            "data-domain": topic.SiteUrl
        });
        var html = [];

        html.push('<section class="mainInfo">');
        html.push('<div class="itemImageContainer">');
        if (topic.ArtichleType === "Topic") {
            html.push('<img class="itemImage" src="https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png" />');
        } else {
            html.push('<img class="itemImage" src="http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/googleNewsIcon_' + topic.ArtichleType + '.png" />');
        }
        html.push('</div>');

        html.push('<div class="information">');
        html.push('<span class="headline" tabindex="' + topic.TabIndex + '">' + topic.Title + '</span>');
        html.push('<span class="title">GOOGLE NEWS / ' + topic.SiteUrl + '</span>');
        if (topic.ArtichleType === "Topic") {
            html.push('<span class="googleNewsEdition"><img class="imgEditionLabel" /><label class="labelEditionLabel"></label></span>');
        }

        html.push('<div class="popularity-star"><span class="popularity-star-full"></span></div>');

        html.push('<div class="additionalBtns">');
        html.push('<a href="#" class="btn arrow" data-tooltip="tooltip" title="" data-original-title="More&nbsp;Details" tabindex="' + (topic.TabIndex + 90) + '">');
        html.push('<i class="icon-angle-down"></i>');
        html.push('</a>');
        html.push('</div>');
        html.push('<div class="feedPreview"></div>');
        html.push('</div>');

        html.push('<div class="plusIcon" style="position: relative; margin-top: 0;" tabindex="' + (topic.TabIndex + 1) + '"><i class="icon-add button"></i></div>');
        html.push('</section>');

        html.push('<section class="additionalInfo">');
        html.push('<span class="addpop title">Popularity: </span>');
        html.push('<div class="popularity-star"><span class="popularity-star-full"></span></div><br />');
        html.push('<span class="title">Feed Url: </span>');
        html.push('<span class="feedUrl"><a href="' + topic.RssUrl + '" target="_blank" tabindex="' + (topic.TabIndex + 91) + '">' + topic.RssUrl + '</a></span><br />');
        html.push('<span class="title">Feed Description: </span>');
        html.push('<span>' + topic.Description + '</span>');
        html.push('<div class="previewBtn"><a href="#" class="btn blue preview" tabindex="' + (topic.TabIndex + 92) + '">Preview</a></div>');
        html.push('</section>');

        $item.html(html.join(""));

        $item.on("error", ".itemImage", function () {
            this.onerror = null;
            this.src = "http://cdn-storage-staging-nt.newstab.com/cdnstaging/Media/Images/rss-logo.png";
        });
        $item.on("click", ".headline", function (e) {
            SocialTab.HTML_OpenFeedPreview($(this));
        });
        $item.on("click", ".arrow", function (e) {
            SocialTab.HTML_Event_RenderAdditionalInfoArrowClick($(this));
        });

        $item.on("click", ".plusIcon", function (e) {
            $(this).closest(".gridList").children("li").removeClass("selected");
            $(this).closest("li").addClass("selected");

            self.Setup_SideSectionMenu(topic);
        });

        $item.on("click", ".preview", function (e) {
            SocialTab.HTML_OpenFeedPreview($(this));
        });

        return $item;
    },

    _$feedCountItem: function (feed) {

        var $item = $("<div/>", {
            "class": "showingResults"
        });

        var html = [];

        html.push('<div class="showingResultsTitle">');
        if (feed.Type == "1") {
            html.push('Results for <strong>#' + feed.Query + '</strong> (<span class="numberOfFeeds">' + feed.TotalResults + '</span> feeds):');
        }
        else {
            html.push('Results for <strong>' + feed.Query + '</strong> (<span class="numberOfFeeds">' + feed.TotalResults + '</span> feeds):');
        }
        html.push('</div>');

        $item.html(html.join(""));

        return $item;
    },

    _$feedsPreview: function (feed) {
        var self = this;

        var $item = $("<div/>", {
            "class": "feedPreviewBody"
        });

        var html = [];

        html.push('<header class="socialTabHeader">');
        html.push('<div class="logo">');
        html.push('<span class="feedPreviewTitle">' + feed.Title + '</span><br/>');
        html.push('<span class="feedPreviewUrl">' + feed.FeedUrl + '</span>');
        html.push('</div>');
        html.push('<div class="buttonGroup">');
        html.push('<a href="#" class="btn blue add closeNotification" style="margin-right: 10px; width: 145px;" tabindex="1000">+ Add to NewsTab</a>');
        html.push('<a href="#" class="btn gray cancel closeNotification"  tabindex="1001">Cancel</a>');
        html.push('</div>');
        html.push('</header>');
        html.push('<div class="feedsPage">');
        html.push('<div class="loadingAnimation">');
        html.push('<div style="position: relative; width: 100%;">');
        html.push('<span class="color1"></span>');
        html.push('<span class="color2"></span>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div id="articles_preview_grid" class="size-300 font-size-2" tabindex="1002"></div>');
        html.push('</div>');

        $item.html(html.join(""));

        $item.on("click", ".add", function () {
            self.Setup_SideSectionMenu(feed);
        });

        return $item;
    },

    _$filterPreview: function (filter) {

        var $item = $("<div/>", {
            "class": "feedPreviewBody"
        });

        var html = [];

        html.push('<header class="socialTabHeader">');
        html.push('<div class="logo">');
        html.push('<span class="feedPreviewTitle">' + filter.Title + '</span>');
        html.push('</div>');
        html.push('<div class="buttonGroup">');
        html.push('<a href="#" class="btn blue add closeNotification" style="margin-right: 10px; width: 145px;" tabindex="1000">+ Add to NewsTab</a>');
        html.push('<a href="#" class="btn gray closeNotification"  tabindex="1001">Cancel</a>');
        html.push('</div>');
        html.push('</header>');
        html.push('<section class="slice animate-hover-slide">');
        html.push('<div class="feedsPage">');
        html.push('<div class="loadingAnimation">');
        html.push('<div style="position: relative; width: 100%;">');
        html.push('<span class="color1"></span>');
        html.push('<span class="color2"></span>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div id="articles_preview_grid" class="size-300 font-size-2" tabindex="1002"></div>');
        html.push('</div>');
        html.push('</section>');

        $item.html(html.join(""));

        $item.on("click", ".add", function () {
            var isHashtag = filter.Title.substr(0, 1) == "#" ? true : false;
            if (isHashtag) {
                $(".searchTagResultHash li[data-value=" + filter.Title.substr(1) + "]", "#contentTwitterFeed").addClass("selected");
            }
            else {
                $(".searchTagResultUser li[data-value=" + filter.Title.substr(1) + "]", "#contentTwitterFeed").addClass("selected");
            }

            $(".searchTagResult", "#contentTwitterFeed").css("height", "calc(100% - 50px)");
            $("#addTwitterFeedBtnField").show();
        });

        return $item;
    },

    Calculate_FeedPreview_ItemNumber: function () {
        var width = $("#feedPreview").width();
        if (width >= 300 && width < 520) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 1;
        } else if (width >= 520 && width < 770) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 2;
        } else if (width >= 770 && width < 1021) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 3;
        } else if (width >= 1021 && width < 1400) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 4;
        } else if (width >= 1400 && width < 1921) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 5;
        } else if (width >= 1921 && width < 2550) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 6;
        } else if (width >= 2550 && width < 3020) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 7;
        } else if (width >= 3020 && width < 3700) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 8;
        } else if (width >= 3700) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 9;
        }
    },

    Calculate_FeedPrevirew_ItemSize: function () {
        var self = this;
        var $feedPreview = $("#feedPreview");

        if ($feedPreview.length === 1) {
            self.Calculate_FeedPreview_ItemNumber();

            var width = $feedPreview.width();
            var gridSizes = [];

            $.each(NewsTab.Modules.ArticleView.ItemSettings.BoxSizes, function (i, n) {
                var gridSize = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes[i] * NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview;
                if (width >= gridSize) {
                    gridSizes.push(gridSize);
                }
            });

            var feedGridWidth = NewsTab.Helpers.FindClosestItem(gridSizes, width);

            NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview = feedGridWidth / NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview;
            $feedPreview.removeClass("grid-size-0");
            $feedPreview.removeClass("grid-size-1");
            $feedPreview.removeClass("grid-size-2");
            $feedPreview.removeClass("grid-size-3");
            $feedPreview.removeClass("grid-size-4");
            $feedPreview.removeClass("grid-size-5");
            $feedPreview.removeClass("grid-size-6");
            $feedPreview.addClass("grid-size-" + NewsTab.Modules.ArticleView.ItemSettings.BoxSizes.indexOf(NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview));

            $(".feedPreviewBody", $feedPreview).width(feedGridWidth);
            $(".feedsPage", $feedPreview).width(feedGridWidth + 30);

            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes.indexOf(NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview);

            self.Calculate_FeedPreview_BoxSizes();
            if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout !== "layout-list" && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout !== "layout-compact") {
                $(".socialTabItem", $feedPreview).attr("style", "width:" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview +
                    "px!important; height:0; padding-bottom:" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview + "px!important;");
            }

            $feedPreview.removeClass(function (index, css) { return (css.match(/\bsize-\S+/g) || []).join(" "); }).addClass("size-" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview);
        }
    },

    Calculate_FeedPreview_BoxSizes: function () {
        NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview;
        NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes[NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview];

        $("#feedPreview").removeClass(function (index, css) { return (css.match(/\bsize-\S+/g) || []).join(" "); }).addClass("size-" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview);

        var actualSize = NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview;
        var posibleNumberOfIments = parseInt(($("#feedPreview").width()) / actualSize, 10);
        var width = actualSize * posibleNumberOfIments;

        $("#feedPreview .feedPreviewBody").width(width);
        $("#feedPreview .feedsPage").width(width + 30);
    },

    Open_FeedPreview: function (feed, $feedItem) {
        var self = this;


        $feedItem.siblings().removeClass("selected");
        $feedItem.addClass("selected");

        var selectedUrl = $feedItem.data("feed-url");

        var newFeed = new Feed().Init({
            Id: $feedItem.data("feed-id"),
            Name: $feedItem.find(".headline").html(),
            Url: selectedUrl,
            SiteUrl: $("li.selected .information .title").html(),
            Icon: $("li.selected .itemImage").attr("src"),
            Type: Feed.TYPES.RSS,
            Language: NewsTab.Modules.SectionsManager.PreviewSection.Language,
            Count: Feed.DEFAULT_COUNT,
            OrderNumber: 0,
            Layout: "layout-grid",
            LayoutType: 0,
            ShowInList: true,
            ApiUrl: NewsTab.ApiUrl_Global,
            EditMenuIcon: "icon-more",
            EditMenuClass: "editRssFeed",
            SectionId: NewsTab.Modules.SectionsManager.PreviewSection.Id
        });

        var $preview = self._$feedsPreview(feed);

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Id: "feedPreview",
            Title: $("<div/>", { "class": "title", "html": "<h4>Feed Preview</h4>" }),
            Text: $preview,
            MaxWidth: 960,
            Height: "100vh",
            Width: "100%",
            CloseOnOutsideClick: true,
            ScrollableText: false,
            FullscreenOption: true,
            Buttons: [],
            OnShow: function () {
                self.Calculate_FeedPrevirew_ItemSize();

                NewsTab.Modules.SectionsManager.LoadFeed(newFeed, $.extend({}, NewsTab.Modules.ArticleView.PREVIEW_SETTINGS, { Refresh: true }));
            }
        });

        //SocialTab.HTML_FeedPreviewScrool();
        //SocialTab.HTML_SetupScrollOutOfBox(true);
        //$("#feedPreview .loadingAnimation span.color1").css({ "background-color": NewsTab.Modules.SectionsManager.CurrentSection.Color });
        //$("#feedPreview .loadingAnimation span.color2").css({ "background-color": SocialTab.LightenDarkenColor(NewsTab.Modules.SectionsManager.CurrentSection.Color, 70) });
    },

    Open_TwitterFeedPreview: function ($filterItem) {
        var self = this;

        var isHashTag = $filterItem.data("type") == "hashtag";
        var name = (isHashTag ? "#" : "@") + $filterItem.data("value");

        var $preview = self._$filterPreview({
            Title: name,
            EncodedTitle: encodeURIComponent(name)
        });

        var newFeed = new Feed().Init(
            {
                Id: NewsTab.EMPTY_GUID,
                Name: name,
                SiteUrl: "twitter.com",
                Icon: null,
                Type: Feed.TYPES.TWITTER,
                Language: "en-US",
                Count: Feed.DEFAULT_COUNT,
                OrderNumber: 0,
                Layout: "layout-grid",
                LayoutType: 0,
                ShowInList: true,
                ApiUrl: NewsTab.ApiUrl_Base + (isHashTag ? "api/twitter/get/hashtagfeed/{count}/{min_id}/{max_id}/{special_parameter}" : "api/twitter/get/usertagfeed/{count}/{min_id}/{max_id}/{special_parameter}"),
                EditMenuIcon: "icon-angle-down",
                EditMenuClass: "deleteSpecialFeed",
                SpecialParameter: name.substr(1),
                SectionId: NewsTab.Modules.SectionsManager.PreviewSection.Id
            });

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Id: "feedPreview",
            Title: $("<div/>", { "class": "title", "html": "<h4>Twitter Filter Preview</h4>" }),
            Text: $preview,
            MaxWidth: 960,
            Height: "100vh",
            Width: "100%",
            CloseOnOutsideClick: true,
            ScrollableText: false,
            FullscreenOption: true,
            Buttons: [],
            OnShow: function () {
                self.Calculate_FeedPrevirew_ItemSize();
                NewsTab.Modules.SectionsManager.LoadFeed(newFeed, $.extend({}, NewsTab.Modules.ArticleView.PREVIEW_SETTINGS, { Refresh: true }));
            }
        });

        //SocialTab.HTML_TwitterFeedPreviewScrool();
        //$(".feedPreview .loadingAnimation span.color1").css({ "background-color": NewsTab.Modules.SectionsManager.CurrentSection.Color });
        //$(".feedPreview .loadingAnimation span.color2").css({ "background-color": SocialTab.LightenDarkenColor(NewsTab.Modules.SectionsManager.CurrentSection.Color, 70) });
    },

    Open_GoogleNewsPreview: function (feed) {
        var self = this;

        //if (type === "googleNewsKwdSection") {
        //    title = $("#" + type).find(".createGNKwdTitle").val().trim();
        //    term = $("#" + type).find(".createGNKwdTerm").val().trim();
        //    region = $("#" + type).find("#googleNewsKwdEditionValue").val() != undefined ? $("#" + type).find("#googleNewsKwdEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
        //    url = "https://news.google.com/news/rss/headlines/section/q/" + term + "?ned=" + region.toLowerCase() + "&num=30";
        //} else {
        //    title = $("#" + type).find(".createGNLctTitle").val().trim();
        //    location = $("#" + type).find(".createGNLctLocation").val().trim();
        //    region = $("#" + type).find("#googleNewsLctEditionValue").val() != undefined ? $("#" + type).find("#googleNewsLctEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
        //    url = "https://news.google.com/news/rss/headlines/section/geo/" + location + "?ned=" + region.toLowerCase() + "&num=30";
        //}

        var newFeed = new Feed().Init(
            {
                Id: NewsTab.EMPTY_GUID,
                Name: feed.Title,
                Url: feed.FeedUrl,
                SiteUrl: feed.Domain,
                Icon: feed.IconUrl,
                Type: Feed.TYPES.RSS,
                Language: feed.Language,
                Count: Feed.DEFAULT_COUNT,
                OrderNumber: 0,
                Layout: "layout-grid",
                LayoutType: 0,
                ShowInList: false,
                ApiUrl: NewsTab.ApiUrl_Global,
                EditMenuIcon: "icon-more",
                EditMenuClass: "editRssFeed",
                SectionId: NewsTab.Modules.SectionsManager.PreviewSection.Id
            });

        var $preview = self._$feedsPreview(feed);

        NewsTab.Modules.NotificationsManager.Open_Modal({
            Id: "feedPreview",
            Title: $("<div/>", { "class": "title", "html": "<h4>Feed Preview</h4>" }),
            Text: $preview,
            MaxWidth: 960,
            Height: "100vh",
            Width: "100%",
            CloseOnOutsideClick: true,
            ScrollableText: false,
            FullscreenOption: true,
            Buttons: [],
            OnShow: function () {
                self.Calculate_FeedPrevirew_ItemSize();
                NewsTab.Modules.SectionsManager.LoadFeed(newFeed, $.extend({}, NewsTab.Modules.ArticleView.PREVIEW_SETTINGS, { Refresh: true }));
            }
        });
    },
    /*********************************/
    /*********************************/
    /*********************************/
    _$addNewContentTitle: function () {
        var $title = $("<div/>", { "class": "title" });

        var html = [];
        html.push('<div class="dropdown" data-space="true" tabindex="1000">');
        html.push('<button class="icon-more"></button>');
        html.push('<ul class="dropdown-menu\">');
        html.push('<li class="addContentItem" data-tab-select="#tabFeeds"><span>New Feed</span></li>');
        html.push('<li class="addContentItem" data-tab-select="#tabSections"><span>New Section</span></li>');
        html.push('</ul>');
        html.push('</div>');
        html.push('<h4>Add Content to NewsTab</h4>');

        $title.html(html.join(""));

        $("button", $title).on("click", function (e) {
            $(this).closest(".dropdown").toggleClass("open");
        });
        return $title;
    },

    _$addNewContentFeedTabMenu: function () {
        var self = this;

        var $tabMenu = $("<div/>", { "class": "tabMenu" });

        var html = [];
        html.push("<a id=\"tabPublishers\" href=\"#popularPublishersTabSection\" data-toggle=\"tab\" aria-controls=\"popularPublishersTabSection\" role=\"tab\" class=\"popularTabSection popularPublishersTabSection shadow active\" data-space=\"true\" tabindex=\"1001\">Popular</a>");
        html.push("<a id=\"tabRegionPublishers\" href=\"#regionPublishersTabSection\" data-toggle=\"tab\" aria-controls=\"regionPublishersTabSection\" role=\"tab\" class=\"popularTabSection regionPublishersTabSection shadow\" data-space=\"true\" tabindex=\"1002\">Local</a>");
        html.push("<a id=\"tabTopics\" href=\"#popularTopicsTabSection\" data-toggle=\"tab\" aria-controls=\"popularTopicsTabSection\" role=\"tab\" class=\"popularTabSection popularTopicsTabSection shadow\" tabindex=\"1003\">Topics</a>");
        html.push("<a id=\"tabTwitter\" href=\"#contentTwitterFeed\" data-toggle=\"tab\" aria-controls=\"twitterFeeds\" role=\"tab\" class=\"popularTabSection twitterFeedsLink shadow\" tabindex=\"1004\">Twitter</a>");
        html.push("<a id=\"tabCustom\" href=\"#contentCustom\" data-toggle=\"tab\" aria-controls=\"contentCustom\" role=\"tab\" class=\"popularTabSection customFeedsLink shadow\" tabindex=\"1005\">Import</a>");
        html.push("<a id=\"tabOrganizer\" href=\"#organizerSectionFeeds\" data-toggle=\"tab\" aria-controls=\"organizer\" role=\"tab\" class=\"popularTabSection organizerSectionFeedsLink shadow\" tabindex=\"1006\">Organize</a>");
        html.push("<span class=\"editionDropdown shadow\" style=\"width: 250px; margin-right: 0;\"><select id=\"mainEditionsDropdown\" name=\"mainEditionsDropdown\" data-space=\"true\" tabindex=\"1007\"></select></span>");

        $tabMenu.html(html.join(""));

        $("a[data-toggle=tab]", $tabMenu).on("click", function (e) {
            self.Update_AddNewContent("#tabFeeds", $(this).attr("id"));
            //$(this).siblings().removeClass("active");
            //$(this).addClass("active");
            //$(this).tab("show");

            //var $addNewContent = $("#addNewContent");

            //$addNewContent.removeClass(function (index, css) { return (css.match(/(^|\s)selected_\S+/g) || []).join(" "); });
            //$addNewContent.addClass("selected_" + $(this).attr("id"));

            //$addNewContent.removeClass("showSideSections");

            //$("#backToPopularBtn", $("#addNewContent")).click();
            // Get Local publishers once when user click on Local tab
            //if ($(this).attr("href") === "#regionPublishersTabSection") {
            //    if ($(".regionPublishers li", $addNewContent).length === 0) {
            //        NewsTab.Modules.SectionsManager.API_GetPublishersByRegion(NewsTab.Modules.RegionManager.AddFeedEdition);
            //    }
            //}

            //if (SocialTab.AutocompleteElm != null) {
            //    SocialTab.AutocompleteElm.hide();
            //    $("input.autoclear", $addNewContent).val("");
            //}
            //$(".urlContainer input", $addNewContent).focus();
        });

        $("#mainEditionsDropdown", $tabMenu).on("change", function (e) {
            self.Change_Region($(this));
        });

        return $tabMenu;
    },

    _$addNewContentFeedTabSearch: function () {
        var self = this;

        var $searchHeader = $("<div>", {
            "class": "tabHeader"
        });

        var html = [];

        html.push('<div class="organizerHeader">Select a section to organize its content (drag and drop to other sections, edit or remove)<hr />');
        html.push('<div id="importStats">');
        html.push('<p><span id="nbrNewSections">0</span> new Sections created, <span id="nbrEditSections">0</span> existing Sections with new feeds and <span id="nbrNewFeeds">0</span> new Feeds added.</p>');
        html.push('<div class="importControls">');
        html.push('<a class="btn gray action-discard" href="#">Discard</a> ');
        html.push('<a class="btn blue action-finish" href="#">Finish</a>');
        html.push('</div>');
        html.push('</div>');
        html.push('</div>');

        html.push('<img class="importPenguin" src="/Media/Images/import-feed-pinguin.png" />');

        html.push('<div id="contentBackButton" class="backPopularBtn">');
        html.push('<img src="/Media/Images/back-icon.png"><span>Back</span>');
        html.push('</div>');

        html.push('<div class="autocomplete urlContainer uk-autocomplete uk-form" id="autocomplete">');
        html.push('<div id="backBtn" class="backPopularBtn" tabindex="1008">');
        html.push('<img src="/Media/Images/back-icon.png" /><span>Back</span>');
        html.push('</div>');
        html.push('<input class="clearable" id="feedSearchInput" type="text" placeholder="" tabindex="1009" />');
        html.push('<a id="feedSearchButton" href="#" class="disabled"><i class="icon-search icon-2x"></i></a>');
        html.push('<span class="searchLoader"><i class="icon"><span class="spinner"></span></i></span>');
        html.push('</div>');

        $searchHeader.html(html.join(""));

        $searchHeader.on("click", "#feedSearchButton", function (e) {

            var url = $("#feedSearchInput").val();
            if (url && url.length > 0) {
                if (self.SearchType === "twitter") {
                    self.SearchFilter(url);
                } else {
                    self.SearchFeeds(url);
                }
            }
        });

        $(".action-dicard").on("click", function (e) {
            NewsTab.Modules.OpmlImportExport.Discard();
        });

        $(".action-finish").on("click", function (e) {
            NewsTab.Modules.OpmlImportExport.Finish();
        });

        var searchTimeout = null;

        $("#feedSearchInput", $searchHeader).on("keyup paste", function (e) {
            clearTimeout(searchTimeout);

            var $control = $(this);
            searchTimeout = setTimeout(function () {
                var url = $control.val();

                if (url && url.length > 0) {
                    $("#feedSearchButton", $searchHeader).removeClass("disabled");

                    if (e.keyCode === 13 || e.type === "click") {
                        if (self.SearchType === "twitter") {
                            self.SearchFilter(url);
                        } else {
                            self.SearchFeeds(url);
                        }
                    }
                } else {
                    $("#feedSearchButton", $searchHeader).addClass("disabled");
                    if (self.SearchType === "twitter") {
                        $(".searchTagResult", "#contentTwitterFeed").remove();
                        $("#contentTwitterFeed").removeClass("withSearchResults");
                    }
                }
            }, 100);
        });

        $("#backBtn", $searchHeader).on("click", function (e) {
            self.Update_AddNewContent(self.ActiveTab, self.ActiveSecondTab, self.AdditionalAction);
        });

        $("#contentBackButton", $searchHeader).on("click", function (e) {
            self.Setup_Custom(null, true);
        });

        return $searchHeader;
    },

    _$addNewContentFeedTabContent: function () {
        var $contentFeeds = $("<div/>", {
            "id": "contentFeeds",
            "role": "tabpanel",
            "class": "mainPanel tab-pane"
        });

        // Sections Side Panel Container
        $contentFeeds.append("<div class=\"sectionsSidePanel\"></div>");

        $contentFeeds.append(NewsTab.Modules.AddNewContent._$addNewContentFeedTabMenu());
        $contentFeeds.append(NewsTab.Modules.AddNewContent._$addNewContentFeedTabSearch());

        var html = [];
        // Main Tab Content
        html.push("<div id=\"addNewContentFeedTabs\">");
        html.push("<div id=\"popularPublishersTabSection\" role=\"tabpanel\" class=\"feedsPanel tab-pane active\"></div>");
        html.push("<div id=\"regionPublishersTabSection\" role=\"tabpanel\" class=\"feedsPanel tab-pane\"></div>");
        html.push("<div id=\"popularTopicsTabSection\" role=\"tabpanel\" class=\"feedsPanel tab-pane\"></div>");
        html.push("</div>");

        // Loader
        html.push("<div class=\"loadingAnimation\">");
        html.push("<div style=\"position: relative; width: 100%;\"><span class=\"color1\"></span><span class=\"color2\"></span></div>");
        html.push("</div>");

        $contentFeeds.append(html.join(""));
        $contentFeeds.append("<div id=\"sideSectionMenu\"></div>");
        $("#addNewContentFeedTabs", $contentFeeds).append(NewsTab.Modules.AddNewContent.$_FeedsCustomContent());
        $("#addNewContentFeedTabs", $contentFeeds).append(NewsTab.Modules.AddNewContent.$_FeedsTwitterContent());
        $("#addNewContentFeedTabs", $contentFeeds).append(NewsTab.Modules.AddNewContent.$_FeedsOrganizeContent());

        return $contentFeeds;
    },


    _$addNewContentTabContent: function () {
        var self = this;

        var $tabContent = $("<div/>", {
            "class": "tab-content",
            "role": "tabpanel"
        });

        $tabContent.append(NewsTab.Modules.AddNewContent._$sections());
        $tabContent.append(NewsTab.Modules.AddNewContent._$addNewContentFeedTabContent());

        return $tabContent;
    },


    LoadingAnimation_Start: function () {
        $("#addNewContent .loadingAnimation").addClass("loading");
    },

    LoadingAnimation_Stop: function () {
        $("#addNewContent .loadingAnimation").removeClass("loading");
    },

    /**/
    VerifySectionNameChange: function ($control, $primaryButton) {
        if ($control.val().length > 1 && $control.val().length <= 50) {
            $control.closest(".newItem").find(".iconPreview").html($control.val().substring(0, 2));
            $primaryButton.removeClass("disabled");
        } else {
            $control.closest(".newItem").find(".iconPreview").html("");
            $primaryButton.addClass("disabled");
        }
    },
    /**/
    SearchFeeds: function (query) {
        var self = this;

        //SocialTab.SearchFilter(this);
        if (query[0] === "#") {
            self.SearchType = "1";
            query = url.substring(1);
        } else {
            self.SearchType = "3";
        }

        self.GetFeedsList({
            $Container: $('#addNewContent .feedsPanel.active .gridList'),
            Url: query,
            Type: "ALL",
            SkipRecords: 0,
            Reset: true
        });
    },

    SearchFilter: function (query) {
        $("#contentTwitterFeed").addClass("withSearchResults");
        NewsTab.Modules.SectionsManager.API_GetTwitterTags(query);
    },


    ShowBackButton: function (show) {
        var self = this;

        NewsTab.Modules.XhrManager.CancelAllRequests();
        if (show) {
            self.BackLevel++;
            $("#backBtn").addClass("show");
            $("#backBtn").parents(".urlContainer").find("input").addClass("backInputText");
        } else {
            if (self.BackLevel > 0) {
                self.BackLevel--;
            }
            if (self.BackLevel === 0) {
                $("#backBtn").removeClass("show");
                $("#backBtn").parents(".urlContainer").find("input").removeClass("backInputText");
            }
        }
    },


    GetFeedsList: function (options) {
        var self = this;

        var opt = $.extend({
            $Container: null,
            Url: null,
            Type: null,
            SkipRecords: 0,
            Reset: false
        }, options);

        if (opt.Reset) {
            self.Reset_SearchData();
        }

        var $addNewContent = $("#addNewContent");

        if (opt.$Container !== null) {
            opt.$Container.addClass("searchResults");
        }

        if (self.Page === 0) {
            if (opt.$Container !== null) {
                opt.$Container.html("");
            }

            self.ShowBackButton(true);
            //NewsTab.Modules.AddNewContent.SearchUrl = url;
            //NewsTab.Modules.AddNewContent.AutocompleteSearchType = type;
            //NewsTab.Modules.RegionManager.PreviousEdition = undefined;
            //SocialTab.HTML_SetupSearchSection("#contentFeeds");
            //NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), true);
            //NewsTab.Modules.AddNewContent.ShowBackButton(true);
        }

        var beforeSendCallback = function () {
            $(".errorScreen", $addNewContent).remove();
        };

        var errorCallback = function (error) {
            self.SearchEventComplete = true;
            self.LoadingAnimation_Stop();
            //NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
            //NewsTab.Modules.AddNewContent.DisplayErrorScreen($("#contentFeeds .searchResults").find(".searchItems"), true);
            //$("#contentFeeds .errorScreen .feedRetry").attr("onclick", "NewsTab.Modules.AddNewContent.API_SearchFeed($('#contents'), '" + url + "', " + skipRekords + ")");
        };

        var successCallback = function (data) {
            self.SearchEventComplete = true;

            if (self.Page === 0) {
                if (opt.Url.indexOf("http://") === -1 && opt.Url.indexOf("https://") === -1 && opt.Url.indexOf("www.") === -1) {
                    if ($(".showingResults", opt.$Container.parent()).length === 0) {
                        opt.$Container.parent().prepend(self._$feedCountItem({ Query: opt.Url, TotalResults: data.TotalResults, Type: self.SearchType }));
                    } else {
                        $(".showingResults .numberOfFeeds", opt.$Container).html(SocialTab.CalculateNumberOfFeeds(opt.Url, data.TotalResults));
                    }
                }
            }

            if (data.Feeds.length) {
                var tabIndex = 1510;
                data.Feeds.forEach(function (s) {
                    var existingFeed = NewsTab.Modules.SectionsManager.GetFeedById(s.FeedId, null);
                    if (existingFeed != null) {
                        s.FeedExist = "added";
                    }
                    s.TabIndex = tabIndex;
                    if (opt.$Container !== null) {
                        opt.$Container.append(self._$feedListItem(s));
                    }
                    tabIndex += 100;
                });

                opt.$Container.parent().unbind();
                opt.$Container.parent().scroll(function (e) {
                    if (($(this).scrollTop() + $(this).innerHeight()) >= (this.scrollHeight - 100)) {
                        if (self.SearchEventComplete && self.SearchDataAvailible) {

                            self.SearchEventComplete = false;
                            self.LoadingAnimation_Start();

                            if (self.Page === undefined) {
                                self.Page = 0;
                            }
                            self.Page += 1;

                            opt.Reset = false;
                            opt.SkipRecords = self.ItemsPerPage * self.Page;
                            self.GetFeedsList(opt);
                        }
                    }
                });
            }
            else {
                self.SearchDataAvailible = false;
            }
            self.LoadingAnimation_Stop();
        };

        var successCallbackGoogleCategories = function (data) {
            self.SearchEventComplete = true;

            if (self.Page === 0) {
                //if ($(".showingResults").length === 0) {
                //    $("#contentFeeds .searchResults").find(".searchItems").prepend(self._$feedCountItem({ Query: "#news.google.com", TotalResults: SocialTab.CalculateNumberOfFeeds("news.google.com", 0, "GN"), Type: self.SearchType }));
                //} else {
                //    $(".showingResults .numberOfFeeds").html(SocialTab.CalculateNumberOfFeeds("news.google.com", 0, "GN"));
                //}
            }

            if (data && data.length > 0) {
                var tabIndex = 1010;
                data.forEach(function (t) {
                    t.TabIndex = tabIndex;
                    opt.$Container.append("<div id=\"googleNewsItemTopic_" + t.Id + "\"></div>");
                    $("#googleNewsItemTopic_" + t.Id, opt.$Container).append(self._$googleNewsItem(t));

                    var gnCode = $("#mainEditionsDropdown").find("option:selected").attr("data-googlenewscode");
                    if (gnCode === "") {
                        $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
                        $(".labelEditionLabel").text("United States");
                    } else {
                        $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
                        $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
                    }

                    //$("#googleNewsItemTopic_" + t.Id, opt.$Container).find(".feedPreview").html('');
                    //$("#googleNewsItemTopic_" + t.Id, opt.$Container).find(".feedPreview").append(self.$_CreateFeedsPreview({
                    //    Title: t.Title,
                    //    EncodedTitle: encodeURIComponent(t.Title),
                    //    FeedUrl: t.RssUrl,
                    //    Id: t.Id,
                    //    Domain: t.SiteUrl,
                    //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                    //}));

                    tabIndex += 100;
                });

                opt.$Container.parent().unbind();
                opt.$Container.parent().scroll(function (e) {
                    if (($(this).scrollTop() + $(this).innerHeight()) >= (this.scrollHeight - 100)) {
                        if (self.SearchEventComplete && self.SearchDataAvailible) {

                            self.SearchEventComplete = false;
                            self.LoadingAnimation_Start();

                            if (self.Page === undefined) {
                                self.Page = 0;
                            }
                            self.Page += 1;

                            opt.Reset = false;
                            opt.SkipRecords = self.ItemsPerPage * self.Page;
                            self.GetFeedsList(opt);
                        }
                    }
                });
            }
            else {
                self.SearchDataAvailible = false;
            }
            self.LoadingAnimation_Stop();
        };

        switch (opt.Type) {
            case "GOOGLENEWS":
                NewsTab.Modules.AddNewContent.SearchType = "3";
                if (NewsTab.Modules.AddNewContent.Page === 0) {
                    self.SearchGoogleNewsFromUrl(opt.Url);
                }
                break;
            case "TOPIC":
                self.SearchType = "1";
                NewsTab.Modules.SectionsManager.API_SearchFeed({
                    Url: opt.Url,
                    SkipRekords: opt.SkipRecords,
                    TakeRecords: self.ItemsPerPage,
                    SearchType: self.SearchType,
                    BeforeSendCallback: beforeSendCallback,
                    ErrorCallback: errorCallback,
                    SuccessCallback: successCallback
                });
                if (self.Page === 0) {
                    self.SearchGoogleNewsFromUrl(opt.Url);
                }
                break;
            case "SITE":
                self.SearchType = "3";
                if (opt.Url === "news.google.com") {
                    NewsTab.Modules.SectionsManager.API_GetGoogleNewsCategories({
                        Url: opt.Url,
                        SkipRekords: opt.SkipRecords,
                        TakeRecords: self.ItemsPerPage,
                        SearchType: self.SearchType,
                        BeforeSendCallback: beforeSendCallback,
                        ErrorCallback: errorCallback,
                        SuccessCallback: successCallbackGoogleCategories
                    });
                } else {
                    NewsTab.Modules.SectionsManager.API_SearchFeed({
                        Url: opt.Url,
                        SkipRekords: opt.SkipRecords,
                        TakeRecords: self.ItemsPerPage,
                        SearchType: self.SearchType,
                        BeforeSendCallback: beforeSendCallback,
                        ErrorCallback: errorCallback,
                        SuccessCallback: successCallback
                    });
                }
                break;
            case "PUBLISHER":
                self.SearchType = "3";
                NewsTab.Modules.SectionsManager.API_SearchFeed({
                    Url: opt.Url,
                    SkipRekords: opt.SkipRecords,
                    TakeRecords: self.ItemsPerPage,
                    SearchType: self.SearchType,
                    BeforeSendCallback: beforeSendCallback,
                    ErrorCallback: errorCallback,
                    SuccessCallback: successCallback
                });

                if (NewsTab.Modules.AddNewContent.Page === 0) {
                    self.SearchGoogleNewsFromUrl(url);
                }
                break;
            case "ALL":
                self.SearchType = "2";
                NewsTab.Modules.SectionsManager.API_SearchFeed({
                    Url: opt.Url,
                    SkipRekords: opt.SkipRecords,
                    TakeRecords: self.ItemsPerPage,
                    SearchType: self.SearchType,
                    BeforeSendCallback: beforeSendCallback,
                    ErrorCallback: errorCallback,
                    SuccessCallback: successCallback
                });

                if (opt.Url.indexOf("http://") > -1 || opt.Url.indexOf("https://") > -1 || opt.Url.indexOf("www.") > -1) {
                    SocialTab.GetFeedsFromUrl(sender, url);
                } else if (NewsTab.Modules.AddNewContent.Page === 0) {
                    self.SearchGoogleNewsFromUrl(opt.Url);
                }
                break;
            default:
                self.SearchType = "3";
                NewsTab.Modules.SectionsManager.API_SearchFeed({
                    Url: opt.Url,
                    SkipRekords: opt.SkipRecords,
                    TakeRecords: self.ItemsPerPage,
                    SearchType: self.SearchType,
                    BeforeSendCallback: beforeSendCallback,
                    ErrorCallback: errorCallback,
                    SuccessCallback: successCallback
                });

                if (self.Page === 0) {
                    self.SearchGoogleNewsFromUrl(opt.Url);
                }
        }

        setTimeout(function () {
            $("#autocomplete").removeClass("uk-open");
        }, 500);
    },

    DisplayErrorScreen: function ($container, retryCallback) {
        var self = this;

        $(".errorScreen", $container).remove();

        var result = "<div class=\"errorScreen\">";
        result += "<div class=\"table\">";
        result += "<div class=\"noIframe content\">";
        result += "<img src=\"/Media/DashboardImages/sorry_penguin.png\" />";
        result += "<h2>Oops...</h2>";
        result += "<p>Something went wrong!. Please check<br/> your internet connection and try again!</p>";
        result += "<p><span class=\"feedRetry btn blue\" style=\"width: 300px;height: 40px;line-height: 2;\" tabindex=\"1010\">Retry</span></p>";
        result += "</div>";
        result += "</div>";
        result += "</div>";

        $container.append(result);

        $(".feedRetry", $container).on("click", function () {
            if (retryCallback) {
                retryCallback();
            }
        });
    },

    Change_Region: function ($sender) {
        var self = this;

        var $selectedValue = $sender.find("option:selected");
        var gnCode = $selectedValue.data("googlenewscode");
        NewsTab.Modules.RegionManager.PreviousAddFeedEdition = NewsTab.Modules.RegionManager.AddFeedEdition;
        NewsTab.Modules.RegionManager.AddFeedEdition = $selectedValue.data("countrycode");
        NewsTab.Modules.RegionManager.AddFeedEditionGnValue =
            $selectedValue.data("googlenewscode") !== "" ?
                $selectedValue.data("googlenewscode") : "US";

        if ($selectedValue.data("googlenewscode") === "US") {
            var options = {
                BeforeSendCallback: null,
                ErrorCallback: null,
                SuccessCallback: function () {
                    self.Setup_UsStates();
                }
            };
            NewsTab.Modules.RegionManager.API_GetUsStates(options);
        } else {
            var options = {
                Region: NewsTab.Modules.RegionManager.AddFeedEdition,
                BeforeSendCallback: null,
                ErrorCallback: null,
                SuccessCallback: function () {
                    self.Update_AddNewContent(self.ActiveTab, self.ActiveSecondTab, self.AdditionalAction);
                }
            };
            NewsTab.Modules.SectionsManager.API_GetPublishersByRegion(options);
        }

        if ($(".searchResults.showSearchItems .searchItems:visible").length > 0 && $(".searchResults.showSearchItems .searchItems .showingResultsTitle").html().indexOf("#news.google.com") > -1) {
            $(".searchResults.showSearchItems .searchItems").html("");
            SocialTab.GetGoogleNewsCategories();
        }

        if (gnCode === "") {
            gnCode = "US";
            $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
            $(".labelEditionLabel").text("United States");
        } else {
            $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
            $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
        }

        SocialTab.RenderSelectEdition($sender, gnCode);

        // Render Create Google Alert edition on change edition
        $("#addNewContent #googleNewsKwdSection .inputContainer.inputContainerDropdown").html("").html("<select id=\"edition_GnKwdRegion\" name=\"edition_GnKwdRegion\" onchange=\"SocialTab.HTML_RenderMainEditionAddFeed($(this));\"></select>");
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnKwdRegion"), false);

        // Render Create Google Location edition on change edition
        $("#addNewContent #googleNewsLctSection .inputContainer.inputContainerDropdown").html("").html("<select id=\"edition_GnLctRegion\" name=\"edition_GnLctRegion\" onchange=\"SocialTab.HTML_RenderMainEditionAddFeed($(this));\"></select>");
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnLctRegion"), false);
    },

    Reset_SearchData: function () {
        var self = this;

        self.Page = 0;
        self.SearchEventComplete = true;
        self.SearchDataAvailible = true;
    },

    Reset_AddNewContent: function () {
        var self = this;

        var $addNewContent = $("#addNewContent");
        $addNewContent.removeClass("showSideSectionMenu");

        $(".tabHeader", $addNewContent).replaceWith(self._$addNewContentFeedTabSearch());

        $("#doubleModal", $addNewContent).remove();
        $(".errorScreen", $addNewContent).remove();

        $(".dropdown", $addNewContent).removeClass("open");
        $(".mainPanel", $addNewContent).removeClass("active");

        $("#feedSearchInput", $addNewContent).val("");

        self.SearchType = "";

        self.Reset_SearchData();

        self.BackLevel = 0;
        self.ShowBackButton(false);

        $(".gridList", $addNewContent).unbind();

        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#mainEditionsDropdown"), false, NewsTab.Modules.RegionManager.AddFeedEdition);

        if (NewsTab.Modules.RegionManager.AddFeedEdition !== NewsTab.Modules.RegionManager.PreviousAddFeedEdition) {
            NewsTab.Modules.SectionsManager.RegionPublishers = [];
        }

    },

    Update_AddNewContent: function (mainTab, secondTab, additionalAction) {
        var self = this;

        var $addNewContent = $("#addNewContent");
        self.Reset_AddNewContent();

        self.ActiveTab = mainTab;
        self.ActiveSecondTab = secondTab;
        self.AdditionalAction = additionalAction;

        $(document.body).off("newcontent.addNewContent").on("newcontent.addNewContent", function (e, section) {
            self.Update_AddNewContent(self.ActiveTab, self.ActiveSecondTab, self.AdditionalAction);
        });

        if (self.ActiveTab === "#tabSections") {
            $("header h4", $addNewContent).html("New section");
            $("#contentSections", $addNewContent).addClass("active");
            self.Setup_Sections();

            $(document.body).off("setion:added.sections").on("setion:added.sections", function (e, s) {
                self.Setup_Sections();
            });
            $(document.body).off("setion:removed.sections").on("setion:removed.sections", function (e, s) {
                self.Setup_Sections();
            });
        }
        else {
            $("header h4", $addNewContent).html("New feed");
            $("#contentFeeds", $addNewContent).addClass("active");

            $addNewContent.removeClass(function (index, css) { return (css.match(/(^|\s)selected_\S+/g) || []).join(" "); });

            if (self.ActiveSecondTab === undefined) {
                self.ActiveSecondTab = "tabPublishers";
            }

            var $tabItem = $(".tabMenu #" + self.ActiveSecondTab, $addNewContent);

            if ($tabItem.length > 0) {
                $tabItem.siblings().removeClass("active");
                $tabItem.addClass("active");
                $tabItem.tab("show");

                switch (self.ActiveSecondTab) {
                    case "tabRegionPublishers":
                        self.Setup_RegionPublishersTab();
                        break;
                    case "tabTopics":
                        self.Setup_TopicsTab();
                        break;
                    case "tabTwitter":
                        self.Setup_Twitter();
                        break;
                    case "tabCustom":
                        self.Setup_Custom(null, true);
                        break;
                    case "OpmlImport":
                        self.Setup_Custom("contentImportOPML");
                        break;
                    case "OpmlExport":
                        self.Setup_Custom("contentExportOPML");
                        break;
                    case "tabOrganizer":
                        self.Setup_Organizer();
                        break;
                    case "tabPublishers":
                    default:
                        self.Setup_PopularPublishersTab();
                }
            }

            if (self.SearchType !== "twitter") {
                $("#feedSearchInput").attr("placeholder", "Search publisher (e.g. “cnn”), domain (e.g. “cnn.com”), topic (e.g. “sports”) or RSS URL (e.g. “http://rss.cnn.com/rss”)");
                //Init Autocomplete
                if (UIkit) {
                    UIkit.on('domready.uk.dom', function () {
                        UIkit.autocomplete($('#autocomplete'), {
                            minLength: 1,
                            source: self.API_GetAutocompleteData,
                            delay: 0,
                            template: self.HTML_AutocompleteTemplate()
                        });
                    });

                    $('.uk-autocomplete').on('select.uk.autocomplete', function (e, data) {
                        if (data == undefined || data.value == undefined) return;
                        self.Select_AutocompleteItem($(this), data.value, data.type, data.url);
                    });
                }
            } else {
                $("#feedSearchInput").attr("placeholder", "Search twitter hashtag (e.g. “#nasa”), usertag (e.g. “@NASA”) or both (e.g. “nasa”)");
            }
        }

        $(".tab-pane.active .tab-pane.active .gridList li", $addNewContent).css("font-size", ($(".tab-pane.active .tab-pane.active .gridList li", $addNewContent).first().width() / 10.0) + "px");
        if (NewsTab.Modules.Context != null) {
            NewsTab.Modules.Context.inputFocusKeys();
        }
    },


    Open_AddNewContent: function (tab, param) {
        var self = this;
        NewsTab.Modules.RegionManager.PreviousAddFeedEdition = NewsTab.Modules.RegionManager.AddFeedEdition;
        NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;

        if ($("#addNewContent").length !== 0) {
            self.Update_AddNewContent(tab, param);
        }
        else {
            NewsTab.Modules.NotificationsManager.Open_Modal({
                Id: "addNewContent",
                Title: self._$addNewContentTitle(),
                Text: self._$addNewContentTabContent(),
                MaxWidth: 960,
                Height: "100vh",
                Width: "100%",
                CloseOnOutsideClick: true,
                ScrollableText: false,
                FullscreenOption: true,
                Buttons: [],
                OnShow: function ($modal) {
                    self.Update_AddNewContent(tab, param);
                },
                OnResize: function ($modal) {
                    $(".tab-pane.active .tab-pane.active .gridList li", $modal).css("font-size", ($(".tab-pane.active .tab-pane.active .gridList li", $modal).first().width() / 10.0) + "px");
                }
            });
        }


           

    }
};