﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.Feedback = {

    OpenModal: function () {
        const self = this;
        NewsTab.Modules.NotificationsManager.Open_Modal({
            Id: "sendFeedback",
            Title: "Send Feedback",
            HeaderType: 0,
            Height: "auto",
            MaxHeight: "auto",
            Text: self.$_CreateForm(),
            FullscreenOption: false,
            Buttons: [
                {
                    Name: "Cancel",
                    Classes: ["btn gray closeNotification float-left"]
                },
                {
                    Name: "<span class=\"sendText\">Send</span><span class=\"searchLoader\" style=\"display: none;\"><i class=\"icon\"><span class=\"spinner\"></span></i></span>",
                    Classes: ["btn blue btn-send-feedback float-right"]
                }
            ],
            OnShow: function ($modal) {
                self.Setup_Dropzone();
                jQuery(function ($) {
                    function tog(v) { return v ? 'addClass' : 'removeClass'; }

                    $(document).on('input', '.clearable', function () {
                        $(this)[tog(this.value)]('x');
                    }).on('mousemove', '.x', function (e) {
                        $(this)[tog(this.offsetWidth - 18 < e.clientX - this.getBoundingClientRect().left)]('onX');
                    }).on('touchstart click', '.onX', function (ev) {
                        ev.preventDefault();
                        $(this).removeClass('x onX').val('').change();
                    });
                });

                $(".btn-send-feedback", $modal).on("click", function () {
                    self.Action_SendFeedback($(this));
                });
            }
        });
    },

    $_CreateForm: function () {
        var $form = $("<section/>");

        var html = [];

        html.push('<div>');
        html.push('<div class="input-block marging-bottom-15">');
        html.push('<span>Name</span>');
        html.push('<input type="text" placeholder="Name" id="fs-name" class="fs-input-field focus clearable" tabindex="1" required autofocus />');
        html.push('</div>');
        html.push('<div class="input-block marging-bottom-15">');
        html.push('<span>Your email address</span>');
        html.push('<input type="email" placeholder="Email" id="fs-email" class="stUserEmail fs-input-field clearable" tabindex="2" required />');
        html.push('</div>');
        html.push('<div class="input-block marging-bottom-15">');
        html.push('<span>What\'s on your mind?</span>');
        html.push('<textarea type="Text" placeholder="Send us your comments or suggestions..." id="fs-description" class="fs-input-field" tabindex="3" required></textarea>');
        html.push('</div>');
        html.push('<div class="input-block marging-bottom-15 rateContainer">');
        html.push('<span>Rate us</span>');
        html.push('<div class="rating" style="float: right;">');
        html.push('<input type="radio" id="star5" name="rating" value="5" /><label class="icon-star full" for="star5" title="Love"></label>');
        html.push('<input type="radio" id="star4" name="rating" value="4" /><label class="icon-star full" for="star4" title="Like"></label>');
        html.push('<input type="radio" id="star3" name="rating" value="3" /><label class="icon-star full" for="star3" title="Meh"></label>');
        html.push('<input type="radio" id="star2" name="rating" value="2" /><label class="icon-star full" for="star2" title="Dislike"></label>');
        html.push('<input type="radio" id="star1" name="rating" value="1" /><label class="icon-star full" for="star1" title="Hate"></label>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div class="fsDropZoneWrapper">');
        html.push('<div class="fsDropZoneTrigger">');
        html.push('<div class="fsDropTriggerIcon">');
        html.push('<i class="icon-paperclip"></i>');
        html.push('<span class="fsDropTriggerText">Add attachment</span>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div class="dropzone-previews"></div>');
        html.push('</div>');
        html.push('</div>');

        $form.html(html.join(""));
        return $form;
    },

    Setup_Dropzone: function () {
        var appId = 3887;
        var key = "iCTr8XgE3AYyHmV2UzHL5JlXg0TqZpKkVF5W8ba1J5y3iFNP8dsnxlRYzOUvdk06";

        $("#sendFeedback .fsDropZoneTrigger, #sendFeedback .fsDropTriggerIcon, #sendFeedback .fsDropTriggerText, #sendFeedback .fsDropTriggerIcon i").dropzone({
            url: "https://doorbell.io/api/applications/" + appId + "/upload?key=" + key,
            maxFilesize: 10, // MB
            addRemoveLinks: true,
            dictRemoveFile: "x",
            createImageThumbnails: false,
            previewsContainer: ".dropzone-previews",
            init: function () {
                this.on("success", function (file, response) {
                    var attachmentId = response.toString().replace(/[^\w\s]/gi, '');
                    $(file.previewElement).find(".dz-filename span").attr("data-dz-upload-id", attachmentId);
                });
            }
        });
    },


    Action_SendFeedback: function (sender) {
        var name = sender.closest("#sendFeedback").find("#fs-name");
        var email = sender.closest("#sendFeedback").find("#fs-email");
        var description = sender.closest("#sendFeedback").find("#fs-description");
        var rating = sender.closest("#sendFeedback").find(".rating input:checked");
        var key = "iCTr8XgE3AYyHmV2UzHL5JlXg0TqZpKkVF5W8ba1J5y3iFNP8dsnxlRYzOUvdk06";
        var appId = 3887;
        var url = "https://doorbell.io/api/applications/" + appId + "/submit";
        var attachmentsIds = [];
        var sentiment;
        var tags;

        if (rating.val() == undefined) {
            tags = "Feedback";
        } else {
            tags = "Feedback,Rating: " + rating.val();
        }

        if (rating.val() < 3) {
            sentiment = "negative";
        } else if (rating.val() === 3 || rating.val() == undefined) {
            sentiment = "neutral";
        } else {
            sentiment = "positive";
        }

        $.each($(".fsDropZoneWrapper").find(".dz-preview .dz-details .dz-filename"), function (index, data) {
            attachmentsIds.push(parseInt($(data).find("span").attr("data-dz-upload-id")));
        });

        name.val().length === 0 ? name.addClass("error") : name.removeClass("error");
        email.val().length === 0 ? email.addClass("error") : email.removeClass("error");
        description.val().length === 0 ? description.addClass("error") : description.removeClass("error");

        if (name.val().length > 0 && email.val().length > 0 && description.val().length > 0) {
            sender.addClass("showLoader");
            $.ajax({
                type: "POST",
                url: url,
                data: {
                    message: description.val(),
                    email: email.val(),
                    key: key,
                    sentiment: sentiment,
                    tags: tags,
                    properties: {
                        Application: "Feedback",
                        Rating: rating.val()
                    },
                    attachments: attachmentsIds
                },
                success: function () {
                    NewsTab.Modules.Feedback.SaveFeedback(name.val(), email.val(), description.val(), rating.val());
                    NewsTab.Modules.NotificationsManager.Close_Modal();
                }
            }).fail(function () {
                sender.removeClass("showLoader");
            });
        }
    },

    SaveFeedback: function (name, email, description, rating) {
        if (rating == undefined) rating = -1;
        $.ajax({
            type: "POST",
            url: NewsTab.ApiUrl_Global + "SaveFeedback?name=" + name + "&email=" + email + "&description=" + description +
                "&rating=" + rating + "&device=0"
        });
    }
};