﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.NotificationsManager = {

    NotificationQueu: [],
    NotificationOnCloseQueu: [],
    NotificationOnResizeQueu: [],
    NotificationQueuZIndex: 10,

    ToastsQueu: [],

    _$notificationsContainer: null,
    _$toastsContainer: null,

    MESSAGE: {
        Id: null,
        ShowTitle: true,
        Title: null,
        HeaderType: 0,
        Text: "",
        CenterText: false,
        ScrollableText: true,
        Width: 450,
        Height: 450,
        MinWidth: null,
        MinHeigth: null,
        MaxWidth: "100vw",
        MaxHeigth: "100vh",
        FullscreenOption: false,
        CenterButtons: false,
        Resizable: false,
        Draggable: false,
        IsTopModal: false,
        CloseOnOutsideClick: false,
        Buttons: [{ Name: "Ok", Action: "Close", Classes: [] }],
        /* Callbacks */
        OnShow: null,
        OnClose: null,
        OnResize: null
    },
    TOAST: {
        Id: null,
        ShowTitle: true,
        Title: "",
        HeaderType: 0,
        Text: "",
        Color: "default",
        IconUrl: null,
        CloseAfterMiliseconds: 3000,
        Buttons: [{ Name: null, Action: "Close", Classes: [] }],
        /* Callbacks */
        OnShow: null
    },

    Init: function () {
        var self = this;

        $("body").append('<div id="notificationsContainer"><div id="notification-container-bg"></div></div>');
        $("body").append('<div id="toastsContainer"></div>');

        self._$notificationsContainer = $("#notificationsContainer");
        self._$toastsContainer = $("#toastsContainer");

        self._$notificationsContainer.on("click", function (e) {
            if (e.target.id === "notification-container-bg") {
                e.preventDefault();
                if (self.NotificationQueu.length > 0) {
                    var $top = self.NotificationQueu[self.NotificationQueu.length - 1];
                    console.log($top.data("close-on-outclick"));
                    if ($top.data("close-on-outclick") === true && !$top.hasClass("disabled")) {
                        self.Close_Modal($top);
                    }
                }
            }
        });

        var res;

        $(window).on('resize.notification', function () {
            if (res) { clearTimeout(res); }
            res = setTimeout(function () {
                self.NotificationQueu.forEach(function (n, i) {
                    var h = n.height();
                    if (!n.hasClass("noButtons")) {
                        h -= 55;
                    }
                    if (!n.hasClass("noTitle")) {
                        h -= 45;
                    }

                    $(".notificationBody", n).css("height", "");
                    $(".notificationBody", n).css("height", h + "px");

                    NewsTab.Helpers.CenterContent(n, self._$notificationsContainer);

                    if (self.NotificationOnResizeQueu[i] !== null) {
                        self.NotificationOnResizeQueu[i](n);
                    }
                });
            }, 100);
        });
    },

    _$toastBody: function (options) {
        var self = this;

        var $nBody = $("<div/>", {
            "class": "toastMessage",
            "tabindex": -1
        });

        if (options.Color.length > 0) {
            $nBody.addClass(options.Color);
        }

        if (options.Id !== null) {
            $nBody.attr("id", options.Id);
        }

        var html = [];

        if (options.IconUrl !== null) {
            html.push('<img src="' + options.IconUrl + '" />');
        }
        html.push('<div class="toastBody"></div>');

        $nBody.html(html.join(""));

        $nBody.on("click", ".closeToast", function () {
            self.Close_Toast($nBody);
        });

        $nBody.on("mouseenter", function () {
            $nBody.addClass("mouseOver");
        }).on("mouseleave", function () {
            if ($nBody.hasClass("closeOnMouseLeave")) {
                self.Close_Toast($nBody);
            }
        });

        return $nBody;
    },

    _$notificationBody: function (options) {
        var self = this;

        var $nBody = $("<div/>", {
            "class": "notificationModal",
            "tabindex": -1,
            "role": "dialog"
        });

        if (options.Id !== null) {
            self.Close_Modal($("#" + options.Id));
            $nBody.attr("id", options.Id);
        }

        if (options.IsTopModal) {
            $nBody.addClass("top-modal");
        }

        if (options.Classes) {
            options.Classes.forEach(function (c) {
                $nBody.addClass(c);
            });
        }

        if (options.Data) {
            options.Data.forEach(function (d) {
                $nBody.data(d.Name, d.Value);
            });
        }

        var html = [];
        if (options.ShowTitle === true) {
            if (options.HeaderType === 1) {
                html.push('<header class="headerType1"><div class="headerOptions"><button class="closeNotification icon-close" title="Close"></button></div></header>');
            } else {
                html.push('<header><div class="headerOptions"><button class="closeNotification icon-close" title="Close"></button></div></header>');
            }
        }
        html.push('<div class="notificationBody"></div>');

        $nBody.html(html.join(""));

        if (options.CenterText) {
            $(".notificationBody", $nBody).addClass("text-center");
        }

        $nBody.on("click", ".closeNotification", function () {
            self.Close_Modal($nBody);
        });

        $nBody.on("click", ".toggleFullScreen", function () {
            $nBody.toggleClass("fullscreen");
            $(window).resize();
        });

        return $nBody;
    },

    _updateNotificationsContainer: function () {
        var self = this;
        var nbrOfNotf = $(".notificationModal", self._$notificationsContainer).length;
        if (nbrOfNotf > 0) {
            self._$notificationsContainer.addClass("show");
        }
        else {
            self._$notificationsContainer.removeClass("show");
        }
        var lastTopModal = $(".notificationModal.top-modal:last", self._$notificationsContainer);
        if (lastTopModal.length > 0) {
            $("#notification-container-bg").css("z-index", lastTopModal.get(0).style.zIndex);
        } else {
            $("#notification-container-bg").css("z-index",0);
        }
    },

    Close_Modal: function ($modal) {
        var self = this;
        if ($modal === undefined && self.NotificationQueu.length > 0) {
            $modal = self.NotificationQueu[self.NotificationQueu.length - 1];
        }
        if ($modal !== undefined) {
            var index = self.NotificationQueu.indexOf($modal);
            if (index > -1) {
                if (self.NotificationOnCloseQueu[index] !== null) {
                    self.NotificationOnCloseQueu[index]($modal);
                }
                self.NotificationQueu.splice(index, 1);
                self.NotificationOnCloseQueu.splice(index, 1);
                self.NotificationOnResizeQueu.splice(index, 1);
            }
            $modal.remove();
        }
        self._updateNotificationsContainer();
    },

    Close_Toast: function ($modal) {
        var self = this;

        var index = self.ToastsQueu.indexOf($modal);
        if (index > -1) {
            self.ToastsQueu.splice(index, 1);
        }
        $modal.fadeOut(1000, function () { $modal.remove(); });
    },

    Open_ToastMessage: function (options) {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="options" type="Object"></param>
        var self = this;
        var msg = $.extend({}, self.TOAST, options);

        var $modal = self._$toastBody(msg);

        if (msg.Title !== null && msg.Title.length > 0) {
            $(".toastBody", $modal).append("<h2>" + msg.Title + "</h2>");
        }

        $(".toastBody", $modal).append(msg.Text);

        if (msg.Buttons.length > 0) {
            $modal.append('<div class="toastOptions"></div>');
            var $btn = null;
            msg.Buttons.forEach(function (button) {
                $btn = $("<button/>", { "class": "btn icon-close" });
                if (button.Action === "Close") {
                    $btn.addClass("closeToast");
                }
                else if (button.Action !== null && button.Action !== undefined) {
                    $btn.on("click", function (e) {
                        button.Action(e, $(this));
                    });
                }

                if (button.Classes && button.Classes.length > 0) {
                    button.Classes.forEach(function (c) {
                        $btn.addClass(c);
                    });
                }
                $(".toastOptions", $modal).append($btn);
            });
        }
        else {
            $modal.addClass("noButtons");
        }

        self.ToastsQueu.push($modal);
        self._$toastsContainer.append($modal);

        if (msg.CloseAfterMiliseconds > 0) {
            setTimeout(function () {
                if (!$modal.hasClass("mouseOver")) {
                    self.Close_Toast($modal);
                }
                else {
                    $modal.addClass("closeOnMouseLeave");
                }
            }, msg.CloseAfterMiliseconds);
        }
    },

    Open_Modal: function (options) {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="options" type="Object"></param>
        var self = this;
        var msg = $.extend({}, self.MESSAGE, options);

        var $modal = self._$notificationBody(msg);

        if (msg.CloseOnOutsideClick === true) {
            $modal.data("close-on-outclick", true);
        }

        if (msg.ShowTitle === true) {
            if (msg.Title !== null) {
                if (msg.Title.jquery) {
                    $("header", $modal).prepend(msg.Title);
                } else {
                    $("header", $modal).prepend("<h2>" + msg.Title + "</h2>");
                }
            }
        }
        else {
            $modal.addClass("noTitle");
        }
        if (msg.FullscreenOption) {
            $("header .headerOptions", $modal).prepend('<button class="toggleFullScreen icon-window-maximize"></button>');
        }

        if (msg.ScrollableText) {
            $(".notificationBody", $modal).html('<div class="scrollContent"></div>');
            $(".scrollContent", $modal).html(msg.Text);
        }
        else {
            $(".notificationBody", $modal).append(msg.Text);
        }

        if (msg.Buttons.length > 0) {
            $modal.append('<div class="notificationOptions"></div>');

            if (msg.CenterButtons) {
                $(".notificationOptions", $modal).css("text-align", "center");
            }

            var $btn = null;
            msg.Buttons.forEach(function (button, index) {
                $btn = $("<button/>", { "class": "btn", "html": button.Name });
                if (button.Action === "Close") {
                    $btn.addClass("closeNotification");
                }
                else if (button.Action !== null && button.Action !== undefined) {
                    $btn.on("click", function (e) {
                        button.Action(e, $(this), $modal);
                    });
                }

                if (button.Classes && button.Classes.length > 0) {
                    button.Classes.forEach(function (c) {
                        $btn.addClass(c);
                    });
                }
                else {
                    $btn.addClass("blue");
                }
                $(".notificationOptions", $modal).append($btn);

                if (index !== msg.Buttons.length - 1) {
                    $(".notificationOptions", $modal).append('<span class="spacer"></span>');
                }
            });
        }
        else {
            $modal.addClass("noButtons");
        }

        self.NotificationQueu.push($modal);
        self.NotificationOnCloseQueu.push(msg.OnClose);
        self.NotificationOnResizeQueu.push(msg.OnResize);

        self._$notificationsContainer.append($modal);

        if (msg.MaxWidth !== null) {
            msg.MaxWidth = NewsTab.Helpers.CssSizeValue(msg.MaxWidth, "px");
            $modal.css("max-width", msg.MaxWidth);
        }
        if (msg.MinWidth !== null) {
            msg.MinWidth = NewsTab.Helpers.CssSizeValue(msg.MinWidth, "px");
            $modal.css("min-width", msg.MinWidth);
        }

        if (msg.MaxHeigth !== null) {
            msg.MaxHeigth = NewsTab.Helpers.CssSizeValue(msg.MaxHeigth, "px");
            $modal.css("max-height", msg.MaxHeigth);
        }
        if (msg.MinHeigth !== null) {
            msg.MinHeigth = NewsTab.Helpers.CssSizeValue(msg.MinHeigth, "px");
            $modal.css("min-height", msg.MinHeigth);
        }

        msg.Width = NewsTab.Helpers.CssSizeValue(msg.Width, "px");
        $modal.css("width", msg.Width);

        msg.Height = NewsTab.Helpers.CssSizeValue(msg.Height, "px");
        $modal.css("height", msg.Height);

        $modal.css("z-index", self.NotificationQueuZIndex + self.NotificationQueu.length * 5);

        if (msg.Resizable) {
            $modal.resizable({
                alsoResize: $(".notificationBody", $modal),
                minHeight: 150
            });
        }

        if (msg.Draggable) {
            $modal.draggable({
                handle: "header",
                addClasses: false
            });
        }

        self._updateNotificationsContainer();
        NewsTab.Helpers.CenterContent($modal, self._$notificationsContainer);

        setTimeout(function () {
            NewsTab.Helpers.CenterContent($modal, self._$notificationsContainer);

            var h = $modal.height();
            if (!$modal.hasClass("noButtons")) {
                h -= 55;
            }
            if (!$modal.hasClass("noTitle")) {
                h -= 45;
            }

            $(".notificationBody", $modal).css("height", "");
            $(".notificationBody", $modal).css("height", h + "px");

            if (msg.OnResize) {
                msg.OnResize($modal);
            }
        }, 100);

        setTimeout(function () {
            NewsTab.Helpers.CenterContent($modal, self._$notificationsContainer);

            var h = $modal.height();
            if (!$modal.hasClass("noButtons")) {
                h -= 55;
            }
            if (!$modal.hasClass("noTitle")) {
                h -= 45;
            }

            $(".notificationBody", $modal).css("height", "");
            $(".notificationBody", $modal).css("height", h + "px");

            if (msg.OnResize) {
                msg.OnResize($modal);
            }
        }, 1000);

        $modal.focus();

        if (msg.OnShow) {
            msg.OnShow($modal);
        }
    }
};

NewsTab.Modules.NotificationsManager.Init();