﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.OpmlImportExport = {

    Importing: false,

    OldSectionsWithNewImportedFeeds: 0,
    NewImportedSections: 0,
    NewImportedFeeds: 0,

    ImportBtn: null,

    ProgressBar: {
        OpmlImportExportModule: null,
        Control: null,
        Value: 0,
        Start: function (opmlImportExportModule) {
            /// <summary>Starts the "fake" progress bar to be shown to the user during a long importing process.</summary>  
            this.OpmlImportExportModule = opmlImportExportModule
            if (this.Control === null) {
                this.Control = $("#contentImportOPML .progressBar");
            }
            $("span", this.Control).css("width", 0 + "%");
            this.Control.css("display", "block");

            var self = this;
            var interval = function () {
                if (self.OpmlImportExportModule.Importing) {
                    self.Value += ((100 - self.Value) / (self.Value > 80 ? 100 : (self.Value > 40 ? 80 : 60)));
                    setTimeout(interval, 500);
                }
                else if (self.Value > 0 && self.Value < 100) {
                    self.Value = 100;
                    setTimeout(interval, 500);
                }
                else {
                    self.Value = 0;
                    self.Control.css("display", "none");
                }
                $("span", self.Control).css("width", self.Value + "%");
            };
            setTimeout(interval, 500);
            interval();
        }
    },

    HasUnsavedChanges: function () {
        /// <summary>Checks if we have any importing changes which can be dicarded.</summary>  
        /// <returns type="bool"></returns>  
        return (this.OldSectionsWithNewImportedFeeds + this.NewImportedSections + this.NewImportedFeeds) > 0
    },

    Init: function () {
        /// <summary>Binds the event listeners to the right controls.</summary>  
        var self = this;
        $("body").on("change", ".uploadOpmlFile", function (e) {
            var v = $(this).val();
            if (v.length > 0) {
                $(".importOPMLWrapper", "#contentImportOPML").addClass("fileSelected");
                $(".importOPML", "#contentImportOPML").removeClass("disabled");
                $(".importOPML", "#contentImportOPML").fadeIn();
                $(".opmlFileName", $(this).parent()).html(v.split(/(\\|\/)/g).pop());
            }
            else {
                $(".importOPMLWrapper", "#contentImportOPML").removeClass("fileSelected");
                $(".importOPML", "#contentImportOPML").addClass("disabled");
                $(".importOPML", "#contentImportOPML").fadeOut();
                $(".opmlFileName", $(this).parent()).html("Select OPML file");
            }
        });
        $("body").on("click", ".importOPML", function (e) {
            self.ImportBtn = $(this);
            self.ImportBtn.parent().addClass("disabled");
            self.ImportBtn.addClass("importing");

            var data = new FormData();
            var files = $(".uploadOpmlFile", "#contentImportOPML").get(0).files;

            if (files.length > 0) {
                data.append("UploadedOpml", files[0]);
            }

            self.Import(data);
        });
    },

    Import: function (opmlFileData) {
        /// <summary>Send OPML file data to the API for import.</summary>  
        /// <param name='opmlFileData' type='FormData' >Form Data (new FormData()) to which the Opml fill is appended.</param>
        /// <param name='type' type='string' >The type ov view you want. It can be "simple","rss" or "social"</param>
        this.Importing = true;
        this.ProgressBar.Start(this);
        var self = this;
        $.ajax({
            type: "POST",
            headers: { Authorization: "Bearer " + NewsTab.Token },
            url: NewsTab.ApiUrl_Global + "uploadOpmlFile",
            contentType: false,
            processData: false,
            data: opmlFileData,
            success: function (data) {
                self.ResetImportView();
                if (data.length > 0) {
                    for (var i = 0, il = data.length; i < il; i++) {
                        var nbrOfBackgroundFeedParsings = 2;

                        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.Id == data[i].Id })
                        if (section.length === 1) {
                            section = section[0];
                            for (var j = 0, jl = data[i].Feeds.length; j < jl; j++) {
                                var feed = new Feed().NewInit(data[i].Feeds[j]);
                                feed.NewImport = true;
                                feed.SectionId = section.Id;
                                section.NewFeedsImported = true;
                                section.Feeds.unshift(feed);
                                if (nbrOfBackgroundFeedParsings > 0) {
                                    SocialTab.BackgroundFeedParse(feed);
                                    nbrOfBackgroundFeedParsings--;
                                }
                            }
                            SocialTab.UpdateSection(data[i], i == il - 1, true, true);
                            self.OldSectionsWithNewImportedFeeds++;
                        }
                        else {
                            self.NewImportedSections++;
                            section = SocialTab.UpdateSection(data[i], i == il - 1, false, true, true);
                            if (section.SectionTypeId != Section.TYPES.Social) {
                                for (var j = 0, jl = section.Feeds.length; j < jl; j++) {
                                    if (nbrOfBackgroundFeedParsings > 0 && section.Feeds[j].Id.length === 36) {
                                        SocialTab.BackgroundFeedParse(section.Feeds[j]);
                                        nbrOfBackgroundFeedParsings--;
                                    }
                                }
                            }
                        }
                        self.NewImportedFeeds += data[i].Feeds.length;
                    }

                    if (SocialTab.LastActiveSections.length < SocialTab.NumberOfVisibleSections && NewsTab.Modules.SectionsManager.Sections.length > SocialTab.NumberOfVisibleSections) {
                        var lastActiveSections = SocialTab.LastActiveSections;
                        var added = false;
                        $.grep(NewsTab.Modules.SectionsManager.Sections, function (el) {
                            if (!added && jQuery.inArray(el.Id, lastActiveSections) === -1 && el.ShowInSourceList) {
                                SocialTab.LastActiveSections.push(el.Id);
                                added = true;
                            }
                        });
                    }

                    if (SocialTab.LastActiveSections.length > 0 && SocialTab.LastActiveSections[0] != NewsTab.Modules.SectionsManager.CurrentSection.Id) {
                        SocialTab.SetCurrentSection(SocialTab.LastActiveSections[0], true, false);
                    }
                    if (NewsTab.User.NumberOfVisibleSections > SocialTab.NumberOfVisibleSections) {
                        SocialTab.NumberOfVisibleSections = NewsTab.User.NumberOfVisibleSections;
                    }
                    SocialTab.SelectSectionToManage(data[data.length - 1]);
                    SocialTab.Calculate_Section_ItemNumber();
                    SocialTab.HTML_UpdateLastActiveSections();
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Title: "Opml Import",
                        Color: "green",
                        Text: "Opml data successfully imported to NewsTab!"
                    });
                    NewsTab.Modules.AddNewContent.Setup_SectionsInOrganizer(false);
                    $("#tabOrganizer").trigger("click");
                }
                else {
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Title: "Opml Import",
                        Text: "No new Sections or Feeds were found!"
                    });
                }
            },
            error: function (error) {
                self.ResetImportView();
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Opml Import",
                    Color: "red",
                    Text: "Opml data import ERROR!"
                });
            }
        });
    },

    ResetImportView: function () {
        /// <summary>Resets the import view, enabline the controls to select a new opml file for importing.</summary>  
        this.Importing = false;
        document.getElementById("uploadOpmlFile").value = "";

        if (this.ImportBtn != null) {
            this.ImportBtn.parent().removeClass("disabled");
            this.ImportBtn.removeClass("importing");
            this.ImportBtn.fadeOut();
            this.ImportBtn = null;
        }
        $(".importOPMLWrapper", "#contentImportOPML").removeClass("fileSelected");
        $(".opmlFileName", "#contentImportOPML .uploadOpmlFileContainer").html("Select OPML file");
    },

    Finish: function () {
        /// <summary>Removes all the temporal "New" indicators from sections and feeds, finalizing the import proccess.</summary>  
        for (var i = 0, l = NewsTab.Modules.SectionsManager.Sections.length; i < l; i++) {
            NewsTab.Modules.SectionsManager.Sections[i].NewFeedsImported = false;
            NewsTab.Modules.SectionsManager.Sections[i].NewImport = false;
            for (var j = 0, jl = NewsTab.Modules.SectionsManager.Sections[i].Feeds.length; j < jl; j++) {
                NewsTab.Modules.SectionsManager.Sections[i].Feeds[j].NewImport = false;
            }
        }
        this.OldSectionsWithNewImportedFeeds = 0;
        this.NewImportedSections = 0;
        this.NewImportedFeeds = 0;

        NewsTab.Modules.AddNewContent.Setup_SectionsInOrganizer(false);
    },

    Discard: function () {
        /// <summary>Triggers a Notification message asking the user to confirm that he wants to discard the new imported sections and feeds.</summary> 
        var self = this;
        SocialTab.Notification_SetUpHTML_OkCancel("Discard Import", "Remove all the new imported sections and feeds.", "Ok", "Cancel", function () {
            $(".notification-modal").addClass("disabled");
            $(".notification-modal .ok").html("<i class=\"icon\"><span class=\"spinner\"></span></i>Removing...");
            return self.DiscardFinish();
        });
    },

    DiscardFinish: function () {
        /// <summary>Discards every section and feed marked as "x.NewImport = true". It's called by the Discard method if user confirms to discard.</summary> 
        var discardObject = {
            SectionsAndFeedsToDiscard: []
        };
        for (var i = 0, l = NewsTab.Modules.SectionsManager.Sections.length; i < l; i++) {
            var section = { SectionId: NewsTab.Modules.SectionsManager.Sections[i].Id, DiscardThisSection: false, FeedsToDiscard: [] }

            if (NewsTab.Modules.SectionsManager.Sections[i].NewImport == true) {
                section.DiscardThisSection = true;
                discardObject.SectionsAndFeedsToDiscard.push(section);
            }
            else {
                var hasFeedsToRemove = false;
                for (var j = 0, jl = NewsTab.Modules.SectionsManager.Sections[i].Feeds.length; j < jl; j++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].Feeds[j].NewImport == true) {
                        section.FeedsToDiscard.push(NewsTab.Modules.SectionsManager.Sections[i].Feeds[j].Id);
                        hasFeedsToRemove = true;
                    }
                }
                if (hasFeedsToRemove) {
                    discardObject.SectionsAndFeedsToDiscard.push(section);
                }
            }
        }

        var self = this;
        var callUrl = NewsTab.ApiUrl_Global + "discard";
        $.ajax({
            url: callUrl,
            type: "DELETE",
            headers: {
                Authorization: "Bearer " + NewsTab.Token
            },
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(discardObject),
            error: function (error) {
                console.error("ERROR - DiscardImportFinal:");
                console.error(error);
                if ($("#doubleModal").length === 1) {
                    $("#doubleModal").remove();
                }
                else {
                    $.modal.impl.close();
                }
            }
        }).then(function (data) {
            if (data == true) {
                for (var i = 0, l = discardObject.SectionsAndFeedsToDiscard.length; i < l; i++) {
                    var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === discardObject.SectionsAndFeedsToDiscard[i].SectionId });
                    if (section.length > 0) {
                        section = section[0];
                        if (discardObject.SectionsAndFeedsToDiscard[i].DiscardThisSection) {
                            NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.SectionsManager.Sections, section);
                            NewsTab.Helpers.RemoveItemFromArray(SocialTab.LastActiveSections, section.Id);
                        }
                        else {
                            section.NewFeedsImported = false;
                            for (var j = 0, jl = discardObject.SectionsAndFeedsToDiscard[i].FeedsToDiscard.length; j < jl; j++) {
                                var feed = $.grep(section.Feeds, function (e) { return e.Id == discardObject.SectionsAndFeedsToDiscard[i].FeedsToDiscard[j] });
                                if (feed.length > 0) {
                                    feed = feed[0];

                                    NewsTab.Helpers.RemoveItemFromArray(section.Feeds, feed);

                                    if (section.DefaultFeed.Id === feed.Id) {
                                        if (section.Feeds.length > 1) {
                                            section.DefaultFeed = section.Feeds[1];
                                        } else {
                                            section.DefaultFeed = section.Feeds[0];
                                        }
                                    }
                                    if (section.CurrentFeed.Id === feed.Id) {
                                        if (section.Feeds.length > 1) {
                                            SocialTab.SetCurrentFeed(section.Feeds[1].Id, true);
                                        } else {
                                            SocialTab.SetCurrentFeed(section.DefaultFeed.Id, true);
                                        }
                                    }
                                }

                                section.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                                var x = 0;
                                for (var y = 0, len = section.Feeds.length; y < len; y++) {
                                    var order = section.Feeds[y].OrderNumber;
                                    if (parseFloat(order) < 0) {
                                        section.Feeds[y].OrderNumber = order;
                                    } else {
                                        section.Feeds[y].OrderNumber = x;
                                        x++;
                                    }
                                }
                            }
                        }
                    }
                }

                if (SocialTab.LastActiveSections.length < SocialTab.NumberOfVisibleSections && NewsTab.Modules.SectionsManager.Sections.length > SocialTab.NumberOfVisibleSections) {
                    var lastActiveSections = SocialTab.LastActiveSections;
                    var added = false;
                    $.grep(NewsTab.Modules.SectionsManager.Sections, function (el) {
                        if (!added && jQuery.inArray(el.Id, lastActiveSections) === -1 && el.ShowInSourceList) {
                            SocialTab.LastActiveSections.push(el.Id);
                            added = true;
                        }
                    });
                }

                if (SocialTab.LastActiveSections.length > 0 && SocialTab.LastActiveSections[0] != NewsTab.Modules.SectionsManager.CurrentSection.Id) {
                    SocialTab.SetCurrentSection(SocialTab.LastActiveSections[0], true, false);
                }

                self.OldSectionsWithNewImportedFeeds = 0;
                self.NewImportedSections = 0;
                self.NewImportedFeeds = 0;

                SocialTab.HTML_UpdateLastActiveSections();
                SocialTab.Menu_SetUpHTML_SubmenuList();
                NewsTab.Modules.AddNewContent.Setup_Sections();
            }
            if ($("#doubleModal").length === 1) {
                $("#doubleModal").remove();
            }
            else {
                $.modal.impl.close();
            }
        });
    }
};

$(document).ready(function () {
    NewsTab.Modules.OpmlImportExport.Init();
});