﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.PromotionsManager = {
    Init: function () {
        const self = this;

        setTimeout(function () {
            self.API_GetPromotion(function (data) {
                self.OpenModal(data);
            })
        }, 2000);
    },

    OpenModal: function (data) {
        const self = this;
        NewsTab.Modules.NotificationsManager.Open_Modal({
            Id: "promoModal",
            Title: data.Title,
            HeaderType: 0,
            Height: "auto",
            MaxHeight: "auto",
            Text: data.Html,
            FullscreenOption: false,
            Buttons: data.Buttons,
            OnShow: function ($modal) {
                $(".promo-action", $modal).on("click", function () {
                    var promoData = NewsTab.Helpers.GetLocalStorageItem("PromoData");
                    if (promoData === null) {
                        promoData = { "LastAction": Date.now(), "IDs": [data.Id] }
                    } else {
                        promoData.LastAction = Date.now();
                        promoData.IDs.push(data.Id);
                    }
                    NewsTab.Helpers.SetLocalStorageItem(promoData, "PromoData");

                    NewsTab.TrackAnalyticsEvent("Promo", "Click", NewsTab.Extension.NameId);
                    window.open(data.Url, "_blank");
                    NewsTab.Modules.NotificationsManager.Close_Modal();
                });

                $(".promo-close", $modal).on("click", function () {
                    var promoData = NewsTab.Helpers.GetLocalStorageItem("PromoData");
                    if (promoData === null) {
                        promoData = { "LastAction": Date.now(), "IDs": [] }
                    } else {
                        promoData.LastAction = Date.now();
                    }
                    NewsTab.Helpers.SetLocalStorageItem(promoData, "PromoData");

                    NewsTab.TrackAnalyticsEvent("Promo", "Close", NewsTab.Extension.NameId);
                    NewsTab.Modules.NotificationsManager.Close_Modal();
                });
            }
        });
    },

    API_GetPromotion: function (callback) {
        const dayInMs = 30 * 60 * 60 * 1000;
        var promoData = NewsTab.Helpers.GetLocalStorageItem("PromoData");
        if (promoData === null || Date.now() - dayInMs > promoData.LastAction) {
            var url = NewsTab.EnviromentUrl + "/api/global/getpromo?nid=" + NewsTab.Extension.NId;

            $.ajax({
                type: "GET",
                url: url,
                timeout: 5000
            }).then(function (data) {
                if (typeof callback === "function") {
                    if (promoData === null || promoData.IDs.indexOf(data.Id) === -1) {
                        callback(data);
                    }
                }
            }).fail(function () {
                console.log("API_GetPromotion: Error");
            });
        }
    }
};