﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.Sharing = {
    ViaSignature: NewsTab.EnviromentUrl !== undefined && NewsTab.EnviromentUrl.indexOf("staging") > 0 ? "via staging.newstab.com" : "via newstab.com",
    NewsTabShareUrl: NewsTab.EnviromentUrl + "?share={ARTICLE_URL}",
    ShareProviders: {
        Facebook: {
            Name: "Facebook",
            Icon: "icon-facebook2",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/fb.gif",
            Tooltip1: "Share\u00a0on\u00a0Facebook",
            Tooltip2: "Facebook",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://www.facebook.com/dialog/feed?app_id=" +
                    (window.facebookApiId !== undefined ? window.facebookApiId : "1065032873548242") +
                    "&display=popup&caption=" + NewsTab.Modules.Sharing.ViaSignature + "&link=" + encodeURIComponent(url);// +
                    //"&redirect_uri=" + encodeURIComponent(NewsTab.EnviromentUrl + "Home/Close");
            }
        },
        Twitter: {
            Name: "Twitter",
            Icon: "icon-twitter2",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/t.gif",
            Tooltip1: "Share\u00a0on\u00a0Twitter",
            Tooltip2: "Twitter",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://twitter.com/intent/tweet?url=" + encodeURIComponent(url) + "&text=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle);
            }
        },
        LinkedIn: {
            Name: "LinkedIn",
            Icon: "icon-linkedin",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/l.gif",
            Tooltip1: "Share\u00a0on\u00a0LinkedIn",
            Tooltip2: "LinkedIn",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "http://www.linkedin.com/shareArticle?mini=true&url=" + encodeURIComponent(url) + "&title=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle) + "&summary=" + NewsTab.Modules.Sharing._cleanUpText(article.Summary !== null ? article.Summary : article.HtmlSummary, 220) + encodeURIComponent(" " + NewsTab.Modules.Sharing.ViaSignature) + "&source=" + encodeURIComponent("https://www.newstab.com/");
            }
        },
        GooglePlus: {
            Name: "GooglePlus",
            Icon: "icon-google-plus",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/g.gif",
            Tooltip1: "Share\u00a0on\u00a0Google+",
            Tooltip2: "Google+",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://plus.google.com/share?url=" + encodeURIComponent(url);
            }
        },
        Email: {
            Name: "Email",
            Icon: "icon-email",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/m.gif",
            Tooltip1: "Share\u00a0via\u00a0Email",
            Tooltip2: "Email",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "mailto:?subject=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle, false) + " [NewsTab]&body=" + encodeURIComponent(url) + "%0D%0A%0D%0A " + encodeURIComponent(NewsTab.Modules.Sharing.ViaSignature);
            }
        },
        WebEmail: {
            Name: "WebEmail",
            Icon: "icon-email",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/wm.gif",
            Tooltip1: "Share\u00a0via\u00a0Web\u00a0Email",
            Tooltip2: "Web\u00a0Email",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://api.addthis.com/oexchange/0.8/forward/email/offer?url=" + encodeURIComponent(url) + "%2F&pubid=ra-586221421d08eed9&title=" + NewsTab.Modules.Sharing._cleanUpText((article.Title !== null ? article.Title : article.HtmlTitle) + " [NewsTab]") + "&note=" + encodeURIComponent(NewsTab.Modules.Sharing.ViaSignature) + "&ct=1";
            }
        },
        Gmail: {
            Name: "Gmail",
            Icon: "icon-gmail",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/gm.gif",
            Tooltip1: "Share\u00a0via\u00a0Gmail",
            Tooltip2: "Gmail",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://mail.google.com/?view=cm&fs=1&tf=1&to=&su=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle, false) + " [NewsTab]&body=" + encodeURIComponent(url) + "%0D%0A%0D%0A " + encodeURIComponent(NewsTab.Modules.Sharing.ViaSignature);
            }
        },
        OneNote: {
            Name: "OneNote",
            Icon: "icon-onenote",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/n.gif",
            Tooltip1: "Share\u00a0via\u00a0OneNote",
            Tooltip2: "OneNote",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://www.onenote.com/clipper/save?sourceUrl=" + encodeURIComponent(url) + (article.ImageUrl != null ? "&imgUrl=" + encodeURIComponent(article.ImageUrl) : (article.Thumbnail != null ? "&imgUrl=" + encodeURIComponent(article.Thumbnail) : "")) + "&title=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle);
            }
        },
        Pocket: {
            Name: "Pocket",
            Icon: "icon-pocket",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/p.gif",
            Tooltip1: "Share\u00a0via\u00a0Pocket",
            Tooltip2: "Pocket",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://getpocket.com/save?url=" + encodeURIComponent(url) + "&title=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle);
            }
        },
        Instapaper: {
            Name: "Instapaper",
            Icon: "icon-instapaper",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/i.gif",
            Tooltip1: "Share\u00a0via\u00a0Instapaper",
            Tooltip2: "Instapaper",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "http://www.instapaper.com/hello2?url=" + encodeURIComponent(url) + "&title=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle);
            }
        },
        Evernote: {
            Name: "Evernote",
            Icon: "icon-evernote",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/e.gif",
            Tooltip1: "Share\u00a0via\u00a0Evernote",
            Tooltip2: "Evernote",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://www.evernote.com/clip.action?url=" + encodeURIComponent(url) + "&title=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle) + "&body=" + NewsTab.Modules.Sharing._cleanUpText(article.Summary !== null ? article.Summary : article.HtmlSummary);
            }
        },
        Reddit: {
            Name: "Reddit",
            Icon: "icon-reddit",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/d.gif",
            Tooltip1: "Post\u00a0on\u00a0Reddit",
            Tooltip2: "Reddit",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return "https://www.reddit.com/submit?url=" + encodeURIComponent(url) + "&title=" + NewsTab.Modules.Sharing._cleanUpText(article.Title !== null ? article.Title : article.HtmlTitle);
            }
        },
        CopyLink: {
            Name: "Copy to Clipboard",
            Icon: "icon-chain",
            Image: NewsTab.EnviromentUrl + "/Media/Images/Icons/ShareIcons/cc.gif",
            Tooltip1: "Copy\u00a0to\u00a0Clipboard",
            Tooltip2: "Copy\u00a0to\u00a0Clipboard",
            Url: function (article) {
                var url = NewsTab.Modules.Sharing.NewsTabShareUrl.replace("{ARTICLE_URL}", encodeURIComponent(article.Url));
                if (NewsTab.Modules.Sharing.EnableCustomShareLinks !== true) {
                    url = url + "&ts=" + (new Date().getTime() + (24 * 60 * 60 * 1000));
                }
                return url;
            }
        }
    },

    EnableCustomShareLinks: true,

    TopShareProviders: ["Facebook", "Twitter", "GooglePlus", "LinkedIn", "Email"],
    DisplayingSharedArticle: false,
    SharedArticleUrl: null,

    _cleanUpText: function (text, crope) {
        if (text) {
            var result = text.replace(/<(?:.|\n)*?>/gm, '').replace(/&nbsp;/g, '');

            if (crope && result.length > crope) {
                result = result.substring(0, crope) + "...";
            }
            return encodeURIComponent(result);//.replace(/'/g, "\\'");
        }
        return text;
    },

    EnableSharingSignature: function (enable) {
        this.EnableCustomShareLinks = enable;
        if (this.EnableCustomShareLinks === false) {
            this.ViaSignature = "";
        } else {
            this.ViaSignature = NewsTab.EnviromentUrl !== undefined && NewsTab.EnviromentUrl.indexOf("staging") > 0 ? "via staging.newstab.com" : "via newstab.com";
        }
    },

    ParseStringToProvider: function (providerName) {
        if ($.type(providerName) === "string") {
            return this.ShareProviders[providerName];
        }
        else if ($.isPlainObject(providerName)) {
            return providerName;
        }
        return null;
    },

    InitShareDashboard: function (callback) {
        /// <summary></summary>  
        var self = this;

        NewsTab.User = {
            Id: 0,
            ProfilePictureUrl: "/Media/Images/allrightsreserved.png",
            Username: "Anonymous",
            FullName: "Public Profile",
            Sections: [],
            ViewHistory: []
        };

        var readedItems = JSON.parse(NewsTab.Helpers.GetLocalStorageItem("ST_" + NewsTab.User.Id + "_ReadItems"));
        if (readedItems !== null) {
            SocialTab.ReadItems = NewsTab.Helpers.ArrayUnique(readedItems.concat(NewsTab.User.ViewHistory));
        } else {
            SocialTab.ReadItems = NewsTab.User.ViewHistory;
        }
        if (window.sharedArticle !== null) {
            window.sharedArticle._sourceFeed = new Feed().NewInit(window.sharedFeed);
            window.sharedArticle.SourceFeedId = window.sharedArticle._sourceFeed.Id;

            NewsTab.Modules.SectionsManager.PreviewSection = new Section().Init_PublicShare(window.sharedArticle._sourceFeed);
            NewsTab.Modules.SectionsManager.CurrentSection = NewsTab.Modules.SectionsManager.PreviewSection;

            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.PageNbr = 0;
            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.IsFixed = true;
            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.OrderNumber = 0;
            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.EditMenuIcon = null;
            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.EditMenuClass = null;

            NewsTab.Modules.ArticleView.SetUp_ExpandView(new Article().Init(window.sharedArticle), true);

            if (NewsTab.Token === null || NewsTab.Token === undefined) {
                $("body").addClass("publicAccess");
                $("*[data-public-remove='true']").remove();
            }
        }
        if (callback) {
            callback();
        }
    },

    Load_TopShareProviders_FromLocalStorage: function () {
        var tsp = localStorage.getItem("ST_" + NewsTab.User.Id + "_TopShareProviders");
        if (tsp) {
            this.TopShareProviders = JSON.parse(tsp);
        }
    },

    Save_TopShareProviders_ToLocalStorage: function () {
        localStorage.setItem("ST_" + NewsTab.User.Id + "_TopShareProviders", JSON.stringify(this.TopShareProviders));
    },

    $Generate_ShareToXYButton: function (article, provider, options) {
        var self = this;

        if (article && provider) {
            var opt = $.extend({}, {
                cssClass: "",
                tooltipPosition: "top",
                mode: "list",
                tabIndex: "0",
                onClick: null
            }, options);

            var button = $("<button/>", {
                "type": "button",
                "class": provider.Icon + " " + opt.cssClass,
                "data-tooltip": "tooltip",
                "data-placement": opt.tooltipPosition,
                "data-space": "true"
            });
            if (opt.mode === "list") {
                button.attr("title", provider.Tooltip2);
                button.removeClass(provider.Icon);
                button.html("<img src=\"" + provider.Image + "\"/>");
            }
            else {
                button.attr("title", provider.Tooltip1);
            }
            button.click(function (e) {
                e.stopPropagation();
                if (provider.Name === self.ShareProviders.CopyLink.Name) {
                    self.CopyToClipboard(provider.Url(article));
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Color: "green",
                        Text: "Link copied to clipboard",
                        Buttons: []
                    });
                } else {
                    self.ShareArticle(article, provider);
                }
                
                if (opt.onClick) {
                    opt.onClick(article, provider);
                }

                if (NewsTab.IsExtension) {
                    NewsTab.TrackAnalyticsEvent("Share", provider.Name, NewsTab.Extension.NameId);
                }
            });

            return button;
        }
        return null;
    },

    $Generate_ShareModal: function (article, options) {
        var self = this;

        var opt = $.extend({}, {
            onShareClick: null,
            onClose: null
        }, options);

        var shareModal = $("<div/>", {
            "id": "shareModal",
            "tabindex": "-1"
        });
        shareModal.append("<div>Share with: </div>");

        var closeBtn = $("<button/>", {
            "type": "type",
            "class": "icon-close closeNotification",
            "data-space": "true"
        });
        closeBtn.click(function (e) {
            if (opt.onClose) {
                opt.onClose();
            }
        });
        $("div", shareModal).append(closeBtn);

        var ul = $("<ul/>");

        var provider = null;

        for (provider in self.ShareProviders) {
            if (self.ShareProviders.hasOwnProperty(provider)) {
                var li = $("<li/>");
                li.append(self.$Generate_ShareToXYButton(article, self.ShareProviders[provider], {
                    tooltipPosition: "top",
                    mode: "list",
                    onClick: opt.onShareClick
                }));
                ul.append(li);
            }
        }
        shareModal.append(ul);
        return shareModal;
    },

    Open_ShareArticleModal: function (article, options) {
        var self = this;

        var opt = $.extend({}, options);

        if (NewsTab.Modules.ArticleView !== undefined) {
            article = NewsTab.Modules.ArticleView.ParseViewItemToArticleObject(article);
        }
        

        if (article !== null) {
            var modal = self.$Generate_ShareModal(article, opt);

            NewsTab.Modules.NotificationsManager.Open_Modal({
                Id: "share-article",
                ShowTitle: false,
                Height: "auto",
                Width: "100%",
                ScrollableText: false,
                CloseOnOutsideClick: true,
                MaxWidth: "520px",
                Text: modal,
                Buttons: []
            });
            $("#shareModal").attr("data-share-url", article.NewsTabUrl);
        }
    },

    ShareArticle: function (article, provider) {
        if (NewsTab.Modules.ArticleView !== undefined) {
            article = NewsTab.Modules.ArticleView.ParseViewItemToArticleObject(article);
        }
        provider = this.ParseStringToProvider(provider);
        var self = this;

        if (self.TopShareProviders.indexOf(provider.Name) < 0) {
            self.TopShareProviders.unshift(provider.Name);
        }
        else {
            var oldPos = self.TopShareProviders.indexOf(provider.Name);
            var temp = self.TopShareProviders[0];
            self.TopShareProviders[0] = provider.Name;
            self.TopShareProviders[oldPos] = temp;
        }
        self.Save_TopShareProviders_ToLocalStorage();
        if (provider.Name === "Email") {
            window.location.href = provider.Url(article);
        }
        else {
            var w = 960;
            var h = $(window).height();

            self.ShareUrl(provider.Url(article), provider.Name, w, h);
        }
    },

    ShareUrl: function (url, name, w, h) {
        if ($(window).width() < w) {
            w = $(window).width() * 0.95;
        }

        w += 32;
        var wleft = (screen.width - w) / 2;
        var wtop = (screen.height - h) / 2;
        if (wleft < 0) {
            w = screen.width;
            wleft = 0;
        }
        if (wtop < 0) {
            h = screen.height;
            wtop = 0;
        }
        var win = window.open(url,
            name,
            'width=' + w + ', height=' + h + ', ' +
            'left=' + wleft + ', top=' + wtop + ', ' +
            'location=no, menubar=no, ' +
            'status=no, toolbar=no, scrollbars=no, resizable=yes');
        win.resizeTo(w, h);
        win.moveTo(wleft, wtop);
        win.focus();
    },

    CopyToClipboard : function(str) {
        const el = document.createElement('textarea');  // Create a <textarea> element
        el.value = str;                                 // Set its value to the string that you want copied
        el.setAttribute('readonly', '');                // Make it readonly to be tamper-proof
        el.style.position = 'absolute';
        el.style.left = '-9999px';                      // Move outside the screen to make it invisible
        document.body.appendChild(el);                  // Append the <textarea> element to the HTML document
        const selected =
            document.getSelection().rangeCount > 0        // Check if there is any content selected previously
                ? document.getSelection().getRangeAt(0)     // Store selection if found
                : false;                                    // Mark as false to know no selection existed before
        el.select();                                    // Select the <textarea> content
        document.execCommand('copy');                   // Copy - only works as a result of a user action (e.g. click events)
        document.body.removeChild(el);                  // Remove the <textarea> element
        if (selected) {                                 // If a selection existed before copying
            document.getSelection().removeAllRanges();    // Unselect everything on the HTML document
            document.getSelection().addRange(selected);   // Restore the original selection
        }
    }
};