﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.SpecialPinSystem = {
    PinSection: null,
    OpmlFile: null,

    Init: function () {
        var self = this;

        $("body").on("click", ".editPinSection", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            $("body").removeClass("asideMenuIn");
            $("body").removeClass("rightSideMenuIn");

            if (self.PinSection !== null) {
                var customDropdown = $("<div/>", { "class": "customDropdown" });

                var ul = $("<ul>");
                customDropdown.append(ul);

                var pinUrl = $("<li/>");
                pinUrl.html("<span>Pin Url</span>");
                ul.append(pinUrl);
                pinUrl.click(function (e) {
                    self.HTML_Modal_PinUrl();
                });

                var importBtn = $("<li/>");
                importBtn.html("<span>Import Pins</span>");
                ul.append(importBtn);
                importBtn.click(function (e) {
                    self.HTML_Modal_Import();
                });

                var exportBtn = $("<li/>");
                exportBtn.html("<span>Export Pins</span>");
                ul.append(exportBtn);
                exportBtn.click(function (e) {
                    self.HTML_Modal_Export();
                });

                $(this).parent().append(customDropdown);
            }
        });

        $("body").on("click", ".pinExternalArticle", function (e) {
            e.stopPropagation();
            $(this).closest(".dropdown").removeClass("open");
            self.HTML_Modal_PinUrlSimple();
        });

        var dbCounter = 0;
        var f = (function () {
            var ff = function () {
                if (SocialTab.DashboardReady) {
                    var pinSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return (s.SectionTypeId === Section.TYPES.Pinned) });
                    if (pinSection.length > 0) {
                        self.PinSection = pinSection[0];
                    }
                    if (NewsTab.User.HasAccessToAdvancedPinned) {

                        var urlPin = $("<li/>");
                        urlPin.html("<span>New Url Pin</span>");
                        urlPin.click(function (e) {
                            self.HTML_Modal_PinUrlAdvanced();
                        })

                        $(".addContentList").append(urlPin);

                        self.PinSection.EditCssClass = "editPinSection";
                        if (NewsTab.Modules.SectionsManager.CurrentSection.Id === self.PinSection.Id) {
                            SocialTab.Menu_SetUpHTML_SubmenuList();
                        }
                    }
                }
                else {
                    dbCounter++;
                    if (dbCounter < 100) {
                        setTimeout(ff, 400);
                    }
                }
            };
            return ff;
        })();
        f();
    },

    HTML_Modal_PinUrlAdvanced: function (article) {
        var self = this;

        var div = $("<div/>", {
            "id": "cutomPinModal",
            "class": "notification-modal"
        });

        var form = $("<div/>", { "class": "form" });
        div.append(form);
        // Article Pin Type
        var pinType_l = $("<label>", { "for": "cpm_PinType" });
        pinType_l.html("Pin type:");
        form.append(pinType_l);
        var pinType = $("<select>", {
            "id": "cpm_PinType",
            "name": "cpm_PinType"
        });
        pinType.append("<option value=\"0\">Normal</option>");
        pinType.append("<option value=\"1\">Landing Page</option>");
        pinType.append("<option value=\"2\">NewsTab Trending</option>");
        form.append(pinType);

        // Article Url
        var articleUrl_l = $("<label>", { "for": "cpm_ArticleUrl" });
        articleUrl_l.html("Article Url:");
        form.append(articleUrl_l);
        var articleUrl = $("<input>", {
            "id": "cpm_ArticleUrl",
            "type": "text",
            "placeholder": "Article Url (starting with https:// or https://)"
        });
        form.append(articleUrl);

        // Image Url
        var imageUrl_l = $("<label>", { "for": "cpm_ImageUrl" });
        imageUrl_l.html("Image Url:");
        form.append(imageUrl_l);
        var imageUrl = $("<input>", {
            "id": "cpm_ImageUrl",
            "type": "text",
            "placeholder": "Image Url (starting with https:// or https://)"
        });
        form.append(imageUrl);
        imageUrl.on("change", function (e) {
            if ($(this).val().indexOf("http") === 0) {
                $("#cpm_Image", $(this).parent()).attr("src", $(this).val());
            }
        });

        // Image Preview
        var image_l = $("<label>", { "for": "cpm_Image" });
        image_l.html("Image Preview:");
        form.append(image_l);
        var image = $("<img>", {
            "id": "cpm_Image",
            "alt": "No Image Preview"
        });
        image.on("load", function () {
            $.modal.impl.setPosition();
        });
        form.append(image);

        // Pin Date
        var pinDate_l = $("<label>", { "for": "cpm_PinDate" });
        pinDate_l.html("Pin Date (used for ordering):");
        form.append(pinDate_l);
        var pinDate = $("<input>", {
            "id": "cpm_PinDate",
            "type": "datetime-local",
            "value": new Date().toDateInputValue(),
            "step": "1"
        });
        form.append(pinDate);

        // Publish Date
        var publishDate_l = $("<label>", { "for": "cpm_PublishDate" });
        publishDate_l.html("Publish Date:");
        form.append(publishDate_l);
        var publishDate = $("<input>", {
            "id": "cpm_PublishDate",
            "type": "datetime-local",
            "value": new Date().toDateInputValue(),
            "step": "1"
        });
        form.append(publishDate);

        if (article !== undefined) {
            pinType.val(article.DisplayLocation);
            articleUrl.val(article.Url);
            imageUrl.val(article.ImageUrl);
            image.attr("src", article.ImageUrl);
            pinDate.val(new Date(article.DateCreated).toDateInputValue());
            publishDate.val(new Date(article.PubDate).toDateInputValue());
        }

        var buttons = $("<div/>", { "class": "buttons" })

        var btnCancel = $("<button>", {
            "type": "button",
            "class": "btn gray"
        });
        btnCancel.html("Cancel");
        btnCancel.on("click", function (e) {
            $.modal.impl.close();
        });
        buttons.append(btnCancel);

        var btnSave = $("<button>", {
            "type": "button",
            "class": "btn ok blue"
        });
        if (article !== undefined) {
            btnSave.html("Save");
        }
        else {
            btnSave.html("Pin");
        }

        btnSave.on("click", function (e) {
            e.stopPropagation();
            btnSave.html("<i class=\"icon\"><span class=\"spinner\"></span></i>");
            var today = new Date();
            var localoffset = today.getTimezoneOffset() / 60;

            var article = {
                Url: articleUrl.val().trim(),
                PubDate: new Date(new Date(publishDate.val()).getTime() + localoffset * 3600 * 1000).toUTCString(),
                DateCreated: new Date(new Date(pinDate.val()).getTime() + localoffset * 3600 * 1000).toUTCString(),
                ImageUrl: imageUrl.val().trim(),
                DisplayLocation: pinType.val()
            }

            self.API_PinUrlAdvanced(article, btnSave);
        });
        buttons.append(btnSave);

        div.append(buttons);

        $.modal(div, {
            fitToView: true,
            autoSize: true,
            overlayClose: true,
            autoResize: true,
            autoPosition: true,
            minWidth: 200,
            maxWidth: 500,
            height: "auto",
            scrolling: "yes"
        });

        $("#cutomPinModal").closest(".simplemodal-container").addClass("heightAuto");
        $("#cpm_PinType").selectmenu();
        $.modal.impl.setPosition();
    },

    HTML_Modal_PinUrlSimple: function () {
        var self = this;

        var div = $("<div/>", {
            "id": "cutomPinModal",
            "class": "notification-modal"
        });

        div.append("<h4>Pin External Article</h4>");

        var form = $("<div/>", { "class": "form" });
        div.append(form);
        // Article Url
        var articleUrl_l = $("<label>", { "for": "cpm_ArticleUrl" });
        articleUrl_l.html("Article Url:");
        form.append(articleUrl_l);
        var articleUrl = $("<input>", {
            "id": "cpm_ArticleUrl",
            "type": "text",
            "placeholder": "Article Url (starting with https:// or https://)"
        });
        form.append(articleUrl);

        var buttons = $("<div/>", { "class": "buttons" })

        var btnCancel = $("<button>", {
            "type": "button",
            "class": "btn gray"
        });
        btnCancel.html("Cancel");
        btnCancel.on("click", function (e) {
            $.modal.impl.close();
        });
        buttons.append(btnCancel);

        var btnSave = $("<button>", {
            "type": "button",
            "class": "btn ok blue"
        });
        btnSave.html("Pin");

        btnSave.on("click", function (e) {
            e.stopPropagation();
            div.addClass("disabled");
            btnSave.html("<i class=\"icon\"><span class=\"spinner\"></span></i>");
            self.API_PinUrlSimple(articleUrl.val().trim(), div, btnSave);
        });
        buttons.append(btnSave);

        div.append(buttons);

        $.modal(div, {
            fitToView: true,
            autoSize: true,
            overlayClose: true,
            autoResize: true,
            autoPosition: true,
            minWidth: 300,
            maxWidth: 500,
            height: "auto",
            scrolling: "yes"
        });

        $("#cutomPinModal").closest(".simplemodal-container").addClass("heightAuto");
        $.modal.impl.setPosition();
    },

    HTML_Modal_Import: function () {
        var self = this;

        var div = $("<div/>", {
            "id": "ImportPinsModal",
            "class": "notification-modal"
        });

        var label = $("<label>", { "for": "pinsImportFile" });
        div.append(label);

        // Article Url
        var imprtFile = $("<input>", { "id": "pinsImportFile", "type": "file" });
        label.append(imprtFile);
        imprtFile.change(function (e) {
            var v = $(this).val();
            if (v.length > 0) {
                $("#btnImport", "#ImportPinsModal").prop("disabled", false);
                $("#btnImport", "#ImportPinsModal").removeClass("disabled");
            }
            else {
                $("#btnImport", "#ImportPinsModal").prop("disabled", true);
                $("#btnImport", "#ImportPinsModal").addClass("disabled");
            }
        });

        var buttons = $("<div/>", { "class": "buttons" })

        var btnCancel = $("<button>", {
            "type": "button",
            "class": "btn gray"
        });
        btnCancel.html("Cancel");
        btnCancel.on("click", function (e) {
            $.modal.impl.close();
        });
        buttons.append(btnCancel);

        var btnImport = $("<button>", {
            "id": "btnImport",
            "type": "button",
            "class": "btn ok blue disabled",
            "disabled": true
        });
        btnImport.html("Import");

        btnImport.on("click", function (e) {
            div.addClass("disabled");

            var data = new FormData();
            var files = $("#pinsImportFile", "#ImportPinsModal").get(0).files;

            if (files.length > 0) {
                data.append("UploadedOpml", files[0]);
            }

            self.API_Import(data, div);
        });
        buttons.append(btnImport);

        div.append(buttons);

        $.modal(div, {
            overlayClose: true,
            autoResize: false,
            autoPosition: true,
            minWidth: 200,
            maxWidth: 400
        });
        $(".notification-modal").closest(".simplemodal-container").addClass("heightAuto");
        $.modal.impl.setPosition();
    },

    HTML_Modal_Export: function () {
        var div = $("<div/>", {
            "id": "ImportPinsModal",
            "class": "notification-modal"
        });

        var buttons = $("<div/>", { "class": "buttons" })

        var btnCancel = $("<button>", {
            "type": "button",
            "class": "btn gray"
        });
        btnCancel.html("Cancel");
        btnCancel.on("click", function (e) {
            $.modal.impl.close();
        });
        buttons.append(btnCancel);

        var btnExport = $("<button>", {
            "id": "btnExport",
            "type": "button",
            "class": "btn ok blue disabled",
            "disabled": true
        });
        btnExport.html("Download");

        btnExport.on("click", function (e) {
            window.open(self.OpmlFile);
            $.modal.impl.close();
        });
        buttons.append(btnExport);

        div.append(buttons);

        $.modal(div, {
            overlayClose: true,
            autoResize: false,
            autoPosition: true,
            minWidth: 200,
            maxWidth: 400
        });
        $(".notification-modal").closest(".simplemodal-container").addClass("heightAuto");
        $.modal.impl.setPosition();

        $.ajax({
            url: NewsTab.ApiUrl_Global + "generatePinsOpmlFileToken",
            type: "POST",
            headers: {
                Authorization: 'Bearer ' + NewsTab.Token
            },
            error: function (error) {
                console.error(error);
                btnExport.addClass("disabled");
            }
        }).then(function (data) {
            self.OpmlFile = NewsTab.ApiUrl_Global + "downloadPinsOpmlFile?opmlToken=" + encodeURIComponent(data);
            btnExport.removeClass("disabled");
            btnExport.prop("disabled", false);
        });
    },

    API_LoadPublicPinned: function (options) {
        var opt = $.extend({}, { Count: "100", MaxId: "X" }, NewsTab.BASE_REQUEST_OPTIONS, options);

        var callUrl = NewsTab.ApiUrl_Global + "get/publicpinned/" + opt.Count + "/X/" + encodeURIComponent(opt.MaxId);

        $.ajax({
            url: callUrl,
            type: "GET",
            error: function (jqXHR, textStatus, errorThrown) {
                console.error("ERROR - API_LoadPublicPinned:", errorThrown);
                if (opt.ErrorCallback) opt.ErrorCallback(jqXHR, textStatus, errorThrown);
            },
            success: function (response) {
                var articles = [];
                for (var i = 0, l = response.Items.length; i < l; i++) {
                    var article = new Article().Init(response.Items[i]);

                    article._sourceFeed = NewsTab.Modules.SectionsManager.GetFeedById(article.FeedId, null);
                    if (article.SourceFeed() == null || article.SourceFeed().Type === Feed.TYPES.PINWALL) {
                        var otherParams = article.OtherParams.split("_NT_");
                        var type, publisher, siteurl = null;
                        if (otherParams.length >= 1) {
                            type = otherParams[0];
                        }
                        if (otherParams.length >= 2) {
                            publisher = otherParams[1];
                        }
                        if (otherParams.length >= 3) {
                            siteurl = otherParams[2];
                        }
                        var sourceFeed = new Feed().Init(
                        {
                            Id: 0,
                            Name: publisher,
                            SiteUrl: siteurl,
                            Type: type == "2" ? Feed.TYPES.TWITTER : Feed.TYPES.RSS,
                            Count: Feed.DEFAULT_COUNT,
                            OrderNumber: 0,
                            Layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                            LayoutType: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.LayoutType,
                            ShowInList: false
                        });
                        article._sourceFeed = sourceFeed;
                    }
                    articles.push(article);
                }

                if (opt.SuccessCallback) opt.SuccessCallback(articles);
            },
            complete: function (jqXHR, textStatus) {
                if (opt.CompleteCallback) opt.CompleteCallback(jqXHR, textStatus);
            }
        });
    },

    API_Import: function (opmlFileData, $form) {
        /// <summary>Send OPML file data to the API for import.</summary>  
        /// <param name='opmlFileData' type='FormData' >Form Data (new FormData()) to which the Opml fill is appended.</param>
        var self = this;
        $.ajax({
            type: "POST",
            headers: { Authorization: "Bearer " + NewsTab.Token },
            url: NewsTab.ApiUrl_Global + "uploadPinsOpmlFile",
            contentType: false,
            processData: false,
            data: opmlFileData,
            success: function (data) {
                SocialTab.SelectCurrentFeed(NewsTab.Modules.SectionsManager.CurrentSection.Id, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id);
                $.modal.impl.close();
            },
            error: function (error) {
                if ($form) {
                    $form.removeClass("disabled");
                }
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Opml Import",
                    Color: "red",
                    Text: "Opml data import ERROR!"
                });
            }
        });
    },

    API_PinArticleById: function (id, pin, closeModal) {
        var article = $.grep(NewsTab.Modules.ArticleView.ListedArticles, function (e) { return e.Id === id; });
        if (article.length > 0) {
            this.API_PinArticle(article[0], pin, closeModal);
        }
    },

    API_PinArticle: function (article, pin, closeModal) {
        var self = this;

        var $object = $(".socialTabItem[data-article-id=" + article.Id + "], #socialTabItemForm[data-article-id=" + article.Id + "]");
        article.Pinned ? $object.removeClass("pinned") : $object.addClass("pinned");

        if (pin) {
            var callUrl = NewsTab.ApiUrl_Global + "post/pin/" + parseInt(article.SourceFeed().Type.Id);
            var pinObject = new Article().ToPinObject(article);
            var raw = JSON.stringify(pinObject);
            NewsTab.Modules.ArticleView.PinnedItemAliases.push(article.Alias);

            $.ajax({
                url: callUrl,
                headers: { Authorization: 'Bearer ' + NewsTab.Token },
                type: "POST",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: raw,
                error: function (error) {
                    if (self.ShowLoadErrors) {
                        console.error("ERROR - PinItem:");
                        console.error(error);
                    }
                    !article.Pinned ? $object.removeClass("pinned") : $object.addClass("pinned");
                }
            }).then(function (data) {
                if (data === true) {
                    article.Pinned = !article.Pinned;

                    var pinWall = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === "-2"; });
                    if (pinWall.length > 0) {
                        pinWall = pinWall[0];
                        pinWall.Feeds[1].Feeds.unshift(article);
                    }

                }
            });
        }
        else {
            var callUrl = NewsTab.ApiUrl_Global + "delete/pin/" + article.Alias;
            var self = this;
            $.ajax({
                url: callUrl,
                headers: { Authorization: 'Bearer ' + NewsTab.Token },
                type: "DELETE",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: raw,
                error: function (error) {
                    if (self.ShowLoadErrors) {
                        console.error("ERROR - UnPinItem:");
                        console.error(error);
                    }
                    !article.Pinned ? $object.removeClass("pinned") : $object.addClass("pinned");
                }
            }).then(function (data) {
                if (data === true) {
                    if (closeModal) {
                        //if ($("#doubleModal").length === 1) {
                        //    $("#doubleModal").remove();
                        //}
                        //else {
                        $.modal.impl.close();
                        //}
                    }
                    NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.ArticleView.PinnedItemAliases, article.Alias);

                    article.Pinned = !article.Pinned;
                    if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Type === Feed.TYPES.PINWALL) {
                        var items = $(".socialTabItem[data-article-id=" + article.Id + "]");
                        for (var i = 0, l = items.length; i < l ; i++) {
                            if (items.eq(i).hasClass("socialTabItemForm")) {
                                $.modal.impl.close();
                            }
                            else {
                                items[0].remove();
                            }
                        }

                    }

                    var pinWall = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.SectionTypeId === Section.TYPES.Pinned; });
                    if (pinWall.length > 0) {
                        pinWall = pinWall[0];
                        var feedItems = $.grep(NewsTab.Modules.SectionsManager.ParsedFeeds, function (e) { return e.Id === pinWall.Feeds[1].Id; });
                        if (feedItems.length > 0) {
                            feedItems = feedItems[0];
                            NewsTab.Helpers.RemoveItemFromArray(feedItems.Articles, article);
                            if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id === feedItems.Id) {
                                NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.ArticleView.ListedArticles, article);
                                if (feedItems.Articles.length === 0) {
                                    SocialTab.LoadMore();
                                }
                                else {
                                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                                        SocialTab.LoadMore();
                                    }
                                }
                            }
                        }
                    }

                }
            });
        }
    },

    API_PinUrlSimple: function (url, $form, $btn) {
        var self = this;

        var callUrl = NewsTab.ApiUrl_Global + "post/pinurlsimple";

        $.ajax({
            url: callUrl,
            headers: { Authorization: 'Bearer ' + NewsTab.Token },
            type: "POST",
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            data: JSON.stringify(url),
            error: function (error) {
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Pin Article",
                    Color: "red",
                    Text: "The given url could not be parsed!"
                });
                console.error("ERROR - API_PinUrlSimple:", error);
                if ($btn) {
                    $btn.html("Pin");
                }
                if ($form) {
                    $form.removeClass("disabled");
                }
            }
        }).then(function (data) {
            if (data === true) {
                if (NewsTab.Modules.SectionsManager.CurrentSection != null && NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Pinned) {
                    $.modal.impl.close();
                    setTimeout(function () {
                        SocialTab.SelectCurrentFeed(NewsTab.Modules.SectionsManager.CurrentSection.Id, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id);
                    }, 500);
                }
                else {
                    $.modal.impl.close();
                    setTimeout(function () {
                        SocialTab.SelectCurrentFeed(self.PinSection.Id, self.PinSection.DefaultFeed.Id);
                    }, 500);
                }
            }
            else {
                if ($btn) {
                    $btn.html("Pin");
                }
                if ($form) {
                    $form.removeClass("disabled");
                }
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Pin Article",
                    Color: "red",
                    Text: "The given url could not be parsed!"
                });
            }

        });
    },

    API_PinUrlAdvanced: function (article, $btn) {
        var raw = JSON.stringify(article);
        var callUrl = NewsTab.ApiUrl_Global + "post/pinurladvanced";

        $.ajax({
            url: callUrl,
            headers: { Authorization: 'Bearer ' + NewsTab.Token },
            type: "POST",
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            data: raw,
            error: function (error) {
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Pin Article",
                    Color: "red",
                    Text: "The given url could not be parsed!"
                });
                console.error("ERROR - API_PinUrlAdvanced:", error);
                $.modal.impl.close();
            }
        }).then(function (data) {
            if (data === true) {
                if (NewsTab.Modules.SectionsManager.CurrentSection != null && NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Pinned) {
                    setTimeout(function () {
                        $.modal.impl.close();
                        SocialTab.SelectCurrentFeed(NewsTab.Modules.SectionsManager.CurrentSection.Id, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id);
                    }, 1000);
                }
                else {
                    $.modal.impl.close();
                }
            }
            else {
                if ($btn) {
                    $btn.html("Save");
                }
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Pin Article",
                    Color: "red",
                    Text: "The given url could not be parsed!"
                });
            }
        });
    }
};

$(document).ready(function () {
    NewsTab.Modules.SpecialPinSystem.Init();
});
