﻿var NewsTab = NewsTab || {};
NewsTab.Modules = NewsTab.Modules || {};

NewsTab.Modules.TwitterManager = {
    TwitterSystemSection: null,

    Init: function () {
        var self = this;
        self.TwitterSystemSection = $.grep(NewsTab.Modules.SectionsManager.SysSections, function (e) { return e.Name === "Twitter" });
        if (self.TwitterSystemSection.length) {
            self.TwitterSystemSection = self.TwitterSystemSection[0];
        }
        else {
            self.TwitterSystemSection = null;
        }
    },

    AddTwitterToUserSection: function () {
        var self = this;

        self.TwitterSystemSection = $.grep(NewsTab.Modules.SectionsManager.SysSections, function (e) { return e.Name === "Twitter" });
        if (self.TwitterSystemSection.length) {
            self.TwitterSystemSection = self.TwitterSystemSection[0];
            NewsTab.Modules.SectionsManager.API_AddSection(self.TwitterSystemSection.Id);
        }
    },

    Connect: function () {
        if (!Feed.TYPES.TWITTER.Linked) {
            //$(".socialSections .icon-statusIcon").hide().after("<i class=\"icon\" style=\"position: absolute; right: 0;\"><span class=\"spinner\" style=\"width: 20px; height: 20px; margin: 0; float: right;\"></span></i>");


            var callUrl = NewsTab.ApiUrl_Base + (NewsTab.IsExtension ? "api/twitter/connectex" : "api/twitter/connect");

            var self = this;
            $.ajax({
                url: callUrl,
                method: "POST",
                headers: { Authorization: "Bearer " + NewsTab.Token },
                error: function (error) {
                    console.error("ERROR - Twitter Connect: ", error);
                }
            }).then(function (data) {
                var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.Name === "Twitter" && s.SectionTypeId === Section.TYPES.Social });
                if (section != null) {
                    SocialTab.UpdateLastActiveSection(section[0].Id);
                }
                window.location.assign(data);
            });
        }
    },

    AddAndConnectTwitter: function () {
        var self = this;

        self.AddTwitterToUserSection();
        self.Connect();
    },

    Disconnect: function (options) {
        var self = this;

        var opt = $.extend({}, NewsTab.BASE_REQUEST_OPTIONS, options);

        var callUrl = NewsTab.ApiUrl_Base + "api/twitter/disconnect";

        $.ajax({
            url: callUrl,
            headers: { Authorization: 'Bearer ' + NewsTab.Token },
            type: "POST",
            contentType: "application/json",
            dataType: "json",
            processdata: true,
            error: function (error) {
                console.error("ERROR - " + self.Name + "_Disconnect: ", error);
                if (opt.ErrorCallback) {
                    opt.ErrorCallback();
                }
            }
        }).then(function (response) {
            if (response) {
                var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) {
                    return s.Name === "Twitter" && s.SectionTypeId === Section.TYPES.Social;
                });
                if (section.length > 0) {
                    section = section[0];

                    Feed.TYPES.TWITTER.Account = null;

                    if (options.RemoveSection) {
                        $("." + section.ClassName).removeClass("connected");
                        NewsTab.Modules.SectionsManager.API_RemoveSection(section,
                            {
                                ErrorCallback: opt.ErrorCallback,
                                SuccessCallback: opt.SuccessCallback
                            });
                    }
                    else {
                        NewsTab.Modules.SectionsManager.SetCurrentSectionAndFeed(section.Id);
                        NewsTab.Modules.SectionsManager.LoadCurrentFeed({ Refresh: true });
                        if (opt.SuccessCallback) {
                            opt.SuccessCallback();
                        }
                    }
                }
            }
        });
    }
};