﻿var AutomaticUpdater = function () {

    var self = this;

    self.lastTimeUpdate = null;

    self.nextExecutionMilisecunds = null;
    self.initializedLoop = false;
    self.windowFocused = true;

    self.UpdateTopFeeds = function () {
        if (SocialTab && NewsTab.User && NewsTab.User.Id) {
            var lastTimeUpdated = AutomaticUpdater.lastTimeUpdate ? AutomaticUpdater.lastTimeUpdate : localStorage.getItem(NewsTab.User.Id + 'UpdateTopLastTime');
            AutomaticUpdater.lastTimeUpdate = lastTimeUpdated;
            if (AutomaticUpdater.lastTimeUpdate) {
                var date = new Date(parseInt(lastTimeUpdated));
                if ((new Date()) < date) {
                    AutomaticUpdater.nextExecutionMilisecunds = date - (new Date());
                    return;
                } else {
                    var v = new Date();
                    v.setMinutes(v.getMinutes() + 15);
                    localStorage.setItem(NewsTab.User.Id + 'UpdateTopLastTime', +v);
                    AutomaticUpdater.lastTimeUpdate = +v;
                    AutomaticUpdater.nextExecutionMilisecunds = v - (new Date());
                }
            } else {
                var v = new Date();
                v.setMinutes(v.getMinutes() + 15);
                localStorage.setItem(NewsTab.User.Id + 'UpdateTopLastTime', +v);
                AutomaticUpdater.lastTimeUpdate = +v;
                AutomaticUpdater.nextExecutionMilisecunds = v - (new Date());
            }
        }

        if (self.windowFocused === false)
            return;

        SocialTab.TopUpdatedFeeds = [];

        if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Type === Feed.TYPES.ALL) {
            SocialTab.UpdateSectionFeeds(NewsTab.Modules.SectionsManager.CurrentSection, function (data) {
                if (data.Results) {
                    $.each(data.Results, function (index1, data1) {
                        /* ONLY FOR LOG */
                        data1.FeedName = ($.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (e) { return e.Id === data1.FeedId; }))[0].Name;
                        /* ONLY FOR LOG */
                        SocialTab.TopUpdatedFeeds.push(data1.FeedId);
                        if (data1.NewArticlesCount > 0 && SocialTab.ShowUpdateTooltip !== true) {
                            $(".updateTopFeeds").closest(".mbBalloon").addClass("importatShow");
                            SocialTab.ShowUpdateTooltip = true;
                        }
                        return;
                    });
                    return;
                }
            });
        } else {
            var homeSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.SectionTypeId === Section.TYPES.Home; });
            if (homeSection.length && SocialTab.ShowUpdateTooltip !== true) {
                SocialTab.UpdateHomeFeeds(homeSection[0].Feeds[1], function (data) {
                    if (data.Results) {
                        $.each(data.Results, function (index1, data1) {
                            var currentFeed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (e) { return e.Id === data1.FeedId; });
                            if (currentFeed.length) {
                                SocialTab.TopUpdatedFeeds.push(data1.FeedId);
                                if (data1.NewArticlesCount > 0 && SocialTab.ShowUpdateTooltip !== true) {
                                    $(".updateTopFeeds").closest(".mbBalloon").addClass("importatShow");
                                    SocialTab.ShowUpdateTooltip = true;
                                }
                            } else if (NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Home) {
                                if (data1.NewArticlesCount > 0 && SocialTab.ShowUpdateTooltip !== true) {
                                    $(".updateTopFeeds").closest(".mbBalloon").addClass("importatShow");
                                    SocialTab.ShowUpdateTooltip = true;
                                }
                            }
                            return;
                        });
                        return;
                    }
                });
            }
        }
    };

    self.StartLoops = function () {
        $(function () {
            $(window).blur(function () {
                AutomaticUpdater.windowFocused = false;
            });
            $(window).focus(function () {
                AutomaticUpdater.windowFocused = true;
                AutomaticUpdater.UpdateTopFeeds();
            });
            $(document).on("mousedown mousemove", function (e) {
                AutomaticUpdater.UpdateTopFeeds();
                if (!AutomaticUpdater.initializedLoop && AutomaticUpdater.nextExecutionMilisecunds && AutomaticUpdater.nextExecutionMilisecunds > 0) {
                    setTimeout(function () {
                        AutomaticUpdater.UpdateTopFeeds();
                    }, AutomaticUpdater.nextExecutionMilisecunds + 1);
                    AutomaticUpdater.initializedLoop = true;
                }
            });
        });
    }
    return self;
}();

$(document).ajaxError(function (event, error) {
    if (error && error.status === 403) {
        var c = document.cookie.split("; ");
        for (i in c) {
            if (c[i].indexOf && c[i].indexOf("BetaKey") > -1) {
                //
            } else {
                document.cookie = /^[^=]+/.exec(c[i])[0] + "=;expires=Thu, 01 Jan 1970 00:00:00 GMT";
            }
        }
        localStorage.clear();
        if (!NewsTab.IsExtension) {
            window.document.location = "/account/login";
        }
    }
});

if (typeof UIkit === 'undefined') {
    var UIkit = null;
}

if (typeof Autolinker === 'undefined') {
    var Autolinker = null;
}

var SocialTab = {
    AllStates: { None: -2, LandingPage: -1, Connect: 0, Feeds: 1, ShortLinks: 2 },
    CurrentState: null,

    DashboardReady: false,
    SharedArticleMode: false,

    ColorPalette: [
        "#e91e63", "#9761a9", "#03a9f4", "#009688",
        "#00bfa5", "#ebc24e", "#fb7243", "#795548"
    ],

    // Organizer


    // End of Organizer

    CurrentSectionPreview: null,
    LastActiveSections: [],
    LastActiveFeeds: [],
    ReadItems: [],
    ParsedFeeds: [], // All feeds that we got from the parsings (initial and all future parsing till we refresh our browser), used to locak store all the parse result and gain quick access to it

    ListedArticles: [], // Articles currenty showing to the user in the grid (could be a list of all sorts of articles), used to quickly get access to the article information for expand and other future tasks

    ExpandedArticle: null,

    APIRSSUrl: NewsTab.ApiUrl_Base + "api/apirss/",

    DefaultProfileImage: "/Media/Images/profile_pic_default.png",

    User: null,
    SysSections: [],
    Sections: [],

    TagId: 0,
    LanguageId: 0,

    Countries: null,
    SelectedCountry: null,

    ListEditions: undefined,
    PreviousEdition: undefined,

    UpdateSectionsOrderXhr: null,
    UpdateFeedsOrderXhr: null,

    ImageLoadTimeOut: 3000,
    ImageLoadInProgress: false,

    NumberOfVisibleSections: 5,
    NumberOfVisibleFeeds: 7,

    TopUpdatedFeeds: [],

    /* Sharing */

    /* Settings */

    AppSettings: {
        LightTheme: false,
        FormMaxWidth: 1024,
        LoadImages: true,
        FontSizes: [10, 12, 14, 16, 18],
        ActiveFontSize: 2,
        BorderStyle: "border-none"
    },

    PopularPublishers: [],
    SelectedPublishers: [],
    PopularTopics: [],
    Şelectedopics: [],
    RegionPublishers: [],
    SelectedRegionPublishers: [],
    UsStates: [],

    LayoutTypes: {
        AllFeedsAndSections: 0,
        CurrentSection: 1,
        CurrentFeed: 2
    },

    LastScrollPosition: 0,

    IpInfo: null,

    NewId: "00000000-0000-0000-0000-000000000000",

    SetVersion: function (varsion) {
        $("#copyRight").text(varsion.CopyRight);
        $("#buildVersion").text(varsion.Version);
    },

    Init: function () {
        NewsTab.Modules.NotificationsManager.Init();

        if (!window.AddEmailPage) {
            Object.freeze(SocialTab.AllStates);
            SocialTab.CurrentState = SocialTab.AllStates.LandingPage;

            if (window.sharedArticle !== null) {
                //NewsTab.Helpers.EraseCookie("ArticlePreview");
                NewsTab.Modules.Sharing.DisplayingSharedArticle = true;
            }

            SocialTab.UserData_GetFromStorage();
        }

        NewsTab.Modules.SectionsManager.Init();
        NewsTab.Modules.AddNewContent.Init();
    },

    /* User Data */

    UserData_GetFromStorage: function () {
        var token;

        if (NewsTab.Helpers.ReadCookie("TokenKey")) {
            token = NewsTab.Helpers.ReadCookie("TokenKey");
            if (token !== null && token !== false) {
                NewsTab.Token = token;
                if (NewsTab.Modules.Sharing.DisplayingSharedArticle) {
                    NewsTab.Modules.Sharing.InitShareDashboard(function () { SocialTab.UserData_GetFromAPI(); });
                }
                else {
                    SocialTab.UserData_GetFromAPI();
                }

            } else {
                console.error("UserData_GetFromStorage: No Token Key");
                setTimeout(function () {
                    window.location.assign("/account/login");
                }, 3000);
            }
        } else {
            token = NewsTab.Helpers.GetQueryVariable("TokenKey");
            if (token) {
                NewsTab.Helpers.CreateCookie("TokenKey", token, 365);
                var redirectUrl = NewsTab.Helpers.GetQueryVariable("RedirectUrl");
                if (redirectUrl === "newtab") {
                    setTimeout(function () {
                        window.location.assign("/");
                    }, 3000);
                }
                else {
                    window.location.assign("/");
                }
            }
            else if (NewsTab.Modules.Sharing.DisplayingSharedArticle) {
                NewsTab.Modules.Sharing.InitShareDashboard(function () { SocialTab.Show_Dashboard(); });
            }
            else {
                console.error("UserData_GetFromStorage: No Token Key");
                setTimeout(function () {
                    window.location.assign("/account/login");
                }, 3000);
            }
        }
    },

    UserData_GetFromAPI: function () {
        if (NewsTab.Token) {
            var callUrl = NewsTab.ApiUrl_Global + "get/initialdata";
            $.ajax({
                type: "GET",
                url: callUrl,
                headers: { Authorization: "Bearer " + NewsTab.Token }, // SETING UP THE TOKEN FOR "Authorize" ACCESS
                cache: false,
                error: function (error) {
                    NewsTab.Helpers.CenterContent($(".confirmationMessage"), false);
                    console.error("ERROR - UserData_GetFromAPI:", error);
                    var failsNumber = localStorage.getItem("Fails");
                    failsNumber = failsNumber != undefined ? parseInt(failsNumber) : 0;

                    if (error.status === 401 || error.status === 403 || failsNumber > 0) {
                        localStorage.setItem("Fails", 0);
                        document.cookie = "TokenKey" + "=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;";
                        window.location = window.location.origin + "/Home";
                    } else {
                        var message = "Something went wrong! Please try again!";
                        var button = {
                            btnClass: "btn blue",
                            action: "window.location.reload()",
                            btnName: "Try again"
                        };
                        SocialTab.ShowConfirmationMessage(message, button);
                        localStorage.setItem("Fails", ++failsNumber);
                    }
                }
            }).then(function (data) {
                if (data) {
                    SocialTab.ProfileImages = data.ProfileImages;
                    NewsTab.User = data.User;
                    SocialTab.MaxTopFeeds = data.User.MaxTopFeeds;
                    SocialTab.LocalAccountAvailable = data.LocalAccountAvailable;

                    try {
                        appInsights.setAuthenticatedUserContext(NewsTab.User.Id);
                    } catch (e) { }

                    if (data.User.SocialNetworks) {
                        for (var i = 0, len = data.User.SocialNetworks.length; i < len; i++) {
                            if (data.User.SocialNetworks[i].SourceId === 2) {
                                Feed.TYPES.TWITTER.Account = data.User.SocialNetworks[i];
                            }
                        }
                    }
                    if (!NewsTab.User.ProfilePictureUrl) {
                        NewsTab.User.ProfilePictureUrl = SocialTab.DefaultProfileImage;
                    }

                    NewsTab.Modules.RegionManager.Countries = data.Countries;
                    NewsTab.Modules.SectionsManager.SysSections = data.Sections;

                    SocialTab.LastActiveSectionId = data.User.LastActiveSection;
                    SocialTab.LastActiveFeedId = data.User.LastActiveFeed;

                    var county;
                    if (data.User.FtsDone === false) {
                        SocialTab.IpInfo = {
                            "country_code": "US",
                            "country_name": "United States"
                        };

                        navigator.geolocation.getCurrentPosition(SocialTab.GetLocationFromHtml, SocialTab.GetLocationFromExternalApi, {
                            enableHighAccuracy: true,
                            timeout: 5000,
                            maximumAge: 0
                        });
                    } else {
                        if (NewsTab.User.CountryId) {
                            county = $.grep(NewsTab.Modules.RegionManager.Countries, function (c) { return c.Id === NewsTab.User.CountryId; });
                            if (county.length > 0) {
                                SocialTab.SelectedCountry = county[0];
                                NewsTab.Modules.RegionManager.MainEdition = SocialTab.SelectedCountry.Code;
                                NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
                                NewsTab.Modules.RegionManager.MainEditionGnValue = (county[0].GoogleNewsEditionCode != null && county[0].GoogleNewsEditionCode !== "")
                                    ? county[0].GoogleNewsEditionCode : "US";
                                NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;
                            } else {
                                NewsTab.Modules.RegionManager.MainEdition = "US";
                                NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
                                NewsTab.Modules.RegionManager.MainEditionGnValue = NewsTab.Modules.RegionManager.MainEdition;
                                NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEdition;
                            }
                        }

                        SocialTab.AppSettings.LightTheme = data.User.LightTheme_Web;
                        SocialTab.AppSettings.TopBarFixed = data.User.TopBarFixed;
                        SocialTab.AppSettings.BorderStyle = data.User.BorderStyle;
                        SocialTab.NumberOfVisibleSections = data.User.NumberOfVisibleSections > 0 ? data.User.NumberOfVisibleSections : 5;
                        SocialTab.Show_Dashboard();
                    }
                }

                AutomaticUpdater.UpdateTopFeeds(); // Update users top 20 feeds
                AutomaticUpdater.StartLoops();

                SocialTab.SetVersion(data.BuildDetails);
                NewsTab.IsReady = true;
            });
        } else {
            console.error("UserData_GetFromAPI: No Token Key");
        }
    },

    GetLocationFromHtml: function (position) {
        var lat = position.coords.latitude;
        var long = position.coords.longitude;
        $.ajax({
            url: "http://maps.googleapis.com/maps/api/geocode/json?latlng=" + lat + "," + long + "&sensor=false",
            method: "GET",
            dataType: "json"
        }).done(function (data) {
            var countryData = $.grep(data.results[0].address_components, function (x) { return x.types.indexOf("country") > -1 });
            SocialTab.IpInfo = {
                "country_code": countryData[0].short_name,
                "country_name": countryData[0].long_name
            }
            var countyCode = SocialTab.IpInfo != undefined ? SocialTab.IpInfo.country_code : 'US';
            county = $.grep(NewsTab.Modules.RegionManager.Countries, function (c) { return c.Code.split("_")[0] === countyCode; });
            if (county.length > 0) {
                SocialTab.SelectedCountry = county[0];
                NewsTab.Modules.RegionManager.MainEdition = SocialTab.SelectedCountry.Code;
                NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
                NewsTab.Modules.RegionManager.MainEditionGnValue = $("#changeEditionSettings option:selected").attr("data-googlenewscode") !== "" ?
                    $("#changeEditionSettings option:selected").attr("data-googlenewscode") : "US";
                NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;
            }
            SocialTab.Show_FtsWelcomePage();
        }).fail(function (e) {
            SocialTab.GetLocationFromExternalApi();
        });
    },

    GetLocationFromExternalApi: function () {
        $.getJSON('https://ipinfo.io/geo', function (data) {
            SocialTab.IpInfo = {
                "country_code": data.country,
                "country_name": data.city
            };
            var countyCode = SocialTab.IpInfo != undefined ? SocialTab.IpInfo.country_code : 'US';
            county = $.grep(NewsTab.Modules.RegionManager.Countries, function (c) { return c.Code.split("_")[0] === countyCode; });
            if (county.length > 0) {
                SocialTab.SelectedCountry = county[0];
                NewsTab.Modules.RegionManager.MainEdition = SocialTab.SelectedCountry.Code;
                NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
                NewsTab.Modules.RegionManager.MainEditionGnValue = $("#changeEditionSettings option:selected").attr("data-googlenewscode") !== "" ?
                    $("#changeEditionSettings option:selected").attr("data-googlenewscode") : "US";
                NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;
            }
            SocialTab.Show_FtsWelcomePage();
        }).fail(function (e) {
            console.error("api.ipify.org", e);
            var countyCode = SocialTab.IpInfo != undefined ? SocialTab.IpInfo.country_code : 'US';
            county = $.grep(NewsTab.Modules.RegionManager.Countries, function (c) { return c.Code.split("_")[0] === countyCode; });
            if (county.length > 0) {
                SocialTab.SelectedCountry = county[0];
                NewsTab.Modules.RegionManager.MainEdition = SocialTab.SelectedCountry.Code;
                NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
                NewsTab.Modules.RegionManager.MainEditionGnValue = $("#changeEditionSettings option:selected").attr("data-googlenewscode") !== "" ?
                    $("#changeEditionSettings option:selected").attr("data-googlenewscode") : "US";
                NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;
            }
            SocialTab.Show_FtsWelcomePage();
        });
    },

    FtsSettings_PostAPI: function () {
        $("#ftsWelcomePage").closest(".fancybox-overlay").hide();
        var normalSections = $(".initialSections li.selected");
        var socialSections = $(".socialSections li.selected");
        var selectedSectionIds = [];
        var i;
        var len;
        for (i = 0, len = normalSections.length; i < len; i++) {
            selectedSectionIds.push(normalSections.eq(i).attr("section-id"));
        }

        for (i = 0, len = socialSections.length; i < len; i++) {
            selectedSectionIds.push(socialSections.eq(i).attr("section-id"));
        }

        var settings = {
            CountryCode: NewsTab.Modules.RegionManager.MainEdition,
            Sections: selectedSectionIds
        };

        $.ajax({
            type: "POST",
            url: NewsTab.ApiUrl_Base + "api/global/post/initialdata",
            headers: { Authorization: "Bearer " + NewsTab.Token },
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(settings)
        }).done(function (data) {
            if (data === true) {
                window.location.assign("/");
            }
        }).fail(function (request, textStatus) {
            console.error(textStatus);
        });
    },

    FirstTimeContent: function (param) {
        $("#addNewContent").find("#contents").hide();
        $("#addNewContent").find("#firstTimeContent").show();
        $("#addNewContent").find("#firstTimeContent .searchItems").html("");
        $("#addNewContent").find("#firstTimeContent").find("#contentFeeds").addClass("active");

        if ($("#firstTimeContent").find(".searchItems").find("#googleNewsItemKeyword").length === 0) {
            SocialTab.HTML_SeatupGoogleNewsSearchSection($("#firstTimeContent"));
        }

        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (c) { return (c.Name === param); });
        var sectionName = section[0].Name;
        var region = NewsTab.Modules.RegionManager.MainEdition.split("_")[0];
        $(".name.feedName").html("").html(sectionName + " feeds");
        $(".iconName.regionName").html("").html(region);

        if (SocialTab.IpInfo.country_code === region) {
            $(".name.regionFullName").html("").html("Publishers in " + SocialTab.IpInfo.country_name);
        } else {
            var selectedCountryName = $.grep(NewsTab.Modules.RegionManager.Countries, function (c) { return c.Code === region; })[0].Name;
            $(".name.regionFullName").html("").html("Publishers in " + selectedCountryName);
        }

        SocialTab.GetGoogleNewsTopicsAndKeyword($("#firstTimeContent"), sectionName, NewsTab.Modules.RegionManager.MainEditionGnValue);
    },

    OpenFeedsShortcut: function (type) {
        NewsTab.Modules.XhrManager.CancelAllRequests();
        switch (type) {
            case 1:
                SocialTab.OpenFeedsSearch();
                break;
            case 2:
                SocialTab.OpenFeedsTopics();
                break;
            case 3:
                SocialTab.OpenPopularPublishers();
                break;
            case 4:
                SocialTab.OpenPublishersByRegion();
                break;
            case 5:
                SocialTab.OpenImportRssUrl();
                break;
            case 6:
                SocialTab.OpenCreateLocationFeeds();
                break;
            case 7:
                SocialTab.OpenGoogleNewsAlert();
                break;
            default:
                SocialTab.OpenFeedsSearch();
                break;
        }
    },

    OpenFeedsSearch: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find(".popularTabSection").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabFeeds").addClass("active");
        $("#addNewContent").find("#contentFeeds").addClass("active");
        $("#addNewContent").find("#tabPublishers").addClass("active");
        $("#addNewContent").find("#popularPublishersTabSection").addClass("active");
    },

    OpenFeedsTopics: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find(".popularTabSection").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabFeeds").addClass("active");
        $("#addNewContent").find("#contentFeeds").addClass("active");
        $("#addNewContent").find("#tabPublishers").addClass("active");
        $("#addNewContent").find("#popularPublishersTabSection").addClass("active");
        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (c) { return (c.Connected && c.ShowInSourceList); });
        NewsTab.Modules.AddNewContent.GetFeedsList({
            $Container: $('#addNewContent .feedsPanel.active .gridList'),
            Url: section[0].Name,
            Type: "TOPIC",
            SkipRecords: 0,
            Reset: true
        });
    },

    OpenPopularPublishers: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find(".popularTabSection").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabFeeds").addClass("active");
        $("#addNewContent").find("#contentFeeds").addClass("active");
        $("#addNewContent").find("#tabPublishers").addClass("active");
        $("#addNewContent").find("#popularPublishersTabSection").addClass("active");
    },

    OpenPublishersByRegion: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find(".popularTabSection").removeClass("active");
        $("#addNewContent").find(".feedsPanel").removeClass("active");
        $("#addNewContent").find("#tabFeeds").addClass("active");
        $("#addNewContent").find("#contentFeeds").addClass("active");
        $("#addNewContent").find("#tabRegionPublishers").addClass("active");
        $("#addNewContent").find("#regionPublishersTabSection").addClass("active");
    },

    OpenImportRssUrl: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find("#tabCustom").addClass("active");
        $("#addNewContent").find("#contentCustom").addClass("active");
        SocialTab.HTML_HowToFindRssUrl();
    },

    OpenCreateLocationFeeds: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find("#tabCustom").addClass("active");
        $("#addNewContent").find("#contentCustom").addClass("active");
        SocialTab.HTML_SetupCreateGoogleNewsLocation();
    },

    OpenGoogleNewsAlert: function () {
        $("#addNewContent").find("#contents").show();
        $("#addNewContent").find("#firstTimeContent").hide();
        $("#addNewContent").find("header .shadow").removeClass("active");
        $("#addNewContent").find(".mainPanel").removeClass("active");
        $("#addNewContent").find("#tabCustom").addClass("active");
        $("#addNewContent").find("#contentCustom").addClass("active");
        SocialTab.HTML_SetupCreateGoogleNewsKeyword();
    },

    /* Setup Dashboard */

    Show_Dashboard: function () {
        this.DashboardReady = true;

        var devOps = NewsTab.Helpers.GetQueryVariable("DevOps");
        if (devOps) {
            devOps = devOps.toString();
            fpButton = devOps.indexOf("ForceParsButton");
            if (fpButton != -1) {
                var opt = devOps.substr(fpButton + 16, 3);
                if (opt.indexOf("On") != -1) {
                    NewsTab.Helpers.CreateCookie("ForceParsButton", "On", 356);
                }
                else if (opt === "Off") {
                    NewsTab.Helpers.CreateCookie("ForceParsButton", "Off", 356);
                }
            }
        }

        var forceParsButton = NewsTab.Helpers.ReadCookie("ForceParsButton");
        if (forceParsButton) {
            if (forceParsButton === "On") {
                if (NewsTab.Modules.ArticleView) {
                    NewsTab.Modules.ArticleView.ForceParsButton = true;
                }
            } else if (forceParsButton === "Off") {
                if (NewsTab.Modules.ArticleView) {
                    NewsTab.Modules.ArticleView.ForceParsButton = false;
                }
            }
        }

        SocialTab.Settings_AttacheEventHandlers();
        SocialTab.Settings_UpdateHTML_FromStorage();

        $("#showSignatureOnSharedArticles").prop("checked", !NewsTab.User.DisableShareSignature_Web);
        if (NewsTab.Modules.Sharing) {
            NewsTab.Modules.Sharing.EnableSharingSignature(!NewsTab.User.DisableShareSignature_Web);
        }
        SocialTab.SetupTheme();
        SocialTab.SetupTopBar();
        SocialTab.SetupBorder();

        NewsTab.Modules.Sharing.Load_TopShareProviders_FromLocalStorage();

        var expandSetting = NewsTab.Helpers.GetLocalStorageItem("ST_" + NewsTab.User.Id + "_ExpandFormSettings");
        if (expandSetting !== null) {
            NewsTab.Modules.ArticleView.ExpandFormSettings = expandSetting;
        }

        var readedItems = NewsTab.Helpers.GetLocalStorageItem("ST_" + NewsTab.User.Id + "_ReadItems");
        if (readedItems !== null) {
            SocialTab.ReadItems = NewsTab.Helpers.ArrayUnique(readedItems.concat(NewsTab.User.ViewHistory));
        } else {
            SocialTab.ReadItems = NewsTab.User.ViewHistory;
        }

        // Init Sections
        NewsTab.User.Sections.forEach(function (s) {
            NewsTab.Modules.SectionsManager.Sections.push(new Section().Init(s));
        });

        // Load pinned items
        var pinSec = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.SectionTypeId === Section.TYPES.Pinned; });
        if (pinSec.length) {
            SocialTab.LoadPinnedFeed(pinSec[0].Feeds[1]);
        }
        // LAST ACTIVE SECTIONS
        SocialTab.LastActiveSections = [];
        for (var i = 0, position = 0; i < NewsTab.User.Sections.length && position < NewsTab.User.Sections.length; i++ , position++) {
            if (NewsTab.User.Sections[position].SectionTypeId === Section.TYPES.Normal ||
                NewsTab.User.Sections[position].SectionTypeId === Section.TYPES.Social) {
                SocialTab.LastActiveSections.push(NewsTab.User.Sections[position].Id);
            } else {
                i--;
            }
        }

        $("i.stProfilePicture").css("background-image", "url(" + NewsTab.User.ProfilePictureUrl + ")");
        $("img.stProfilePicture").attr("src", NewsTab.User.ProfilePictureUrl);
        $("li.myProfileTitle").attr("title", NewsTab.User.FullName);
        $(".stUsername").text(NewsTab.User.FullName);
        $(".stUserEmail").val(NewsTab.User.FullName);

        if (SocialTab.DoesUserSignupViaFacebook()) {
            $(".socialAccWrapper").text("(Via Facebook)");
        } else if (SocialTab.DoesUserSignupViaGoogle()) {
            $(".socialAccWrapper").text("(Via Google)");
        }

        NewsTab.Modules.AddNewContent.Setup_Sections();
        SocialTab.HTML_SetUpSourceList();
        SocialTab.Calculate_Section_ItemNumber();

        if (SocialTab.LastActiveSectionId == undefined) {
            var twitter = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === SocialTab.LastActiveSections[0] && x.SectionTypeId === Section.TYPES.Social });
            if (twitter.length) {
                SocialTab.LastActiveSectionId = SocialTab.LastActiveSections[1];
            } else {
                SocialTab.LastActiveSectionId = SocialTab.LastActiveSections[0];
            }
        } else {
            SocialTab.LastActiveSectionId = SocialTab.LastActiveSectionId;
        }

        localStorage.setItem("ST_Id", NewsTab.User.Id);
        localStorage.setItem("ST_" + NewsTab.User.Id + "_FullName", NewsTab.User.FullName);
        localStorage.setItem("ST_" + NewsTab.User.Id + "_ProfilePictureUrl", NewsTab.User.ProfilePictureUrl);

        if (!NewsTab.Modules.Sharing.DisplayingSharedArticle || NewsTab.Token) {
            if (NewsTab.Modules.SectionsManager.SetCurrentSectionAndFeed()) {
                NewsTab.Modules.SectionsManager.LoadCurrentFeed();
            }
        }
        else {
            SocialTab.SetCurrentFeed(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id, true, false);
        }

        var source = NewsTab.Helpers.GetQueryVariable("Source");
        if (source) {
            var topic = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === source });
            if (topic.length > 0) {
                topic = topic[0];
            }
            if (topic.Id !== SocialTab.LastActiveSectionId) {
                SocialTab.SetCurrentSection(topic.Id, true, false);
            }
        }
        if (!source && NewsTab.Modules.SectionsManager.CurrentSection !== undefined) {
            source = NewsTab.Modules.SectionsManager.CurrentSection.Id;
            if (source != null) {
                if (source !== SocialTab.LastActiveSectionId) {
                    SocialTab.SetCurrentSection(source, true, false);
                }
            } else {
                var firstSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return t.SectionTypeId !== Section.TYPES.Social && t.ShowInSourceList; });
                if (firstSection.length > 0) {
                    firstSection = firstSection[0];
                }
                if (firstSection.Id !== SocialTab.LastActiveSectionId) {
                    SocialTab.SetCurrentSection(firstSection.Id, true, false);
                }
            }
        }

        SocialTab.Set_AppSettings_ActiveLayout();

        $(".loader").addClass("close");

        if (NewsTab.Token) {
            NewsTab.API_GetColors();
            NewsTab.API_GetTags();
            NewsTab.API_GetLanguages();
        }
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#mainEditionsDropdown"), false, NewsTab.Modules.RegionManager.AddFeedEdition);
        SocialTab.RenderFeedbackDropzone();

        var boxSize = localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveBoxSize");
        if (boxSize != NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize || $(window).width() <= 800) {
            SocialTab.Calculate_Feed_ItemSize();
        }

        SocialTab.page = 0;

        SocialTab.FcmConfiguration();
        SocialTab.Calculate_Section_ItemNumber();
    },

    FcmConfiguration: function () {
        var config = {
            apiKey: "AIzaSyBoew4-TJO1tmmh_0m1hH76R1nPDkE99e8",
            authDomain: "newstab-ecc37.firebaseapp.com",
            databaseURL: "https://newstab-ecc37.firebaseio.com",
            storageBucket: "newstab-ecc37.appspot.com",
            messagingSenderId: "903880153201"
        };
        firebase.initializeApp(config);
        var dbRef = firebase.database().ref().child('object');
        dbRef.on('value', (function (snap) { SocialTab.Fcm_SetMessage(snap); }).bind(this));
    },

    DoesUserSignupViaFacebook: function () {
        if (SocialTab.LocalAccountAvailable === true)
            return false;

        if (SocialTab && NewsTab.User && NewsTab.User.SocialNetworks) {
            var seed = NewsTab.User.SocialNetworks.filter(function (value) {
                if (value.SourceId === 3)
                    return value;
            });

            if (seed && seed.length > 0) {
                return true;
            }
        }

        return false;
    },

    DoesUserSignupViaGoogle: function () {
        if (SocialTab.LocalAccountAvailable === true)
            return false;

        if (SocialTab && NewsTab.User && NewsTab.User.SocialNetworks) {
            var seed = NewsTab.User.SocialNetworks.filter(function (value) {
                if (value.SourceId === 4)
                    return value;
            });

            if (seed && seed.length > 0) {
                return true;
            }
        }

        return false;
    },

    Show_Tooltip: function (tooltipNumber, container, position, animation, nextData) {
        if ($("body").width() < 350) {
            position = "down";
        }

        var tooltip = localStorage.getItem("ST_" + NewsTab.User.Id + "_Tooltip" + tooltipNumber);
        if (tooltip !== "true" && $(container).is(":visible")) {
            $(".mbBalloon").remove();
            setTimeout(function () {
                $(container).showBalloon(undefined, {
                    balloon: $("#tooltip_" + tooltipNumber),
                    forceposition: position,
                    bgcolor: "#3bc1f1",
                    bordercolor: "#3bc1f1",
                    textcolor: "#FFF",
                    highlight: false,
                    addclose: true
                });

                setTimeout(function () {
                    $("#tooltip_" + tooltipNumber + " .btn-gotIt").on("click", function (e) {
                        e.preventDefault();
                        $(container).hideBalloon();

                        if (nextData != undefined && $(nextData.container).is(":visible")) {
                            SocialTab.Show_Tooltip(nextData.tooltipNumber, nextData.container, nextData.position, nextData.animation, nextData.nextData);
                        }
                    });
                }, animation);

                localStorage.setItem("ST_" + NewsTab.User.Id + "_Tooltip" + tooltipNumber, true);
            }, animation);
        }
    },

    NewArticlesNotificationTmpl: function (showUpdateTooltip, marginLeft) {
        return "<div class=\"mbBalloon n " + showUpdateTooltip + "\" style=\"margin-left: " + marginLeft + "px !important;\">" +
            "<div class=\"arrow n\"></div>" +
            "<div class=\"arrow border n\"></div>" +
            "<div id=\"tooltip_updateTop\" class=\"updateTopFeeds\" style=\"display: block;\">" +
            "<p class=\"tooltip-content\" style=\"margin-top: -9px;\">" +
            "<i class=\"icon-refresh\"><span style=\"margin-left: 20px;\">New stories</span></i></p></div></div>";
    },

    /* First Time Setup */

    Show_FtsWelcomePage: function () {
        var html = "<div id=\"ftsWelcomePage\"></div>";

        $.fancybox(html,
            {
                autoSize: false,
                width: "100%",
                height: "100%",
                scrolling: "no",
                closeBtn: false,
                closeClick: false,
                openEffect: "none",
                closeEffect: "none",
                openOpacity: false,
                closeOpacity: false,
                margin: 0,
                padding: 0,
                helpers: {
                    overlay: { closeClick: false }
                }
            }
        );

        var region = localStorage.getItem("FTS_" + NewsTab.User.Id + "_Region");
        NewsTab.Modules.RegionManager.MainEdition = region != undefined ? region : NewsTab.Modules.RegionManager.MainEdition;

        if (SocialTab.SelectedCountry) {
            $("#ftsWelcomePageTemplate").tmpl({ Email: NewsTab.User.FullName, CountryName: SocialTab.SelectedCountry.Name }).appendTo($("#ftsWelcomePage"));
        }
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#countryRegionDropdown"), true, NewsTab.Modules.RegionManager.MainEdition);

        var twitterIsConnected = localStorage.getItem("FTS_" + NewsTab.User.Id + "_TwitterSection");
        if (twitterIsConnected != undefined) {
            SocialTab.TwitterIsConnected = true;
            SocialTab.Show_FtsConfiguration();
        }

        //$("#ftsWelcomePage .container .btn.btn-primary").focus();
    },

    ReplaceEmail: function () {

        var email = $("#addEmailAddressSetup").val();

        var options = {
            trigger: "manual",
            placement: "right",
            template: "<div class=\"tooltip error\" role=\"tooltip\"><div class=\"tooltip-arrow\"></div><div class=\"tooltip-inner\"></div></div>"
        };

        var valid = true;

        if (!NewsTab.Helpers.ValidateEmail(email)) {
            $("#addEmailAddressSetup").tooltip("destroy");
            $("#addEmailAddressSetup").attr("title", "Please use a valid email!");
            $("#addEmailAddressSetup").tooltip(options);
            $("#addEmailAddressSetup").tooltip("show");
            $("#addEmailAddressSetup").addClass("error");
            valid = false;
        }
        else {
            $("#addEmailAddressSetup").tooltip("destroy");
            $("#addEmailAddressSetup").removeClass("error");
        }

        if (valid === true)
            $.ajax({
                url: NewsTab.ApiUrl_Base + "api/auth/addemail?emailAddress=" + $("#addEmailAddressSetup").val() + "&oldEmail=" + NewsTab.Helpers.GetQueryVariable("Email"),
                cache: false,
                type: "GET",
                error: function (error) {
                    $("#addEmailAddressSetup").tooltip("destroy");
                    $("#addEmailAddressSetup").attr("title", "Email address is used by another NewsTab account!");
                    $("#addEmailAddressSetup").tooltip(options);
                    $("#addEmailAddressSetup").tooltip("show");
                    $("#addEmailAddressSetup").addClass("error");
                }
            }).then(function (data) {
                window.document.location = data;
            });
    },

    Show_Content: function () {
        $("#ftsWelcomePage").find(".container").hide();
        $("#ftsConfiguration").show();
        if (!$("#ftsConfiguration .tabNav li[value=welcome]").hasClass("selected")) SocialTab.Show_FtsConfiguration();
        $("#ftsConfiguration .tabNav li[value=welcome]").removeClass("selected");
        $("#ftsConfiguration .tabNav li[value=confirmeRegion]").addClass("selected");
        $("#ftsConfiguration .confirmeRegion").addClass("active");
    },

    Show_FtsConfiguration: function () {
        //$("#ftsWelcomePage .container a.btn.btn-primary").focus();
        var initialSectionsList = $(".initialSections ul");
        var initialSocialSectionsList = $(".socialSections ul");

        function openInitialSectionsTab() {
            initialSectionsList.css("height", ($(window).height() - initialSectionsList.offset().top) + "px");
        }

        function openInitialSocialSectionsTab() {
            initialSocialSectionsList.css("height", ($(window).height() - initialSocialSectionsList.offset().top) + "px");
        }

        if (SocialTab.TwitterIsConnected) {
            $("#ftsWelcomePage").find(".container").hide();
            $("#ftsConfiguration").show();
            $("#ftsConfiguration header .btn-primary").html("Finish");
            $("#ftsConfiguration .tab").removeClass("active");
            $("#ftsConfiguration .tabNav li").removeClass("selected");
            $("#ftsConfiguration .tabNav li[value=socialSections]").addClass("selected");
            $("#ftsConfiguration .socialSections").addClass("active");

            openInitialSocialSectionsTab();
        }

        SocialTab.Sections_SetupHTML_InitialList();
        SocialTab.SocialSections_SetupHTML_InitialList();

        $("#ftsConfiguration a.btn-back").on("click", function () {
            if ($("#ftsConfiguration .tabNav li[value=confirmeRegion]").hasClass("selected")) {
                $("#ftsConfiguration .tab").removeClass("active");
                $("#ftsConfiguration .tabNav li").removeClass("selected");
                $("#ftsConfiguration .tabNav li[value=welcome]").addClass("selected");
                $("#ftsWelcomePage").find(".container").show();
                $("#ftsConfiguration").hide();
            } else if ($("#ftsConfiguration .tabNav li[value=initialSections]").hasClass("selected")) {
                $("#ftsConfiguration header .btn-primary").html("Continue");
                $("#ftsConfiguration .tab").removeClass("active");
                $("#ftsConfiguration .tabNav li").removeClass("selected");
                $("#ftsConfiguration .tabNav li[value=confirmeRegion]").addClass("selected");
                $("#ftsConfiguration .confirmeRegion").addClass("active");
            } else if ($("#ftsConfiguration .tabNav li[value=socialSections]").hasClass("selected")) {
                $("#ftsConfiguration header .btn-primary").html("Continue");
                $("#ftsConfiguration .tab").removeClass("active");
                $("#ftsConfiguration .tabNav li").removeClass("selected");
                $("#ftsConfiguration .tabNav li[value=initialSections]").addClass("selected");
                $("#ftsConfiguration .initialSections").addClass("active");
                openInitialSectionsTab();
            }
        });

        $("#ftsConfiguration .tabNav li[value=confirmeRegion]").on("click", function () {
            $("#ftsConfiguration header .btn-primary").html("Continue");
            $("#ftsConfiguration .tab").removeClass("active");
            $("#ftsConfiguration .tabNav li").removeClass("selected");

            $(this).addClass("selected");
            $("#ftsConfiguration .confirmeRegion").addClass("active");
        });

        $("#ftsConfiguration .tabNav li[value=initialSections]").on("click", function () {
            $("#ftsConfiguration header .btn-primary").html("Continue");
            $("#ftsConfiguration .tab").removeClass("active");
            $("#ftsConfiguration .tabNav li").removeClass("selected");

            $(this).addClass("selected");
            $("#ftsConfiguration .initialSections").addClass("active");

            SocialTab.HTML_ChangeCountryRegion($("#countryRegionDropdown"));
            openInitialSectionsTab();
        });

        $("#ftsConfiguration .tabNav li[value=socialSections]").on("click", function () {
            $("#ftsConfiguration header .btn-primary").html("Finish");
            $("#ftsConfiguration .tab").removeClass("active");
            $("#ftsConfiguration .tabNav li").removeClass("selected");

            $(this).addClass("selected");
            $("#ftsConfiguration .socialSections").addClass("active");
            openInitialSocialSectionsTab();
        });

        $("#ftsConfiguration header .btn-primary").on("click", function () {
            if ($("#ftsConfiguration .tabNav li[value=confirmeRegion]").hasClass("selected")) {
                localStorage.setItem("FTS_" + NewsTab.User.Id + "_Region", NewsTab.Modules.RegionManager.MainEdition);
                $("#ftsConfiguration .tab").removeClass("active");
                $("#ftsConfiguration .tabNav li").removeClass("selected");
                $("#ftsConfiguration .tabNav li[value=initialSections]").addClass("selected");
                $("#ftsConfiguration .initialSections").addClass("active");
                SocialTab.HTML_ChangeCountryRegion($("#countryRegionDropdown"));
                openInitialSectionsTab();
            } else if ($("#ftsConfiguration .tabNav li[value=initialSections]").hasClass("selected")) {
                if ($(".initialSections li.item.selected").length > 0) {
                    var normalSections = $(".initialSections li.selected");
                    var selectedSectionIds = [];
                    var i;
                    var len;
                    for (i = 0, len = normalSections.length; i < len; i++) {
                        selectedSectionIds.push(normalSections.eq(i).attr("section-id"));
                    }

                    localStorage.setItem("FTS_" + NewsTab.User.Id + "_Sections", JSON.stringify(selectedSectionIds));

                    $(this).html("Finish");
                    $("#ftsConfiguration .tab").removeClass("active");
                    $("#ftsConfiguration .tabNav li").removeClass("selected");

                    $("#ftsConfiguration .tabNav li[value=socialSections]").addClass("selected");
                    $("#ftsConfiguration .socialSections").addClass("active");
                    openInitialSocialSectionsTab();
                } else {
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Title: "First time setup",
                        Color: "red",
                        Text: "Please select at least one section to continue"
                    });
                }
            } else if ($("#ftsConfiguration .tabNav li[value=socialSections]").hasClass("selected")) {
                Object.keys(localStorage).forEach(function (key) {
                    if (/FTS_/.test(key)) {
                        localStorage.removeItem(key);
                    }
                });

                SocialTab.FtsSettings_PostAPI();
            }
        });

        SocialTab.Sections_AttacheEventHandlers_InitialList();
        SocialTab.SocialSections_AttacheEventHandlers_InitialList();
        SocialTab.HTML_SetupScrollOutOfBox();
    },

    HTML_SetupScrollOutOfBox: function (isPreview) {
        if (isPreview) {
            $(".feedPreview").on("mousewheel DOMMouseScroll", function (e) {
                var scrollTo = null;

                if (e.type === "mousewheel") {
                    scrollTo = (e.originalEvent.wheelDelta * -1);
                }
                else if (e.type === "DOMMouseScroll") {
                    scrollTo = 40 * e.originalEvent.detail;
                }

                if (scrollTo) {
                    e.preventDefault();
                    SocialTab.HTML_InitialScroller(scrollTo, isPreview);
                }
            });
        } else {
            $("body").bind("mousewheel", function (e) {
                var scrollTo = null;

                if (e.type === "mousewheel") {
                    scrollTo = (e.originalEvent.wheelDelta * -1);
                }
                else if (e.type === "DOMMouseScroll") {
                    scrollTo = 40 * e.originalEvent.detail;
                }

                if (scrollTo) {
                    var self = $(".initialSections.sections");
                    self.scrollTop(scrollTo + self.scrollTop());
                }
            });
        }
    },

    HTML_ChangeCountryRegion: function (sender) {
        var selectedValue = sender.find("option:selected");
        NewsTab.Modules.RegionManager.MainEdition = selectedValue.attr("data-countrycode");
        NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
        NewsTab.Modules.RegionManager.MainEditionGnValue = selectedValue.attr("data-googlenewscode") !== "" ? selectedValue.attr("data-googlenewscode") : "US";
        NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;

        var callUrl = NewsTab.ApiUrl_Base + "api/global/get/sectionsbyregion/" + NewsTab.Modules.RegionManager.MainEditionGnValue + "/false";
        $.ajax({
            url: callUrl,
            headers: { Authorization: "Bearer " + NewsTab.Token },
            type: "GET",
            contentType: "application/json; charset=utf-8",
            cache: false,
            success: function (data) {
                NewsTab.Modules.SectionsManager.SysSections = [];
                NewsTab.Modules.SectionsManager.SysSections = data;
                SocialTab.Sections_SetupHTML_InitialList();
            }
        });
    },

    Sections_SetupHTML_InitialList: function () {
        $("#ftsWelcomePage .initialSections.sections").html("");
        var j = 0;
        var storageSelectedSections = localStorage.getItem("FTS_" + NewsTab.User.Id + "_Sections");
        storageSelectedSections = JSON.parse(storageSelectedSections);
        for (var i = 0, len = NewsTab.Modules.SectionsManager.SysSections.length; i < len; i++) {
            if (NewsTab.Modules.SectionsManager.SysSections[i].SectionTypeId === Section.TYPES.Normal) {
                if (storageSelectedSections != null && storageSelectedSections.length) {
                    $("#initialSocialSectionsTemplate").tmpl({
                        Id: NewsTab.Modules.SectionsManager.SysSections[i].Id,
                        Color: NewsTab.Modules.SectionsManager.SysSections[i].Color,
                        Name: NewsTab.Modules.SectionsManager.SysSections[i].Name,
                        ShortName: NewsTab.Modules.SectionsManager.SysSections[i].Name.substring(0, 2),
                        ClassName: NewsTab.Modules.SectionsManager.SysSections[i].ClassName,
                        SelectedClass: storageSelectedSections.indexOf(NewsTab.Modules.SectionsManager.SysSections[i].Id) > -1 ? "selected" : "",
                        Event: "",
                        TabIndex: i + 1005
                    }).appendTo($("#ftsWelcomePage .initialSections.sections"));
                    j++;
                } else {
                    $("#initialSocialSectionsTemplate").tmpl({
                        Id: NewsTab.Modules.SectionsManager.SysSections[i].Id,
                        Color: NewsTab.Modules.SectionsManager.SysSections[i].Color,
                        Name: NewsTab.Modules.SectionsManager.SysSections[i].Name,
                        ShortName: NewsTab.Modules.SectionsManager.SysSections[i].Name.substring(0, 2),
                        ClassName: NewsTab.Modules.SectionsManager.SysSections[i].ClassName,
                        SelectedClass: j === 0 ? "selected" : "",
                        Event: "",
                        TabIndex: i + 1005
                    }).appendTo($("#ftsWelcomePage .initialSections.sections"));
                    j++;
                }
            }
        }
    },

    Sections_AttacheEventHandlers_InitialList: function () {
        $(".initialSections ul").on("click", "li", function () {
            var item = $(this);
            item.toggleClass("selected");
        });
    },

    SocialSections_SetupHTML_InitialList: function () {
        for (var i = 0, len = NewsTab.Modules.SectionsManager.SysSections.length; i < len; i++) {
            if (NewsTab.Modules.SectionsManager.SysSections[i].SectionTypeId === Section.TYPES.Social) {
                $("#initialSocialSectionsTemplate").tmpl({
                    Id: NewsTab.Modules.SectionsManager.SysSections[i].Id,
                    Color: NewsTab.Modules.SectionsManager.SysSections[i].Color,
                    Name: NewsTab.Modules.SectionsManager.SysSections[i].Name,
                    ShortName: NewsTab.Modules.SectionsManager.SysSections[i].Name.substring(0, 2),
                    ClassName: NewsTab.Modules.SectionsManager.SysSections[i].ClassName,
                    SelectedClass: SocialTab.TwitterIsConnected ? "selected" : "",
                    Event: "onclick=SocialTab.ConnectTwitter(true);",
                    TabIndex: i + 1005
                }).appendTo($("#ftsWelcomePage .socialSections.sections"));
            }
        }
    },

    SocialSections_AttacheEventHandlers_InitialList: function () {
        $(".socialSections ul").on("click", "li", function () {
            var item = $(this);
            item.toggleClass("selected");
        });
    },

    UpdateHomeFeeds: function (feed, callback) {
        var tempFeedList = [];
        var feedtoparse = [];
        var i, j, len, len2;

        if (feed.Type === Feed.TYPES.HOME) {
            for (i = 0, len = NewsTab.Modules.SectionsManager.Sections.length; i < len; i++) {
                for (j = 0, len2 = NewsTab.Modules.SectionsManager.Sections[i].Feeds.length; j < len2; j++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].Feeds[j].Type.Id === Feed.TYPES.RSS.Id) {
                        tempFeedList.push(NewsTab.Modules.SectionsManager.Sections[i].Feeds[j]);
                    }
                }
            }
        }

        if (tempFeedList.length > 0) {
            tempFeedList.sort(NewsTab.Helpers.Sort("UsageCount", true, parseInt));
            SocialTab.UpdateTopCall(tempFeedList, feedtoparse, callback);
        }
    },

    UpdateSectionFeeds: function (section, callback) {
        var tempFeedList = [];
        var feedtoparse = [];

        for (var i = 0; i < section.Feeds.length; i++) {
            if (section.Feeds[i].Type.Id === Feed.TYPES.RSS.Id) {
                tempFeedList.push(section.Feeds[i]);
            }
        }

        if (tempFeedList.length > 0) {
            if (tempFeedList.length <= 20) {
                tempFeedList.sort(NewsTab.Helpers.Sort("UsageCount", true, parseInt));
            } else {
                tempFeedList.sort(NewsTab.Helpers.SortF("TopFeed", "UsageCount", true));
            }

            SocialTab.UpdateTopCall(tempFeedList, feedtoparse, callback);
        }
    },

    UpdateTopCall: function (tempFeedList, feedtoparse, callback) {
        for (var i = 0; i < 20 && i < tempFeedList.length; i++) {
            feedtoparse.push({
                FeedId: tempFeedList[i].Id,
                FeedUrl: tempFeedList[i].Url,
                IncludeInParsedArticlesList: true,
                FeedUrlHash: tempFeedList[i].FeedUrlHash
            });
        }

        var request = {
            "ParsedArticlesPageSize": 20,
            "FeedRequests": feedtoparse,
            "CurrentPage": 1
        };

        var feedUrlHashes = "";
        $.each(request.FeedRequests, function (index, feed) {
            feedUrlHashes = feedUrlHashes + feed.FeedUrlHash + ",";
        });
        feedUrlHashes.substr(0, feedUrlHashes.length - 1);
        var invokerParams = "updatefeeds?feedUrlHashes=" + feedUrlHashes;

        $.ajax({
            url: NewsTab.FeedApiUrl_Feed + invokerParams,
            type: "GET",
            cache: true,
            error: function (x) {
                console.error("ERROR - Parser filed for the following request:", request);
                console.error("Error message is:", x);
            }
        }).then(callback);
    },

    ParseFeed: function (feed) {
        if (feed == null) {
            feed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;
        }

        var parsingFeedId = feed.Id;
        var tempFeedList = [];
        var feedtoparse = [];
        var customOrderBy = false;
        var i, j, len, len2;
        SocialTab.HTML_StopLoadingAnimation();
        if (feed.Type === Feed.TYPES.HOME) {
            for (i = 0, len = NewsTab.Modules.SectionsManager.Sections.length; i < len; i++) {
                for (j = 0, len2 = NewsTab.Modules.SectionsManager.Sections[i].Feeds.length; j < len2; j++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].Feeds[j].Type.Id === Feed.TYPES.RSS.Id) {
                        tempFeedList.push(NewsTab.Modules.SectionsManager.Sections[i].Feeds[j]);
                    }
                }
            }
        } else if (feed.Type === Feed.TYPES.ALL) {
            if (NewsTab.Modules.SectionsManager.CurrentSection.Feeds.length === 2) {
                SocialTab.ClearPlaceholders(false);
                return;
            }

            for (i = 0, len = NewsTab.Modules.SectionsManager.CurrentSection.Feeds.length; i < len && i < 10; i++) {
                if (NewsTab.Modules.SectionsManager.CurrentSection.Feeds[i].Type.Id === Feed.TYPES.RSS.Id) {
                    tempFeedList.push(NewsTab.Modules.SectionsManager.CurrentSection.Feeds[i]);
                }
            }
        } else if (feed.Type === Feed.TYPES.TRENDING) {
            for (i = 0, len = NewsTab.Modules.SectionsManager.Sections.length; i < len; i++) {
                for (j = 0, len2 = NewsTab.Modules.SectionsManager.Sections[i].Feeds.length; j < len2; j++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].Feeds[j].Type.Id === Feed.TYPES.RSS.Id) {
                        tempFeedList.push(NewsTab.Modules.SectionsManager.Sections[i].Feeds[j]);
                    }
                }
            }
        } else {
            tempFeedList.push(feed);
        }

        if (tempFeedList.length > 0) {
            tempFeedList.sort(NewsTab.Helpers.Sort("UsageCount", true, parseInt));
            for (var i = 0, len = tempFeedList.length; i < 20 && i < len; i++) {
                feedtoparse.push({ FeedId: tempFeedList[i].Id, FeedUrl: tempFeedList[i].Url, IncludeInParsedArticlesList: true, FeedUrlHash: tempFeedList[i].FeedUrlHash });
            }

            feed.LastUpdate = Math.floor(Date.now() / 1000);
            feed.IsLoading = true;
            SocialTab.LoadingAnimation_Start();

            var request = { "ParsedArticlesPageSize": 20, "FeedRequests": feedtoparse, "CurrentPage": feed.PageNbr };

            var invokerParams = "";
            var feedUrlHashes = "";

            if (feed.Type === Feed.TYPES.TRENDING) {
                // trending feeds
                $.each(request.FeedRequests, function (index, feed) {
                    feedUrlHashes = feedUrlHashes + feed.FeedUrlHash + ",";
                });
                feedUrlHashes.substr(0, feedUrlHashes.length - 1);
                invokerParams = "gettrendings?feedUrlHashes=" + feedUrlHashes;
                customOrderBy = localStorage.getItem("OrderTrending_" + NewsTab.User.Id) !== "1"; // if true -> Order by popularity, else -> Order by time
            } else if (request.FeedRequests && request.FeedRequests.length === 1) {
                // single feed
                invokerParams = "readsinglefeed?pageSize=" + request.ParsedArticlesPageSize +
                    "&currentPage=" + request.CurrentPage +
                    "&feedId=" + encodeURIComponent(request.FeedRequests[0].FeedId) +
                    "&feedUrl=" + encodeURIComponent(request.FeedRequests[0].FeedUrl);

                if (NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId !== Section.TYPES.Home) {
                    customOrderBy = request.FeedRequests[0].FeedUrl.indexOf("news.google.com") > -1;
                }
            } else {
                // multiple feeds
                $.each(request.FeedRequests, function (index, feed) {
                    feedUrlHashes = feedUrlHashes + feed.FeedUrlHash + ",";
                });
                feedUrlHashes.substr(0, feedUrlHashes.length - 1);
                invokerParams = "readmultiplefeeds?pageSize=" + request.ParsedArticlesPageSize +
                    "&currentPage=" + request.CurrentPage +
                    "&feedUrlHashes=" + feedUrlHashes;
            }

            $.ajax({
                url: NewsTab.FeedApiUrl_Feed + invokerParams,
                type: "GET",
                cache: true,
                async: true,
                error: function (x) {
                    feed.IsLoading = false;
                    console.error("ERROR - Parser filed for the following request:", request);
                    console.error("Error message is:", x);
                    SocialTab.HTML_SetUpErrorFeedLest();
                    SocialTab.HTML_StopLoadingAnimation();
                }
            }).then(function (data) {
                feed.IsLoading = false;
                var allArticles = [];
                NewsTab.Modules.ArticleView.UnparsedArticles = [];
                if (data && data.Result != undefined) {
                    for (var i = 0, len = data.Result.length; i < len; i++) {
                        var sourceFeed = NewsTab.Modules.SectionsManager.GetFeedById(data.Result[i].FeedId, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed);

                        var parsedfeedindex = NewsTab.Modules.SectionsManager.ParsedFeeds.map(function (x) { return x.Id; }).indexOf(data.Result[i].FeedId);

                        if (parsedfeedindex === -1) {
                            var parsedfeed = { Id: data.Result[i].FeedId, FullArticleParsing: data.Result[i].RequiredFullArticleParsing, Articles: [] };
                            NewsTab.Modules.SectionsManager.ParsedFeeds.push(parsedfeed);
                            for (var j = 0, len1 = data.Result[i].FeedArticles.length; j < len1; j++) {
                                var article = new Article().Init(data.Result[i].FeedArticles[j]);
                                article._sourceFeed = sourceFeed;

                                var articleindex = NewsTab.Modules.SectionsManager.ParsedFeeds[NewsTab.Modules.SectionsManager.ParsedFeeds.length - 1].Articles.map(function (x) { return x.Alias; }).indexOf(article.Alias);
                                if (articleindex === -1) {
                                    NewsTab.Modules.SectionsManager.ParsedFeeds[NewsTab.Modules.SectionsManager.ParsedFeeds.length - 1].Articles.push(article);
                                    if (allArticles.length < 20) {
                                        if (NewsTab.Modules.ArticleView.PinnedItemAliases != undefined) {
                                            if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(article.Alias) > -1) {
                                                article.Pinned = true;
                                            }
                                        }
                                        allArticles.push(article);
                                        if (!article.FullHtmlParsed) {
                                            NewsTab.Modules.ArticleView.UnparsedArticles.push(article);
                                        }
                                    }
                                }
                            }
                        } else {
                            for (var j = 0, len2 = data.Result[i].FeedArticles.length; j < len2; j++) {
                                var article = new Article().Init(data.Result[i].FeedArticles[j]);
                                article._sourceFeed = sourceFeed;
                                var articleindex = NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.map(function (x) { return x.Alias; }).indexOf(article.Alias);
                                if (articleindex === -1) {
                                    NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.push(article);
                                    if (allArticles.length < 20) {
                                        if (NewsTab.Modules.ArticleView.PinnedItemAliases != undefined) {
                                            if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(article.Alias) > -1) {
                                                article.Pinned = true;
                                            }
                                        }
                                        allArticles.push(article);
                                        if (!article.FullHtmlParsed) {
                                            NewsTab.Modules.ArticleView.UnparsedArticles.push(article);
                                        }
                                    }
                                } else {
                                    NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.splice(articleindex, 1, article);
                                    if (allArticles.length < 20) {
                                        if (NewsTab.Modules.ArticleView.ListedArticles.map(function (x) { return x.Alias; }).indexOf(NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[articleindex].Alias) === -1) {
                                            if (NewsTab.Modules.ArticleView.PinnedItemAliases != undefined) {
                                                if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(article.Alias) > -1) {
                                                    NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[articleindex].Pinned = true;
                                                }
                                            }
                                            allArticles.push(new Article().Init(NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[articleindex]));
                                            if (!article.FullHtmlParsed) {
                                                NewsTab.Modules.ArticleView.UnparsedArticles.push(article);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                if (data && data.Result != undefined && data.Result.length > 0) {
                    if (customOrderBy === true) {
                        if (feed.Type === Feed.TYPES.TRENDING) {
                            allArticles.sort(function (a, b) { return b.Rsr - a.Rsr; });
                        } else {
                            allArticles.sort(function (a, b) { return parseInt(b.CustomOrder) - parseInt(a.CustomOrder); });
                        }
                    } else {
                        allArticles.sort(function (a, b) { return new Date(b.PubDate) - new Date(a.PubDate); });
                    }
                }

                for (var i = 0, len = allArticles.length; i < len; i++) {
                    // Is article pinned
                    if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(allArticles[i].Alias) > -1) {
                        allArticles[i].Pinned = true;
                    }

                    allArticles[i].DestinationFeedId = feed.Id;
                }

                SocialTab.ParsedArticles = [];
                SocialTab.ParsedArticles = allArticles;
                if (parsingFeedId === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                    SocialTab.Feed_SetUpHTML_Items(allArticles);

                    if (allArticles.length > 0) {
                        if (feed.MinId === "X") {
                            feed.MinId = allArticles[0].Id;
                        }
                        feed.MaxId = allArticles[allArticles.length - 1].Id;
                    }

                    feed.IsAtEnd = !data.MoreArticlesAvailable;
                    if (!data.MoreArticlesAvailable) {
                        SocialTab.ClearPlaceholders();
                    }
                }

                var expandForm = $("div:not(#itemFormHolder) > #socialTabItemForm");
                if (expandForm.length > 0) {
                    NewsTab.Modules.ArticleView.SetUp_ExpandViewById(expandForm.attr("data-article-id"));
                }

                SocialTab.HTML_StopLoadingAnimation();

                if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                    SocialTab.LoadMore();
                }
                SocialTab.ResetArticleHover();
            });
            $("body").css({ height: "100%" });
        } else {
            SocialTab.ClearPlaceholders();
            SocialTab.HTML_SetUpEmptyFeedLest();
        }
    },

    LoadSocialFeed: function (feed) {
        if (feed == null) {
            feed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;
        }
        SocialTab.HTML_StopLoadingAnimation();
        if (feed == null) return;

        var parsingFeedId = feed.Id;

        if (feed && feed.Type != undefined && Feed.Linked(feed.Type) && !feed.IsLoading && !feed.IsAtEnd && feed.Id !== Feed.TYPES.NONE.Id && NewsTab.Token.length) {
            var loadedFromChach = false;

            if (feed.LastUpdate + feed.UpdateTimeout > Math.floor(Date.now() / 1000)) {
                var cachedArticles = [];
                var parsedfeedindex = NewsTab.Modules.SectionsManager.ParsedFeeds.map(function (x) { return x.Id; }).indexOf(feed.Id);
                if (parsedfeedindex >= 0) {
                    for (var j = 0, len2 = NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.length; j < len2; j++) {
                        cachedArticles.push(NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[j]);
                    }
                    cachedArticles.sort(function (a, b) { return new Date(b.PubDate) - new Date(a.PubDate); });
                    if (cachedArticles.length >= 20 * feed.PageNbr) {

                        loadedFromChach = true;

                        feed.IsLoading = false;
                        var s = 20 * (feed.PageNbr - 1);
                        var cachedArticlesToShow = cachedArticles.slice(s, s + 20);

                        for (var i = 0, len = cachedArticlesToShow.length; i < len; i++) {
                            if (!cachedArticlesToShow[i].FullHtmlParsed && cachedArticlesToShow[i].ExternalUrl) {
                                NewsTab.Modules.ArticleView.UnparsedArticles.push(cachedArticlesToShow[i]);
                            }
                        }

                        if (parsingFeedId === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                            SocialTab.Feed_SetUpHTML_Items(cachedArticlesToShow);
                            SocialTab.HTML_StopLoadingAnimation();
                        }

                        if (cachedArticlesToShow.length > 0) {
                            if (feed.MinId === "X") {
                                feed.MinId = cachedArticlesToShow[0].Id;
                            }
                            feed.MaxId = cachedArticlesToShow[cachedArticlesToShow.length - 1].Id;
                        } else {
                            feed.IsAtEnd = true;
                            SocialTab.ClearPlaceholders();
                        }

                        SocialTab.ParsedArticles = [];
                        SocialTab.ParsedArticles = cachedArticlesToShow;

                        var expandForm = $("div:not(#itemFormHolder) > #socialTabItemForm");
                        if (expandForm.length > 0) {
                            NewsTab.Modules.ArticleView.SetUp_ExpandViewById(expandForm.attr("data-article-id"));
                        }

                        SocialTab.HTML_StopLoadingAnimation();

                        if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                            SocialTab.LoadMore();
                        }
                    }
                }
            }

            if (!loadedFromChach) {
                feed.LastUpdate = Math.floor(Date.now() / 1000);

                var tusername = "";
                var tu = $.grep(NewsTab.User.SocialNetworks, function (a) { return a.SourceId == 2 });
                if (tu.length) {
                    tusername = tu[0].Username;
                }
                var callUrl = feed.ApiUrl.replace("{count}", feed.Count).replace("{min_id}", "X").replace("{max_id}", feed.MaxId) + "?_cache=" + tusername + feed.Id;
                if (callUrl.indexOf("top20tweets") >= 0) {
                    feed.IsAtEnd = true;
                }

                if (feed.SpecialParameter) {
                    callUrl = callUrl.replace("{special_parameter}", feed.SpecialParameter)
                }
                feed.IsLoading = true;
                SocialTab.LoadingAnimation_Start();
                $.ajax({
                    url: callUrl,
                    cache: true,
                    headers: { Authorization: "Bearer " + NewsTab.Token },
                    error: function (error) {
                        console.error("ERROR - " + feed.Name + ":", error);
                        feed.IsLoading = false;
                        SocialTab.HTML_SetUpErrorFeedLest();
                        SocialTab.HTML_StopLoadingAnimation();
                    }
                }).then(function (data) {

                    feed.IsLoading = false;
                    var allArticles = [];

                    if (data.Error == "Rate limit exceeded!") {
                        feed.RateLimit = true;
                    }
                    else {
                        feed.RateLimit = false;
                    }
                    var sourceFeed = NewsTab.Modules.SectionsManager.GetFeedById(parsingFeedId, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed);
                    var parsedfeed = $.grep(NewsTab.Modules.SectionsManager.ParsedFeeds, function (f) { return f.Id === parsingFeedId });
                    if (parsedfeed.length === 0) {
                        for (var j = 0, len2 = data.Items.length; j < len2; j++) {
                            data.Items[j]._sourceFeed = sourceFeed;

                            if (data.Items[j].SourceFeed().TextLinker) {
                                if (data.Items[j].Title) {
                                    data.Items[j].Title = data.Items[j].SourceFeed().TextLinker.link(data.Items[j].Title);
                                }
                                if (data.Items[j].Summary) {
                                    data.Items[j].Summary = data.Items[j].SourceFeed().TextLinker.link(data.Items[j].Summary);
                                }
                            }
                            allArticles.push(data.Items[j]);
                            if (!data.Items[j].FullHtmlParsed && data.Items[j].ExternalUrl) {
                                NewsTab.Modules.ArticleView.UnparsedArticles.push(data.Items[j]);
                            }
                        }
                        parsedfeed = { Id: parsingFeedId, Articles: data.Items };
                        NewsTab.Modules.SectionsManager.ParsedFeeds.push(parsedfeed);
                    } else {
                        parsedfeed = parsedfeed[0];
                        for (var j = 0, len2 = data.Items.length; j < len2; j++) {
                            var article = new Article().Init(data.Items[j]);

                            article._sourceFeed = sourceFeed;
                            if (article.SourceFeed().TextLinker) {
                                if (article.Title) {
                                    article.Title = article.SourceFeed().TextLinker.link(article.Title);
                                }
                                if (article.Summary) {
                                    article.Summary = article.SourceFeed().TextLinker.link(article.Summary);
                                }
                            }
                            var a = $.grep(parsedfeed.Articles, function (f) { return f.Alias === article.Alias });
                            if (a.length === 0) {
                                parsedfeed.Articles.push(article);
                            } else {
                                a = a[0];
                                a = article;
                            }

                            allArticles.push(article);
                            if (!article.FullHtmlParsed && article.ExternalUrl) {
                                NewsTab.Modules.ArticleView.UnparsedArticles.push(article);
                            }
                        }
                    }

                    if (parsingFeedId === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                        SocialTab.Feed_SetUpHTML_Items(allArticles);
                        SocialTab.HTML_StopLoadingAnimation();
                    }

                    if (allArticles.length > 0) {
                        if (feed.MinId === "X") {
                            feed.MinId = allArticles[0].Id;
                        }
                        feed.MaxId = allArticles[allArticles.length - 1].Id;
                    } else {
                        feed.IsAtEnd = true;
                        SocialTab.ClearPlaceholders();
                    }

                    SocialTab.ParsedArticles = [];
                    SocialTab.ParsedArticles = allArticles;

                    var expandForm = $("div:not(#itemFormHolder) > #socialTabItemForm");
                    if (expandForm.length > 0) {
                        NewsTab.Modules.ArticleView.SetUp_ExpandViewById(expandForm.attr("data-article-id"));
                    }

                    SocialTab.HTML_StopLoadingAnimation();

                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                        SocialTab.LoadMore();
                    }
                });
            }
        } else {
            SocialTab.ClearPlaceholders();
        }

    },

    LoadSocialTrendingFeed: function (feed) {
        if (feed == null) {
            feed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;
        }

        var region = localStorage.getItem("ST_" + NewsTab.User.Id + "_SocialFeedRegion_" + feed.Id);
        if (region === null) {
            region = NewsTab.Modules.RegionManager.TemporaryEdition ? NewsTab.Modules.RegionManager.TemporaryEdition : (NewsTab.Modules.RegionManager.AddFeedEdition ? NewsTab.Modules.RegionManager.AddFeedEdition : "US");
        }
        var customOrderBy = false;
        if (region) {
            if (region.indexOf("US_") === -1) {
                region = region.split("_")[0];
            }

            SocialTab.HTML_StopLoadingAnimation();
            if (feed == null) return;

            var parsingFeedId = feed.Id;

            if (feed && feed.Type != undefined && Feed.Linked(feed.Type) && !feed.IsLoading && !feed.IsAtEnd && feed.Id !== Feed.TYPES.NONE.Id && NewsTab.Token.length) {
                var loadedFromChach = false;

                customOrderBy = localStorage.getItem("OrderTrending_" + parsingFeedId + NewsTab.User.Id) !== "1"; // if true -> Order by popularity, else -> Order by time

                if (feed.LastUpdate + feed.UpdateTimeout > Math.floor(Date.now() / 1000)) {
                    var cachedArticles = [];
                    var parsedfeedindex = NewsTab.Modules.SectionsManager.ParsedFeeds.map(function (x) { return x.Id; }).indexOf(feed.Id);
                    if (parsedfeedindex >= 0) {
                        for (var j = 0, len2 = NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.length; j < len2; j++) {
                            cachedArticles.push(NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[j]);
                        }
                        cachedArticles.sort(function (a, b) { return new Date(b.PubDate) - new Date(a.PubDate); });
                        if (cachedArticles.length >= 20 * feed.PageNbr) {

                            loadedFromChach = true;

                            feed.IsLoading = false;
                            var s = 20 * (feed.PageNbr - 1);
                            var cachedArticlesToShow = cachedArticles.slice(s, s + 20);

                            for (var i = 0, len = cachedArticlesToShow.length; i < len; i++) {
                                if (!cachedArticlesToShow[i].FullHtmlParsed && cachedArticlesToShow[i].ExternalUrl) {
                                    NewsTab.Modules.ArticleView.UnparsedArticles.push(cachedArticlesToShow[i]);
                                }
                            }

                            if (parsingFeedId === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                                SocialTab.Feed_SetUpHTML_Items(cachedArticlesToShow);
                                SocialTab.HTML_StopLoadingAnimation();
                            }

                            if (cachedArticlesToShow.length > 0) {
                                if (feed.MinId === "X") {
                                    feed.MinId = cachedArticlesToShow[0].Id;
                                }
                                feed.MaxId = cachedArticlesToShow[cachedArticlesToShow.length - 1].Id;
                            } else {
                                feed.IsAtEnd = true;
                                SocialTab.ClearPlaceholders();
                            }

                            SocialTab.ParsedArticles = [];
                            SocialTab.ParsedArticles = cachedArticlesToShow;

                            var expandForm = $("div:not(#itemFormHolder) > #socialTabItemForm");
                            if (expandForm.length > 0) {
                                NewsTab.Modules.ArticleView.SetUp_ExpandViewById(expandForm.attr("data-article-id"));
                            }

                            SocialTab.HTML_StopLoadingAnimation();

                            if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                                SocialTab.LoadMore();
                            }
                        }
                    }
                }

                if (!loadedFromChach) {
                    feed.LastUpdate = Math.floor(Date.now() / 1000);

                    var tusername = NewsTab.User.Username;

                    var callUrl = feed.ApiUrl.replace("{count}", feed.Count).replace("{region}", region) + "?_cache=" + tusername + feed.Id;
                    feed.IsAtEnd = true;

                    if (feed.SpecialParameter) {
                        callUrl = callUrl.replace("{special_parameter}", feed.SpecialParameter)
                    }
                    feed.IsLoading = true;
                    SocialTab.LoadingAnimation_Start();


                    $.ajax({
                        url: callUrl,
                        cache: true,
                        headers: { Authorization: "Bearer " + NewsTab.Token },
                        error: function (error) {
                            console.error("ERROR - " + feed.Name + ":", error);
                            feed.IsLoading = false;
                            SocialTab.HTML_SetUpErrorFeedLest();
                            SocialTab.HTML_StopLoadingAnimation();
                        }
                    }).then(function (data) {
                        var d = new Date;
                        feed.IsLoading = false;
                        var allArticles = [];
                        NewsTab.Modules.ArticleView.UnparsedArticles = [];
                        //NewsTab.Modules.SectionsManager.ParsedFeeds = [];
                        if (data && data.Result != undefined) {
                            for (var i = 0, len = data.Result.length; i < len; i++) {
                                var sourceFeed = NewsTab.Modules.SectionsManager.GetFeedById(data.Result[i].FeedId, null);

                                var parsedfeedindex = NewsTab.Modules.SectionsManager.ParsedFeeds.map(function (x) { return x.Id; }).indexOf(data.Result[i].FeedId);

                                if (parsedfeedindex === -1) {
                                    var parsedfeed = { Id: data.Result[i].FeedId, FullArticleParsing: data.Result[i].RequiredFullArticleParsing, Articles: [] };
                                    NewsTab.Modules.SectionsManager.ParsedFeeds.push(parsedfeed);
                                    for (var j = 0, len1 = data.Result[i].FeedArticles.length; j < len1; j++) {
                                        if (sourceFeed === null) {
                                            var otherParams = data.Result[i].FeedArticles[j].OtherParams.split("_NT_");
                                            var type, publisher, siteurl = null;
                                            if (otherParams.length >= 1) {
                                                type = otherParams[0];
                                            }
                                            if (otherParams.length >= 2) {
                                                publisher = otherParams[1];
                                            }
                                            if (otherParams.length >= 3) {
                                                siteurl = otherParams[2];
                                            }
                                            sourceFeed = new Feed().Init({
                                                Id: data.Result[i].FeedArticles[j].FeedId,
                                                Name: publisher,
                                                SiteUrl: siteurl,
                                                Type: Feed.TYPES.RSS,
                                                Count: Feed.DEFAULT_COUNT,
                                                OrderNumber: 0,
                                                Layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                                                LayoutType: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.LayoutType,
                                                ShowInList: true
                                            });
                                        }
                                        data.Result[i].FeedArticles[j]._sourceFeed = sourceFeed;
                                        var articleindex = NewsTab.Modules.SectionsManager.ParsedFeeds[NewsTab.Modules.SectionsManager.ParsedFeeds.length - 1].Articles.map(function (x) { return x.Alias; }).indexOf(data.Result[i].FeedArticles[j].Alias);
                                        if (articleindex === -1) {
                                            NewsTab.Modules.SectionsManager.ParsedFeeds[NewsTab.Modules.SectionsManager.ParsedFeeds.length - 1].Articles.push(data.Result[i].FeedArticles[j]);
                                            if (allArticles.length < 20) {
                                                if (NewsTab.Modules.ArticleView.PinnedItemAliases != undefined) {
                                                    if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(data.Result[i].FeedArticles[j].Alias) > -1) {
                                                        data.Result[i].FeedArticles[j].Pinned = true;
                                                    }
                                                }
                                                allArticles.push(data.Result[i].FeedArticles[j]);
                                                if (!data.Result[i].FeedArticles[j].FullHtmlParsed) {
                                                    NewsTab.Modules.ArticleView.UnparsedArticles.push(data.Result[i].FeedArticles[j]);
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    for (var j = 0, len2 = data.Result[i].FeedArticles.length; j < len2; j++) {
                                        if (sourceFeed === null) {
                                            var otherParams = data.Result[i].FeedArticles[j].OtherParams.split("_NT_");
                                            var type, publisher, siteurl = null;
                                            if (otherParams.length >= 1) {
                                                type = otherParams[0];
                                            }
                                            if (otherParams.length >= 2) {
                                                publisher = otherParams[1];
                                            }
                                            if (otherParams.length >= 3) {
                                                siteurl = otherParams[2];
                                            }
                                            sourceFeed = new Feed().Init({
                                                Id: data.Result[i].FeedArticles[j].FeedId,
                                                Name: publisher,
                                                SiteUrl: siteurl,
                                                Type: Feed.TYPES.RSS,
                                                Count: Feed.DEFAULT_COUNT,
                                                OrderNumber: 0,
                                                Layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                                                LayoutType: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.LayoutType,
                                                ShowInList: true
                                            });
                                        }
                                        data.Result[i].FeedArticles[j]._sourceFeed = sourceFeed;
                                        var articleindex = NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.map(function (x) { return x.Alias; }).indexOf(data.Result[i].FeedArticles[j].Alias);
                                        if (articleindex === -1) {
                                            NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.push(data.Result[i].FeedArticles[j]);
                                            if (allArticles.length < 20) {
                                                if (NewsTab.Modules.ArticleView.PinnedItemAliases != undefined) {
                                                    if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(data.Result[i].FeedArticles[j].Alias) > -1) {
                                                        data.Result[i].FeedArticles[j].Pinned = true;
                                                    }
                                                }
                                                allArticles.push(data.Result[i].FeedArticles[j]);
                                                if (!data.Result[i].FeedArticles[j].FullHtmlParsed) {
                                                    NewsTab.Modules.ArticleView.UnparsedArticles.push(data.Result[i].FeedArticles[j]);
                                                }
                                            }
                                        } else {
                                            NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles.splice(articleindex, 1, data.Result[i].FeedArticles[j]);
                                            if (allArticles.length < 20) {
                                                if (NewsTab.Modules.ArticleView.ListedArticles.map(function (x) { return x.Alias; }).indexOf(NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[articleindex].Alias) === -1) {
                                                    if (NewsTab.Modules.ArticleView.PinnedItemAliases != undefined) {
                                                        if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(data.Result[i].FeedArticles[j].Alias) > -1) {
                                                            NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[articleindex].Pinned = true;
                                                        }
                                                    }
                                                    allArticles.push(NewsTab.Modules.SectionsManager.ParsedFeeds[parsedfeedindex].Articles[articleindex]);
                                                    if (!data.Result[i].FeedArticles[j].FullHtmlParsed) {
                                                        NewsTab.Modules.ArticleView.UnparsedArticles.push(data.Result[i].FeedArticles[j]);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        if (data && data.Result != undefined && data.Result.length > 0) {
                            if (customOrderBy === true) {
                                if (feed.Type === Feed.TYPES.SOCIALTRENDING) {
                                    allArticles.sort(function (a, b) { return b.Rsr - a.Rsr; });
                                } else {
                                    allArticles.sort(function (a, b) { return parseInt(b.CustomOrder) - parseInt(a.CustomOrder); });
                                }
                            } else {
                                allArticles.sort(function (a, b) { return new Date(b.PubDate) - new Date(a.PubDate); });
                            }
                        }

                        SocialTab.ParsedArticles = [];
                        SocialTab.ParsedArticles = allArticles;
                        if (parsingFeedId === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                            SocialTab.Feed_SetUpHTML_Items(allArticles);

                            if (allArticles.length > 0) {
                                if (feed.MinId === "X") {
                                    feed.MinId = allArticles[0].Id;
                                }
                                feed.MaxId = allArticles[allArticles.length - 1].Id;
                            }

                            feed.IsAtEnd = !data.MoreArticlesAvailable;
                            if (!data.MoreArticlesAvailable) {
                                SocialTab.ClearPlaceholders();
                            }
                        }

                        var expandForm = $("div:not(#itemFormHolder) > #socialTabItemForm");
                        if (expandForm.length > 0) {
                            NewsTab.Modules.ArticleView.SetUp_ExpandViewById(expandForm.attr("data-article-id"));
                        }

                        SocialTab.HTML_StopLoadingAnimation();

                        if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                            SocialTab.LoadMore();
                        }
                    });
                }
            } else {
                SocialTab.ClearPlaceholders();
            }
        }
    },

    LoadPinnedFeed: function (feed) {
        if (feed == null) {
            feed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;
        }
        var parsingFeedId = feed.Id;
        SocialTab.HTML_StopLoadingAnimation();
        if (feed && feed.Type != undefined && Feed.Linked(feed.Type) && !feed.IsLoading && !feed.IsAtEnd && feed.Id !== Feed.TYPES.NONE.Id) {
            if (NewsTab.Token.length) {
                var callUrl = NewsTab.ApiUrl_Global + "get/pinned/" + feed.Count + "/X/" + encodeURIComponent(feed.MaxId);

                feed.IsLoading = true;
                if (NewsTab.Modules.SectionsManager.CurrentSection) {
                    SocialTab.LoadingAnimation_Start();
                } else {
                    SocialTab.LoadingAnimation_Start(true);
                }

                $.ajax({
                    url: callUrl,
                    headers: { Authorization: "Bearer " + NewsTab.Token },
                    cache: false,
                    error: function (error) {
                        console.error("ERROR - " + feed.Name + ":", error);
                        feed.IsLoading = false;
                        SocialTab.HTML_SetUpErrorFeedLest();
                        SocialTab.HTML_StopLoadingAnimation();
                    }
                }).then(function (data) {
                    feed.IsLoading = false;
                    var allArticles = [];

                    $.each(data.Items, function (index, article) {
                        if (NewsTab.Modules.ArticleView.PinnedItemAliases.indexOf(article.Alias) === -1) {
                            NewsTab.Modules.ArticleView.PinnedItemAliases.push(article.Alias);

                            var obj = $(".socialTabItem[feed-alias-id='" + article.FeedId + "_NT_" + article.Alias + "']");
                            if (!obj.hasClass("pinned")) {
                                obj.addClass("pinned");
                            }

                        }
                        data.Items[index] = new Article().Init(article);
                    });

                    var parsedfeed = $.grep(NewsTab.Modules.SectionsManager.ParsedFeeds, function (f) { return f.Id === parsingFeedId });
                    if (parsedfeed.length === 0) {
                        parsedfeed = { Id: parsingFeedId, Articles: data.Items };

                        for (var j = 0, len2 = data.Items.length; j < len2; j++) {
                            data.Items[j].Pinned = true;
                            data.Items[j]._sourceFeed = NewsTab.Modules.SectionsManager.GetFeedById(data.Items[j].FeedId, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed);
                            if (data.Items[j].SourceFeed() == null || data.Items[j].SourceFeed().Type === Feed.TYPES.PINWALL) {
                                var otherParams = data.Items[j].OtherParams.split("_NT_");
                                var type, publisher, siteurl = null;
                                if (otherParams.length >= 1) {
                                    type = otherParams[0];
                                }
                                if (otherParams.length >= 2) {
                                    publisher = otherParams[1];
                                }
                                if (otherParams.length >= 3) {
                                    siteurl = otherParams[2];
                                }
                                var sourceFeed = new Feed().Init(
                                    {
                                        Id: 0,
                                        Name: publisher,
                                        SiteUrl: siteurl,
                                        Type: type == "2" ? Feed.TYPES.TWITTER : Feed.TYPES.RSS,
                                        Count: Feed.DEFAULT_COUNT,
                                        OrderNumber: 0,
                                        Layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                                        LayoutType: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.LayoutType,
                                        ShowInList: false
                                    });
                                data.Items[j]._sourceFeed = sourceFeed;
                            }
                            allArticles.push(data.Items[j]);
                        }
                        NewsTab.Modules.SectionsManager.ParsedFeeds.push(parsedfeed);
                    } else {
                        parsedfeed = parsedfeed[0];
                        for (var j = 0, len2 = data.Items.length; j < len2; j++) {
                            data.Items[j].Pinned = true;
                            data.Items[j]._sourceFeed = NewsTab.Modules.SectionsManager.GetFeedById(data.Items[j].FeedId, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed);
                            if (data.Items[j].SourceFeed() == null || data.Items[j].SourceFeed().Type === Feed.TYPES.PINWALL) {
                                var otherParams = data.Items[j].OtherParams.split("_NT_");
                                var type, publisher, siteurl = null;
                                if (otherParams.length >= 1) {
                                    type = otherParams[0];
                                }
                                if (otherParams.length >= 2) {
                                    publisher = otherParams[1];
                                }
                                if (otherParams.length >= 3) {
                                    siteurl = otherParams[2];
                                }
                                var sourceFeed = new Feed().Init(
                                    {
                                        Id: 0,
                                        Name: publisher,
                                        SiteUrl: siteurl,
                                        Type: type == "2" ? Feed.TYPES.TWITTER : Feed.TYPES.RSS,
                                        Count: Feed.DEFAULT_COUNT,
                                        OrderNumber: 0,
                                        Layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                                        LayoutType: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.LayoutType,
                                        ShowInList: false
                                    });
                                data.Items[j]._sourceFeed = sourceFeed;
                            }
                            var a = $.grep(parsedfeed.Articles, function (f) { return f.Alias === data.Items[j].Alias });
                            if (a.length === 0) {
                                parsedfeed.Articles.push(data.Items[j]);
                            } else {
                                a = a[0];
                                a = data.Items[j];
                            }
                            allArticles.push(data.Items[j]);
                        }
                    }

                    if (parsingFeedId === NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                        SocialTab.Feed_SetUpHTML_Items(allArticles);
                        SocialTab.HTML_StopLoadingAnimation();
                    }

                    if (allArticles.length > 0) {
                        if (feed.MinId === "X") {
                            feed.MinId = new Date(allArticles[0].DateCreated).getTime();
                        }
                        feed.MaxId = new Date(allArticles[allArticles.length - 1].DateCreated).getTime();

                    } else {
                        feed.IsAtEnd = true;
                        if (NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Pinned) {
                            SocialTab.ClearPlaceholders();
                        }
                    }

                    var expandForm = $("div:not(#itemFormHolder) > #socialTabItemForm");
                    if (expandForm.length > 0) {
                        NewsTab.Modules.ArticleView.SetUp_ExpandViewById(expandForm.attr("data-article-id"));
                    }

                    SocialTab.HTML_StopLoadingAnimation();

                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                        SocialTab.LoadMore();
                    }
                });
            }
        } else {
            SocialTab.ClearPlaceholders();
        }
    },

    LoadPinnedFeedAlias: function (feed) {
        if (feed == undefined) {
            feed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;
        }
        if (NewsTab.Token.length) {
            var callUrl = NewsTab.ApiUrl_Global + "get/pinnedalias/" + feed.Count + "/X/" + encodeURIComponent(feed.MaxId);
            $.ajax({
                url: callUrl,
                headers: { Authorization: "Bearer " + NewsTab.Token },
                cache: false,
                error: function (error) {
                    console.error("ERROR - " + feed.Name + ":", error);
                    feed.IsLoading = false;
                    SocialTab.HTML_SetUpErrorFeedLest();
                    SocialTab.HTML_StopLoadingAnimation();
                }
            }).then(function (data) {
                NewsTab.Modules.ArticleView.PinnedItemAliases = data;
            });
        }
    },

    LoadMore: function (feed, refrash, isPreview) {
        if (!NewsTab.IsExtension) {
            if (feed === null || feed === undefined) {
                feed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;
            }

            if (!feed.IsAtEnd && !feed.IsLoading || refrash) {
                if (!refrash) {
                    feed.PageNbr++;
                }
                NewsTab.Modules.SectionsManager.LoadFeed(feed);
                $("body").css({ height: "100%" });
            } else if (feed.IsAtEnd && NewsTab.Modules.ArticleView.ListedArticles.length === 0 && feed.PageNbr < 2 && feed.Type === Feed.TYPES.PINWALL) {
                NewsTab.Modules.ArticleView.DisplayFeedEmpty(feed);
            }

            //if (!feed.IsAtEnd && !feed.IsLoading || refrash) {
            //    if (feed.Type.Id === Feed.TYPES.TWITTER.Id) {
            //        if (!refrash) feed.PageNbr++;
            //        if (isPreview) {
            //            SocialTab.ParseTwitterFeedPreview(feed);
            //        }
            //        else {
            //            SocialTab.LoadSocialFeed(feed);
            //        }
            //    } else if (feed.Type === Feed.TYPES.PINWALL) {
            //        SocialTab.LoadPinnedFeed(feed);
            //    } else if (feed.Type === Feed.TYPES.PUBLICPINWALL) {
            //        NewsTab.Modules.PublicDashboard.Load_PublicPinnedFeed(feed);
            //    } else if (feed.Type === Feed.TYPES.SOCIALTRENDING) {
            //        SocialTab.LoadSocialTrendingFeed(feed);
            //    } else {
            //        if (!refrash) feed.PageNbr++;
            //        if (isPreview) {
            //            SocialTab.ParseFeedPreview(feed);
            //        } else {
            //            SocialTab.ParseFeed(feed);
            //        }
            //    }
            //    $("body").css({ height: "100%" });
            //} else if (feed.IsAtEnd && NewsTab.Modules.ArticleView.ListedArticles.length === 0 && feed.PageNbr < 2 && feed.Type === Feed.TYPES.PINWALL) {
            //    SocialTab.HTML_SetUpEmptyFeedLest(false);
            //}
        }
    },

    UpdateLastActiveSection: function (id) {
        if (NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            $.ajax({
                url: NewsTab.ApiUrl_Global + "post/lastactivesection/" + id,
                headers: { Authorization: "Bearer " + NewsTab.Token },
                type: "POST",
                error: function (error) {
                    console.error("ERROR - UpdateLastActiveSection:", error);
                }
            });
        }
    },

    UpdateLastActiveFeed: function (id) {
        if (NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            if (id[0] === "#" || id[0] === "@") {
                id = id.slice(1);
            }
            $.ajax({
                url: NewsTab.ApiUrl_Global + "post/lastactivefeed/" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "/" + id,
                headers: {
                    Authorization: "Bearer " + NewsTab.Token
                },
                type: "POST",
                error: function (error) {
                    console.error("ERROR - UpdateLastActiveFeed:", error);
                }
            }).then(function (data) {
                SocialTab.UpdateUsageCount(data, 1);
            });
        }
    },

    UpdateUsageCount: function (data, count) {
        NewsTab.Modules.SectionsManager.Sections.forEach(function (section) {
            if (section.SectionTypeId === Section.TYPES.Normal) {
                section.Feeds.forEach(function (feed) {
                    if (feed.Id === data.Id) {
                        feed.UsageCount += count;
                        feed.LastTimeUsed = data.LastTimeUsed;
                        feed.PopularityRank = data.PopularityRank;
                    }
                });
            }
        });
    },

    UpdateTopFeed: function (data) {
        NewsTab.Modules.SectionsManager.Sections.forEach(function (section) {
            if (section.SectionTypeId === Section.TYPES.Normal) {
                section.Feeds.forEach(function (feed) {
                    var topFeed = $.grep(data, function (t) { return (t === feed.Id); });
                    if (topFeed.length > 0) {
                        feed.TopFeed = true;
                    } else {
                        feed.TopFeed = false;
                    }
                });
            }
        });
    },

    PostFavorite: function (article) {
        if (NewsTab.Token.length) {
            var allItems = [];
            for (var i = 0, l = NewsTab.Modules.SectionsManager.ParsedFeeds.length; i < l; i++) {
                var tempList = $.grep(NewsTab.Modules.SectionsManager.ParsedFeeds[i].Articles, function (e) {
                    return e.Id === article.Id ||
                        e.Id === article.IdOfOrginalArticle ||
                        e.IdOfOrginalArticle === article.IdOfOrginalArticle ||
                        e.IdOfOrginalArticle === article.Id
                });
                for (var ii = 0, ll = tempList.length; ii < ll; ii++) {
                    allItems.push(NewsTab.Modules.SectionsManager.ParsedFeeds[i].Articles[ii]);
                }
            }
            var obj = $(".socialTabItem[data-article-id=" + article.Id + "], #socialTabItemForm[data-article-id=" + article.Id + "]");
            article.HasFavorited ? obj.removeClass("favorited") : obj.addClass("favorited");
            for (var i = 0, l = allItems.length; i < l; i++) {
                allItems[i].HasFavorited = article.HasFavorited;
            }
            var callUrl = NewsTab.ApiUrl_Base + "api/twitter/post/favorite/" + (NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Pinned ? article.IdOfOrginalArticle : article.Id);

            $.ajax({
                url: callUrl,
                headers: { Authorization: 'Bearer ' + NewsTab.Token, 'isFavorite': article.HasFavorited },
                type: "POST",
                contentType: "application/json",
                dataType: "json",
                processdata: true,
                error: function (error) {
                    console.error("ERROR - Twitter_Favorite:", error);
                    !article.HasFavorited ? obj.removeClass("favorited") : obj.addClass("favorited");
                }
            }).then(function (data) {
                if (data !== "") {
                    var count = parseInt(obj.find("button.icon-heart").attr("data-likes"));
                    article.HasFavorited ? count-- : count++;
                    article.Favorites.Count = count;
                    obj.find("button.icon-heart").attr("data-likes", count);
                    obj.find("button.icon-heart").html("<small>" + NewsTab.Helpers.GetShortCount(count) + "</small>");
                    article.HasFavorited = !article.HasFavorited;
                    for (var i = 0, l = allItems.length; i < l; i++) {
                        allItems[i].HasFavorited = article.HasFavorited
                        if (allItems[i].Favorites === null || allItems[i].Favorites === undefined) {
                            allItems[i].Favorites = {};
                        }
                        allItems[i].Favorites.Count = article.Favorites.Count;
                    }
                } else {
                    !article.HasFavorited ? obj.removeClass("favorited") : obj.addClass("favorited");
                }
            });
        }
    },

    /*******************/

    ConnectTwitter: function (fts) {
        if (!Feed.TYPES.TWITTER.Linked) {
            $(".socialSections .icon-statusIcon").hide().after("<i class=\"icon\" style=\"position: absolute; right: 0;\"><span class=\"spinner\" style=\"width: 20px; height: 20px; margin: 0; float: right;\"></span></i>");

            var callUrl = NewsTab.ApiUrl_Base + "api/twitter/connect";

            var self = this;
            $.ajax({
                url: callUrl,
                method: "POST",
                headers: { Authorization: "Bearer " + NewsTab.Token },
                error: function (error) {
                    if (self.ShowLoadErrors) {
                        console.error("ERROR - " + self.Name + "_Connect", error);
                    }
                }
            }).then(function (data) {
                if (fts) {
                    localStorage.setItem("FTS_" + NewsTab.User.Id + "_TwitterSection", true);
                }
                else {
                    var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (s) { return s.Name === "Twitter" && s.SectionTypeId === Section.TYPES.Social });
                    if (section != null) {
                        SocialTab.UpdateLastActiveSection(section[0].Id);
                    }
                }
                window.location.assign(data);
            });
        }
    },

    AddTwitter: function () {
        var section = $.grep(NewsTab.Modules.SectionsManager.SysSections, function (e) { return e.Name === "Twitter" });
        if (section.length > 0) {
            section = section[0];
            section.Connected = true;
            localStorage.setItem("ST_" + NewsTab.User.Id + "_TwitterConnected", true);
            $("." + section.ClassName).addClass("connected");
            var twitterSection = new Section().Init_Twitter(section);
            SocialTab.AddSection(twitterSection.Id);
            SocialTab.SetCurrentSection(twitterSection.Id, true, false);
            SocialTab.Menu_SetUpHTML_SubmenuList();
        }
    },

    DisconnectSocialSection: function (id) {
        var connector = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === id });
        if (connector.length > 0) {
            connector = connector[0];
            connector.Disconnect(false);
        }
        if ($("#doubleModal").length === 1) {
            $("#doubleModal").remove();
        }
        else {
            $.modal.impl.close();
        }
    },

    RemoveSocialSection: function (id, modul) {
        var connector = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === id });
        if (connector.length > 0) {
            connector = connector[0];
            connector.Disconnect(true);
        }
        if (modul) {
            if ($("#doubleModal").length === 1) {
                $("#doubleModal").remove();
            }
            else {
                $.modal.impl.close();
            }
        }
    },

    HideShowAddSectionButtons: function (effect) {
        if (effect === "show" || $(".newAdd").length > 0 || $(".newRemove").length > 0) {
            $("#addSectionsBtnField").addClass("show");
        } else if (effect === "hide" || $(".newAdd").length === 0 || $(".newRemove").length > 0) {
            $("#addSectionsBtnField").removeClass("show");
        }
    },

    CheckSection: function (id) {
        var t = $(".topics").find(".item[data-section-id=" + id + "]");
        if ($(t).hasClass("newRemove")) {
            $(t).addClass("connected").removeClass("newRemove");
        } else {
            $(t).addClass("connected").addClass("newAdd");
        }

        t.attr("onclick", "SocialTab.UnCheckSection('" + id + "')");
        //$(t).css("background-color", $(t).css(""));

        SocialTab.HideShowAddSectionButtons();
    },

    UnCheckSection: function (id) {
        var t = $(".topics").find(".item[data-section-id=" + id + "]");
        if ($(t).hasClass("newAdd")) {
            $(t).removeClass("connected").removeClass("newAdd");
            t.attr("onclick", "SocialTab.CheckSection('" + id + "')");
        }

        //$(t).css("background-color", $(t).css(""));

        SocialTab.HideShowAddSectionButtons();
    },

    CancelSections: function () {
        var newSections = $("#socialTopicsTabSection ul.topics li.newAdd");
        var removedSections = $("#socialTopicsTabSection ul.topics li.newRemove");
        $.each(newSections, function () {
            if ($(this).hasClass("newAdd")) {
                $(this).removeClass("connected").removeClass("newAdd");
            }
            $(this).attr("onclick", "SocialTab.CheckSection('" + $(this).data("section-id") + "')");
        });
        $.each(removedSections, function () {
            if ($(this).hasClass("newRemove")) {
                $(this).removeClass("newRemove").addClass("connected");
            }
            $(this).attr("onclick", "SocialTab.UnCheckSection('" + $(this).data("section-id") + "')");
        });
        SocialTab.HideShowAddSectionButtons();
    },

    SaveSections: function () {
        var newSections = $("#socialTopicsTabSection ul.topics li.connected");
        var removedSections = $("#socialTopicsTabSection ul.topics li.newRemove");
        var newCount = $("#socialTopicsTabSection ul.topics li.newAdd").length;
        $.each(newSections, function () {
            $(this).removeClass("newAdd");
            SocialTab.AddSection($(this).data("section-id"));
        });

        $.each(removedSections, function () {
            $(this).removeClass("newRemove");
            SocialTab.RemoveSection($(this).data("section-id"));
        });

        var message = "Added " + newCount + " section";
        if (newCount > 1) {
            message = "Added " + newCount + " sections";
        }

        NewsTab.Modules.NotificationsManager.Open_ToastMessage({
            Title: "New Sections",
            Text: message
        });
        SocialTab.HideShowAddSectionButtons("hide");
    },

    SelectSectionToManage: function (section) {
        if (section == null) {
            $(".feedManager").fadeOut();
        }
        else {
            $("#organizerSectionFeeds .sectionManager li").removeClass("selected");
            var t = $("#organizerSectionFeeds .sectionManager").find(".item[data-section-id=" + section.Id + "]");
            t.addClass("selected");


            var tabIndex = parseInt($("#organizerSectionFeeds").find(".sectionManager.topics").find("li:last").attr("tabindex")) + 10;

            NewsTab.Modules.AddNewContent.SelectedSectionInOrganizer = section;
            $("#organizerSectionFeeds .feedManager .selectedSection").css("background-color", section.Color);

            var sectionHtml = "";
            if (section.ClassName) {
                sectionHtml += "<span class=\"sIcon\" style=\"background-color:" + section.Color + "\"><i class=\"icon-" + section.ClassName + "\"></i></span>";
            } else {
                sectionHtml += "<span class=\"sIcon\" style=\"background-color:" + section.Color + "\">" + section.Name.substring(0, 2) + "</span>";
            }
            sectionHtml += "<span class=\"sName\">" + section.Name + "</span>";
            sectionHtml += "<div class=\"sControls\" data-item=\"" + section.Id + "\"  data-section-id=\"" + section.Id + "\">";
            if (section.SectionTypeId == Section.TYPES.Social) {
                //sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Edit\" data-item class=\"icon-pencil sectionEdit\"></i>";
                sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Delete\" class=\"icon-trash-o sectionSocialRemove\"></i>";
                //sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"More\" class=\"icon-more editRssSectionFeeds\"></i>";
            }
            else {
                sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Edit\" data-item class=\"icon-pencil sectionEdit\"></i>";
                sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"Delete\" class=\"icon-trash-o sectionRemove\"></i>";
                sectionHtml += "<i data-tooltip=\"tooltip\" data-placement=\"top\" title=\"More\" class=\"icon-more editRssSectionFeeds\"></i>";
            }
            sectionHtml += "</div>";

            $("#organizerSectionFeeds .feedManager .selectedSection").html(sectionHtml);

            $("#organizerSectionFeeds .feedManager ul").html("");
            $("#organizerSectionFeeds .feedManager ul").css("border-color", section.Color);

            var empty = true;

            var timeline = $.grep(section.Feeds, function (e) { return e.Name == "Timeline" });
            if (timeline.length) {
                timeline = timeline[0];

                var feedItemHtml = "<li class=\"feed timeline" + (NewsTab.Modules.SectionsManager.CurrentSection != null && timeline.Id == NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? " active" : "") + "\" data-feed-id=\"" + timeline.Id + "\" data-section-id=\"" + section.Id + "\"  tabindex=\"" + (tabIndex + 4) + "\">";

                feedItemHtml += "<span  class=\"feedName\">" + (timeline.NewImport || section.NewImport ? "[New] " : "") + timeline.Name + "</span>";
                feedItemHtml += "<div class=\"feedControls\" data-item=\"" + timeline.Id + "\" data-section-id=\"" + section.Id + "\">";

                feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Delete\" class=\"icon-trash-o deleteSpecialFeedClick " + ((timeline.Name.indexOf("#") == 0 || timeline.Name.indexOf("@") == 0) ? "" : "disabled") + "\" tabindex=\"" + (tabIndex + 6) + "\"></i>";

                feedItemHtml += "</div></li>";

                $("#organizerSectionFeeds .feedManager ul").append(feedItemHtml);
                empty = false;
                tabIndex++;
            }

            for (var i = 0, l = section.Feeds.length; i < l; i++) {
                if (section.Feeds[i].Id.length == 36 && (section.SectionTypeId != Section.TYPES.Social || section.Feeds[i].Name != "Timeline")) {
                    var feedItemHtml = "<li class=\"feed" + (section.Feeds[i].OrganizeFeedSelected ? " selected" : "") + (NewsTab.Modules.SectionsManager.CurrentSection != null && section.Feeds[i].Id == NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id ? " active" : "") + "\" data-feed-id=\"" + section.Feeds[i].Id + "\" data-section-id=\"" + section.Id + "\" draggable=\"true\" ondragstart=\"SocialTab.FeedManagerDragStart(event)\" ondragend=\"SocialTab.FeedManagerDragEnd(event)\" ondragenter=\"SocialTab.FeedManagerFeedDragEnter(event)\"  tabindex=\"" + (tabIndex + 4) + "\">";

                    if (section.SectionTypeId !== Section.TYPES.Social) {
                        if (section.Feeds[i].Type !== Feed.TYPES.SOCIALTRENDING) {
                            feedItemHtml += "<div class=\"checkContainer\">";
                            feedItemHtml += "<input type=\"checkbox\" id=\"feed_" + section.Feeds[i].Id + "\" " + (section.Feeds[i].OrganizeFeedSelected ? "checked=\"\"" : "") + "><label  data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Select\"  for=\"feed_" + section.Feeds[i].Id + "\"></label>";
                            feedItemHtml += "</div>";
                        }

                        if (section.Feeds[i].Icon != null && section.Feeds[i].Icon.indexOf(".") > 0) {
                            feedItemHtml += "<img draggable=\"false\" src=\"" + section.Feeds[i].Icon + "\" class=\"feedIcon\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" title=\"" + section.Feeds[i].Name + "\" />";
                        } else if (section.Feeds[i].FavIcon) {
                            feedItemHtml += "<img draggable=\"false\" class=\"feedIcon\" src=\"" + section.Feeds[i].FavIcon + "\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" title=\"" + section.Feeds[i].Name + "\"/>";
                        }
                        else {
                            feedItemHtml += "<img draggable=\"false\" class=\"feedIcon\" src=\"/Media/ExtensionImages/rss.png\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" title=\"" + section.Feeds[i].Name + "\"/>";
                        }
                    }
                    feedItemHtml += "<span  class=\"feedName\">" + (section.Feeds[i].NewImport || section.NewImport ? "[New] " : "") + section.Feeds[i].Name + "</span>";
                    feedItemHtml += "<div class=\"feedControls\" data-item=\"" + section.Feeds[i].Id + "\" data-section-id=\"" + section.Id + "\">";
                    if (section.Feeds[i].Type === Feed.TYPES.SOCIALTRENDING) {
                        if (section.Feeds[i].ShowInList) {
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Hide\" class=\"icon-eye hideSTFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                        }
                        else {
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Show\" class=\"icon-eye-slash hideSTFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                        }
                    } else if (section.SectionTypeId != Section.TYPES.Social) {
                        feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Copy&nbsp;Mode&nbsp;On/Off\" class=\"icon-copy feedCopyDrag " + (section.Feeds[i].OrganizeCopyMode ? "selected" : "") + "\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                        feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Delete\" class=\"icon-trash-o sourceItemRemove\" tabindex=\"" + (tabIndex + 6) + "\"></i>";
                        feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"More\" class=\"icon-more editRssFeed\" data-item=\"" + section.Feeds[i].Id + "\" data-section-id=\"" + section.Id + "\" tabindex=\"" + (tabIndex + 7) + "\"></i>";
                    }
                    else {
                        if (section.Feeds[i].ShowInList) {
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Hide\" class=\"icon-eye hideSpecialFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                        }
                        else {
                            feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Show\" class=\"icon-eye-slash hideSpecialFeedClick\" tabindex=\"" + (tabIndex + 5) + "\"></i>";
                        }

                        feedItemHtml += "<i data-tooltip=\"tooltip\" data-placement=\"bottom\" title=\"Delete\" class=\"icon-trash-o deleteSpecialFeedClick " + ((section.Feeds[i].Name.indexOf("#") == 0 || section.Feeds[i].Name.indexOf("@") == 0) ? "" : "disabled") + "\" tabindex=\"" + (tabIndex + 6) + "\"></i>";
                    }
                    feedItemHtml += "</div></li>";

                    $("#organizerSectionFeeds .feedManager ul").append(feedItemHtml);
                    empty = false;
                    tabIndex++;
                }
            }

            if (empty) {
                var feedItemHtml = "<li class=\"empty\"><span>This Section is empty!</span></li>";
                $("#organizerSectionFeeds .feedManager ul").append(feedItemHtml);
            }
            $(".feedManager").fadeIn();
        }
    },


    FeedManagerIsBefore: function (a, b) {
        if (a.parentNode == b.parentNode) {
            for (var cur = a; cur; cur = cur.previousSibling) {
                if (cur === b) {
                    return true;
                }
            }
        }
        return false;
    },

    FeedManagerSetFeedAtPosition: function (sectionId, feedOneId, feedTwoId) {
        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === sectionId });
        if (section.length) {
            section = section[0];
            feedOne = $.grep(section.Feeds, function (e) { return e.Id === feedOneId });
            feedTwo = $.grep(section.Feeds, function (e) { return e.Id === feedTwoId });

            var currentSelectedFeed = false;
            if (feedOne.length && feedTwo.length) {
                feedOne = feedOne[0];
                feedTwo = feedTwo[0];
                var oldOrder = feedOne.OrderNumber;
                var newOrder = feedTwo.OrderNumber;
                if (oldOrder < newOrder) {
                    if (feedOne.Id == NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id) {
                        currentSelectedFeed = true;
                        NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                            Title: "Feed manager",
                            Color: "red",
                            Text: "The current active feed can only be moved up!"
                        });
                    }
                    else {
                        for (var i = 0, l = section.Feeds.length; i < l; i++) {
                            if (section.Feeds[i].OrderNumber <= newOrder && section.Feeds[i].OrderNumber > oldOrder) {
                                section.Feeds[i].OrderNumber--;
                            }
                        }
                    }
                } else {
                    for (var i = 0, l = section.Feeds.length; i < l; i++) {
                        if (section.Feeds[i].OrderNumber >= newOrder && section.Feeds[i].OrderNumber < oldOrder) {
                            section.Feeds[i].OrderNumber++;
                        }
                    }
                }
                if (!currentSelectedFeed) {
                    feedOne.OrderNumber = newOrder;
                }
                section.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                SocialTab.LastActiveFeeds = [];
                for (var i = 0; i < section.Feeds.length; i++) {
                    if (section.Feeds[i].ShowInList) {
                        SocialTab.LastActiveFeeds.push(section.Feeds[i].Id);
                    }
                }

                SocialTab.Menu_SetUpHTML_SubmenuList();


                if (!currentSelectedFeed) {
                    var callUrl = NewsTab.ApiUrl_Global + "post/feeds/insertat";
                    var switchOrderApiCall = $.ajax({
                        url: callUrl,
                        data: JSON.stringify({
                            items: [feedOneId, feedTwoId],
                            id: sectionId
                        }),
                        headers: {
                            Authorization: "Bearer " + NewsTab.Token
                        },
                        type: "POST",
                        contentType: "application/json",
                        dataType: "json",
                        processdata: true,
                        error: function (error) {
                            console.error("ERROR - FeedManagerSwitchFeedOrder:", error);
                        }
                    });
                    switchOrderApiCall.then(function (response) {
                        if (response === true) {

                        }
                    });
                }
            }
        }
    },

    FeedManagerSetSectionAtPosition: function (sectionOneId, sectionTwoId) {

        var sectionOne = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === sectionOneId });
        var sectionTwo = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === sectionTwoId });

        var sectionIds = [];
        if (sectionOne.length && sectionTwo.length) {
            var oldOrder = sectionOne[0].OrderNumber;
            var newOrder = sectionTwo[0].OrderNumber;
            if (oldOrder < newOrder) {
                for (var i = 0, l = NewsTab.Modules.SectionsManager.Sections.length; i < l; i++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].OrderNumber <= newOrder && NewsTab.Modules.SectionsManager.Sections[i].OrderNumber > oldOrder) {
                        if (NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Normal ||
                            NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Social) {
                            NewsTab.Modules.SectionsManager.Sections[i].OrderNumber--;
                        }
                    }
                }
            } else {
                for (var i = 0, l = NewsTab.Modules.SectionsManager.Sections.length; i < l; i++) {
                    if (NewsTab.Modules.SectionsManager.Sections[i].OrderNumber >= newOrder && NewsTab.Modules.SectionsManager.Sections[i].OrderNumber < oldOrder) {
                        if (NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Normal ||
                            NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Social) {
                            NewsTab.Modules.SectionsManager.Sections[i].OrderNumber++;
                        }
                    }
                }
            }

            sectionOne[0].OrderNumber = newOrder;
            NewsTab.Modules.SectionsManager.Sections.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

            SocialTab.LastActiveSections = [];

            for (var i = 0, c = 0; i < NewsTab.Modules.SectionsManager.Sections.length; i++) {
                if (NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Normal ||
                    NewsTab.Modules.SectionsManager.Sections[i].SectionTypeId === Section.TYPES.Social) {
                    SocialTab.LastActiveSections.push(NewsTab.Modules.SectionsManager.Sections[i].Id);
                    sectionIds.push(NewsTab.Modules.SectionsManager.Sections[i].Id);
                }
            }
            SocialTab.HTML_UpdateLastActiveSections();
            SocialTab.Menu_SetUpHTML_SubmenuList();

            NewsTab.Modules.AddNewContent.Setup_Sections();

            SocialTab.Calculate_Section_ItemNumber();


            var callUrl = NewsTab.ApiUrl_Global + "post/sections/order";
            $.ajax({
                url: callUrl,
                data: JSON.stringify({ items: sectionIds }),
                headers: {
                    Authorization: "Bearer " + NewsTab.Token
                },
                type: "POST",
                contentType: "application/json",
                dataType: "json",
                processdata: true,
                error: function (error) {
                    console.error("ERROR - FeedManagerSetSectionAtPosition:", error);
                }
            });
        }
    },


    FeedManagerDragStart: function (ev) {
        SocialTab.DragedFeedInOrganizer = ev.target;

        var section = NewsTab.Modules.SectionsManager.GetSectionById($(ev.target).data("section-id"), null);
        if (section !== null) {
            if (section.SectionTypeId == Section.TYPES.Normal) {
                ev.dataTransfer.setDragImage($("img", $(ev.target))[0], 16, 16);
                var feed = NewsTab.Modules.SectionsManager.GetFeedById($(ev.target).data("feed-id"), null, true);
                if (feed !== null) {
                    ev.dataTransfer.setData("section-id", section.Id);
                    ev.dataTransfer.setData("feed-id", feed.Id);

                    if (feed.OrganizeFeedSelected) {
                        var feedItems = $("#organizerSectionFeeds .feeds li.selected");
                        feedItems.css("opacity", 0.5);
                        ev.dataTransfer.effectAllowed = "copyMove";
                    }
                    else {
                        if (feed.OrganizeCopyMode) {
                            ev.dataTransfer.effectAllowed = "copy";
                        }
                        else {
                            ev.dataTransfer.effectAllowed = "move";
                        }
                        $(ev.target).css("opacity", 0.5);
                    }
                }
            }
        }
    },

    FeedManagerDragEnd: function (ev) {
        if (SocialTab.DragedFeedInOrganizer != null && SocialTab.PlaceAtFeedInOrganizer != null) {
            SocialTab.FeedManagerSetFeedAtPosition(
                NewsTab.Modules.AddNewContent.SelectedSectionInOrganizer.Id,
                $(SocialTab.DragedFeedInOrganizer).data("feed-id"),
                $(SocialTab.PlaceAtFeedInOrganizer).data("feed-id"));
        }

        SocialTab.DragedFeedInOrganizer = null;
        SocialTab.PlaceAtFeedInOrganizer = null;
        $("#organizerSectionFeeds .feeds li").css("opacity", 1);
    },

    FeedManagerFeedDragEnter: function (ev) {
        if ($(ev.target).hasClass("feed") && SocialTab.DragedFeedInOrganizer != ev.target) {
            SocialTab.PlaceAtFeedInOrganizer = ev.target;
            if (SocialTab.FeedManagerIsBefore(SocialTab.DragedFeedInOrganizer, ev.target)) {
                ev.target.parentNode.insertBefore(SocialTab.DragedFeedInOrganizer, SocialTab.PlaceAtFeedInOrganizer);
            }
            else {
                ev.target.parentNode.insertBefore(SocialTab.DragedFeedInOrganizer, SocialTab.PlaceAtFeedInOrganizer.nextSibling);
            }

        }
    },


    FeedManagerSectionDragStart: function (ev) {
        SocialTab.DragedSectionInOrganizer = ev.target;
        ev.dataTransfer.effectAllowed = "move";
    },

    FeedManagerSectionDragEnd: function (ev) {
        if (SocialTab.DragedSectionInOrganizer != null && SocialTab.PlaceAtSectionInOrganizer != null) {
            SocialTab.FeedManagerSetSectionAtPosition(
                $(SocialTab.DragedSectionInOrganizer.parentElement).data("section-id"),
                $(SocialTab.PlaceAtSectionInOrganizer.parentElement).data("section-id"));
        }
        SocialTab.DragedSectionInOrganizer = null;
        SocialTab.PlaceAtSectionInOrganizer = null;
    },

    FeedManagerSectionDragEnter: function (ev) {
        if (SocialTab.DragedSectionInOrganizer == null) {
            $(ev.target).addClass("highlightDropZone");
        }
        else {
            if ($(ev.target.parentElement).hasClass("item") && SocialTab.DragedSectionInOrganizer != ev.target) {
                SocialTab.PlaceAtSectionInOrganizer = ev.target;
                if (SocialTab.FeedManagerIsBefore(SocialTab.DragedSectionInOrganizer.parentElement, ev.target.parentElement)) {
                    ev.target.parentNode.parentNode.insertBefore(SocialTab.DragedSectionInOrganizer.parentElement, SocialTab.PlaceAtSectionInOrganizer.parentElement);
                }
                else {
                    ev.target.parentNode.parentNode.insertBefore(SocialTab.DragedSectionInOrganizer.parentElement, SocialTab.PlaceAtSectionInOrganizer.parentElement.nextSibling);
                }

            }
        }
        ev.stopPropagation();
        ev.preventDefault();
        return false;
    },

    FeedManagerDragLeave: function (ev) {
        $(ev.target).removeClass("highlightDropZone");
        return false;
    },

    FeedManagerDragOver: function (ev) {
        ev.preventDefault();

        var newSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id == $(ev.target).parent().data("section-id") });
        if (newSection.length) {
            if (newSection[0].SectionTypeId == NewsTab.Modules.AddNewContent.SelectedSectionInOrganizer.SectionTypeId) {
                ev.dataTransfer.dropEffect = "copyMove";
            }
            else {
                ev.dataTransfer.dropEffect = "none";
            }
        }
    },

    FeedManagerDrop: function (ev) {
        if (!$(ev.target).parent().hasClass("selected")) {
            $(ev.target).removeClass("highlightDropZone");
            ev.preventDefault();

            var sectionId = ev.dataTransfer.getData("section-id");
            var section = NewsTab.Modules.SectionsManager.GetSectionById(sectionId, null);
            if (section !== null) {
                if (section.SectionTypeId == Section.TYPES.Normal || section.SectionTypeId == Section.TYPES.Chrome) {
                    var feedId = ev.dataTransfer.getData("feed-id");
                    var feed = $.grep(section.Feeds, function (e) { return e.Id == feedId });
                    if (feed.length > 0) {
                        feed = feed[0];

                        if (feed.Type === Feed.TYPES.SOCIALTRENDING) {
                            NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                                Title: "Feed manager",
                                Color: "red",
                                Text: "You can't move this feed to another section!"
                            });
                        } else {
                            var newSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id == $(ev.target).parent().data("section-id") });
                            if (newSection.length) {
                                newSection = newSection[0];
                                if (newSection.SectionTypeId == Section.TYPES.Normal) {
                                    if (section.ClassName !== "googlechrome") {
                                        if (feed.OrganizeFeedSelected) {
                                            for (var i = 0, l = section.Feeds.length; i < l; i++) {
                                                if (section.Feeds[i].OrganizeFeedSelected) {
                                                    SocialTab.CopyFeed2(section.Feeds[i].Id, newSection.Id, sectionId, (ev.ctrlKey || section.Feeds[i].OrganizeCopyMode ? false : true), true);
                                                }
                                            }
                                        }
                                        else {
                                            SocialTab.CopyFeed2(feed.Id, newSection.Id, sectionId, (ev.ctrlKey || feed.OrganizeCopyMode ? false : true), true);
                                        }
                                    }
                                    else {
                                        SocialTab.AddFeedToSection(newSection.Id, feed.Id, feed.Name, feed.SiteUrl, feed.Url, feed.Icon, feed.Type);
                                    }
                                }
                                else {
                                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                                        Title: "Feed manager",
                                        Color: "red",
                                        Text: "You can't move News feeds to Twitter section!"
                                    });
                                }
                            }
                        }
                    }
                }
                else {
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Title: "Feed manager",
                        Color: "red",
                        Text: "You can't move Twitter feeds to other sections!"
                    });
                }
            }
        }
    },


    ShowConfirmationMessage: function (message, button) {
        if (button) {
            var data = new Object();
            data.event = button.action;
            var $btn = $("<a class=\"" + button.btnClass + "\" style=\"margin-left: 30px;\">" + button.btnName + "</a>");
            $btn.on("click", function () {
                data.event(this);
            });
            $(".confirmationMessage").html("<span>" + message + "</span>").append(html).show();
        } else {
            $(".confirmationMessage").html(message).show().delay(2000).fadeOut(300);
        }
        NewsTab.Helpers.CenterContent($(".confirmationMessage"), false);
    },

    AddSection: function (id) {
        var callUrl = NewsTab.ApiUrl_Global + "post/section/" + id;
        $.ajax({
            url: callUrl,
            headers: {
                Authorization: 'Bearer ' + NewsTab.Token,
                Layout: localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_DefaultLayoutType")
            },
            type: "POST",
            contentType: "application/json",
            dataType: "json",
            processdata: true,
            error: function (error) {
                console.error("ERROR - AddSection:", error);
            }
        }).then(function (data) {
            if (data) {
                if (data.Id !== SocialTab.NewId) {
                    SocialTab.UpdateSection(data, false);
                }
                SocialTab.SetCurrentSection(data.Id, true, false);
                SocialTab.Menu_SetUpHTML_SubmenuList();
                SocialTab.Calculate_Section_ItemNumber();
            }
        });
    },

    AddNewSection: function (name, color, dontOpenSection) {
        var section = {
            Name: name.trim(),
            Color: color
        };
        var callUrl = NewsTab.ApiUrl_Global + "post/section";
        $.ajax({
            url: callUrl,
            type: "POST",
            headers: {
                Authorization: "Bearer " + NewsTab.Token,
                Layout: localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_DefaultLayoutType")
            },
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(section),
            error: function (error) {
                console.error("ERROR - AddNewSection:", error);
            }
        }).then(function (data) {
            if (data) {
                if (data.Id !== SocialTab.NewId) {
                    SocialTab.UpdateSection(data, true, false, dontOpenSection);
                }
                if (!dontOpenSection) {
                    SocialTab.SetCurrentSection(data.Id, true, false, false);
                }
                var systemSection = $.grep(NewsTab.Modules.SectionsManager.SysSections, function (s) { return s.EnglishName === data.EnglishName; });
                if (systemSection.length) {
                    NewsTab.Modules.AddNewContent.Setup_Sections();
                }
                SocialTab.Calculate_Section_ItemNumber();
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "New Section",
                    Text: data.Message
                });
            }
        });
    },

    RemoveSection: function (id, modul, dontOpenSection) {
        var callUrl = NewsTab.ApiUrl_Global + "delete/section/" + id;
        $.ajax({
            url: callUrl,
            headers: { Authorization: "Bearer " + NewsTab.Token },
            type: "DELETE",
            contentType: "application/json",
            dataType: "json",
            processdata: true,
            error: function (error) {
                console.error("ERROR - RemoveSection:", error);
            }
        }).then(function (data) {
            if (data) {
                var connector = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === data.Id });
                if (connector.length > 0) {
                    connector = connector[0];
                    connector.Init(data);
                    NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.SectionsManager.Sections, connector);
                    NewsTab.Helpers.RemoveItemFromArray(SocialTab.LastActiveSections, connector.Id);

                    if (SocialTab.LastActiveSections.length < SocialTab.NumberOfVisibleSections && NewsTab.Modules.SectionsManager.Sections.length > SocialTab.NumberOfVisibleSections) {
                        var lastActiveSections = SocialTab.LastActiveSections;
                        var added = false;
                        $.grep(NewsTab.Modules.SectionsManager.Sections, function (el) {
                            if (!added && jQuery.inArray(el.Id, lastActiveSections) === -1 && el.ShowInSourceList) {
                                SocialTab.LastActiveSections.push(el.Id);
                                added = true;
                            }
                        });
                    }

                    if (!dontOpenSection) {
                        if (SocialTab.LastActiveSections[0] !== NewsTab.Modules.SectionsManager.CurrentSection.Id) {
                            SocialTab.SetCurrentSection(SocialTab.LastActiveSections[0], true, false);
                        }
                    }

                    SocialTab.HTML_UpdateLastActiveSections();
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                    NewsTab.Modules.AddNewContent.Setup_Sections();
                    SocialTab.Calculate_Section_ItemNumber();
                }

                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Remove Section",
                    Text: data.Message
                });
                if (modul) {
                    if ($("#doubleModal").length === 1) {
                        $("#doubleModal").remove();
                    }
                    else {
                        $.modal.impl.close();
                    }
                }
            }
        });
    },

    RemoveSections: function (ids, modul, dontOpenSection) {
        var callUrl = NewsTab.ApiUrl_Global + "delete/sections";
        $.ajax({
            url: callUrl,
            headers: { Authorization: "Bearer " + NewsTab.Token },
            type: "DELETE",
            dataType: "json",
            data: { "": ids },
            error: function (error) {
                console.error("ERROR - RemoveSection:", error);
            }
        }).then(function (data) {
            if (data == true) {
                for (var i = 0, l = ids.length; i < l; i++) {
                    var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === ids[i].Id });
                    if (section.length > 0) {
                        section = section[0];

                        NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.SectionsManager.Sections, section);
                        NewsTab.Helpers.RemoveItemFromArray(SocialTab.LastActiveSections, section.Id);
                    }
                }

                if (SocialTab.LastActiveSections.length < SocialTab.NumberOfVisibleSections && NewsTab.Modules.SectionsManager.Sections.length > SocialTab.NumberOfVisibleSections) {
                    var lastActiveSections = SocialTab.LastActiveSections;
                    var added = false;
                    $.grep(NewsTab.Modules.SectionsManager.Sections, function (el) {
                        if (!added && jQuery.inArray(el.Id, lastActiveSections) === -1 && el.ShowInSourceList) {
                            SocialTab.LastActiveSections.push(el.Id);
                            added = true;
                        }
                    });
                }

                if (!dontOpenSection) {
                    if (SocialTab.LastActiveSections[0].Id != NewsTab.Modules.SectionsManager.CurrentSection.Id) {
                        SocialTab.SetCurrentSection(SocialTab.LastActiveSections[0], true, false);
                    }
                }

                SocialTab.HTML_UpdateLastActiveSections();
                SocialTab.Menu_SetUpHTML_SubmenuList();
                NewsTab.Modules.AddNewContent.Setup_Sections();
                SocialTab.Calculate_Section_ItemNumber();

                if (modul) {
                    if ($("#doubleModal").length === 1) {
                        $("#doubleModal").remove();
                    }
                    else {
                        $.modal.impl.close();
                    }
                }
            }
        });
    },

    EditSection: function (id, name, color) {
        var callUrl = NewsTab.ApiUrl_Global + "post/section/" + id + "/" + encodeURIComponent(name) + "/" + color.slice(1);
        $.ajax({
            url: callUrl,
            type: "GET",
            headers: { Authorization: "Bearer " + NewsTab.Token },
            error: function (error) {
                console.error("ERROR - EditSection:", error);
            }
        }).then(function (data) {
            if (data) {
                if (data.Id !== SocialTab.NewId) {
                    SocialTab.UpdateSection(data, false, true);
                }
                SocialTab.SetCurrentSection(data.Id, true, true);
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Edit Section",
                    Text: data.Message
                });
            }
        });
    },

    UpdateSection: function (section, setupSection, isEdit, dontOpenSection, isImport) {
        var isNew = true;
        var elementPosition = 0;
        var newSection;
        if (section != null) {
            for (var i = 0, len = NewsTab.Modules.SectionsManager.Sections.length; i < len; i++) {
                if (NewsTab.Modules.SectionsManager.Sections[i].Id === section.SystemSectionId || NewsTab.Modules.SectionsManager.Sections[i].Id === section.Id) {
                    newSection = NewsTab.Modules.SectionsManager.Sections[i];
                    elementPosition = i;
                    if (isEdit) {
                        NewsTab.Modules.SectionsManager.Sections[i].Name = section.Name;
                        NewsTab.Modules.SectionsManager.Sections[i].Color = section.Color;
                    } else {
                        NewsTab.Modules.SectionsManager.Sections[i] = new Section().Init(section);
                    }
                    isNew = false;
                    break;
                }
            };
            if (isNew) {
                newSection = new Section().Init(section);
                SocialTab.LastActiveSections.unshift(String(newSection.Id));
                newSection.NewImport = isImport;
                NewsTab.Modules.SectionsManager.Sections.push(newSection);
            } else if (!isEdit) {
                NewsTab.Modules.SectionsManager.Sections.splice(elementPosition, 1);
            }
        }

        for (var j = 0; j < SocialTab.LastActiveSections.length; j++) {
            var s = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return t.Id === SocialTab.LastActiveSections[j] });
            if (s.length) {
                s = s[0];
                s.OrderNumber = j;
            }
        }

        NewsTab.Modules.SectionsManager.Sections.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

        if (setupSection === true) {
            NewsTab.Modules.AddNewContent.Setup_Sections(newSection);
        }
        if (isImport) {
            return newSection;
        }
        SocialTab.HTML_SetUpSourceList(dontOpenSection);
        SocialTab.HTML_UpdateLastActiveSections();
        SocialTab.Calculate_Section_ItemNumber();

        return newSection;
    },

    ReorderSections: function () {
        if (NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            var active = false;
            var width = $("#dashboardGridBody").width();
            var newNumberOfVisibleSections = parseInt((width - 600) / 44);
            if ($("body").width() <= 1000 && $("body").width() > 950) {
                newNumberOfVisibleSections = parseInt((width - 550) / 44);
            } else if ($("body").width() <= 950 && $("body").width() > 800) {
                newNumberOfVisibleSections = parseInt((width - 450) / 44);
            }

            if (NewsTab.Modules.SectionsManager.CurrentSection != undefined && NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Normal && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.ShowInList) {
                newNumberOfVisibleSections = parseInt((width - 640) / 44);
                if ($("body").width() <= 1000 && $("body").width() > 950) {
                    newNumberOfVisibleSections = parseInt((width - 630) / 44);
                } else if ($("body").width() <= 950 && $("body").width() > 800) {
                    newNumberOfVisibleSections = parseInt((width - 500) / 44);
                }
            }

            if (newNumberOfVisibleSections >= SocialTab.NumberOfVisibleSections) {
                newNumberOfVisibleSections = SocialTab.NumberOfVisibleSections;
            }

            $("#lastActiveConnectors").sortable({
                revert: true,
                items: "li.xOption",
                axis: "x",
                opacity: 0.9,
                dropOnEmpty: false,
                stop: function (e, ui) {
                    active = false;
                },
                activate: function (e, ui) {
                    active = true;
                    ui.item.css({
                        "margin-top": "-3px",
                        "width": "46px",
                        "height": "46px",
                        "padding-top": "3px"
                    });
                    $(".sourceItemArrow").hide();
                },
                deactivate: function (e, ui) {
                    ui.item.css({
                        "margin-top": "0",
                        "width": "40px",
                        "height": "40px",
                        "padding-top": "0"
                    });
                    $(".sourceItemArrow").show();

                    SocialTab.LastActiveSections = [];
                    $.each($("#lastActiveConnectors .sourceItem, .sectionsDropdown .sourceItem, .rightSideMenu .sourceItem"), function (index, data) {
                        SocialTab.LastActiveSections.push($(data).data("section-id"));
                    });

                    if (SocialTab.UpdateSectionsOrderXhr && SocialTab.UpdateSectionsOrderXhr.readystate !== 4) {
                        SocialTab.UpdateSectionsOrderXhr.abort();
                    }

                    var callUrl = NewsTab.ApiUrl_Global + "post/sections/order";
                    SocialTab.UpdateSectionsOrderXhr = $.ajax({
                        url: callUrl,
                        data: JSON.stringify({ items: SocialTab.LastActiveSections }),
                        headers: {
                            Authorization: "Bearer " + NewsTab.Token
                        },
                        type: "POST",
                        contentType: "application/json",
                        dataType: "json",
                        processdata: true,
                        error: function (error) {
                            console.error("ERROR - OrderSections:", error);
                        }
                    });
                }
            });

            $("#lastActiveConnectors li.xOption").mousedown(function (e) {
                if (active === false) {
                    var self = $(this);
                    var event = e;
                    this.downTimer = setTimeout(function () {
                        active = true;
                        self.trigger(event);
                        self.css({
                            "margin-top": "-3px",
                            "width": "46px",
                            "height": "46px",
                            "padding-top": "3px"
                        });
                        $(".sourceItemArrow").hide();
                        // Resize sections place for 6px when grap section
                        $("#lastActiveConnectors").width((newNumberOfVisibleSections * 44) + 6);
                    }, 300);
                }
            }).mouseup(function () {
                clearTimeout(this.downTimer);
                active = false;
                $(this).css({
                    "margin-top": "0",
                    "width": "40px",
                    "height": "40px",
                    "padding-top": "0"
                });
                $(".sourceItemArrow").show();
                // Resize back sections place for 6px when grap section
                $("#lastActiveConnectors").width(newNumberOfVisibleSections * 44);
            }).mousemove(function () {
                clearTimeout(this.downTimer);
                active = false;
            });
        }
    },

    ResizeElement: function () {
        var $markAllAsRead = $("#markAllAsReaded")
        if ($markAllAsRead !== null && $markAllAsRead.length > 0) {
            var startWidth, newWidth, maxWidth;
            var numberOfSections = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.ShowInSourceList; }).length;
            var maxWidth1 = numberOfSections * 44;
            var maxWidth2 = $markAllAsRead.position().left - $(".xOption.feedDd.dropdown").position().left + $("#lastActiveConnectors").width() - 75;

            if (NewsTab.Modules.SectionsManager.CurrentSection != undefined && NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Normal && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.ShowInList) {
                maxWidth2 = $markAllAsRead.position().left - $(".xOption.feedDd.dropdown").position().left + $("#lastActiveConnectors").width() - 115;
            }

            if (numberOfSections < 1) {
                if ($("#lastActiveConnectors").resizable("instance") != undefined) {
                    $("#lastActiveConnectors").resizable("destroy");
                };
                return;
            };

            if (maxWidth1 <= maxWidth2) {
                maxWidth = maxWidth1;
            } else {
                maxWidth = maxWidth2;
            }
            $("#lastActiveConnectors").resizable({
                maxHeight: 42,
                minHeight: 42,
                maxWidth: maxWidth,
                minWidth: 42,
                handles: "e",
                grid: 44,
                start: function (e, ui) {
                    if ($("body").hasClass("light")) {
                        $("#lastActiveConnectors").css({ "outline": "1px dashed gray" });
                        $(".ui-resizable-e").addClass("resizable-lines");
                    } else {
                        $("#lastActiveConnectors").css({ "outline": "1px dashed white" });
                        $(".ui-resizable-e").addClass("resizable-lines");
                    }
                    startWidth = parseInt(ui.size.width, 10);
                },
                resize: function (e, ui) {
                    newWidth = ui.element[0].offsetWidth;
                    if (newWidth > startWidth) {
                        startWidth = newWidth;
                        SocialTab.NumberOfVisibleSections = $("#lastActiveConnectors").width() / 44;
                        SocialTab.HTML_UpdateLastActiveSections();
                    } else if (newWidth < startWidth) {
                        startWidth = newWidth;
                        SocialTab.NumberOfVisibleSections = $("#lastActiveConnectors").width() / 44;
                        SocialTab.HTML_UpdateLastActiveSections();
                    }
                },
                stop: function () {
                    $("#lastActiveConnectors").css({ "outline": "none" });
                    $(".ui-resizable-e").removeClass("resizable-lines");
                    SocialTab.HTML_SaveUserSettings("NumberOfVisibleSections", SocialTab.NumberOfVisibleSections);
                }
            });
            $(".ui-resizable-handle.ui-resizable-e").html("<div class=\"line-separator\"></div><div class=\"line-separator\"></div>");
        }
    },

    SetLastActiveFeeds: function () {
        if (NewsTab.Modules.SectionsManager.CurrentSection.Feeds != null && NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            if (SocialTab.UpdateFeedsOrderXhr && SocialTab.UpdateFeedsOrderXhr.readystate !== 4) {
                SocialTab.UpdateFeedsOrderXhr.abort();
            }

            SocialTab.LastActiveFeeds = [];
            $.each($(".sourceItemSubmenu li.menuItem:not(.defaultFeed)"), function (index, data) {
                SocialTab.LastActiveFeeds.push($(data).data("feed-id"));
            });

            $.each($(".socialTabSourceList li.menuSubItems"), function (index, data) {
                SocialTab.LastActiveFeeds.push($(data).data("feed-id"));
            });

            var callUrl = NewsTab.ApiUrl_Global + "post/feeds/order";
            SocialTab.UpdateFeedsOrderXhr = $.ajax({
                url: callUrl,
                data: JSON.stringify({
                    items: SocialTab.LastActiveFeeds,
                    id: NewsTab.Modules.SectionsManager.CurrentSection.Id
                }),
                headers: {
                    Authorization: "Bearer " + NewsTab.Token
                },
                type: "POST",
                contentType: "application/json",
                dataType: "json",
                processdata: true,
                error: function (error) {
                    console.error("ERROR - OrderFeeds:", error);
                }
            });
            SocialTab.UpdateFeedsOrderXhr.then(function (response) {
                $.each(response, function (index, data) {
                    var feed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (e) { return e.Id === data.Id });
                    if (feed.length) {
                        feed[0].OrderNumber = data.OrderNumber;
                    }
                });
            });
        }
    },

    ReorderFeeds: function () {
        var active = false;
        $(".sourceItemSubmenu").sortable({
            revert: false,
            items: "li.menuItem:not(.defaultFeed)",
            axis: "x",
            opacity: 0.9,
            dropOnEmpty: false,
            tolerance: "pointer",
            stop: function (e, ui) {
                active = false;
            },
            activate: function (e, ui) {
                active = false;
                $(".socialTabHeader").off("mouseleave", ".lastActiveItemsContainer");
                ui.item.addClass("highlight");
            },
            deactivate: function (e, ui) {
                clearTimeout(this.downTimer);
                active = false;
                $(".socialTabHeader").on("mouseleave", ".lastActiveItemsContainer", function () {
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                    $(".sourceItem").removeClass("active");
                    if (NewsTab.Modules.SectionsManager.CurrentSection != null) {
                        $(".sourceItem[data-section-id='" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "']").addClass("active");
                    }
                });
                ui.item.removeClass("highlight");
                SocialTab.SetLastActiveFeeds();
            }
        });

        $(".sourceItemSubmenu li.menuItem:not(.defaultFeed)").mousedown(function (e) {
            if (active === false) {
                var self = $(this);
                var event = e;
                this.downTimer = setTimeout(function () {
                    active = true;
                    self.trigger(event);
                    $(".socialTabHeader").off("mouseleave", ".lastActiveItemsContainer");
                    self.addClass("highlight");
                }, 300);
            }
        }).mouseup(function () {
            clearTimeout(this.downTimer);
            active = false;
            $(".socialTabHeader").on("mouseleave", ".lastActiveItemsContainer", function () {
                SocialTab.Menu_SetUpHTML_SubmenuList();
                $(".sourceItem").removeClass("active");
                if (NewsTab.Modules.SectionsManager.CurrentSection != null) {
                    $(".sourceItem[data-section-id='" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "']").addClass("active");
                }
            });
            $(this).removeClass("highlight");
        }).mousemove(function () {
            clearTimeout(this.downTimer);
            active = false;
        });
    },

    GetFeedsFromUrl: function (sender, url) {
        if (SocialTab.GetFeedsXhr && SocialTab.GetFeedsXhr.readystate !== 4) {
            SocialTab.GetFeedsXhr.abort();
        }

        var callUrl = NewsTab.ApiUrl_Rss + "FeedsFromUrl";
        $(sender).closest("#contentCustom").removeClass("showSideSections");
        $(sender).closest("#contentCustom").removeClass("showOpmlSections");
        NewsTab.Modules.AddNewContent.ShowLoader($("#contentCustom"), true);
        $(sender).closest("#contentCustom").addClass("onSearch");

        SocialTab.GetFeedsXhr = $.ajax({
            url: callUrl,
            timeout: 25000,
            headers: { Authorization: 'Bearer ' + NewsTab.Token, 'Url': encodeURIComponent(url) },
            cache: false,
            error: function (error) {
                NewsTab.Modules.AddNewContent.ShowLoader($("#contentCustom"), false);
                console.error("ERROR - GetFeedsFromUrl:", error);
            }
        });

        SocialTab.GetFeedsXhr.then(function (data) {
            var main = $(sender).closest(".main");
            NewsTab.Modules.AddNewContent.ShowLoader($("#contentCustom"), false);
            var result = main.find(".searchResults");
            result.html("");
            $("#contentCustom").removeClass("showSideSections");

            if (data.length) {
                main.find(".noResults").hide();
                var tabIndex = 1510;
                data.forEach(function (s) {
                    s.FeedExist = "overflow";
                    s.FeedId = s.Id;
                    s.FeedUrl = s.Url;
                    s.Domain = s.SiteUrl;

                    if ($("#contentCustom").is(":visible")) {
                        s.TabIndex = tabIndex + 10;
                        $("#contentCustom .searchResults").append(NewsTab.Modules.AddNewContent._$feedListItem(s));
                    } else if ($("#contentFeeds").is(":visible")) {
                        s.TabIndex = tabIndex;
                        $("#contentFeeds .searchResults").find(".searchItems").append(NewsTab.Modules.AddNewContent._$feedListItem(s));
                        $(".searchResults").addClass("showSearchItems");
                    }
                    tabIndex += 100;
                });
            } else {
                result.prepend("<div class=\"noResults\"><p>No match - please verify the URL and try again</p></div>");
            }
        });
    },

    GetFeedsFromUrl1: function (sender, url) {
        //if (SocialTab.GetFeedsXhr && SocialTab.GetFeedsXhr.readystate !== 4) {
        //    SocialTab.GetFeedsXhr.abort();
        //}

        var main = $(sender).closest(".main");
        var result = main.find(".searchResults");
        result.append("<div class=\"noResults\"><p>We are searching for new feeds over the web. This can take some time, please wait!</p></div>");

        var callUrl = NewsTab.ApiUrl_Rss + "FeedsFromUrlInBackground";

        SocialTab.GetFeedsXhr1 = $.ajax({
            url: callUrl,
            timeout: 60000,
            headers: { Authorization: 'Bearer ' + NewsTab.Token, 'Url': encodeURIComponent(url) },
            cache: false,
            error: function (error) {
                NewsTab.Modules.AddNewContent.ShowLoader($("#contentCustom"), false);
                console.error("ERROR - GetFeedsFromUrl:", error);
            }
        });

        SocialTab.GetFeedsXhr1.then(function (data) {
            main.find(".noResults").hide();
            var tabIndex = 1020;
            data.forEach(function (s) {
                s.TabIndex = tabIndex;

                s.FeedExist = "overflow";
                s.FeedId = s.Id;
                s.FeedUrl = s.Url;
                s.Domain = s.SiteUrl;
                $("#contentCustom .searchResults").append(NewsTab.Modules.AddNewContent._$feedListItem(s));
                tabIndex += 100;
            });
        });
    },

    SearchBestFeed: function (sender, url) {
        if (SocialTab.SearchBestFeedXhr && SocialTab.SearchBestFeedXhr.readystate !== 4) {
            SocialTab.SearchBestFeedXhr.abort();
        }

        var callUrl = NewsTab.ApiUrl_Base + "api/feeds/GetByFeedUrl?feedUrl=" + url;
        SocialTab.SearchBestFeedXhr = $.ajax({
            url: callUrl,
            timeout: 10000,
            crossDomain: true,
            error: function (error) {
                NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
                //NewsTab.Modules.SectionsManager.DisplayErrorScreen($("#contentFeeds .searchResults").find(".searchItems"), true);
                //$("#contentFeeds .errorScreen .feedRetry").attr("onclick", "SocialTab.SearchBestFeed($('#contents'), '" + url + "')");
                console.error(error);
            },
            beforeSend: function () {
                $("#contentFeeds .errorScreen").remove();
            }
        });

        SocialTab.SearchBestFeedXhr.then(function (data) {
            if (SocialTab.page === 0) {
                if ($(".showingResults").length === 0) {
                    $("#contentFeeds .searchResults").find(".searchItems").prepend(NewsTab.Modules.SectionsManager.$_CreateFeedCountItem({ Query: url, TotalResults: data.TotalResults, Type: SocialTab.searchType }));
                } else {
                    $(".showingResults .numberOfFeeds").html(SocialTab.CalculateNumberOfFeeds(url, data.TotalResults));
                }
            }

            if (data.Feeds != null && data.Feeds.length) {
                var tabIndex = 1510;
                data.Feeds.forEach(function (s) {
                    s.TabIndex = tabIndex;
                    $("#contentFeeds .searchResults").find(".searchItems").append(NewsTab.Modules.AddNewContent._$feedListItem(s));
                    tabIndex += 100;
                    $(".searchResults").addClass("showSearchItems");
                });
            }
            SocialTab.ShowLoader($("#contentFeeds"), false);
        });
    },

    SearchGoogleNewsFromUrl: function (sender, url, edition, from) {
        if (SocialTab.SearchGoogleNewsXhr && SocialTab.SearchGoogleNewsXhr.readystate !== 4) {
            SocialTab.SearchGoogleNewsXhr.abort();
        }

        if ($("#contentFeeds").find(".searchItems").find("#googleNewsItemKeyword").length === 0) {
            SocialTab.HTML_SeatupGoogleNewsSearchSection($("#contentFeeds"));
        }
        edition = edition != undefined ? edition : NewsTab.Modules.RegionManager.AddFeedEditionGnValue != undefined ? NewsTab.Modules.RegionManager.AddFeedEditionGnValue : NewsTab.Modules.RegionManager.MainEditionGnValue;
        var callUrl = NewsTab.ApiUrl_Global + "get/googlenewsfeeds?query=" + encodeURIComponent(url) + "&edition=" + edition;
        SocialTab.SearchGoogleNewsXhr = $.ajax({
            url: callUrl,
            headers: { Authorization: "Bearer " + NewsTab.Token },
            timeout: 10000,
            crossDomain: true,
            error: function (error) {
                NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
                console.error("ERROR - SearchFeedsFromUrl:", error);
            },
            beforeSend: function () {
                $("#contentFeeds .errorScreen").remove();
            }
        });

        SocialTab.SearchGoogleNewsXhr.then(function (data) {
            if (data.Topics != null && data.Topics.Channel != null && data.Topics.Channel.Items.length > 0) {
                data.Topics.TabIndex = 1010;

                $("#contentFeeds").find(".searchResults").find("#googleNewsItemTopic").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Topics));

                var gnCode = $("#mainEditionsDropdown").find("option:selected").attr("data-googlenewscode");
                if (gnCode === "") {
                    $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
                    $(".labelEditionLabel").text("United States");
                } else {
                    $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
                    $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
                }

                //$("#googleNewsItemTopic").find(".feedPreview").html('');
                //$("#googleNewsItemTopic").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                //    Title: data.Topics.Title,
                //    EncodedTitle: encodeURIComponent(data.Topics.Title),
                //    FeedUrl: data.Topics.RssUrl,
                //    Id: data.Topics.Id,
                //    Domain: data.Topics.SiteUrl,
                //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                //}));
            }

            if (data.Keywords != null && data.Keywords.Title != null) {
                data.Keywords.TabIndex = 1110;
                $("#contentFeeds").find(".searchResults").find("#googleNewsItemKeyword").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Keywords));

                //$("#googleNewsItemKeyword").find(".feedPreview").html('');
                //$("#googleNewsItemKeyword").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                //    Title: data.Topics.Title,
                //    EncodedTitle: encodeURIComponent(data.Topics.Title),
                //    FeedUrl: data.Topics.RssUrl,
                //    Id: data.Topics.Id,
                //    Domain: data.Topics.SiteUrl,
                //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                //}));
            }

            if (data.Locations != null && data.Locations.Channel != null && data.Locations.Channel.Items.length > 0) {
                data.Locations.TabIndex = 1210;
                $("#contentFeeds").find(".searchResults").find("#googleNewsItemLocation").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Locations));

                //$("#googleNewsItemLocation").find(".feedPreview").html('');
                //$("#googleNewsItemLocation").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                //    Title: data.Topics.Title,
                //    EncodedTitle: encodeURIComponent(data.Topics.Title),
                //    FeedUrl: data.Topics.RssUrl,
                //    Id: data.Topics.Id,
                //    Domain: data.Topics.SiteUrl,
                //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                //}));
            }

            if (SocialTab.page === 0) {
                if ($(".showingResults").length === 0) {
                    $("#contentFeeds .searchResults").find(".searchItems").prepend(NewsTab.Modules.AddNewContent.$_CreateFeedCountItem({ Query: url, TotalResults: SocialTab.CalculateNumberOfFeeds(url, 0, "GN"), Type: SocialTab.searchType }));
                } else {
                    $(".showingResults .numberOfFeeds").html(SocialTab.CalculateNumberOfFeeds(url, 0, "GN"));
                }
            }

            NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
        });
    },

    GetGoogleNewsTopicsAndKeyword: function (sender, url, edition) {

        if (sender.find(".searchItems").find("#googleNewsItemKeyword").length === 0) {
            SocialTab.HTML_SeatupGoogleNewsSearchSection(sender);
        }

        var callUrl = NewsTab.ApiUrl_Global + "/GetGoogleNewsTopicsAndKeyword?query=" + url + "&edition=" + (edition != undefined ? edition : NewsTab.Modules.RegionManager.MainEditionGnValue);
        SocialTab.SearchGoogleNewsXhr = $.ajax({
            url: callUrl,
            timeout: 10000,
            crossDomain: true,
            error: function (error) {
                console.error("ERROR - GetGoogleNewsTopicsAndKeyword:", error);
            },
            beforeSend: function () {
                $("#contentFeeds .errorScreen").remove();
            }
        });

        SocialTab.SearchGoogleNewsXhr.then(function (data) {
            NewsTab.Modules.RegionManager.MainEditionGnValue = edition;
            data.Topics.TabIndex = 1010;
            sender.find(".searchResults").find("#googleNewsItemTopic").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Topics));

            var gnCode = $("#mainEditionsDropdown").find("option:selected").attr("data-googlenewscode");
            if (gnCode === "") {
                $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
                $(".labelEditionLabel").text("United States");
            } else {
                $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
                $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
            }

            //$("#googleNewsItemTopic").find(".feedPreview").html('');
            //$("#googleNewsItemTopic").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
            //    Title: data.Topics.Title,
            //    EncodedTitle: encodeURIComponent(data.Topics.Title),
            //    FeedUrl: data.Topics.RssUrl,
            //    Id: data.Topics.Id,
            //    Domain: data.Topics.SiteUrl,
            //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
            //}));

            data.Keywords.TabIndex = 1110;
            sender.find(".searchResults").find("#googleNewsItemKeyword").append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(data.Keywords));

            //$("#googleNewsItemKeyword").find(".feedPreview").html('');
            //$("#googleNewsItemKeyword").find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
            //    Title: data.Topics.Title,
            //    EncodedTitle: encodeURIComponent(data.Topics.Title),
            //    FeedUrl: data.Topics.RssUrl,
            //    Id: data.Topics.Id,
            //    Domain: data.Topics.SiteUrl,
            //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
            //}));
        });
    },

    CalculateNumberOfFeeds: function (url, count, type) {
        var totalResults, currentResults = $(".showingResults .numberOfFeeds").html();

        var countOfGoogleNews = $("div[id^='googleNewsItem']").filter(function () {
            return $(this).html();
        }).length;

        if ($(".showingResults").length === 0) {
            if (SocialTab.searchType === "1") {
                return count;
            }
            else if (SocialTab.searchType === "2" && type !== "GN") {
                return count;
            } else {
                totalResults = (currentResults != undefined ? parseInt(currentResults) : 0) + countOfGoogleNews;
                return totalResults;
            }
        } else {
            if (currentResults == count) {
                totalResults = (currentResults != undefined ? parseInt(currentResults) : 0) + countOfGoogleNews;
            } else {
                totalResults = (currentResults != undefined ? parseInt(currentResults) : 0) + count;
            }
            return totalResults;
        }
    },

    GetGoogleNewsCategories: function (skipRecords) {
        if (SocialTab.SearchGoogleNewsXhr && SocialTab.SearchGoogleNewsXhr.readystate !== 4) {
            SocialTab.SearchGoogleNewsXhr.abort();
        }

        var takeRecords = 10;
        var callUrl = NewsTab.ApiUrl_Global + "get/googlenewscategories?subCategories=true&edition=" + NewsTab.Modules.RegionManager.AddFeedEditionGnValue +
            "&skipRecords=" + (skipRecords != undefined ? skipRecords : 0) + "&takeRecords=" + takeRecords;
        SocialTab.SearchGoogleNewsXhr = $.ajax({
            url: callUrl,
            headers: { Authorization: "Bearer " + NewsTab.Token },
            timeout: 16000,
            crossDomain: true,
            error: function (error) {
                NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
                console.error("ERROR - GetGoogleNewsCategories:");
                console.error(error);
            },
            beforeSend: function () {
                $("#contentFeeds .errorScreen").remove();
            }
        });

        SocialTab.SearchGoogleNewsXhr.then(function (data) {
            if (data) {
                var tabIndex = 1010;
                data.forEach(function (s) {
                    s.TabIndex = tabIndex;
                    var result = $("#contentFeeds .searchResults");
                    result.find(".searchItems").append("<div id=\"googleNewsItemTopic_" + s.Id + "\"></div>");
                    $("#contentFeeds .searchResults").find("#googleNewsItemTopic_" + s.Id).append(NewsTab.Modules.AddNewContent.$_CreateGoogleNewsItem(s));
                    var gnCode = $("#mainEditionsDropdown").find("option:selected").attr("data-googlenewscode");
                    if (gnCode === "") {
                        $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
                        $(".labelEditionLabel").text("United States");
                    } else {
                        $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
                        $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
                    }

                    //$("#googleNewsItemTopic_" + s.Id).find(".feedPreview").html('');
                    //$("#googleNewsItemTopic_" + s.Id).find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                    //    Title: s.Title,
                    //    EncodedTitle: encodeURIComponent(s.Title),
                    //    FeedUrl: s.RssUrl,
                    //    Id: s.Id,
                    //    Domain: s.SiteUrl,
                    //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                    //}));

                    tabIndex += 100;
                });

                NewsTab.Modules.AddNewContent.Event_SearchFeedPager($("#contentFeeds .searchResults"), true);
                $(".searchResults").addClass("showSearchItems");

                if (SocialTab.page === 0) {
                    if ($(".showingResults").length === 0) {
                        $("#contentFeeds .searchResults").find(".searchItems").prepend(NewsTab.Modules.AddNewContent.$_CreateFeedCountItem({ Query: "#news.google.com", TotalResults: SocialTab.CalculateNumberOfFeeds("news.google.com", 0, "GN"), Type: SocialTab.searchType }));
                    } else {
                        $(".showingResults .numberOfFeeds").html(SocialTab.CalculateNumberOfFeeds("news.google.com", 0, "GN"));
                    }
                }
            }

            NewsTab.Modules.AddNewContent.ShowLoader($("#contentFeeds"), false);
        });
    },

    SearchPublishersOrTopics: function (sender, url, type) {
        if (SocialTab.GetPopularXhr && SocialTab.GetPopularXhr.readystate !== 4) {
            SocialTab.GetPopularXhr.abort();
        }

        var callUrl;
        if (type === "SITEHEADER") {
            callUrl = NewsTab.ApiUrl_Base + "api/feeds/suggestions?query=" + url + "&maxTopics=0&maxSites=60";
        } else {
            callUrl = NewsTab.ApiUrl_Base + "api/feeds/suggestions?query=" + url + "&maxTopics=40&maxSites=0";
        }

        $("#contentFeeds").removeClass("showSideSections");

        SocialTab.GetPopularXhr = $.ajax({
            url: callUrl,
            timeout: 10000,
            error: function (error) {
                console.error("ERROR - SearchPublishersOrTopics:");
                NewsTab.Modules.AddNewContent.DisplayErrorScreen($("#popularPublishersTabSection"), true);
                $("#contentFeeds .errorScreen .feedRetry").attr("onclick", "SocialTab.SearchPublishersOrTopics($('#contents'), '" + url + "', '" + type + "')");
                console.error(error);
            },
            beforeSend: function () {
                $("#contentFeeds .errorScreen").remove();
            }
        });

        SocialTab.GetPopularXhr.then(function (response) {
            if (type === "SITEHEADER") {
                NewsTab.Modules.AddNewContent.PublisherSearchType = "selected";
                NewsTab.Modules.AddNewContent.SelectedPublishers = [];
                response.forEach(function (d) {
                    NewsTab.Modules.AddNewContent.SelectedPublishers.push({
                        IconUrl: d.IconUrl,
                        Id: d.Id,
                        SiteUrl: d.Name,
                        WebSiteUrl: d.WebSiteUrl,
                        PublisherName: d.PublisherName !== "" ? d.PublisherName : d.Name,
                        IsActive: true,
                        NumberOfFeeds: d.NumberOfFeeds,
                        DateCreated: new Date().toLocaleString(),
                        Type: d.Type,
                        RssUrl: d.RssUrl,
                        Color: d.Color,
                        PopularityIndex: d.PopularityIndex,
                        IconUrlWidth: d.IconUrlWidth,
                        IconUrlHeight: d.IconUrlHeight,
                        DisplayType: type
                    });
                });
                NewsTab.Modules.AddNewContent.Setup_SelectedPublishers();
            } else {
                NewsTab.Modules.AddNewContent.TopicSearchType = 'selected';
                NewsTab.Modules.AddNewContent.SelectedTopics = [];
                response.forEach(function (item) {
                    NewsTab.Modules.AddNewContent.SelectedTopics.push({
                        Id: item.Id,
                        Name: item.Name,
                        Value: item.Value,
                        IconUrl: item.IconUrl,
                        NumberOfFeeds: item.NumberOfFeeds,
                        Color: SocialTab.ColorPalette[NewsTab.Helpers.GetRandomInt(0, 7)],
                        DisplayType: type
                    });
                });
                NewsTab.Modules.AddNewContent.Setup_SelectedTopics();
            }
        });
    },

    MarkSelectText: function (term) {
        $.each($("#autocomplete .autocompleteTitle"), function () {
            var str = $(this).html();
            term = term.replace(/(\s+)/, "(<[^>]+>)*$1(<[^>]+>)*");
            var pattern = new RegExp("(" + term + ")", "gi");
            str = str.replace(pattern, "<strong>$1</strong>");
            str = str.replace(/(<strong>[^<>]*)((<[^>]+>)+)([^<>]*<\/strong>)/, "$1</strong>$2<strong>$4");
            $(this).html(str);
        });
    },



    RenderSelectEdition: function (sender, edition) {
        NewsTab.Modules.RegionManager.PreviousEdition = edition;

        if (!$("#firstTimeContent").is(":visible")) {
            if ($("[id^=googleNewsItemTopic]").length > 0) {
                $.each($("[id^=googleNewsItemTopic]"), function () {
                    var previousValue = $(this).find("li").attr("rssurl");
                    var topic = NewsTab.Helpers.GetParameterFromUrl('topic', previousValue);
                    var newValue;
                    if (topic != null) {
                        newValue = "https://news.google.com/news/rss/headlines/section/topic/" + topic + "?ned=" + edition.toLowerCase() + "&num=30";
                    } else {
                        newValue = "https://news.google.com/news/rss/headlines/section/q/" + previousValue + "?ned=" + edition.toLowerCase() + "&num=30";
                    }
                    $(this).find("li").attr("rssurl", newValue);
                    $(this).find("li").attr("domain", newValue);
                    $(this).find(".feedUrl a").html(newValue);
                    $(this).find(".feedUrl a").attr("href", newValue);
                    var id = $(this).find("li").data("feed-id");
                    var title = $(this).find("li .headline").html();
                    var siteUrl = $(this).find("li").attr("domain");

                    //$("#googleNewsItemTopic_" + id).find(".feedPreview").html('');
                    //$("#googleNewsItemTopic_" + id).find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
                    //    Title: title,
                    //    EncodedTitle: encodeURIComponent(title),
                    //    FeedUrl: newValue,
                    //    Id: id,
                    //    Domain: siteUrl,
                    //    IconUrl: "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png"
                    //}));
                });
            }

            if ($(sender).closest("#googleNewsItemTopic").length > 0) {
                $("#googleNewsItemTopic").html('');
                $("#googleNewsItemKeyword").html('');
                $("#googleNewsItemLocation").html('');
                SocialTab.SearchGoogleNewsFromUrl($(this).closest("#contents"), SocialTab.searchUrl, edition);
            }
        } else {
            $("#firstTimeContent").find("#googleNewsItemTopic").html('');
            $("#firstTimeContent").find("#googleNewsItemKeyword").html('');
            $("#firstTimeContent").find("#googleNewsItemLocation").html('');
        }
    },

    CopyFeed: function (sId, name, rssUrl, siteUrl, iconUrl) {
        var topicsContainner = $(".copyMoveModal .item.selected");

        $.each(topicsContainner, function (index, data) {
            SocialTab.AddFeedToSection($(data).attr("data-section-id"), sId, name, siteUrl, rssUrl, iconUrl);
        });
        if ($("#doubleModal").length === 1) {
            $("#doubleModal").remove();
        }
        else {
            $.modal.impl.close();
        }
    },

    CopyAllFeed: function (oldSectionId) {
        var topicsContainner = $(".copyMoveModal .item.selected");

        var newSectionIds = [];
        $.each(topicsContainner, function (index, data) {
            newSectionIds.push($(data).attr("data-section-id"));
        });
        SocialTab.CopyAllFeedsAPI(oldSectionId, newSectionIds, false);
    },

    MoveFeed: function (sId, name, dId, rssUrl, siteUrl, iconUrl) {
        var tId = $(".copyMoveModal .item.selected").attr("data-section-id");
        SocialTab.AddFeedToSection(tId, sId, name, siteUrl, rssUrl, iconUrl, "MOVEFEED", dId);

        if ($("#doubleModal").length === 1) {
            $("#doubleModal").remove();
        }
        else {
            $.modal.impl.close();
        }
    },

    MoveAllFeed: function (oldSectionId) {
        var newSectionId = $(".copyMoveModal .item.selected").attr("data-section-id");
        SocialTab.CopyAllFeedsAPI(oldSectionId, [newSectionId], true);
    },

    CopyFeed2: function (feedId, newSetionId, oldSectionId, deleteFromOld, dontOpenFeed) {
        var callUrl = NewsTab.ApiUrl_Rss + "CopyFeed?deleteFromSource=" + deleteFromOld;

        $.ajax({
            url: callUrl,
            type: "POST",
            contentType: "charset=utf-8",
            headers: {
                Authorization: "Bearer " + NewsTab.Token,
                'FeedId': feedId,
                'DestinationSectionId': newSetionId,
                'SourceSectionId': oldSectionId
            },
            error: function (error) {
                console.error("ERROR - CopyFeed2:");
                console.error(error);
            }
        }).then(function (data) {
            if (data == true) {
                $("#organizerSectionFeeds .sectionManager > li[data-section-id=" + newSetionId + "] > div").addClass("highlightDropZone");
                var oldSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === oldSectionId });
                if (oldSection.length > 0) {
                    oldSection = oldSection[0];

                    var feed = $.grep(oldSection.Feeds, function (e) { return e.Id === feedId });
                    if (feed.length > 0) {
                        feed = feed[0];
                        var newFeed = $.extend(true, {}, feed);
                        newFeed.OrganizeCopyMode = false;
                        newFeed.OrganizeFeedSelected = false;

                        var newSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === newSetionId });
                        if (newSection.length > 0) {
                            newSection = newSection[0];
                            newSection.Feeds.unshift(newFeed);
                            newSection.CurrentFeed = newFeed;

                            SocialTab.LastActiveFeeds = [];
                            for (var i = 0; i < newSection.Feeds.length; i++) {
                                if (newSection.Feeds[i].ShowInList) {
                                    SocialTab.LastActiveFeeds.push(newSection.Feeds[i].Id);
                                }
                            }
                            newSection.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                            if (deleteFromOld) {
                                NewsTab.Helpers.RemoveItemFromArray(oldSection.Feeds, feed);

                                if (oldSection.DefaultFeed.Id === feed.Id) {
                                    if (oldSection.Feeds.length > 1) {
                                        oldSection.DefaultFeed = oldSection.Feeds[1];
                                    } else {
                                        oldSection.DefaultFeed = oldSection.Feeds[0];
                                    }
                                }
                                if (oldSection.CurrentFeed.Id === feed.Id) {
                                    if (oldSection.Feeds.length > 1) {
                                        SocialTab.SetCurrentFeed(oldSection.Feeds[1].Id, true);
                                    } else {
                                        SocialTab.SetCurrentFeed(oldSection.DefaultFeed.Id, true);
                                    }
                                }

                                oldSection.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                                var j = 0;
                                for (var i = 0, len = oldSection.Feeds.length; i < len; i++) {
                                    var order = oldSection.Feeds[i].OrderNumber;
                                    if (parseFloat(order) < 0) {
                                        oldSection.Feeds[i].OrderNumber = order;
                                    } else {
                                        oldSection.Feeds[i].OrderNumber = j;
                                        j++;
                                    }
                                }
                            }
                        }
                    }

                    if (!dontOpenFeed) {
                        SocialTab.SetCurrentSection(newSection.Id, true, false);
                        SocialTab.SetCurrentFeed(newFeed.Id, true);
                    }
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                }
                $("#organizerSectionFeeds .sectionManager > li[data-section-id=" + newSetionId + "] > div").addClass("highlightDropZone");
                setTimeout(function () {
                    $("#organizerSectionFeeds .sectionManager > li[data-section-id=" + newSetionId + "] > div").removeClass("highlightDropZone");
                }, 500);
            }
        });
    },

    CopyAllFeedsAPI: function (oldSectionId, newSectionIds, deleteFromOld, dontOpenFeed) {
        var callUrl = NewsTab.ApiUrl_Rss + "CopyAllFeeds?deleteFromSource=" + deleteFromOld;

        $.ajax({
            url: callUrl,
            type: "POST",
            dataType: "json",
            data: { "": newSectionIds },
            headers: {
                Authorization: "Bearer " + NewsTab.Token,
                'SourceSectionId': oldSectionId
            },
            error: function (error) {
                console.error("ERROR - CopyAllFeedsAPI:");
                console.error(error);
            }
        }).then(function (data) {
            if (data) {
                var oldSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === oldSectionId });
                if (oldSection.length > 0) {
                    oldSection = oldSection[0];

                    var feeds = oldSection.Feeds;
                    var newfeed = null;
                    for (var i = 0, l = data.length; i < l; i++) {
                        var newSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === data[i].Id });
                        if (newSection.length > 0) {
                            newSection = newSection[0];
                            for (var j = 0, jl = data[i].Feeds.length; j < jl; j++) {
                                var newfeed = new Feed().NewInit(data[i].Feeds[j])
                                newfeed.SectionId = newSection.Id;
                                newSection.Feeds.unshift(newfeed);
                                newSection.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
                            }
                            newfeed = newSection.Feeds[0];
                        }
                    }

                    if (deleteFromOld) {
                        var feedsToRemove = [];
                        for (var i = 0, l = oldSection.Feeds.length; i < l; i++) {
                            if (oldSection.Feeds[i].Type.Id === Feed.TYPES.RSS.Id) {
                                feedsToRemove.push(oldSection.Feeds[i]);
                            }
                        }

                        for (var i = 0, l = feedsToRemove.length; i < l; i++) {
                            NewsTab.Helpers.RemoveItemFromArray(oldSection.Feeds, feedsToRemove[i]);
                        }

                        if (oldSection.Feeds.length > 1) {
                            oldSection.DefaultFeed = oldSection.Feeds[1];
                        } else {
                            oldSection.DefaultFeed = oldSection.Feeds[0];
                        }

                        if (oldSection.Feeds.length > 1) {
                            SocialTab.SetCurrentFeed(oldSection.Feeds[1].Id, true);
                        } else {
                            SocialTab.SetCurrentFeed(oldSection.DefaultFeed.Id, true);
                        }

                        oldSection.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
                    }

                    if (!dontOpenFeed) {
                        SocialTab.SetCurrentSection(newSection.Id, true, false);
                        if (newfeed != null) {
                            SocialTab.SetCurrentFeed(newfeed.Id, true);
                        }
                    }
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                }
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Feed manager",
                    Text: data.Message
                });
            }
            if ($("#doubleModal").length === 1) {
                $("#doubleModal").remove();
            }
            else {
                $.modal.impl.close();
            }
        });
    },

    RemoveAllFeedsFromSection: function (sectionId) {
        var callUrl = NewsTab.ApiUrl_Rss + "RemoveAllFeedsFromSection?sectionId=" + sectionId;

        $.ajax({
            url: callUrl,
            type: "DELETE",
            dataType: "json",
            headers: {
                Authorization: "Bearer " + NewsTab.Token
            },
            error: function (error) {
                console.error("ERROR - CopyAllFeedsAPI:");
                console.error(error);
            }
        }).then(function (data) {
            if (data == true) {
                var oldSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === sectionId });
                if (oldSection.length > 0) {
                    oldSection = oldSection[0];

                    var feedsToRemove = [];
                    for (var i = 0, l = oldSection.Feeds.length; i < l; i++) {
                        if (oldSection.Feeds[i].Type.Id === Feed.TYPES.RSS.Id) {
                            feedsToRemove.push(oldSection.Feeds[i]);
                        }
                    }

                    for (var i = 0, l = feedsToRemove.length; i < l; i++) {
                        NewsTab.Helpers.RemoveItemFromArray(oldSection.Feeds, feedsToRemove[i]);
                    }

                    if (oldSection.Feeds.length > 1) {
                        oldSection.DefaultFeed = oldSection.Feeds[1];
                    } else {
                        oldSection.DefaultFeed = oldSection.Feeds[0];
                    }

                    if (oldSection.Feeds.length > 1 && NewsTab.Modules.SectionsManager.CurrentSection.Id == oldSection.Id) {
                        SocialTab.SetCurrentFeed(oldSection.Feeds[1].Id, true);
                    } else {
                        SocialTab.SetCurrentFeed(oldSection.DefaultFeed.Id, true);
                    }

                    oldSection.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
                }
                SocialTab.Menu_SetUpHTML_SubmenuList();
            }
            if ($("#doubleModal").length === 1) {
                $("#doubleModal").remove();
            }
            else {
                $.modal.impl.close();
            }
        });
    },

    CancelOpmlFileSection: function () {
        $(".importOpmlFile .cancel").click(function () {
            $("#contentCustom").removeClass("showOpmlSections");
        });
    },

    /**** SET ****/

    SetCurrentState: function (state) {
        if (this.CurrentState !== state) {
            this.CurrentState = state;
        }
    },

    SetCurrentSection: function (source, setupFeed, reload, isPreview, fromSubMenu) {
        var section = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;
        if (section === null || section.Id !== source || reload === true) {
            var connectors;
            if (isPreview) {
                connectors = SocialTab.PreviewConnector;
            } else {
                connectors = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return t.Id === source });
            }

            if (connectors.length === 1 && !isPreview) {
                section = connectors[0];
            } else if (connectors && isPreview) {
                section = connectors;
            } else {
                section = NewsTab.Modules.SectionsManager.Sections[1];
            }

            if (isPreview) {
                section.Type = "FeedPreview";
                SocialTab.CurrentSectionPreview = section;
            } else {
                if (section !== null) {
                    if (section.Name === "Twitter") {
                        $("body").parent().addClass("twitterMode");
                    }
                    else {
                        $("body").parent().removeClass("twitterMode");
                    }

                    if (!NewsTab.IsExtension) {
                        SocialTab.UpdateLastActiveSection(section.Id);
                        if (setupFeed) {
                            var feedId = section.CurrentFeed.Id;
                            if (feedId !== null) {
                                var feeds = $.grep(section.Feeds, function (t) { return (t.ShowInList === true && t.Id !== (section.Id + "-100")); });
                                if (feeds.length) {
                                    SocialTab.LastActiveFeeds = [];
                                    if (feeds.length === 1) {
                                        feeds = feeds[0];
                                        SocialTab.LastActiveFeeds.push(feeds.Id);
                                    } else {
                                        for (var i = 0; i < feeds.length; i++) {
                                            SocialTab.LastActiveFeeds.push(feeds[i].Id);
                                        }
                                    }
                                }

                                NewsTab.Modules.SectionsManager.ChangeFeed(section.Id, feedId);
                            }
                            else {
                                if (section.Feeds.length > 1) {
                                    NewsTab.Modules.SectionsManager.ChangeFeed(section.Id, section.Feeds[1].Id);
                                }
                            }
                            if (fromSubMenu !== true) {
                                SocialTab.PostLastActiveSections(isPreview);
                            }
                            SocialTab.HTML_SetUpFeed(isPreview);
                        }

                        $(".confirmLayout.active").removeClass("active");
                        $(".layoutDetails").find(".active").removeClass("active");
                        $(".layoutDetails").find("." + (section.CurrentFeed.Layout != undefined ? section.CurrentFeed.Layout : "layout-grid")).addClass("active");
                        SocialTab.MarkActiveLayout();

                        $(".sourceItem").removeClass("selectedItem");
                        $(".sourceItem.active").addClass("selectedItem");
                        $(".sourceItem").css("border", "none");
                        $(".sourceItem.active").css("border", "2px solid " + SocialTab.LightenDarkenColor(section.Color, 70));
                        $(".loadingAnimation span.color1").css({ "background-color": section.Color });
                        $(".loadingAnimation span.color2").css({ "background-color": SocialTab.LightenDarkenColor(section.Color, 70) });
                        SocialTab.Menu_SetUpItemsTemplateMobile(section.Id);
                    }
                    else {
                        NewsTab.Modules.SectionsManager.SetCurrentSectionAndFeed(section.Id, null, true);
                    }
                }
            }
        }
    },

    SetCurrentFeed: function (listId, setupFeedList, isPreview) {
        var section = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;

        if (section !== undefined) {
            if (section.CurrentFeed) {
                Feed.Reset(section.CurrentFeed);
            }
            if (section) {
                if (section.Feeds.length === 3 && section.SectionTypeId !== Section.TYPES.Home) {
                    section.CurrentFeed = section.Feeds[2];
                } else {
                    var t = $.grep(section.Feeds, function (e) { return e.Id == listId });
                    if (t.length === 1) {
                        section.CurrentFeed = t[0];
                    } else if (section.SectionTypeId === Section.TYPES.Home) {
                        section.CurrentFeed = section.Feeds[2];
                    } else {
                        section.CurrentFeed = section.Feeds[0];
                    }
                }

                if (section.CurrentFeed.Id === "-0" && section.Feeds.length > 1) {
                    section.CurrentFeed = section.Feeds[1];
                }

                if (section.CurrentFeed.Id !== "-0") {

                    if (!NewsTab.IsExtension) {
                        if (SocialTab.CurrentState !== SocialTab.AllStates.LandingPage) {
                            SocialTab.UpdateLastActiveFeed(section.CurrentFeed.Id);
                        }

                        if (setupFeedList) {
                            SocialTab.HTML_SetUpFeedList(isPreview);
                            SocialTab.SetLastActiveFeeds();
                        }

                        $(".confirmLayout.active").removeClass("active");
                        $(".layoutDetails").find(".active").removeClass("active");
                        $(".layoutDetails").find("." + (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout != undefined ? NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout : "layout-grid")).addClass("active");
                        SocialTab.MarkActiveLayout(false);

                        if (section.SectionTypeId === Section.TYPES.Normal && section.CurrentFeed.ShowInList) {
                            $(".topFeedIndicator").show();
                            if (section.CurrentFeed.TopFeed !== true) {
                                $(".topFeedIndicator .icon-star").removeClass("gold").addClass("icon-star-o");
                                $(".topFeedIndicator").attr("data-original-title", "Star feed");
                                $(".topFeedIndicator").siblings(".tooltip").find(".tooltip-inner").text("Star feed");
                                $(".topFeedIndMenu .topFeedIndDetails p").text("Star feed");
                            } else {
                                $(".topFeedIndicator .icon-star").removeClass("icon-star-o").addClass("gold");
                                $(".topFeedIndicator").attr("data-original-title", "Unstar feed");
                                $(".topFeedIndicator").siblings(".tooltip").find(".tooltip-inner").text("Unstar feed");
                                $(".topFeedIndMenu .topFeedIndDetails p").text("Unstar feed");
                            }
                        } else {
                            $(".topFeedIndicator").hide();
                        }

                        SocialTab.Calculate_Section_ItemNumber();
                    }
                    else {
                        if (setupFeedList) {
                            NewsTab.Modules.SectionsManager.SetCurrentSectionAndFeed(section.Id, section.CurrentFeed.Id, true);
                        }
                    }
                }
            }
        }
    },

    MarkActiveLayout: function (loadMore) {
        $(".check").closest(".confirmLayout").find("input[layout-type=2]").attr("checked", true);
        $(".check").removeClass("active");
        $(".confirmLayout").find("input[type=radio]:checked").closest("div").find(".check").addClass("active");
        $(".confirmLayout").find(".save").removeClass("disabled");
        if (NewsTab.Modules.SectionsManager.CurrentSection != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout != null) {
            $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout);
        } else {
            $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass("layout-grid");
        }

        SocialTab.Calculate_Feed_BoxSizes();

        if (loadMore && $(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
            SocialTab.LoadMore();
        }
    },

    SetSectionFeedLayout: function (type, layout) {
        if (NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            SocialTab.FinishSetSectionFeedLayout(type, layout);
        }
        else {
            var callUrl = NewsTab.ApiUrl_Global + "post/layout";
            $.ajax({
                url: callUrl,
                type: "POST",
                contentType: "charset=utf-8",
                timeout: 25000,
                async: true,
                headers: {
                    Authorization: "Bearer " + NewsTab.Token,
                    "SectionId": NewsTab.Modules.SectionsManager.CurrentSection.Id,
                    "FeedId": NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id,
                    "Type": type,
                    "Layout": layout
                },
                error: function (error) {
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Title: "Change Layout",
                        Color: "red",
                        Text: "Something went wrong! Please try again!"
                    });

                    console.error("ERROR - SetSectionFeedLayout:", error);
                }
            }).then(function (response) {
                SocialTab.FinishSetSectionFeedLayout(response.LayoutType, response.Layout);
            });
        }
    },

    FinishSetSectionFeedLayout: function (type, layout) {
        NewsTab.Modules.SectionsManager.CurrentLayout = layout;
        NewsTab.Modules.SectionsManager.MAS = layout;
        if (type === SocialTab.LayoutTypes.AllFeedsAndSections) {
            $.each(NewsTab.Modules.SectionsManager.Sections, function (index, data) {
                data.Layout = layout;
                data.LayoutType = type;
                $.each(data.Feeds, function (index1, data1) {
                    data1.Layout = layout;
                    data1.LayoutType = type;
                });
            });
        } else if (type === SocialTab.LayoutTypes.CurrentSection) {
            NewsTab.Modules.SectionsManager.CurrentSection.Layout = layout;
            $.each(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (index1, data1) {
                data1.Layout = layout;
                data1.LayoutType = type;
            });
        } else if (type === SocialTab.LayoutTypes.CurrentFeed) {
            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout = layout;
            NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.LayoutType = type;
        }

        switch (layout) {
            case "layout-grid":
                $(".socialTabItem").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $(".layoutDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Grid");
                break;
            case "layout-card":
                $(".socialTabItem").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $(".layoutDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Card");
                break;
            case "layout-list":
                $(".socialTabItem").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $(".layoutDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("List");
                break;
            case "layout-compact":
                $(".socialTabItem").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass(layout);
                $(".layoutDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Compact");
                break;
            default:
                $(".socialTabItem").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass("layout-grid");
                $("body").removeClass(function (index, css) { return (css.match(/\blayout-\S+/g) || []).join(" "); }).addClass("layout-grid");
                $(".layoutDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Grid");
                break;
        }

        SocialTab.HTML_SetUpFeedList();
        NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.PageNbr = 1;
        NewsTab.Modules.SectionsManager.LoadCurrentFeed();


        $(".layoutDetails div.active").removeClass("active");
        $(".layoutDetails").find("." + layout).addClass("active");
        SocialTab.MarkActiveLayout();
    },

    /**** ADD ****/

    AddNewFilter: function (filter, setupMenuList) {
        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Name === "Twitter" });
        if (section.length > 0 && filter.length < 30) {
            section = section[0];
            var filterValue = filter.substring(1);
            var callUrl;
            if (filter[0] === "#") {
                callUrl = NewsTab.ApiUrl_Base + "api/" + section.ClassName + "/post/specialfeed/hashtag/" + section.Id + "/" + filterValue;
            } else
                callUrl = NewsTab.ApiUrl_Base + "api/" + section.ClassName + "/post/specialfeed/usertag/" + section.Id + "/" + filterValue;
        }

        $.ajax({
            url: callUrl,
            type: "POST",
            contentType: "application/json",
            headers: {
                Authorization: "Bearer " + NewsTab.Token
            },
            error: function (error) {
                console.error("ERROR - AddNewFilter:");
                console.error(error);
            }
        }).then(function (data) {
            if (data != null) {
                var feed = new Feed().NewInit(data);
                feed.SectionId = section.Id;
                section.Feeds.push(feed);
                if (setupMenuList) {
                    SocialTab.SetCurrentFeed(section.Feeds[section.Feeds.length - 1].Id, true);
                    if (filter[0] === "#") {
                        NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                            Title: "New Twitter feed",
                            Color: "green",
                            Text: "New Hashtag Feed added to Twitter!"
                        });
                    }
                    else {
                        NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                            Title: "New Twitter feed",
                            Color: "green",
                            Text: "New User Feed added to Twitter!"
                        });
                    }
                }
            }
        });
    },

    AddNewFilterFromPreview: function (filter) {
        parent.jQuery.fancybox.close();

        var isHashtag = filter.substr(0, 1) == "#" ? true : false;
        if (isHashtag) {
            $(".searchTagResultHash li[data-value=" + filter.substr(1) + "]").addClass("selected");
        }
        else {
            $(".searchTagResultUser li[data-value=" + filter.substr(1) + "]").addClass("selected");
        }

        $(".searchTagResult").height($(".searchTagResult").height() - 50);
        $("#addTwitterFeedBtnField").show();
    },

    /**** REMOVE / DELETE  ****/

    RemoveFeedFromSection: function (topicId, sourceId, dontOpenFeed) {
        if (NewsTab.Token) {
            var callUrl = NewsTab.ApiUrl_Rss + "RemoveFeedFromSection";
            $.ajax({
                url: callUrl,
                contentType: "charset=utf-8",
                type: "POST",
                headers: { Authorization: 'Bearer ' + NewsTab.Token, 'SectionId': topicId, 'FeedId': sourceId },
                error: function (error) {
                    console.error("ERROR - RemoveFeedFromSection:");
                    console.error(error);
                }
            }).then(function (data) {
                if (data === true) {
                    var topic = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === topicId });
                    if (topic.length > 0) {
                        topic = topic[0];

                        var source = $.grep(topic.Feeds, function (e) { return e.Id === sourceId });
                        if (source.length > 0) {
                            source = source[0];

                            NewsTab.Helpers.RemoveItemFromArray(topic.Feeds, source);

                            if (topic.DefaultFeed.Id === source.Id) {
                                if (topic.Feeds.length > 1) {
                                    topic.DefaultFeed = topic.Feeds[1];
                                } else {
                                    topic.DefaultFeed = topic.Feeds[0];
                                }
                            }
                            if (topic.CurrentFeed.Id === source.Id) {
                                if (topic.Feeds.length > 1) {
                                    SocialTab.SetCurrentFeed(topic.Feeds[1].Id, true);
                                } else {
                                    SocialTab.SetCurrentFeed(topic.DefaultFeed.Id, true);
                                }
                            }
                        }

                        topic.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                        var j = 0;
                        for (var i = 0, len = topic.Feeds.length; i < len; i++) {
                            var order = topic.Feeds[i].OrderNumber;
                            if (parseFloat(order) < 0) {
                                topic.Feeds[i].OrderNumber = order;
                            } else {
                                topic.Feeds[i].OrderNumber = j;
                                j++;
                            }
                        }
                    }
                    if (!dontOpenFeed) {
                        SocialTab.HTML_SetUpFeedList(false);
                    }
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                }
                if (!dontOpenFeed) {
                    if ($("#doubleModal").length === 1) {
                        $("#doubleModal").remove();
                    }
                    else {
                        $.modal.impl.close();
                    }
                }
            });
        }
    },

    RemoveSpecialFeed: function (sectionId, feedId) {
        if (NewsTab.Token) {
            var callUrl = NewsTab.ApiUrl_Global + "delete/specialfeed/" + sectionId + "/" + feedId;
            $.ajax({
                url: callUrl,
                contentType: "application/json",
                type: "DELETE",
                headers: { Authorization: 'Bearer ' + NewsTab.Token },
                error: function (error) {
                    console.error("ERROR - RemoveFeedFromSection:");
                    console.error(error);
                }
            }).then(function (data) {

                if (data === true) {
                    var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === sectionId });
                    if (section.length > 0) {
                        section = section[0];

                        var feed = $.grep(section.Feeds, function (e) { return e.Id === feedId });
                        if (feed.length > 0) {
                            feed = feed[0];

                            NewsTab.Helpers.RemoveItemFromArray(section.Feeds, feed);

                            if (section.DefaultFeed.Id === feed.Id) {
                                if (section.Feeds.length > 1) {
                                    section.DefaultFeed = section.Feeds[1];
                                } else {
                                    section.DefaultFeed = section.Feeds[0];
                                }
                            }
                            if (section.CurrentFeed.Id === feed.Id) {
                                if (section.Feeds.length > 1) {
                                    section.Feeds[1].ShowInList = true;
                                    SocialTab.SetCurrentFeed(section.Feeds[1].Id, true);
                                } else {
                                    section.DefaultFeed.ShowInList = true;
                                    SocialTab.SetCurrentFeed(section.DefaultFeed.Id, true);
                                }
                                NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists, NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id);
                                localStorage.setItem("ST_" + NewsTab.User.Id + "_" + NewsTab.Modules.SectionsManager.CurrentSection.Name + "_HiddenLists", JSON.stringify(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists));
                            }
                        }

                        section.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                        var j = 0;
                        for (var i = 0, len = section.Feeds.length; i < len; i++) {
                            var order = section.Feeds[i].OrderNumber;
                            if (parseFloat(order) < 0) {
                                section.Feeds[i].OrderNumber = order;
                            } else {
                                section.Feeds[i].OrderNumber = j;
                                j++;
                            }
                        }
                    }
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                }
                if ($("#doubleModal").length === 1) {
                    $("#doubleModal").remove();
                }
                else {
                    $.modal.impl.close();
                }
            });
        }
    },

    DeleteUserAccount: function () {
        var callUrl = NewsTab.ApiUrl_Global + "delete/user";
        $.ajax({
            url: callUrl,
            type: 'DELETE',
            contentType: "charset=utf-8",
            timeout: 25000,
            headers: { Authorization: 'Bearer ' + NewsTab.Token },
            error: function (error) {
                console.error("ERROR - DeleteUserAccount:");
                console.error(error);
            }
        }).then(function (data) {
            if (data === true) {
                NewsTab.Helpers.EraseCookie("TokenKey");
                localStorage.removeItem("TokenKey");
                Object.keys(localStorage).forEach(function (key) {
                    var re = new RegExp("^ST_" + NewsTab.User.Id + "_");
                    if (re.test(key)) {
                        localStorage.removeItem(key);
                    }
                });
                window.location.assign("/");
            } else {
                alert("Delete User Account - Failed");
            }
        });
    },

    PostLastActiveSections: function (isPreview, numberOfVisibleSections) {
        if (SocialTab.LastActiveSections != null && NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            numberOfVisibleSections = numberOfVisibleSections != undefined ? numberOfVisibleSections : SocialTab.NumberOfVisibleSections;
            var currentSection = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;

            SocialTab.SetActiveSectionFirst(currentSection, numberOfVisibleSections);

            var storageLastActiveSections = JSON.stringify(SocialTab.LastActiveSections);
            var isSame = (storageLastActiveSections != null && storageLastActiveSections.length === SocialTab.LastActiveSections.length) && storageLastActiveSections.every(function (element, index) {
                return element === SocialTab.LastActiveSections[index];
            });

            if (!isSame || (SocialTab.LastActiveSections.indexOf(currentSection.Id) < 0 && currentSection.ShowInSourceList === true)) {
                if (SocialTab.UpdateSectionsOrderXhr && SocialTab.UpdateSectionsOrderXhr.readystate !== 4) {
                    SocialTab.UpdateSectionsOrderXhr.abort();
                }

                var callUrl = NewsTab.ApiUrl_Global + "post/sections/order";
                SocialTab.UpdateSectionsOrderXhr = $.ajax({
                    url: callUrl,
                    data: JSON.stringify({ items: SocialTab.LastActiveSections }),
                    headers: {
                        Authorization: "Bearer " + NewsTab.Token
                    },
                    type: "POST",
                    contentType: "application/json",
                    dataType: "json",
                    processdata: true,
                    error: function (error) {
                        console.error("ERROR - OrderSections:");
                        console.error(error);
                    }
                });

                SocialTab.Calculate_Section_ItemNumber(isPreview);
            }
        } else {
            this.LastActiveSections = [];
        }
    },

    RenameFeed: function (topicId, sourceId) {
        var name = $("#editName_" + sourceId).val();
        var top = $(".newItem.modular .icon-star").hasClass("gold") ? true : false;

        if (name.length > 350) {
            NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                Title: "Rename Feed",
                Color: "red",
                Text: "Feed name is too long."
            });
        }

        if (name.length > 0) {
            var callUrl = NewsTab.ApiUrl_Rss + "RenameFeed?sectionId=" + topicId + "&feedId=" + sourceId + "&name=" + encodeURIComponent(name.trim()) + "&top=" + top;

            $.ajax({
                url: callUrl,
                contentType: "application/x-www-form-urlencoded;charset=ISO-8859-15",
                type: "POST",
                headers: {
                    Authorization: 'Bearer ' + NewsTab.Token
                },
                error: function (error) {
                    console.error("ERROR - RenameFeed:");
                    console.error(error);
                }
            }).then(function (data) {
                if (data.Success) {
                    var topic = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Id === topicId });
                    if (topic.length > 0) {
                        topic = topic[0];

                        var source = $.grep(topic.Feeds, function (e) { return e.Id === sourceId });
                        if (source.length > 0) {
                            source = source[0];
                            source.Name = name;
                        }
                    }
                    SocialTab.UpdateTopFeed(data.TopFeeds);
                    NewsTab.Modules.AddNewContent.Setup_SectionsInOrganizer();
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                }
                if ($("#doubleModal").length === 1) {
                    $("#doubleModal").remove();
                }
                else {
                    $.modal.impl.close();
                }
            });
        }
    },

    SetAsRead: function (id, setAsRead) {
        var article = $.grep(NewsTab.Modules.ArticleView.ListedArticles, function (e) { return e.Id === id });
        if (article.length > 0) {
            article = article[0];
            var asread = $.grep(this.ReadItems, function (e) { return e === article.Alias });

            var obj = $(".socialTabItem[data-article-id=" + article.Id + "]").first();

            if (asread.length > 0) {
                if (!setAsRead) {
                    NewsTab.Helpers.RemoveItemFromArray(this.ReadItems, article.Alias);
                    obj.removeClass("readX");
                    obj.find(".icon-markasread").attr("data-original-title", "Mark as read");
                    obj.find(".tooltip-inner").text("Mark as read");
                    if (NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
                        var callUrl = NewsTab.ApiUrl_Global + "delete/read/" + article.Alias;
                        $.ajax({
                            url: callUrl,
                            type: "DELETE",
                            contentType: "application/json",
                            dataType: "json",
                            headers: { Authorization: 'Bearer ' + NewsTab.Token },
                            error: function (error) {
                                console.error("ERROR - SetAsRead:");
                                console.error(error);
                            }
                        });
                    }
                }
            } else {
                this.ReadItems.push(article.Alias);
                obj.addClass("readX");
                obj.find(".icon-markasread").attr("data-original-title", "Mark as unread");
                obj.find(".tooltip-inner").text("Mark as unread");
                if (NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
                    var callUrl = NewsTab.ApiUrl_Global + "post/read/" + article.Alias + "/" + article.SourceFeedId;
                    $.ajax({
                        url: callUrl,
                        type: "POST",
                        contentType: "application/json",
                        dataType: "json",
                        headers: { Authorization: 'Bearer ' + NewsTab.Token },
                        error: function (error) {
                            console.error("ERROR - SetAsRead:");
                            console.error(error);
                        }
                    }).then(function () {
                        SocialTab.UpdateUsageCount({ Id: article.SourceFeedId }, 0.5);
                    });
                }
            }

            localStorage.setItem("ST_" + NewsTab.User.Id + "_ReadItems", JSON.stringify(this.ReadItems));
        }
    },

    OpenOriginalView: function (id, url) {
        window.open(url, '_blank');
        SocialTab.SetAsRead(id, true);
    },

    ShowFeedDescriptionDetails: function (sender) {
        $("div.desc").hide();
        if (!$(sender).hasClass("active")) {
            $(".expandDetails").find(".active").removeClass("active");
            $(".expandDetails").removeClass("expandDetails");
            $(sender).addClass("active").addClass("expandDetails");
            $(sender).closest(".socialTabItem").addClass("expandDetails");
            $(sender).closest(".socialTabItem").find("div.desc").show();
        } else {
            $(sender).removeClass("active").removeClass("expandDetails");
            $(sender).closest(".socialTabItem").removeClass("expandDetails");
        }
    },
    /**** SET ****/

    Set_AppSetings_LightTheme: function (useLightTheme, save) {
        SocialTab.AppSettings.LightTheme = useLightTheme;
        if (useLightTheme) {
            $("body").addClass("light");
            $(".themeDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Light");
        } else {
            $("body").removeClass("light");
            $(".themeDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Dark");
        }

        if (save) {
            SocialTab.HTML_SaveUserSettings("LightTheme", SocialTab.AppSettings.LightTheme);
        }

        SocialTab.Feed_UpdateHTML_ItemSize();

        NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveBoxSize");
        NewsTab.Modules.ArticleView.ItemSettings.ActiveFontSize = localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveFontSize");
        SocialTab.Set_FeedItemSettings_ActiveBoxSize(NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize != undefined ? NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize : null);
        SocialTab.Set_AppSettings_ActiveFontSize(NewsTab.Modules.ArticleView.ItemSettings.ActiveFontSize != undefined ? NewsTab.Modules.ArticleView.ItemSettings.ActiveFontSize : 2);
    },

    Set_AppSetings_TopBar: function (useFixed, save) {
        SocialTab.AppSettings.TopBarFixed = useFixed;
        if (useFixed) {
            $(".topBarDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Fixed");
        } else {
            $(".topBarDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Responsive");
        }
        if (save) {
            SocialTab.HTML_SaveUserSettings("TopBarFixed", SocialTab.AppSettings.TopBarFixed);
        }
    },

    Set_AppSetings_BorderSytle: function (border, save) {
        SocialTab.AppSettings.BorderStyle = border;
        if (save) {
            SocialTab.HTML_SaveUserSettings("BorderStyle", SocialTab.AppSettings.BorderStyle);
        }
        switch (border) {
            case "border-contrast":
                $("body").removeClass(function (index, css) { return (css.match(/\bborder-\S+/g) || []).join(" "); }).addClass(border);
                $(".borderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Contrast");
                break;
            case "border-colored":
                $("body").removeClass(function (index, css) { return (css.match(/\bborder-\S+/g) || []).join(" "); }).addClass(border);
                $(".borderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("Colored");
                break;
            case "border-none":
                $("body").removeClass(function (index, css) { return (css.match(/\bborder-\S+/g) || []).join(" "); }).addClass(border);
                $(".borderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("None");
                break;
            default:
                $("body").removeClass(function (index, css) { return (css.match(/\bborder-\S+/g) || []).join(" "); }).addClass("border-none");
                $(".borderDetails").closest(".settingsDetailsItem").find(".menuItemSelected").text("None");
                SocialTab.AppSettings.BorderStyle = "border-none";
                if (save) {
                    SocialTab.HTML_SaveUserSettings("BorderStyle", SocialTab.AppSettings.BorderStyle);
                }
                break;
        }
        SocialTab.Menu_SetUpHTML_SubmenuList();
    },

    Set_FeedItemSettings_ActiveBoxSize: function (size) {
        NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = parseInt(size);
        $("body").removeClass("grid-size-0");
        $("body").removeClass("grid-size-1");
        $("body").removeClass("grid-size-2");
        $("body").removeClass("grid-size-3");
        $("body").removeClass("grid-size-4");
        $("body").removeClass("grid-size-5");
        $("body").removeClass("grid-size-6");
        $("body").addClass("grid-size-" + NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize);

        SocialTab.Calculate_Feed_BoxSizes();
        SocialTab.Feed_UpdateHTML_ItemSize();

        if (NewsTab.User != null) {
            localStorage.setItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveBoxSize", NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize);
        }

        if (NewsTab.Modules.SectionsManager.CurrentSection != undefined && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != undefined) {
            if ($(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                SocialTab.LoadMore();
            }
        }

        if ($(window).width() > 800) {
            SocialTab.Calculate_Section_ItemNumber();
        }
    },

    Set_AppSettings_ActiveFontSize: function (size) {
        SocialTab.AppSettings.ActiveFontSize = parseInt(size);
        $("body").removeClass("font-size-0");
        $("body").removeClass("font-size-1");
        $("body").removeClass("font-size-2");
        $("body").removeClass("font-size-3");
        $("body").removeClass("font-size-4");
        $("body").addClass("font-size-" + SocialTab.AppSettings.ActiveFontSize);

        if (NewsTab.User != null) {
            localStorage.setItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveFontSize", SocialTab.AppSettings.ActiveFontSize);
        }
    },

    Set_AppSettings_ActiveLayout: function () {
        if (NewsTab.Modules.SectionsManager.CurrentSection != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout != null) {
            $("body").addClass(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout);
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (f) { return f.LayoutType === 0 });
            if (section.length) {
                section = section[0];
                localStorage.setItem("ST_" + NewsTab.User.Id + "_Settings_DefaultLayoutType", section.Layout != undefined ? section.Layout : "layout-grid");
            }
        } else {
            $("body").addClass("layout-grid");
            localStorage.setItem("ST_" + NewsTab.User.Id + "_Settings_DefaultLayoutType", "layout-grid");
        }
    },

    /**** Calculations ****/

    GetPopularityLevelOfFeed: function (feed) {
        var lvl = 0;

        if (feed.Retweets) {
            lvl += feed.Retweets.Count < 5 ? 0 : feed.Retweets.Count < 20 ? 1 : feed.Retweets.Count < 60 ? 2 : 3;
        }
        if (feed.Favorites) {
            lvl += feed.Favorites.Count < 10 ? 0 : feed.Favorites.Count < 40 ? 1 : feed.Favorites.Count < 300 ? 2 : 3;
        }
        if (feed.Comments) {
            lvl += feed.Comments.Count < 5 ? 0 : feed.Comments.Count < 20 ? 1 : feed.Comments.Count < 60 ? 2 : 3;
        }
        if (feed.Likes) {
            lvl += feed.Likes.Count < 20 ? 0 : feed.Likes.Count < 100 ? 1 : feed.Likes.Count < 500 ? 2 : 3;
        }
        return lvl;
    },

    Calculate_Section_ItemNumber: function (isPreview) {
        SocialTab.ResizeElement();
        if ($("#lastActiveConnectors").resizable("instance") == undefined) return;

        var numberOfSections = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.ShowInSourceList; }).length;
        if (numberOfSections === 0) {
            SocialTab.NumberOfVisibleSections = 5;
            $("#lastActiveConnectors").width(numberOfSections * 44);
            SocialTab.HTML_SaveUserSettings("NumberOfVisibleSections", SocialTab.NumberOfVisibleSections);
        } else {
            if (numberOfSections <= 5) {
                SocialTab.NumberOfVisibleSections = 5;
            }
            if (SocialTab.NumberOfVisibleSections > numberOfSections) {
                SocialTab.NumberOfVisibleSections = numberOfSections;
            }
            $("#lastActiveConnectors").width(SocialTab.NumberOfVisibleSections * 44);
        }

        var width = $("#dashboardGridBody").width();
        var newNumberOfVisibleSections = parseInt((width - 600) / 44);
        if ($("body").width() <= 1000 && $("body").width() > 950) {
            newNumberOfVisibleSections = parseInt((width - 550) / 44);
        } else if ($("body").width() <= 950 && $("body").width() > 800) {
            newNumberOfVisibleSections = parseInt((width - 450) / 44);
        }

        if (NewsTab.Modules.SectionsManager.CurrentSection != undefined && NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Normal && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.ShowInList) {
            newNumberOfVisibleSections = parseInt((width - 640) / 44);
            if ($("body").width() <= 1000 && $("body").width() > 950) {
                newNumberOfVisibleSections = parseInt((width - 630) / 44);
            } else if ($("body").width() <= 950 && $("body").width() > 800) {
                newNumberOfVisibleSections = parseInt((width - 500) / 44);
            }
        }

        if (newNumberOfVisibleSections > -1 && newNumberOfVisibleSections <= SocialTab.NumberOfVisibleSections) {
            SocialTab.HTML_UpdateLastActiveSections(isPreview, newNumberOfVisibleSections);
            $("#lastActiveConnectors").width(newNumberOfVisibleSections * 44);
        } else {
            SocialTab.HTML_UpdateLastActiveSections(isPreview);
            $("#lastActiveConnectors").width(SocialTab.NumberOfVisibleSections * 44);
        }

        NewsTab.Helpers.CenterContent($(".confirmationMessage"), false);
    },

    Calculate_Feed_ItemNumber: function () {
        var width = $("body").width();
        if (width >= 300 && width < 520) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 1;
        } else if (width >= 520 && width < 770) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 2;
        } else if (width >= 770 && width < 1021) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 3;
        } else if (width >= 1021 && width < 1400) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 4;
        } else if (width >= 1400 && width < 1921) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 5;
        } else if (width >= 1921 && width < 2550) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 6;
        } else if (width >= 2550 && width < 3020) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 7;
        } else if (width >= 3020 && width < 3700) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 8;
        } else if (width >= 3700) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = 9;
        }
    },

    Calculate_Feed_ItemSize: function () {
        SocialTab.Calculate_Feed_ItemNumber();

        var width = $("body").width() - 20;

        var gridSizes = [];
        $.each(NewsTab.Modules.ArticleView.ItemSettings.BoxSizes, function (i, n) {
            var gridSize = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes[i] * NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize;
            if (width >= gridSize) {
                gridSizes.push(gridSize);
            }
        });

        var dashboardGridWidth = NewsTab.Helpers.FindClosestItem(gridSizes, width);
        NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize = dashboardGridWidth / NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize;

        $("#dashboardGridBody").width(dashboardGridWidth);
        $("#dashboardGridBody .socialTabHeader").width(dashboardGridWidth);
        $(".dashboardGrid").width(dashboardGridWidth);

        SocialTab.Set_FeedItemSettings_ActiveBoxSize(NewsTab.Modules.ArticleView.ItemSettings.BoxSizes.indexOf(NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize));

        if (document.getElementById('gridSize').noUiSlider != undefined) {
            document.getElementById('gridSize').noUiSlider.set(NewsTab.Modules.ArticleView.ItemSettings.BoxSizes.indexOf(NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize));
        }

        $("body").removeClass(function (index, css) { return (css.match(/\bsize-\S+/g) || []).join(" "); }).addClass("size-" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize);

        NewsTab.Helpers.CenterContent($(".confirmationMessage"), false);
    },

    Calculate_Feed_BoxSizes: function () {
        NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize = NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize;
        NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes[NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize];

        $("body").removeClass(function (index, css) { return (css.match(/\bsize-\S+/g) || []).join(" "); }).addClass("size-" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize);

        var actualSize = NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize;
        var posibleNumberOfIments = parseInt(($("body").width() - 20) / actualSize, 10);
        var width = actualSize * posibleNumberOfIments;

        $("#dashboardGridBody").width(width);
        $("#dashboardGridBody .socialTabHeader").width(width);
        $(".dashboardGrid").width(width);
    },

    Calculate_FeedPreview_ItemNumber: function () {
        var width = $(".feedPreview:visible").width();
        if (width >= 300 && width < 520) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 1;
        } else if (width >= 520 && width < 770) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 2;
        } else if (width >= 770 && width < 1021) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 3;
        } else if (width >= 1021 && width < 1400) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 4;
        } else if (width >= 1400 && width < 1921) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 5;
        } else if (width >= 1921 && width < 2550) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 6;
        } else if (width >= 2550 && width < 3020) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 7;
        } else if (width >= 3020 && width < 3700) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 8;
        } else if (width >= 3700) {
            NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = 9;
        }
    },

    Calculate_FeedPrevirew_ItemSize: function () {
        SocialTab.Calculate_FeedPreview_ItemNumber();

        var width = $(".feedPreview:visible").width();

        var gridSizes = [];
        $.each(NewsTab.Modules.ArticleView.ItemSettings.BoxSizes, function (i, n) {
            var gridSize = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes[i] * NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview;
            if (width >= gridSize) {
                gridSizes.push(gridSize);
            }
        });

        var feedGridWidth = NewsTab.Helpers.FindClosestItem(gridSizes, width);
        NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview = feedGridWidth / NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview;
        $(".feedPreview:visible").removeClass("grid-size-0");
        $(".feedPreview:visible").removeClass("grid-size-1");
        $(".feedPreview:visible").removeClass("grid-size-2");
        $(".feedPreview:visible").removeClass("grid-size-3");
        $(".feedPreview:visible").removeClass("grid-size-4");
        $(".feedPreview:visible").removeClass("grid-size-5");
        $(".feedPreview:visible").removeClass("grid-size-6");
        $(".feedPreview:visible").addClass("grid-size-" + NewsTab.Modules.ArticleView.ItemSettings.BoxSizes.indexOf(NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview));

        $(".feedPreview:visible .feedPreviewBody").width(feedGridWidth);
        $(".feedPreview:visible .feedsPage").width(feedGridWidth + 30);

        NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes.indexOf(NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview);

        SocialTab.Calculate_FeedPreview_BoxSizes();
        SocialTab.Feed_UpdateHTML_ItemSize(true);

        $(".feedPreview:visible").removeClass(function (index, css) { return (css.match(/\bsize-\S+/g) || []).join(" "); }).addClass("size-" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview);
    },

    Calculate_FeedPreview_BoxSizes: function () {
        NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview = NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview;
        NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview = NewsTab.Modules.ArticleView.ItemSettings.BoxSizes[NewsTab.Modules.ArticleView.ItemSettings.ActiveBoxSize_Preview];

        $(".feedPreview:visible").removeClass(function (index, css) { return (css.match(/\bsize-\S+/g) || []).join(" "); }).addClass("size-" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview);

        var actualSize = NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview;
        var posibleNumberOfIments = parseInt(($(".feedPreview:visible").width()) / actualSize, 10);
        var width = actualSize * posibleNumberOfIments;

        $(".feedPreview:visible .feedPreviewBody").width(width);
        $(".feedPreview:visible .feedsPage").width(width + 30);
    },

    /**** HTML NEW >= 07.05.2015 ****/

    Feed_SetUpHTML_Items: function (articles, insertAtBeginning, isPreview) {
        var counter = 0;
        var item;
        var placeholder;
        articles.forEach(function (article) {
            if (isPreview) {
                item = $(".feedPreview").find(".socialTabItem[data-article-id=" + article.Id + "]");
                if (item.length) {
                    counter++;
                } else {
                    placeholder = $(".feedPreview").find(".socialTabItem.empty:first");
                    SocialTab.Feed_SetUpHTML_PlaceholderItem(placeholder, article, articles.length, counter, insertAtBeginning, isPreview);
                }
            } else {
                var a = $.grep(NewsTab.Modules.ArticleView.ListedArticles, function (f) { return f.Alias === article.Alias });
                if (a.length === 0) {
                    NewsTab.Modules.ArticleView.ListedArticles.push(article);
                    item = $(".socialTabItem[data-article-id=" + article.Id + "]");
                    if (item.length) {
                        counter++;
                    } else {
                        placeholder = $(".socialTabItem.empty:first");
                        SocialTab.Feed_SetUpHTML_PlaceholderItem(placeholder, article, articles.length, counter, insertAtBeginning, isPreview);
                    }
                }
            }
        });

        SocialTab.ClearPlaceholders();
        CheckItemSize(true);

        SocialTab.GridItemFocusEvent();
    },

    Feed_SetUpHTML_PlaceholderItem: function (placeholder, article, length, counter, insertAtBeginning, isPreview) {
        var gridSize = document.getElementById('gridSize');
        var settings = isPreview === true ? NewsTab.Modules.ArticleView.PREVIEW_SETTINGS : NewsTab.Modules.ArticleView.DEFAULT_SETTINGS;
        settings = $.extend({}, settings, {
            Layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
            InsertAtBeginning: insertAtBeginning
        });
        var destFeed = NewsTab.Modules.SectionsManager.GetFeedById(article.DestinationFeedId, null, true);

        if (placeholder.length) {
            counter++;
            if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-list") {
                NewsTab.Modules.ArticleView.SetUp_ListPreviewItem(destFeed, article, settings);
                if (gridSize != undefined) {
                    gridSize.setAttribute('disabled', true);
                }
            } else if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-compact") {
                NewsTab.Modules.ArticleView.SetUp_CompactPreviewItem(destFeed, article, settings);
                if (gridSize != undefined) {
                    gridSize.setAttribute('disabled', true);
                }
            } else {
                NewsTab.Modules.ArticleView.SetUp_GridPreviewItem(destFeed, article, settings);
                if (gridSize != undefined) {
                    gridSize.removeAttribute('disabled');
                }
            }
        } else {
            if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-list") {
                if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(length - counter, settings)) {
                    $("#magicGrid").css("padding-right", 0);
                    this.HTML_InitialScroller(0, isPreview);
                }
                NewsTab.Modules.ArticleView.SetUp_ListPreviewItem(destFeed, article, settings);
                if (gridSize != undefined) {
                    gridSize.setAttribute('disabled', true);
                }
            } else if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-compact") {
                if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(length - counter, settings)) {
                    $("#magicGrid").css("padding-right", 0);
                    this.HTML_InitialScroller(0, isPreview);
                }
                NewsTab.Modules.ArticleView.SetUp_CompactPreviewItem(destFeed, article, settings);
                if (gridSize != undefined) {
                    gridSize.setAttribute('disabled', true);
                }
            } else {
                if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(length - counter, settings)) {
                    this.HTML_InitialScroller(0, isPreview);
                }
                NewsTab.Modules.ArticleView.SetUp_GridPreviewItem(destFeed, article, settings);
                if (gridSize != undefined) {
                    gridSize.setAttribute('disabled', true);
                }
            }
        }
    },

    Feed_SetUpEmptyHTML_Items: function (insertAtBeginning, isPreview) {
        var counter = 0;
        var numberOfItems = isPreview ? 10 : 9;
        var settings = isPreview === true ? NewsTab.Modules.ArticleView.PREVIEW_SETTINGS : NewsTab.Modules.ArticleView.DEFAULT_SETTINGS;
        for (var i = 0; i < numberOfItems; i++) {
            var placeholder = isPreview ? $(".feedPreview").find(".socialTabItem.empty:first") : $(".socialTabItem.empty:first");

            if (placeholder.length) {
                counter++;
                placeholder.removeClass("empty");
                placeholder.addClass("rss");
            } else {
                if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-list") {
                    if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(settings, {
                        layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                        numberOfPlaceHolder: numberOfItems - counter,
                        insertAtBeginning: insertAtBeginning
                    })) {
                        $("#magicGrid").css("padding-right", 0);
                        this.HTML_InitialScroller(0, isPreview);
                    }
                } else if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != null && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-compact") {
                    if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(settings, {
                        layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                        numberOfPlaceHolder: numberOfItems - counter,
                        insertAtBeginning: insertAtBeginning
                    })) {
                        $("#magicGrid").css("padding-right", 0);
                        this.HTML_InitialScroller(0, isPreview);
                    }
                } else {
                    if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(settings, {
                        layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout,
                        numberOfPlaceHolder: numberOfItems - counter,
                        insertAtBeginning: insertAtBeginning
                    })) {
                        this.HTML_InitialScroller(0, isPreview);
                    }
                }
                placeholder.removeClass("empty");
                placeholder.addClass("rss");
            }
        }
        $(".loadingAnimation").removeClass("loading");
        this.ClearPlaceholders();
        CheckItemSize(true);
    },

    Feed_SetUpHTML_Item_FullScreenImage: function (sender, id) {
        var src = "<div><img src=\"" + $(sender).attr("src") + "\" /></div>";

        $.fancybox(src,
            {
                maxWidth: SocialTab.AppSettings.FormMaxWidth,
                scrolling: "no",
                fitToView: true,
                autoSize: true,
                margin: [0, 0, 0, 0]
            }
        );
    },

    ImgError: function (sender) {
        $(sender).remove();
    },

    Set_Layout: function (layoutMode, type) {
        switch (type) {
            case SocialTab.LayoutTypes.AllFeedsAndSections:
                SocialTab.SetSectionFeedLayout(type, layoutMode);
                localStorage.setItem("ST_" + NewsTab.User.Id + "_Settings_DefaultLayoutType", layoutMode);
                break;
            case SocialTab.LayoutTypes.CurrentSection:
                SocialTab.SetSectionFeedLayout(type, layoutMode);
                break;
            case SocialTab.LayoutTypes.CurrentFeed:
                SocialTab.SetSectionFeedLayout(type, layoutMode);
                break;
            default:
                break;
        }
    },

    Feed_UpdateHTML_ItemSize: function (isPreview) {
        if (isPreview) {
            if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout !== "layout-list" && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout !== "layout-compact") {
                $("#feedPreview .socialTabItem").attr("style", "width:" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview +
                    "px!important; height:0; padding-bottom:" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize_Preview + "px!important;");
            }
        } else {
            if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout !== "layout-list" && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout !== "layout-compact") {
                $(".dashboardGrid #magicGrid .socialTabItem").attr("style", "width:" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize +
                    "px!important; height:0; padding-bottom:" + NewsTab.Modules.ArticleView.ItemSettings.ActualBoxSize + "px!important;");
            }
            $(".dashboardGrid #magicGrid").css("border", "none");
        }
    },

    /**** Menu ****/

    LightenDarkenColor: function (col, amt) {
        var usePound = false;
        if (col[0] == "#") {
            col = col.slice(1);
            usePound = true;
        }
        var num = parseInt(col, 16);
        var r = (num >> 16) + amt;
        if (r > 255) r = 255;
        else if (r < 0) r = 0;
        var b = ((num >> 8) & 0x00FF) + amt;
        if (b > 255) b = 255;
        else if (b < 0) b = 0;
        var g = (num & 0x0000FF) + amt;
        if (g > 255) g = 255;
        else if (g < 0) g = 0;
        return (usePound ? "#" : "") + (g | (b << 8) | (r << 16)).toString(16);
    },

    ParseDate: function (date) {
        return date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds() + "." + date.getMilliseconds();
    },

    TimeDiff: function (time1, time2) {
        if (time1 != undefined && time2 != undefined) {
            return (time1.getTime() - time2.getTime()) / 1000;
        }
        return 0;
    },

    Menu_AttacheEventHandlers: function () {
        $("body").on("click", ".doubleModal-close", function (e) {
            e.preventDefault();
            $("#doubleModal").remove();
        });

        // Change the ListShowing on Dashboard 
        $(".socialTabHeader").on("click", ".sourceItemSubmenu li.menuItem", function () {
            $(".updateTopFeeds").closest(".mbBalloon").removeClass("importatShow");
            SocialTab.ShowUpdateTooltip = false;
            $(".defaultFeed").hideBalloon();
            $(this).closest(".dropdown").removeClass("open"); // close the dropedown menu
            $(".confirmLayout").removeClass("active");
            var fId = $(this).data("feed-id"); // get the list id from the selected item
            var sId = $(".sourceItemSelectedList").find(".lastActiveItemsConteinerName").data("section-id"); // get the source id from the selected item
            //SocialTab.SelectCurrentFeed(selectedSource, selectedList);
            NewsTab.Modules.SectionsManager.ChangeFeed(sId, fId);
        });

        $(".socialTabHeader").on("click", ".sourceItemSubmenu li.menuSubItems", function () {
            $(this).closest(".dropdown").removeClass("open"); // close the dropedown menu
            var selectedList = $(this).data("feed-id"); // get the list id from the selected item
            var selectedSource = $(".sourceItemSelectedList").find(".lastActiveItemsConteinerName").data("section-id"); // get the source id from the selected item
            SocialTab.SetCurrentState(SocialTab.AllStates.Feeds);
            SocialTab.SetCurrentSection(selectedSource, true, false);
            SocialTab.SetCurrentFeed(selectedList, true);
        });

        $(".socialTabHeader").on("click", ".deleteSpecialFeed", function (e) {
            e.stopPropagation();
            var self = $(this);
            var id = self.attr("data-item");
            var sectionId = self.attr("data-section-id");
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var positionLeft = self.position().left - 162;
            if ($("body").width() <= 800) {
                positionLeft = 40;
            }

            var html = "<div class=\"customDropdown\" style=\"left: " + positionLeft + "px !important;\">" +
                "<ul data-item=\"" + id + "\" data-section-id=\"" + sectionId + "\">" +
                "<li class=\"hideSpecialFeedClick\">Hide</li>" +
                "<li class=\"deleteSpecialFeedClick\">Remove</li>" +
                "</ul>" +
                "</div>";

            $(this).parent().append(html);

        });

        $("body, .socialTabHeader").on("click", ".deleteSpecialFeedClick", function (e) {
            e.stopPropagation();
            $(this).closest(".customDropdown").remove();

            var sectionId = $(this).parent().attr("data-section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }

            var id = $(this).parent().attr("data-item");

            var feed = $.grep(section.Feeds, function (e) { return e.Id === id });
            if (feed.length === 1) {
                feed = feed[0];
                SocialTab.Notification_SetUpHTML_OkCancel("Remove " + feed.Name, "You can always get it back from the \"+\" button on the feed bar.", "Remove", "Cancel", function () {
                    $(".notification-modal").addClass("disabled");
                    $(".notification-modal .ok").html("<i class=\"icon\"><span class=\"spinner\"></span></i>Removing...");
                    return SocialTab.RemoveSpecialFeed(NewsTab.Modules.SectionsManager.CurrentSection.Id, feed.Id);
                });
            }
        });

        $(".socialTabHeader").on("click", ".hideSpecialFeed", function (e) {
            e.stopPropagation();
            var self = $(this);
            var id = self.attr("data-item");
            var sectionId = self.attr("data-section-id");
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var positionLeft = self.position().left - 162;
            if ($("body").width() <= 800) {
                positionLeft = 40;
            }

            var html = "<div class=\"customDropdown\" style=\"left: " + positionLeft + "px !important;\">" +
                "<ul data-item=\"" + id + "\" data-section-id=\"" + sectionId + "\">" +
                "<li class=\"hideSpecialFeedClick\">Hide</li>" +
                "</ul>" +
                "</div>";

            $(this).parent().append(html);
        });

        $("body, .socialTabHeader").on("click", ".hideSpecialFeedClick", function (e) {
            e.stopPropagation();
            $(this).closest(".customDropdown").remove();
            var sectionId = $(this).parent().attr("data-section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }
            var id = $(this).parent().attr("data-item");
            var feed = $.grep(section.Feeds, function (e) { return e.Id === id });
            if (feed.length === 1) {
                feed = feed[0];
                var title = feed.ShowInList ?
                    ("Hide " + feed.Name) : ("Show " + feed.Name);
                var message = feed.ShowInList ?
                    "You can add it back from the Preferences menu in your Twitter section or in Organize by selecting the Twitter Section." :
                    "You can hide it again from the Preferences menu in your Twitter section or in Organize by selecting the Twitter Section.";
                SocialTab.Notification_SetUpHTML_OkCancel(title, message, feed.ShowInList ? "Hide" : "Show", "Cancel", function () {
                    if ($("#doubleModal").length === 1) {
                        $("#doubleModal").remove();
                    }
                    else {
                        $.modal.impl.close();
                    }
                    return SocialTab.ChangeFeedVisibility(feed.Id, !feed.ShowInList, true);
                });
            }
        });

        $("body, .socialTabHeader").on("click", ".hideSTFeedClick", function (e) {
            e.stopPropagation();
            $(this).closest(".customDropdown").remove();
            var sectionId = $(this).parent().attr("data-section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }
            var id = $(this).parent().attr("data-item");
            var feed = $.grep(section.Feeds, function (e) { return e.Id === id });
            if (feed.length === 1) {
                feed = feed[0];
                var title = feed.ShowInList ?
                    ("Hide " + feed.Name) : ("Show " + feed.Name);
                var message = feed.ShowInList ?
                    "You can add it back from inside the Organize by selecting the Trending Section." :
                    "You can hide it again inside the Organize by selecting the Trending Section.";
                SocialTab.Notification_SetUpHTML_OkCancel(title, message, feed.ShowInList ? "Hide" : "Show", "Cancel", function () {
                    if ($("#doubleModal").length === 1) {
                        $("#doubleModal").remove();
                    }
                    else {
                        $.modal.impl.close();
                    }
                    return SocialTab.ChangeFeedVisibility(feed.Id, !feed.ShowInList, true);
                });
            }
        });

        $("body, .socialTabHeader").on("click", ".editRssFeed", function (e) {
            e.stopPropagation();
            var self = $(this);
            var id = self.attr("data-item");
            var sectionId = self.attr("data-section-id");
            var isAlreadyOpen = $(".customDropdown", self.parent()).length;
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            $("body").removeClass("asideMenuIn");
            $("body").removeClass("rightSideMenuIn");

            var positionLeft = self.position().left - 162;
            if ($("body").width() <= 800) {
                positionLeft = 40;
            }

            if (!isAlreadyOpen) {
                var html = "<div class=\"customDropdown\" style=\"left: " + positionLeft + "px;\">";
                html += "<ul data-item=\"" + id + "\" data-section-id=\"" + sectionId + "\">";
                html += "<li class=\"sourceItemEdit\">Edit</li>";
                html += "<li class=\"sourceItemRemove\">Remove</li>";

                var normalTypeSections = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.SectionTypeId === Section.TYPES.Normal; });
                if (normalTypeSections.length > 1) {
                    html += "<li class=\"sourceItemMove\">Move to</li>";
                    html += "<li class=\"sourceItemCopy\">Copy to</li>";
                }

                html += "<li class=\"sourceItemAbout\">About</li>";
                html += "</ul>";
                html += "</div>";

                self.parent().append(html);
            }
        });

        $("body, .socialTabHeader").on("click", ".sortTrendingNews", function (e) {
            e.stopPropagation();
            var self = $(this);
            var id = self.attr("data-item");
            var sectionId = self.attr("data-section-id");
            var isAlreadyOpen = $(".customDropdown", self.parent()).length;
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var positionLeft = self.position().left - 162;
            if ($("body").width() <= 800) {
                positionLeft = 40;
            }

            if (!isAlreadyOpen) {
                var orderByTime = localStorage.getItem("OrderTrending_" + NewsTab.User.Id) === "1";

                var html = "<div class=\"customDropdown\" style=\"left: " + positionLeft + "px;\">";
                html += "<ul class=\"orderTrending\" data-item=\"" + id + "\" data-section-id=\"" + sectionId + "\">";
                html += "<li class=\"orderByPopularity\">";
                html += "<div style=\"position: relative;padding-top: 2px;\">";
                html += "<input id=\"orderByPopularity\" type=\"radio\" name=\"orderTrending\" " + (!orderByTime ? "checked=\"checked\"" : "") + " value=\"0\" \>";
                html += "<label for=\"orderByPopularity\">Order by importance</label>";
                html += "<div class=\"check " + (!orderByTime ? "active" : "") + "\"></div>";
                html += "</div>";
                html += "</li>";
                html += "<li class=\"orderByTime\">";
                html += "<div style=\"position: relative;padding-top: 2px;\">";
                html += "<input id=\"orderByTime\" type=\"radio\" name=\"orderTrending\" " + (orderByTime ? "checked=\"checked\"" : "") + " value=\"1\" \>";
                html += "<label for=\"orderByTime\">Order by time</label>";
                html += "<div class=\"check " + (orderByTime ? "active" : "") + "\"></div>";
                html += "</div>";
                html += "</li>";
                html += "<li class=\"orderByAboutPop\" value=\"0\">About</li>";
                html += "</ul>";
                html += "</div>";

                self.parent().append(html);

                $(".orderTrending label").on("click", function () {
                    $(".dropdown").removeClass("open");
                    $(".customDropdown").remove();

                    var value = $(this).closest("div").find("input").val();
                    localStorage.setItem("OrderTrending_" + NewsTab.User.Id, value);
                    NewsTab.Modules.SectionsManager.LoadCurrentFeed({ Refresh: true });
                });
            }
        });

        $("body, .socialTabHeader").on("click", ".sortSocialTrendingNews", function (e) {
            e.stopPropagation();
            var self = $(this);
            var id = self.attr("data-item");
            var sectionId = self.attr("data-section-id");
            var isAlreadyOpen = $(".customDropdown", self.parent()).length;
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var positionLeft = self.position().left - 162;
            if ($("body").width() <= 800) {
                positionLeft = 40;
            }

            if (!isAlreadyOpen) {
                var orderByTime = localStorage.getItem("OrderTrending_" + NewsTab.User.Id) === "1";

                var feed = NewsTab.Modules.SectionsManager.GetFeedById(id);

                var html = "<div class=\"customDropdown\" style=\"left: " + positionLeft + "px;\">";
                html += "<ul class=\"orderTrending\" data-item=\"" + id + "\" data-section-id=\"" + sectionId + "\">";
                html += "<li class=\"hideSTFeedClick\">Hide</li>";
                html += "<li class=\"orderByAboutPop\" value=\"3\" data-feedname=\"" + feed.Name + "\">About</li>";
                html += "</ul>";
                html += "</div>";

                var region = localStorage.getItem("ST_" + NewsTab.User.Id + "_SocialFeedRegion_" + id);

                var regionList = $("<select>", { "data-space": "true", "style": "width:100%" });

                regionList.on("mouseleave", function (e) {
                    e.stopPropagation();
                    e.stopImmediatePropagation();
                });

                self.parent().append(html);
            }
        });

        $(".socialTabHeader").on("mouseleave", ".lastActiveItemsConteinerName", function () {
            var dps = $(".customDropdown");
            for (var i = 0, l = dps.length; i < l; i++) {
                var dp = dps.eq(i);
                if (!dp.is(":focus")) {
                    dp.remove();
                }
            }
        });

        $(".socialTabHeader").on("mouseleave", ".menuItem", function (e) {
            var dps = $(".customDropdown");
            for (var i = 0, l = dps.length; i < l; i++) {
                var dp = dps.eq(i);
                if (!dp.is(":focus")) {
                    dp.remove();
                }
            }
        });

        $("body").on("click", ".editRssSection", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            $("body").removeClass("asideMenuIn");
            $("body").removeClass("rightSideMenuIn");

            var sectionId = $(this).parent().data("section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
                var feeds = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (x) { return x.ShowInList === true });

                var html = "<div class=\"customDropdown\">";
                html += "<ul id=\"sectionMenuOptions\" data-item=\"" + sectionId + "\">";

                if (section.SectionTypeId === Section.TYPES.Normal) {
                    html += "<li class=\"sectionEdit\">Edit</li>";
                    html += "<li class=\"sectionRemove\">Remove</li>";
                }
                if (feeds.length > 0 && section.SectionTypeId === Section.TYPES.Home) {
                    html += "<li class=\"openTopFeeds\">Top Feeds</li>";
                }

                html += "</ul>";
                html += "</div>";

                $(this).parent().append(html);
            }
        });

        $("body").on("click", ".editRssSectionFeeds", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var sectionId = $(this).parent().data("section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id == sectionId })
            if (section.length == 1) {
                section = section[0];
                var html = "<div class=\"customDropdown\">" +
                    "<ul id=\"sectionMenuOptions\" data-section-id=\"" + section.Id + "\">";
                if (section.SectionTypeId === Section.TYPES.Normal) {
                    html += "<li class=\"sectionMoveAll\">Move all feeds</li>";
                    html += "<li class=\"sectionCopyAll\">Copy all feeds</li>";
                    html += "<li class=\"sectionRemoveAll\">Delete all feeds</li>";
                }
                html += "</ul>" +
                    "</div>";

                $(this).parent().append(html);
            }
        });

        $("body").on("click", ".sectionRemove", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            var sectionId = $(this).parent().attr("data-item");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];

                SocialTab.Notification_SetUpHTML_OkCancel("Remove " + section.Name, "You can always add it back from the “+” icon on your dashboard.", "Remove", "Cancel", function () {
                    $(".notification-modal").addClass("disabled");
                    $(".notification-modal .ok").html("<i class=\"icon\"><span class=\"spinner\"></span></i>Removing...");
                    return SocialTab.RemoveSection(section.Id, true, false);
                });
            }
        });

        $("body").on("click", ".sectionEdit", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var sectionId = $(this).parent().attr("data-item");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];

                var doubleModal = false;
                if ($("#simplemodal-overlay").length === 1) {
                    doubleModal = true;
                }
                var html = "";

                if (doubleModal) {
                    html += "<div id=\"doubleModal\"><div class=\"modalCell\" style=\"max-height:285px;max-width:400px;\"><div class=\"modalContent\" >";
                }

                html += "<header>";
                html += "<div class=\"title\">";
                html += "<h2>Edit section</h2>";
                html += "</div>";
                html += "</header>";
                html += "<div class=\"newItem modular\">";
                html += "<div class=\"inputContainer\">";
                html += "<input type=\"text\" class=\"newSectionName clearable\" placeholder=\"Section Name\" value=\"" + section.Name.trim() + "\" " + (section.ClassName ? "onkeyup=\"SocialTab.HTML_Event_SectionName_KeyUp_NoIcon($(this))\"" : "onkeyup=\"SocialTab.HTML_Event_SectionName_KeyUp($(this))\"") + " tabindex=\"1000\" />";

                if (section.ClassName) {
                    html += "<span class=\"iconPreview\" style=\"background-color:" + section.Color + "\"><i class=\"icon-" + section.ClassName + "\"></i></span></div>";
                } else {
                    html += "<span class=\"iconPreview\" style=\"background-color:" + section.Color + "\">" + section.Name.substring(0, 2) + "</span></div>";
                }
                html += "<ul class=\"colors\">";
                var i = 1001;
                NewsTab.Colors.forEach(function (color) {
                    html += "<li " + (color === section.Color ? "class=\"active\"" : "") + " color=\"" + color + "\" style=\"background-color:" + color + "\" onclick=\"SocialTab.HTML_Event_SectionColorClick($(this))\" data-space=\"true\" tabindex=\"" + i + "\"></li>";
                    i++;
                });
                html += "</ul>";

                html += "<div class=\"btnContainer\">";
                html += "<a class=\"btn blue cancel " + (doubleModal ? "doubleModal-close" : "simplemodal-close") + "\" tabindex=\"1009\">Cancel</a>";
                html += "<a class=\"btn blue save disabled\" onclick=\"SocialTab.HTML_Event_SaveSectionChangesClick($(this),'" + section.Id + "')\" tabindex=\"1010\">Save</a>";
                html += "</div>";
                html += "</div>";

                if (doubleModal) {
                    html += "</div></div></div>";
                    $("#addNewContent").append(html);
                }
                else {
                    $.modal(html, {
                        overlayClose: true,
                        autoResize: false,
                        autoPosition: true,
                        maxHeight: "285",
                        minWidth: "400"
                    });
                }
            }
            if (NewsTab.Modules.Context !== undefined) {
                NewsTab.Modules.Context.inputFocusKeys();
            }
        });

        $("body").on("click", ".openTopFeeds", function (e) {
            e.stopPropagation();

            SocialTab.OpenTopFeeds();
        });

        $("body").on("click", ".editSocialSection", function (e) {
            e.stopPropagation();

            var editSocialSectionDropdown = $(".editSocialSection .customDropdown").length;
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            if (editSocialSectionDropdown === 0) {
                var html = "<div class=\"customDropdown socialNetworkDropdown\">" +
                    "<ul id=\"sectionMenuOptions\" data-item=\"" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "\">";
                if (Feed.Linked(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Type)) {
                    var acc = Feed.Account(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Type);

                    html += "<li class=\"userMenu\">" +
                        (acc != null && acc.ProfilePictureUrl != null ?
                            "<img class=\"stProfilePicture\" src=\"" + acc.ProfilePictureUrl + "\" alt=\"\">" : "") +
                        "<div class=\"stUsername\">" + (acc ? acc.Username : "") + "</div></li>" +
                        "<li class=\"sectionSocialDisconnect snBtn\">Disconnect</li>" +
                        "<li class=\"sectionSocialPreferences snBtn\">Preferences</li>" +
                        "<li class=\"sectionSocialRemove snBtn\">Remove</li>";
                }
                else {
                    html += "<li class=\"snBtn\" onclick=\"SocialTab.Connect" + NewsTab.Modules.SectionsManager.CurrentSection.Name + "()\">Connect to " + NewsTab.Modules.SectionsManager.CurrentSection.Name + "</li>" +
                        "<li class=\"sectionSocialRemove snBtn\">Remove</li>";
                }
                html += "</ul></div>";


                $(this).parent().append(html);
            } else {
                $(".dropdown").removeClass("open");
                $(".customDropdown").remove();
            }
        });

        $(".socialTabHeader").on("click", ".sectionSocialPreferences", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            SocialTab.TwitterPreferences();
        });

        $(".socialTabHeader").on("click", ".sectionSocialDisconnect", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            var acc = Feed.Account(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Type);
            SocialTab.Notification_SetUpHTML_OkCancel("Disconnect " + NewsTab.Modules.SectionsManager.CurrentSection.Name, "Disconnect your " + NewsTab.Modules.SectionsManager.CurrentSection.Name + " account (" + (acc != null ? acc.Username : "none") + ") from Newstab.", "Disconnect", "Cancel", function () {
                if ($("#doubleModal").length === 1) {
                    $("#doubleModal").remove();
                }
                else {
                    $.modal.impl.close();
                }
                return SocialTab.DisconnectSocialSection(NewsTab.Modules.SectionsManager.CurrentSection.Id);
            });
        });

        $("body, .socialTabHeader").on("click", ".sectionSocialRemove", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            var sectionId = $(this).parent().attr("data-item");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }
            var acc = Feed.Account(section.CurrentFeed.Type);
            SocialTab.Notification_SetUpHTML_OkCancel("Remove " + section.Name, "Disconnect your " + section.Name + " account (" + (acc != null ? acc.Username : "none") + ") from Newstab and remove the " + section.Name + " icon from your dashboard.", "Remove", "Cancel", function () {
                $(".notification-modal").addClass("disabled");
                $(".notification-modal .ok").html("<i class=\"icon\"><span class=\"spinner\"></span></i>Removing...");
                return SocialTab.RemoveSocialSection(section.Id, true);
            });
        });

        $("body,.socialTabHeader").on("click", ".sourceItemEdit", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var sectionId = $(this).parent().attr("data-section-id");
            var id = $(this).parent().attr("data-item");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }
            var feed = $.grep(section.Feeds, function (x) { return x.Id === id });
            if (feed.length === 1) {
                feed = feed[0];
                var doubleModal = false;
                if ($("#simplemodal-overlay").length === 1) {
                    doubleModal = true;
                }
                var html = "";

                if (doubleModal) {
                    html += "<div id=\"doubleModal\"><div class=\"modalCell\" style=\"max-height:220px;max-width:400px;\"><div class=\"modalContent\">";
                }
                html += "<header>";
                html += "<div class=\"title\">";
                html += "<h2>Edit feed";
                html += "</h2>";
                html += "</div>";
                html += "</header>";
                html += "<div class=\"newItem modular\">";
                html += "<div class=\"inputContainer\">";
                html += "<input type=\"text\" class=\"clearable\" id=\"editName_" + feed.Id + "\" placeholder=\"Feed Name\" value=\"" + feed.Name.trim() + "\" onkeyup=\"SocialTab.HTML_Event_FeedName_KeyUp($(this))\" tabindex=\"1000\" />";
                html += "<img class=\"iconPreview\" src=\"" + (feed.Icon ? feed.Icon : "/Media/ExtensionImages/rss.png") + "\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\"/>";
                html += "<label class=\"errorMessage\"></lebel>";
                html += "</div>";
                html += "<div class=\"btnContainer\" style=\"margin-top: 30px;\">";
                html += "<a class=\"btn blue cancel " + (doubleModal ? "doubleModal-close" : "simplemodal-close") + "\" tabindex=\"1001\">Cancel</a>";
                html += "<a class=\"btn blue save disabled\" onclick=\"SocialTab.RenameFeed('" + section.Id + "','" + feed.Id + "')\" tabindex=\"1001\">Save</a>";
                html += "</div>";
                html += "</div>";

                if (doubleModal) {
                    html += "</div></div></div>";
                    $("#addNewContent").append(html);
                }
                else {
                    $.modal(html, {
                        overlayClose: true,
                        autoResize: false,
                        autoPosition: true,
                        maxHeight: "200",
                        minWidth: "400"
                    });
                }
            }
            if (NewsTab.Modules.Context !== undefined) {
                NewsTab.Modules.Context.inputFocusKeys();
            }

            $(".newItem.modular .icon-star").click(function () {
                var self = $(this);
                SocialTab.HTML_Event_FeedName_KeyUp(self.closest(".newItem.modular").find("#editName_" + feed.Id));
                if (self.hasClass("gold")) {
                    self.removeClass("gold").addClass("icon-star-o");
                } else {
                    self.removeClass("icon-star-o").addClass("gold");
                }
            });
        });

        $("body,.socialTabHeader").on("click", ".sourceItemRemove", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var sectionId = $(this).parent().attr("data-section-id");
            var id = $(this).parent().attr("data-item");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }
            var feed = $.grep(section.Feeds, function (x) { return x.Id === id });
            if (feed.length === 1) {
                feed = feed[0];
                SocialTab.Notification_SetUpHTML_OkCancel("Remove " + feed.Name + " from " + section.Name, "You can always add it back from the “+” icon on your dashboard.", "Remove", "Cancel", function () {
                    $(".notification-modal").addClass("disabled");
                    $(".notification-modal .ok").html("<i class=\"icon\"><span class=\"spinner\"></span></i>Removing...");
                    return SocialTab.RemoveFeedFromSection(section.Id, feed.Id);
                });
            }
        });



        $("body,.socialTabHeader").on("click", ".sourceItemAbout", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var sectionId = $(this).parent().attr("data-section-id");
            var id = $(this).parent().attr("data-item");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId });
            var height = 220;
            var html = "";
            var doubleModal = false;
            if (section.length === 1) {
                section = section[0];
            }
            else {
                section = NewsTab.Modules.SectionsManager.CurrentSection;
            }
            var feed = $.grep(section.Feeds, function (x) { return x.Id === id });
            if (feed.length === 1) {
                feed = feed[0];
                if ($("#simplemodal-overlay").length === 1) {
                    doubleModal = true;
                }

                if (doubleModal) {
                    html += "<div id=\"doubleModal\"><div class=\"modalCell\" style=\"height:250px;min-width:700px;max-width:700px;\"><div class=\"modalContent\">";
                }

                html += "<header style=\"height: 45px;\">";
                html += "<div class=\"title\" style=\"padding: 0 15px !important;\">";
                html += "<h2 style=\"float: left; font-size: 17px; line-height: 45px; margin: 0; margin-left: 15px;\">About</h2>";
                html += "<i class=\"icon-close\" onclick=\"$.modal.impl.close(); return false;\" style=\"float: right; font-size: 14px; line-height: 27px; cursor: pointer; margin-top: 10px;\"></i>";
                html += "</div>";
                html += "</header>";
                html += "<div class=\"newItem modular\">";
                html += "<div class=\"feedAbout\">";
                html += "<div><p class=\"feedAbout-title\">Feed Displayed Name: </p><p class=\"feedAbout-body-ellipsis\">" + feed.Name + "</p></div>";
                if (feed.OriginalFeedName && feed.OriginalFeedName.replace("(Google News)", "").trim() !== feed.Name.replace("(Google News)", "").trim()) {
                    html += "<div><p class=\"feedAbout-title\">Original Feed Name: </p><p class=\"feedAbout-body-ellipsis\">" + feed.OriginalFeedName + "</p></div>";
                    height += 30;
                }
                html += "<div style=\"margin-top: 10px;margin-bottom: 10px;\"><p class=\"feedAbout-title\">Feed Url: </p><a href=\"" + feed.Url + "\" class=\"feedAbout-body-ellipsis feedAbout-body-link\" target=\"_blank\">" + feed.Url + "</a></div>";
                html += "<div><p class=\"feedAbout-title\">Feed Domain: </p><p class=\"feedAbout-body-ellipsis\">" + feed.SiteUrl + "</p></div>";
                if (feed.Description) {
                    html += "<div><p class=\"feedAbout-title\">Description: </p><p class=\"feedAbout-body-ellipsis\">" + feed.Description + "</p></div>";
                    height += 30;
                }
                if (feed.Url.indexOf("news.google.com") > -1) {
                    var searchTerm = NewsTab.Helpers.GetParameterFromUrl("q", feed.Url);
                    var location = NewsTab.Helpers.GetParameterFromUrl("geo", feed.Url);
                    if (location) {
                        html += "<div><p class=\"feedAbout-title\">Location: </p><p class=\"feedAbout-body-ellipsis\">" + location + "</p></div>";
                        height += 30;
                    } else if (searchTerm) {
                        html += "<div><p class=\"feedAbout-title\">Search Term: </p><p class=\"feedAbout-body-ellipsis\">" + searchTerm + "</p></div>";
                        height += 30;
                    }
                }
                if (feed.TotalSubscribers > 0) {
                    html += "<div><p class=\"feedAbout-title\">Popularity: </p>";
                    html += "<div class=\"popularity-star\" style=\"margin-left: 92px;\">";
                    html += "<span class=\"popularity-star-full " + SocialTab.HTML_PopularityRating(feed.TotalSubscribers) + "\"></span>";
                    html += "</div>";
                    html += "</div>";
                    height += 30;
                }
                html += "</div>";
                html += "</div>";
                html += "<div class=\"btnContainer\" style=\"position: absolute; margin-left: 300px; bottom: 20px;\">";
                html += "<a class=\"btn blue cancel " + (doubleModal ? "doubleModal-close" : "simplemodal-close") + "\" style=\"width: 120px;\" tabindex=\"0\">Close</a>";
                html += "</div>";

                if (doubleModal) {
                    html += "</div></div></div>";
                    $("#addNewContent").append(html);
                }
                else {
                    $.modal(html, {
                        overlayClose: true,
                        autoResize: false,
                        autoPosition: true,
                        maxHeight: height,
                        minWidth: "700",
                        maxWidth: "700"
                    });
                }
            }
        });

        $("body,.socialTabHeader,.socialTabItem").on("click", ".orderByAboutPop", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();

            var type = $(this).val();
            var doubleModal = false;
            var html = "";

            if ($("#simplemodal-overlay").length === 1) {
                doubleModal = true;
            }

            if (doubleModal) {
                html += "<div id=\"doubleModal\"><div class=\"modalCell\" style=\"height:250px;min-width:700px;max-width:700px;\"><div class=\"modalContent\">";
            }

            html += "<header style=\"height: 45px;\">";
            html += "<div class=\"title\">";
            if (type === 0) {
                html += "<h2 style=\"float: left; font-size: 17px; line-height: 45px; margin: 0; margin-left: 15px;\">Best of my NewsTab</h2>";
            } else if (type === 1) {
                html += "<h2 style=\"float: left; font-size: 17px; line-height: 45px; margin: 0; margin-left: 15px;\">Best of " + NewsTab.Modules.SectionsManager.CurrentSection.Name + "</h2>";
            } else if (type === 3) {
                html += "<h2 style=\"float: left; font-size: 17px; line-height: 45px; margin: 0; margin-left: 15px;\">Trending on " + $(this).attr("data-feedname") + "</h2>";
            } else {
                html += "<h2 style=\"float: left; font-size: 17px; line-height: 45px; margin: 0; margin-left: 15px;\">Importance Rank</h2>";
            }
            html += "<i class=\"icon-close\" onclick=\"$.modal.impl.close(); return false;\" style=\"float: right; font-size: 14px; line-height: 27px; cursor: pointer; margin-top: 10px;\"></i>";
            html += "</div>";
            html += "</header>";
            html += "<div class=\"newItem modular\">";
            if (type === 0) {
                html += "<div style=\"padding: 20px;\">";
                html += "<span><p>These are the top 20 stories in the feeds you follow on NewsTab that were published within the last day. We use various signals to identify the stories you'll be most interested in. Some of those signals are your specific reading pattern on NewsTab, popularity of stories on NewsTab and social networks and media coverage for similar stories.</p></span>";
                html += "</div>";
            } else if (type === 1) {
                html += "<div style=\"padding: 20px;\">";
                html += "<span><p>These are the top 20 stories in this section that were published within the last day. We use various signals to identify the stories you'll be most interested in. Some of those signals are your specific reading pattern on NewsTab, popularity of stories on NewsTab and social networks and media coverage for similar stories.</p></span>";
                html += "</div>";
            } else if (type === 3) {
                html += "<div style=\"padding: 20px;\">";
                html += "<span><p>These are the trending stories on " + $(this).attr("data-feedname") + " for the region that were published within the last day.</p></span>";
                html += "</div>";
            } else {
                html += "<div style=\"padding: 40px 20px 20px 20px;\">";
                html += "<span><p>Stories are ranked for importance based on various signals, such as popularity on NewsTab, activity on social networks and media coverage for similar stories.</p></span>";
                html += "</div>";
            }
            html += "</div>";

            if (doubleModal) {
                html += "</div></div></div>";
                $("#addNewContent").append(html);
            }
            else {
                $.modal(html, {
                    overlayClose: true,
                    autoResize: false,
                    autoPosition: true,
                    maxHeight: "200",
                    minWidth: "700",
                    maxWidth: "700"
                });
            }
        });

        $("body,.socialTabHeader,.socialTabItem").on("click", ".regionSelect", function (e) {
            e.stopPropagation();
            //$(".dropdown").removeClass("open");
            //$(".customDropdown").remove();
        });

        $("body").on("click", ".feedCopyDrag", function (e) {
            e.stopPropagation();
            $(this).toggleClass("selected");

            var sectionId = $(this).closest("li").attr("data-section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId; });
            if (section.length === 1) {
                section = section[0];
                var feedId = $(this).closest("li").attr("data-feed-id");
                var feed = $.grep(section.Feeds, function (x) { return x.Id === feedId; });
                if (feed.length === 1) {
                    feed = feed[0];

                    feed.OrganizeCopyMode = $(this).hasClass("selected");
                    NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                        Title: "Feed manager",
                        Text: $(this).hasClass("selected") ? "Drag & Drop to COPY!" : "Drag & Drop to MOVE!"
                    });
                }
            }
        });

        $("body").on("change", "#organizerSectionFeeds .feedManager li.feed .checkContainer input", function () {
            var li = $(this).closest("li");
            var sectionId = li.attr("data-section-id");
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (x) { return x.Id === sectionId; });
            if (section.length === 1) {
                section = section[0];
                var feedId = li.attr("data-feed-id");
                var feed = $.grep(section.Feeds, function (x) { return x.Id === feedId; });
                if (feed.length === 1) {
                    feed = feed[0];
                    feed.OrganizeFeedSelected = $(this).is(":checked");
                    if (feed.OrganizeFeedSelected) {
                        li.addClass("selected");
                    }
                    else {
                        li.removeClass("selected");
                    }
                }
            }
        });

        $("body").on("click", "#organizerSectionFeeds .feedManager li.feed .feedIcon, #organizerSectionFeeds .feedManager li.feed .feedName", function () {
            var checkbox = $(this).closest("li").find(".checkContainer input");
            checkbox[0].checked = !checkbox[0].checked;
            checkbox.trigger("change");
        });


        $("body").on("click", ".copyMoveModal .item", function (e) {
            e.stopPropagation();
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            $(".copyMoveModal .item").removeClass("selected");
            $(this).addClass("selected");
        });
        // Refresh - Load new articles for CurrentFeed
        $("body").on("click", ".refreshFeed", function () {
            var selectedList = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id; // get the list id from the selected item
            var selectedSource = NewsTab.Modules.SectionsManager.CurrentSection.Id; // get the source id from the selected item
            SocialTab.SetCurrentState(SocialTab.AllStates.Feeds);
            SocialTab.SetCurrentSection(selectedSource, false, false);
            SocialTab.SetCurrentFeed(selectedList, true);
        });
        // Change the CurrentSection on Dashboard
        $("body").on("click", ".socialTabHeader .sourceItem, .rightSideMenu .sourceItem", function () {
            var self = $(this);
            var selectedSource = self.data("section-id"); // get the source id from the selected item
            SocialTab.SelectCurrentSection(selectedSource, $(self).hasClass("xOption"));
        });
        // Hover Navigation

        $(".socialTabHeader").on("mouseleave", ".lastActiveItemsContainer", function () {
            SocialTab.Menu_SetUpHTML_SubmenuList();
            $(".sourceItem").removeClass("active");
            if (NewsTab.Modules.SectionsManager.CurrentSection != null) {
                $(".sourceItem[data-section-id='" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "']").addClass("active");
            }
        });


        $("body").on("mouseenter", ".socialTabHeader .sourceItem, .rightSideMenu .sourceItem", function (n) {
            if ($(".sectionName").has(n.target).length === 0 && $(".rightSideMenu").has(n.target).length === 0) {
                var t = $(this).data("section-id");
                $(".sourceItem").removeClass("active");
                $(".sourceItem[data-section-id='" + t + "']").addClass("active");
                SocialTab.Menu_SetUpHTML_SubmenuList_Temporary(t);
                SocialTab.Menu_SetUpItemsTemplateMobile(t);
            }
        });

        $(".socialTabHeader").on("mouseenter", ".sectionsDropdown.yOption", function () {
            SocialTab.Menu_SetUpHTML_SubmenuList();
            $(".sourceItem").removeClass("active");
            NewsTab.Modules.SectionsManager.CurrentSection != null && $(".sourceItem[data-section-id='" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "']").addClass("active");
        });

        $("body").on("mouseleave", ".socialTabHeader .sourceItem, .rightSideMenu .sourceItem", function (n) {
            n.relatedTarget != null &&
                n.relatedTarget.firstElementChild &&
                n.relatedTarget.firstElementChild.offsetParent != null &&
                n.toElement.firstElementChild.offsetParent.className === "options" ||
                n.toElement != undefined &&
                (
                    n.toElement.className === "sourceItemSelectedList" ||
                    n.toElement.className === "sourceItemSubmenu" ||
                    n.target.className === "sourceItemArrow" ||
                    n.relatedTarget.lastChild != null &&
                    n.relatedTarget.lastChild.className === "icon-angle-down editRssFeed"
                ) &&
                n.toElement != null &&
                n.toElement.className !== "lastActiveConteiner" &&
                n.toElement.className !== "options" ||
                $(".rightSideMenu").has(n.target).length === 0 &&
                (SocialTab.Menu_SetUpHTML_SubmenuList(),
                    $(".sourceItem").removeClass("active"),
                    NewsTab.Modules.SectionsManager.CurrentSection != null && $(".sourceItem[data-section-id='" + NewsTab.Modules.SectionsManager.CurrentSection.Id + "']").addClass("active"));
        });

        // Add a new filter to the selected list (hashtag or user) by ENTER 
        $("#contentTwitterFeed").on("keydown", ".filterInput", function (e) {
            if (e.keyCode === 32) {
                return false;
            } else if (e.keyCode === 13) {
                if ($(this).val().length > 0) {
                    SocialTab.SearchFilter(this);
                }
                else {
                    $(".searchTagResult", "#contentTwitterFeed").remove();
                    $("#contentTwitterFeed").removeClass("withSearchResults");
                }
            }
            return true;
        });
        // Validate filter input and show/hide warning message
        $("#contentTwitterFeed").on("input", ".filterInput", function () {
            var filtertag = $(this).val();
            if (filtertag) {
                filtertag = filtertag.replace(/#/gi, '');
                filtertag = filtertag.replace(/@/gi, '');
                if (filtertag.length > 0) {
                    $(".searchTwitterFeeds", "#contentTwitterFeed").removeClass("disabled");
                }
                else {
                    $(".searchTwitterFeeds", "#contentTwitterFeed").addClass("disabled");
                    $(".searchTagResult", "#contentTwitterFeed").remove();
                    $("#contentTwitterFeed").removeClass("withSearchResults");
                }
            }
            else {
                $(".searchTwitterFeeds", "#contentTwitterFeed").addClass("disabled");
                $(".searchTagResult", "#contentTwitterFeed").remove();
                $("#contentTwitterFeed").removeClass("withSearchResults");
            }
        });

        $("#contentTwitterFeed").on("click", "#clearTwitterFilterSearch", function () {
            $("#contentTwitterFeed .searchTagResult").remove();
            $("#contentTwitterFeed").removeClass("withSearchResults");
            $("#contentTwitterFeed .filterInput").val("");
        });

        $("#contentTwitterFeed").on("click", ".searchTagResult li", function (e) {
            $(this).toggleClass("selected");
            var nbrOfSel = $("li.selected", "#contentTwitterFeed .searchTagResult").length;
            if (nbrOfSel > 0) {
                $(".searchTagResult").height($(".searchTagResult").height() - 50);
                $("#addTwitterFeedBtnField").show();
            }
            else {
                $(".searchTagResult").height($(".searchTagResult").height() + 50);
                $("#addTwitterFeedBtnField").hide();
            }
        });

        $("#contentTwitterFeed").on("click", ".addTwitterFeed", function (e) {
            var selectedTags = $("li.selected", "#contentTwitterFeed .searchTagResult");
            if (selectedTags.length > 0) {
                for (var i = 0, l = selectedTags.length; i < l; i++) {
                    var type = selectedTags.eq(i).attr("data-type");
                    var value = selectedTags.eq(i).attr("data-value");
                    if (type === "hashtag") {
                        SocialTab.AddNewFilter("#" + value, true);
                    }
                    else {
                        SocialTab.AddNewFilter("@" + value, true);
                    }
                    selectedTags.addClass("disabled");
                    selectedTags.removeClass("selected");
                }
                $(".searchTagResult").height($(".searchTagResult").height() + 50);
                $("#addTwitterFeedBtnField").hide();
            }
            else {
                $("#contentTwitterFeed .addTwitterFeed").addClass("disabled");
            }
        });

        // Mark all articles of CurrentFeed as readed
        $("#markAllAsReaded").on("click", function () {
            SocialTab.MarkAllAsRead($(this));
        });

        $(".socialTabHeader").on("click", ".topFeedIndIcon", function (e) {
            e.stopPropagation();

            var topFeedIndIsOpened = $(this).parent().hasClass("open");
            $(this).parent().removeClass("open");
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            $("body").removeClass("asideMenuIn");

            if (!topFeedIndIsOpened) {
                $(this).parent().addClass("open");
            } else {
                $(this).parent().removeClass("open");
            }
        });

        $(".socialTabHeader").on("click", ".topFeedIndMenu div.topFeedIndDetails", function (e) {
            SocialTab.StarFeedOnDashboard($(this));
        });

        $(".socialTabHeader").on("click", ".layouts", function (e) {
            e.stopPropagation();

            var layoutDropdownIsOpened = $(this).parent().hasClass("open");
            $(this).parent().removeClass("open");
            $(".dropdown").removeClass("open");
            $(".customDropdown").remove();
            $("body").removeClass("asideMenuIn");

            if (!layoutDropdownIsOpened) {
                $(this).parent().addClass("open");
            } else {
                $(this).parent().removeClass("open");
            }
        });

        $(".socialTabHeader").on("click", ".layoutMenu div.set-layout", function (e) {
            SocialTab.ChangeLayout($(this), e);
        });

        $(".socialTabHeader").on("click", ".layoutMenu .applyLayout input", function (e) {
            e.stopPropagation();
            if (!$(this).closest(".applyLayout").hasClass("checked")) {
                $(this).closest(".applyLayout").addClass("checked");
            } else {
                $(this).closest(".applyLayout").removeClass("checked");
            }
        });



        $("body").on("click", "*[data-expand-background]", function () {
            NewsTab.Modules.ArticleView.ExpandFormSettings.Background = $(this).attr("data-expand-background");
            NewsTab.Modules.ArticleView.SetUp_ExpandViewClasses();
            $("*[data-expand-background]").removeClass("selected");
            $("*[data-expand-background=" + NewsTab.Modules.ArticleView.ExpandFormSettings.Background + "]").addClass("selected");
        });

        $("body").on("click", "*[data-expand-font]", function () {
            NewsTab.Modules.ArticleView.ExpandFormSettings.Font = $(this).attr("data-expand-font");
            NewsTab.Modules.ArticleView.SetUp_ExpandViewClasses();
            $("*[data-expand-font]").removeClass("selected");
            $("*[data-expand-font=" + NewsTab.Modules.ArticleView.ExpandFormSettings.Font + "]").addClass("selected");
        });

        $("body").on("click", ".twitterListPreferences .applyChanges", function () {
            var feeds = $(".twitterListPreferences .twitterFeeds li");
            var visibleFeeds = $(".twitterListPreferences .twitterFeeds li input:checked");

            if (visibleFeeds.length == 0) {
                $('.toastMessage').html("At least one feed needs to be enabled");
                $('.toastMessage').fadeIn(400).delay(3000).fadeOut(400);
            }
            else {
                for (var i = 0, l = feeds.length; i < l; i++) {
                    var enabled = feeds.eq(i).find("input").is(":checked");
                    var id = feeds.eq(i).data("feed-id");
                    SocialTab.ChangeFeedVisibility(id, enabled, false);
                }

                if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.ShowInList == false) {
                    var visibleFeed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.ShowInList === true) });
                    if (visibleFeed.length > 0) {
                        SocialTab.SetCurrentFeed(visibleFeed[0].Id, true);
                    }
                    else {
                        SocialTab.SetCurrentFeed(NewsTab.Modules.SectionsManager.CurrentSection.Feeds[0], true);
                    }
                }
                else {
                    SocialTab.Menu_SetUpHTML_SubmenuList();
                }
                if ($("#doubleModal").length === 1) {
                    $("#doubleModal").remove();
                }
                else {
                    $.modal.impl.close();
                }
            }
        });

        $("body").on("click", ".subscribeToIOsBeta", function (e) {
            e.preventDefault();
            e.stopPropagation();
            $("#mc_embed_signup").toggleClass("show");
        });

        $("body").on("click", ".closeiOSsubscribe", function (e) {
            e.preventDefault();
            e.stopPropagation();
            $("#mce-EMAIL").val("");
            $("#mc_embed_signup").removeClass("show");
        });

        $("body").on("click", "#mc-embedded-subscribe", function (e) {
            e.preventDefault();
            e.stopPropagation();
            $("#mc-embedded-subscribe-form").submit();
            $("#mce-EMAIL").val("");
            $("#mc_embed_signup").removeClass("show");
        });
    },

    OpenTopFeeds: function () {
        $(".dropdown").removeClass("open");
        $(".customDropdown").remove();
        $("body").removeClass("asideMenuIn");

        var doubleModal = false;
        if ($("#simplemodal-overlay").length === 1) {
            doubleModal = true;
        }
        var html = "";

        if (doubleModal) {
            html += "<div id=\"doubleModal\"><div class=\"modalCell\" style=\"max-height:285px;max-width:400px;\"><div class=\"modalContent\">";
        }

        html += "<header style=\"height: 45px;\">";
        html += "<div class=\"title\">";
        html += "<h2 style=\"float: left; font-size: 17px; line-height: 45px; margin: 0; margin-left: 15px;\">Top Feeds</h2>";
        html += "<i class=\"icon-close\" onclick=\"" + (doubleModal ? "$('#doubleModal').remove();" : "$.modal.impl.close(); ") + " return false;\" style=\"float: right; font-size: 14px; line-height: 27px; cursor: pointer; margin-top: 10px;\"></i>";
        html += "</div>";
        html += "</header>";
        html += "<span class=\"modalLoader_center\"><i class=\"icon\"><span class=\"spinner\"></span></i></span>";
        html += "<div class=\"topFeeds\">";

        html += "<div class=\"topFeedsHint\">";
        html += "<span class=\"topFeedsHintTitle\"><i class=\"icon-angle-down\"></i><p>About Top Feeds</p></span>";
        html += "<span class=\"topFeedsHintDescription\">Feeds are ranked for importance based on the user activity pattern, to surface the most relevant results in  “Best”. The list below shows the current ranking of your NewsTab feeds, by order of importance. You can manually assign higher importance to a feed by starring it.</span>";
        html += "</div>";

        html += "<ul class=\"topFeedsList\">";
        html += "</ul>";
        html += "</div>";

        $.modal(html, {
            overlayClose: true,
            autoResize: true,
            autoPosition: true,
            minHeight: "100%",
            maxHeight: "100%",
            minWidth: "960",
            maxWidth: "auto"
        });

        SocialTab.TopFeedsResult();

        $(".topFeedsHintTitle").off("click").on("click", function (e) {
            e.stopPropagation();

            if ($(".topFeedsHint").hasClass("open")) {
                $(".topFeedsHint").removeClass("open");
            } else {
                $(".topFeedsHint").addClass("open");
            }
        });
    },

    StarFeedOnDashboard: function (self) {
        var star;

        if (self.find("i.icon-star").hasClass("gold")) {
            self.closest(".topFeedIndicator").find("i.topFeedIndIcon").removeClass("gold").addClass("icon-star-o");
            self.closest(".topFeedIndicator").attr("data-original-title", "Star feed");
            self.closest(".topFeedIndicator").siblings(".tooltip").find(".tooltip-inner").text("Star feed");

            self.find("i.icon-star").removeClass("gold").addClass("icon-star-o");
            self.find("p").text("Star feed");

            star = false;
        } else {
            self.closest(".topFeedIndicator").find("i.topFeedIndIcon").removeClass("icon-star-o").addClass("gold");
            self.closest(".topFeedIndicator").attr("data-original-title", "Unstar feed");
            self.closest(".topFeedIndicator").siblings(".tooltip").find(".tooltip-inner").text("Unstar feed");

            self.find("i.icon-star").removeClass("icon-star-o").addClass("gold");
            self.find("p").text("Unstar feed");

            star = true;
        }

        $(".dropdown").removeClass("open");
        SocialTab.SetTopFeed(NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id, star);
    },

    TopFeedsResult: function () {
        var feeds = [];
        NewsTab.Modules.SectionsManager.Sections.forEach(function (section) {
            if (section.SectionTypeId === Section.TYPES.Normal) {
                section.Feeds.forEach(function (feed) {
                    var uniqueFeed = ($.grep(feeds, function (t) { return (t.Id === feed.Id); }));
                    if (uniqueFeed.length === 0 && feed.ShowInList) {
                        feeds.push(feed);
                    }
                });
            }
        });

        feeds = feeds.sort(NewsTab.Helpers.SortF("TopFeed", "PopularityRank", true));
        var html = "";
        var i = 0;
        feeds.forEach(function (feed) {
            var favIcon = "https://s2.googleusercontent.com/s2/favicons?domain=" + feed.SiteUrl;
            html += "<li class=\"topFeed\" feedId=\"" + feed.Id + "\">";
            html += "<div>";
            if ($("#buildVersion").html().indexOf(".L") > -1 || $("#buildVersion").html().indexOf(".S") > -1) {
                html += "<span class=\"numberOrder\" data-tooltip=\"tooltip\" data-placement=\"right\" title=\"" + feed.PopularityRank + " (Importance Rank = " + feed.PopularityRank + ", Activity Counter = " + feed.UsageCount + ", Recently used = " + feed.LastTimeUsed + "d)\">" + (i + 1) + ".</span>";
            } else {
                html += "<span class=\"numberOrder\">" + (i + 1) + ".</span>";
            }
            html += "<span style=\"cursor: pointer;\">";
            if (feed.TopFeed !== true || i >= SocialTab.MaxTopFeeds) {
                html += "<i class=\"icon-star icon-star-o\" data-space=\"true\" tabindex=\"" + (i + 1000) + "\"></i>";
            } else {
                html += "<i class=\"icon-star gold\" data-space=\"true\" tabindex=\"" + (i + 1000) + "\"></i>";
            }
            html += "</span>";
            html += "<span>";
            html += "<img src=\"" + (feed.Icon != null ? feed.Icon : favIcon) + "\" onerror=\"this.src = '" + favIcon + "'\">";
            html += "</span>";
            html += "<span><a href=\"" + feed.Url + "\" target=\"_blank\" tabindex=\"-1\">" + feed.Name + "</a></span>";
            html += "<span>- <a href=\"http://" + feed.SiteUrl + "\" target=\"_blank\" tabindex=\"-1\">" + feed.SiteUrl + "</a></span>";
            html += "</div>";
            html += "</li>";
            i++;
        });

        $(".topFeedsList").html("").append(html);

        $(".topFeeds .icon-star").click(function () {
            var self = $(this);
            var feedId = self.closest("li.topFeed").attr("feedId");
            var star;
            if (self.hasClass("gold")) {
                self.removeClass("gold").addClass("icon-star-o");
                star = false;
            } else {
                star = true;
                if ($(".topFeeds .icon-star").closest("li .gold").length >= SocialTab.MaxTopFeeds) {
                    var lastTop = $("li.topFeed .gold:last").closest("li");
                    lastTop.find(".gold").removeClass("gold").addClass("icon-star-o");
                }
                self.removeClass("icon-star-o").addClass("gold");
            }

            SocialTab.SetTopFeed(feedId, star);
        });

        $(".topFeed i.icon-star:first").focus();
    },

    SetTopFeed: function (feedId, star) {
        $.ajax({
            type: "POST",
            url: NewsTab.ApiUrl_Global + "post/feed/topfeed/" + feedId + "/" + star,
            headers: { Authorization: 'Bearer ' + NewsTab.Token },
            contentType: "application/json",
            dataType: "json",
            beforeSend: function () {
                $(".topFeeds").css({ "pointer-events": "none", "opacity": "0.5" });
                $(".modalLoader_center .spinner").css({ "display": "block" });
            },
            complete: function () {
                $(".topFeeds").css({ "pointer-events": "all", "opacity": "1" });
                $(".modalLoader_center .spinner").css({ "display": "none" });
            },
            success: function (data) {
                if (data) {
                    SocialTab.UpdateTopFeed(data);
                    SocialTab.TopFeedsResult();

                    if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id === feedId) {
                        if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.TopFeed !== true) {
                            $(".topFeedIndicator .icon-star").removeClass("gold").addClass("icon-star-o");
                            $(".topFeedIndicator").attr("data-original-title", "Star feed");
                            $(".topFeedIndicator").siblings(".tooltip").find(".tooltip-inner").text("Star feed");
                            $(".topFeedIndMenu .topFeedIndDetails p").text("Star feed");
                        } else {
                            $(".topFeedIndicator .icon-star").removeClass("icon-star-o").addClass("gold");
                            $(".topFeedIndicator").attr("data-original-title", "Unstar feed");
                            $(".topFeedIndicator").siblings(".tooltip").find(".tooltip-inner").text("Unstar feed");
                            $(".topFeedIndMenu .topFeedIndDetails p").text("Unstar feed");
                        }
                    }
                }
            },
            error: function (error) {
                console.error("ERROR - TopFeed:");
                console.error(error);
            }
        });
    },

    SelectCurrentSection: function (sectionId, fromSubMenu) {
        SocialTab.SetCurrentState(SocialTab.AllStates.Feeds);
        SocialTab.SetCurrentSection(sectionId, true, false, false, fromSubMenu);
        $(".sourceItem").removeClass("selectedItem");
        $(".sourceItem.active").addClass("selectedItem");
        $(".sourceItem").css("border", "none");
        if (NewsTab.Modules.SectionsManager.CurrentSection != null) {
            $(".sourceItem.active").css("border", "2px solid " + SocialTab.LightenDarkenColor(NewsTab.Modules.SectionsManager.CurrentSection.Color, 70));
        }
    },

    SelectCurrentFeed: function (selectedSource, selectedList) {
        SocialTab.SetCurrentState(SocialTab.AllStates.Feeds);
        SocialTab.SetCurrentSection(selectedSource, false, false);
        SocialTab.SetCurrentFeed(selectedList, true);
    },

    MarkAllAsRead: function (self) {
        if (!self.hasClass("read")) {
            self.addClass("read");
            self.attr("data-original-title", "Mark all as unread");
            self.siblings(".tooltip").find(".tooltip-inner").text("Mark all as unread");
            for (var i = 0, len = NewsTab.Modules.ArticleView.ListedArticles.length; i < len; i++) {
                SocialTab.SetAsRead(NewsTab.Modules.ArticleView.ListedArticles[i].Id, true);
            }
        } else {
            self.removeClass("read");
            self.attr("data-original-title", "Mark all as read");
            self.siblings(".tooltip").find(".tooltip-inner").text("Mark all as read");
            for (var i = 0, len = NewsTab.Modules.ArticleView.ListedArticles.length; i < len; i++) {
                SocialTab.SetAsRead(NewsTab.Modules.ArticleView.ListedArticles[i].Id, false);
            }
        }
    },

    ToggleAsideMenu: function () {
        if ($("body").hasClass("asideMenuIn")) {
            $("body").removeClass("asideMenuIn");
        } else {
            $("body").addClass("asideMenuIn");
            SocialTab.MarkActiveLayout();
        }

        // Close layout and region dropdown on Appearance & Settings
        $(".asideMenu .layoutDetails div.active").removeClass("active");
        $(".asideMenu .confirmLayout").removeClass("active");
        $(".appearanceSettingsDetails .layoutDetails").find("." + NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout).addClass("active");
        if ($(".appearanceSettingsDetails select#selectedRegion1").data("selectBox-selectBoxIt") != undefined) {
            $(".appearanceSettingsDetails select#selectedRegion1").data("selectBox-selectBoxIt").close();
        }

        // Close other dropdowns
        $(".dropdown").removeClass("open");
        $(".customDropdown").remove();

        setTimeout(SocialTab.Menu_SetUpHTML_SubmenuList, 500);
        return false;
    },

    ChangeLayout: function (self, e) {
        e.stopPropagation();

        if ($(".applyLayout").has(e.target).length === 0) {
            $(".layoutMenu div.set-layout").removeClass("active");
            self.addClass("active");

            var layout = self.attr("value");
            var type = $(".applyLayout input").is(":checked") ? 0 : 2;

            SocialTab.Set_Layout(layout, type);

            $(".dropdown").removeClass("open");

            if ($("#applyLytToAllFeeds").is(":checked")) {
                $(".applyLayout.checked").removeClass("checked");
                $("#applyLytToAllFeeds").attr("checked", false);
            }
        }
    },

    CancelTwitterFilter: function () {
        $("#contentTwitterFeed .searchTagResult li").removeClass("selected");
        $(".searchTagResult").height($(".searchTagResult").height() + 50);
        $("#addTwitterFeedBtnField").hide();
    },

    ChangeFeedVisibility: function (id, show, update) {
        var visibleFeeds = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.ShowInList == true) });
        if (show || !update || (visibleFeeds.length > 1 && !show)) {
            var feed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.Id == id) });
            feed = feed[0];
            if (feed.Name != "Timeline" || feed.IsList == true || feed.Type === Feed.TYPES.SOCIALTRENDING) {
                if (show) {
                    feed.ShowInList = true;
                    NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists, id)
                    localStorage.setItem("ST_" + NewsTab.User.Id + "_" + NewsTab.Modules.SectionsManager.CurrentSection.Name + "_HiddenLists", JSON.stringify(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists));
                }
                else {
                    feed.ShowInList = false;
                    NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists.push(id);
                    localStorage.setItem("ST_" + NewsTab.User.Id + "_" + NewsTab.Modules.SectionsManager.CurrentSection.Name + "_HiddenLists", JSON.stringify(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists));
                }
                if (update) {
                    if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id == id) {
                        var visibleFeed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.ShowInList === true) });
                        if (visibleFeed.length > 0) {
                            SocialTab.SetCurrentFeed(visibleFeed[0].Id, true);
                        }
                        else {
                            var defaultFeed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.Name === "Timeline") });
                            if (defaultFeed) {
                                defaultFeed = defaultFeed[0];
                                defaultFeed.ShowInList = true;
                                NewsTab.Helpers.RemoveItemFromArray(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists, defaultFeed.Id);
                                localStorage.setItem("ST_" + NewsTab.User.Id + "_" + NewsTab.Modules.SectionsManager.CurrentSection.Name + "_HiddenLists", JSON.stringify(NewsTab.Modules.SectionsManager.CurrentSection.HiddenLists));
                                SocialTab.SetCurrentFeed(defaultFeed.Id, true);
                            }

                        }
                    }
                    else {
                        SocialTab.Menu_SetUpHTML_SubmenuList();
                    }
                }
            }
        }
        else {
            $('.toastMessage').html("At least one feed needs to be enabled");
            $('.toastMessage').fadeIn(400).delay(3000).fadeOut(400);
        }
    },

    SearchFilter: function (sender) {
        $("#contentTwitterFeed").addClass("withSearchResults");
        var value = $(sender).closest("#contentTwitterFeed").find(".filterInput").val();
        if (value && value.length > 0) {
            SocialTab.GetSearchTags(value);
        }
    },

    GetSearchTags: function (query) {
        $(".searchTagResult").remove();
        var callUrl = NewsTab.ApiUrl_Base + "api/twitter/get/getsearchtags/" + encodeURIComponent(query);
        var self = this;
        $.ajax({
            url: callUrl,
            cache: false,
            headers: { Authorization: 'Bearer ' + NewsTab.Token },
            error: function (error) {
                if (self.ShowLoadErrors) {
                    console.error("ERROR - GetSearchTags:");
                    console.error(error);
                }
                NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                    Title: "Twitter",
                    Color: "red",
                    Text: "Please connect a Twitter Account first!"
                });
            }
        }).then(function (data) {
            if (data) {
                var twitterSection = $.grep(NewsTab.Modules.SectionsManager.Sections, function (e) { return e.Name === "Twitter" });
                $(".searchTagResult").remove();
                var height = $("#addNewContent").height() - 180;

                var hasUsers = false, hasHashs = false;
                var html = "<div style=\"height:" + height + "px\" class=\"searchTagResult twoColumns\">";
                html += "<div class=\"searchTagResultStates\"><span class=\"icon-twitter\"></span> Results for <strong>" + query + "</strong> (" + data.length + " feeds):</div>";
                var htmlHash = "<ul class=\"searchTagResultHash\">";
                var htmlUser = "<ul class=\"searchTagResultUser\">";
                var tabIndex = 1010;
                for (var i = 0, l = data.length; i < l; i++) {
                    if (data[i].ProfilePictureUrl != null && data[i].ProfilePictureUrl[0] == "#") {
                        var feed = $.grep(twitterSection[0].Feeds, function (e) { return e.Name === "#" + data[i].Username });
                        hasHashs = true;
                        htmlHash += "<li data-type=\"hashtag\" data-value=\"" + data[i].Username + "\" " + (feed.length > 0 ? "class=\"disabled\"" : "") + " tabindex=\"" + tabIndex + "\">";
                        htmlHash += "<div class=\"imageContainer\"><span class=\"hash\">#</span><div class=\"previewBtn\"><a href=\"#\" class=\"btn blue preview\" onclick=\"SocialTab.HTML_OpenTwitterFeedPreview($(this));\" tabindex=\"" + (++tabIndex) + "\">Preview</a></div></div>";
                        htmlHash += "<i class=\"icon-add button\"></i><div class=\"filterDesc\">#" + data[i].Username + "</div>";
                        htmlHash += "<div class=\"feedPreview\"></div>";
                        htmlHash += "</li>";
                    }
                    else {
                        var feed = $.grep(twitterSection[0].Feeds, function (e) { return e.Name === "@" + data[i].Username });
                        hasUsers = true;
                        htmlUser += "<li data-type=\"usertag\" data-value=\"" + data[i].Username + "\" " + (feed.length > 0 ? "class=\"disabled\"" : "") + " tabindex=\"" + tabIndex + "\">";
                        htmlUser += "<div class=\"imageContainer\" style=\"background-image:url('" + data[i].ProfilePictureUrl + "');\"><div class=\"previewBtn\"><a href=\"#\" class=\"btn blue preview\" onclick=\"SocialTab.HTML_OpenTwitterFeedPreview($(this));\" tabindex=\"" + (++tabIndex) + "\">Preview</a></div></div>";
                        htmlUser += "<i class=\"icon-add button\"></i><div class=\"filterDesc\">@" + data[i].Username + "<span>" + data[i].FullName + "</span></div>";
                        htmlUser += "<div class=\"feedPreview\"></div>";
                        htmlUser += "</li>";
                    }
                    tabIndex++;
                }
                if (!hasHashs) {
                    htmlHash += "<div class=\"table\"><div class=\"content\"><div class=\"twitterFeedForm\"><span class=\"icon-twitter\"></span><br/>No matching twitter hashtags found!</div></div></div>";
                }
                if (!hasUsers) {
                    htmlUser += "<div class=\"table\"><div class=\"content\"><div class=\"twitterFeedForm\"><span class=\"icon-twitter\"></span><br/>No matching twitter users found!</div></div></div>";
                }
                htmlHash += "</ul>";
                htmlUser += "</ul>";
                html += htmlUser;
                html += htmlHash;
                html += "</div>";
                $("#contentTwitterFeed .table").before(html);
            }
        });
    },

    Menu_SetUpItemsTemplate: function (section) {
        section.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
        var isSectionRtl = NewsTab.Helpers.ShouldBeRTL(section.Name);

        $(".sourceItemLists").html("");
        if (section && section.SectionTypeId !== Section.TYPES.Chrome) {
            var currentFeeds = $.grep(section.Feeds, function (t) { return (t.ShowInList === true && t.Id !== section.Id + "-100" && t.Name != "Timeline") });
            var defaultFeed = $.grep(section.Feeds, function (t) { return (t.Id === section.Id + "-100" || t.Name == "Timeline") });
            if (defaultFeed.length > 0) {
                defaultFeed = defaultFeed[0];
            }

            var result = "";
            if (SocialTab.AppSettings.BorderStyle === "border-none") {
                result += "<div class=\"lastActiveItemsConteinerName\" data-section-id=\"" + section.Id + "\" style=\"color: " + section.Color + "; border-left: 5px solid " + section.Color + ";\" " + (isSectionRtl ? "dir=\"rtl\"" : "") + ">";
            } else {
                result += "<div class=\"lastActiveItemsConteinerName\" data-section-id=\"" + section.Id + "\" style=\"color: " + section.Color + ";\" " + (isSectionRtl ? "dir=\"rtl\"" : "") + ">";
            }
            switch (section.Id) {
                case "1":
                case "2":
                    result += "<i class=\"sectionIcon icon-" + section.ClassName + "\"></i>";
                    break;
                default:
                    {
                        if (section.ClassName) {
                            result += "<i class=\"sectionIcon icon-" + section.ClassName + "\"></i>";
                        } else if ((section.User ? section.User.ProfilePictureUrl : section.IconUrl)) {
                            result += "<img class=\"sectionIcon\" src=\"" + (section.User ? section.User.ProfilePictureUrl : section.IconUrl) + "\"/>";
                        } else {
                            result += "<i class=\"sectionIcon\">" + section.Name.substring(0, 2) + "</i>";
                        }
                    }
            }
            result += "<p>" + section.Name + "</p>";
            if (section.Id === NewsTab.Modules.SectionsManager.CurrentSection.Id && section.EditCssClass !== null) {
                result += "<i class=\"icon-angle-right " + section.EditCssClass + "\" style=\"color: " + section.Color + "!important;\" data-space=\"true\" data-space=\"true\" tabindex=\"500\"></i>";
            }
            result += "</div>";

            result += "<div class=\"line-separator\"></div>";

            result += "<ul class=\"sourceItemSubmenu\">";

            var currentFeedId = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id;
            var activeClass = (currentFeedId == null || (currentFeedId != null && currentFeedId == defaultFeed.Id)) ? "active" : "";
            if ((section.SectionTypeId === Section.TYPES.Normal && currentFeeds.length > 1) || section.SectionTypeId === Section.TYPES.Home) {
                result += "<li data-feed-id=\"" + defaultFeed.Id + "\" class=\"menuItem defaultFeed " + activeClass + "\" tabindex=\"505\">";
                result += "<span>" + defaultFeed.Name + "</span>";

                if (currentFeedId === defaultFeed.Id) {
                    var marginLeft = (section.SectionTypeId === Section.TYPES.Home) ? marginLeft = -62 : marginLeft = -40;
                    var showUpdateTooltip = (SocialTab.ShowUpdateTooltip) ? "importatShow" : "";
                    result += SocialTab.NewArticlesNotificationTmpl(showUpdateTooltip, marginLeft);
                }
                result += "</li>";
            }
            else if (section.SectionTypeId === Section.TYPES.Social && defaultFeed.ShowInList) {
                result += "<li data-feed-id=\"" + defaultFeed.Id + "\" class=\"menuItem defaultFeed " + activeClass + "\" tabindex=\"505\">";
                result += "<span>" + defaultFeed.Name + "</span>";
                if (defaultFeed.EditMenuIcon && defaultFeed.Type != "twitter/list") {
                    result += "<i class=\"" + defaultFeed.EditMenuIcon + " " + defaultFeed.EditMenuClass + "\" data-item=\"" + defaultFeed.Id + "\" data-space=\"true\" tabindex=\"506\" data-section-id=\"" + section.Id + "\"></i>";
                }
                if (currentFeedId === defaultFeed.Id) {
                    var marginLeft = -40;
                    var showUpdateTooltip = (SocialTab.ShowUpdateTooltip) ? "importatShow" : "";
                    result += SocialTab.NewArticlesNotificationTmpl(showUpdateTooltip, marginLeft);
                }
                result += "</li>";
            }

            if (section.Feeds.length > SocialTab.NumberOfVisibleFeeds) {
                result += "<li class=\"yOptionItem notHover yOption dropdown\" style=\"float: right;\">";
                result += "<i class=\"icon-more showDropedown\" data-tooltip=\"tooltip\" title=\"More&nbsp;Feeds\"  data-space=\"true\" tabindex=\"549\"></i>";
                result += "<ul class=\"sourceItemDropdown dropdown-menu pull-right socialTabSourceList\"></ul>";
                result += "</li>";
            }
            result += "</ul>";

            $(".sourceItemSelectedList").html(result);
        }
    },

    Menu_SetUpItemsTemplateMobile: function (selectedSourceId) {
        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return (t.Id === selectedSourceId) });
        if (section.length) {
            section = section[0];

            section.Feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
            var isSectionRtl = NewsTab.Helpers.ShouldBeRTL(section.Name);

            $(".sectionName").html("");
            if (section && section.SectionTypeId !== Section.TYPES.Chrome) {

                var result = "";
                result += "<div class=\"xOption sourceItem\" data-section-id=\"" + section.Id + "\" style=\"background-color: " + section.Color + "\">";
                switch (section.Id) {
                    case "1":
                    case "2":
                        result += "<i class=\"icon icon-" + section.ClassName + "\"></i>";
                        break;
                    default:
                        {
                            if (section.ClassName) {
                                result += "<i class=\"icon-" + section.ClassName + "\"></i>";
                            } else if ((section.User ? section.User.ProfilePictureUrl : section.IconUrl)) {
                                result += "<img src=\"" + (section.User ? section.User.ProfilePictureUrl : section.IconUrl) + "\"/>";
                            } else {
                                result += "<i>" + section.Name.substring(0, 2) + "</i>";
                            }
                        }
                }
                result += "<div class=\"sourceItemArrow\"></div>";
                result += "</div>";
                result += "<div class=\"lastActiveItemsConteinerName\" data-section-id=\"" + section.Id + "\" " + (isSectionRtl ? "dir=\"rtl\"" : "") + ">";
                result += "<p>" + section.Name + "</p>";
                if (section.Id === NewsTab.Modules.SectionsManager.CurrentSection.Id && section.EditCssClass !== null) {
                    result += "<i class=\"icon-angle-right " + section.EditCssClass + "\" data-space=\"true\" data-space=\"true\" tabindex=\"10\"></i>";
                }

                result += "</div>";

                $(".sectionName").html(result);
            }
        }
    },

    Menu_PopulateVisibleItems: function (section, feeds) {
        var result1 = "";
        var result2 = "";

        var i = 510;
        var counter = 0; // Counter for "< SocialTab.NumberOfVisibleFeeds" instear of "list.OrederNbr" since on twitter to make sure the # and @ feeds are always last they start with a Oreder number 100 and up
        feeds.forEach(function (feed) {

            if (feed.ShowInList && (section.SectionTypeId != Section.TYPES.Social || feed.Name != "Timeline")) { // to make sure that the hidden feeds of twiiter and other sections are not counted in this logic
                var isItemRtl = NewsTab.Helpers.ShouldBeRTL(feed.Name);
                if (counter < SocialTab.NumberOfVisibleFeeds) {
                    var selectedFeed = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.ShowInList === true/* && t.Id !== (NewsTab.Modules.SectionsManager.CurrentSection.Id + "-100")*/); });
                    var currentFeedId = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Id;
                    var activeClass = "";
                    if (selectedFeed.length > 1 && currentFeedId != null && currentFeedId == feed.Id && currentFeedId !== "-0") {
                        activeClass = (currentFeedId == feed.Id) ? "active" : "";
                    } else if (selectedFeed.length === 1 && currentFeedId === "-0") {
                        if (selectedFeed[0].Id === feed.Id) {
                            activeClass = "active";
                        } else {
                            activeClass = "";
                        }
                    }
                    result1 += "<li data-feed-id=\"" + feed.Id + "\" class=\"menuItem " + activeClass + "\" tabindex=\"" + (i++) + "\">";
                    if (section.SectionTypeId === Section.TYPES.Normal || feed.Type === Feed.TYPES.TRENDING) {
                        if (feed.Icon) {
                            if (feed.Icon.indexOf("http") > -1) {
                                result1 += "<img class=\"listIcon\" src=\"" + feed.Icon + "\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" \>";
                            } else {
                                result1 += "<i class=\"listIcon " + feed.Icon + "\"></i>";
                            }
                        } else {
                            result1 += "<img class=\"listIcon\" src=\"http://" + feed.SiteUrl + "/favicon.ico\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" \>";
                        }
                    }
                    result1 += "<span " + (isItemRtl ? "dir=\"rtl\"" : "") + ">" + feed.Name + "</span>";
                    if (section.Id === NewsTab.Modules.SectionsManager.CurrentSection.Id && feed.EditMenuIcon && feed.Type != "twitter/list") {
                        result1 += "<i class=\"" + feed.EditMenuIcon + " " + feed.EditMenuClass + "\" data-item=\"" + feed.Id + "\" data-space=\"true\" tabindex=\"" + (i++) + "\" data-section-id=\"" + section.Id + "\"></i>";
                    }

                    if (NewsTab.Modules.SectionsManager.CurrentSection.Id === section.Id && feeds.length === 1) {
                        var showUpdateTooltip = (SocialTab.ShowUpdateTooltip) ? "importatShow" : "";
                        result1 += SocialTab.NewArticlesNotificationTmpl(showUpdateTooltip, -40);
                    }

                    result1 += "</li>";
                } else {
                    result2 += "<li data-feed-id=\"" + feed.Id + "\" class=\"menuSubItems\">";
                    if (section.SectionTypeId === Section.TYPES.Normal) {
                        if (feed.Icon) {
                            result2 += "<img class=\"listIcon\" src=\"" + feed.Icon + "\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" \>";
                        } else {
                            result2 += "<img class=\"listIcon\" src=\"http://" + feed.SiteUrl + "/favicon.ico\" onError=\"this.onerror=null;this.src='/Media/ExtensionImages/rss.png';\" \>";
                        }
                    }
                    result2 += "<span " + (isItemRtl ? "dir=\"rtl\"" : "") + ">" + feed.Name + "</span>";
                    result2 += "</li>";
                }
                counter++;
            }
        });

        if ($(".lastActiveItemsContainer .sourceItemSubmenu").find("li.yOptionItem").length !== 0) {
            $(".lastActiveItemsContainer .sourceItemSubmenu").find("li.yOptionItem").before(result1);
        } else {
            if ($(".lastActiveItemsContainer .sourceItemSubmenu").find("li.menuItem").length !== 0) {
                $(".lastActiveItemsContainer .sourceItemSubmenu").find("li.menuItem").after(result1);
            } else {
                $(".lastActiveItemsContainer .sourceItemSubmenu").html(result1);
            }
        }

        $(".yOption .sourceItemDropdown").html(result2);

        //if (section.SectionTypeId === Section.TYPES.Social) {
        //    $(".lastActiveItemsContainer .sourceItemSubmenu").append("<li class=\"addFilter notHover\" style=\"float: right; margin-right: 15px;\"><a class=\"btn addSocial\"><i class=\"icon-add\"></i></a></li>");
        //}

        if ($(".sourceItemDropdown li").length > 0) {
            $(".yOptionItem").show();
        } else {
            $(".yOptionItem").hide();
        }

        //SocialTab.SetLastActiveFeeds();
        SocialTab.ReorderFeeds();
    },

    Menu_SetUpHTML_SubmenuList: function () {
        if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId !== Section.TYPES.Chrome) {
            NewsTab.Modules.AddNewContent.Setup_SectionsInOrganizer();
            var feeds = $.grep(NewsTab.Modules.SectionsManager.CurrentSection.Feeds, function (t) { return (t.ShowInList === true && t.Id !== (NewsTab.Modules.SectionsManager.CurrentSection.Id + "-100")); });
            var currentFeed = NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed;

            if (currentFeed != null && currentFeed !== undefined && NewsTab.Modules.SectionsManager.CurrentSection.Id !== undefined) {
                if (SocialTab.LastActiveFeeds) {
                    if (SocialTab.LastActiveFeeds.indexOf(currentFeed.Id) >= SocialTab.NumberOfVisibleFeeds && currentFeed.ShowInList === true) {
                        NewsTab.Helpers.RemoveItemFromArray(SocialTab.LastActiveFeeds, currentFeed.Id);
                        SocialTab.LastActiveFeeds.unshift(String(currentFeed.Id));
                    }

                    for (var i = 0; i < SocialTab.LastActiveFeeds.length; i++) {
                        var feed = $.grep(feeds, function (t) { return t.Id === SocialTab.LastActiveFeeds[i]; });
                        if (feed.length) {
                            feed = feed[0];
                            feed.OrderNumber = i;
                        }
                    }
                }

                this._options && $.each(this._options, function (key, value) {
                    if (defaults[key] !== value) options[key] = value;
                });

                feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));

                if (NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Social && SocialTab.NumberOfVisibleFeeds <= 1) {
                    feeds.splice(feeds.indexOf(currentFeed), 1);
                    feeds.splice(0, 0, currentFeed);
                }

                SocialTab.CalculateNumberOfMenuItems();
                SocialTab.Menu_SetUpItemsTemplate(NewsTab.Modules.SectionsManager.CurrentSection);

                SocialTab.Menu_PopulateVisibleItems(NewsTab.Modules.SectionsManager.CurrentSection, feeds);
                SocialTab.MenuItemHover();
                SocialTab.SimulateFeedHover();
            }
        }
    },

    Menu_SetUpHTML_SubmenuList_Temporary: function (selectedSourceId) {
        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return (t.Id === selectedSourceId) });
        section = section[0];

        if (section && section.SectionTypeId !== Section.TYPES.Chrome) {
            var feeds = $.grep(section.Feeds, function (t) { return (t.ShowInList === true && t.Id !== (selectedSourceId + "-100")); });
            feeds.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
            SocialTab.CalculateNumberOfMenuItems();
            SocialTab.Menu_SetUpItemsTemplate(section);
            SocialTab.Menu_PopulateVisibleItems(section, feeds);
            SocialTab.MenuItemHover();
            SocialTab.SimulateFeedHover();
        }
    },

    MenuItemHover: function () {
        $(".lastActiveItemsContainer .sourceItemSubmenu li").hover(function () {
            if ($(this).parents("li").hasClass("yOptionItem") || $(this).hasClass("yOptionItem") || $(this).hasClass("addFilter")) return;
            if ($(this).find("[id^='editName_']").length > 0) {
                $(this).css({ "max-width": "220px" });
            } else {
                var newWidth = $(".sourceItemSelectedList").width() - (150 + (162 * ($(".menuItem").length - 2)));
                if ($("#dashboardGridBody").width() > 800) {
                    newWidth = $(".sourceItemSelectedList").width() - (335 + (162 * ($(".menuItem").length - 2)));
                }
                if (newWidth > 350) {
                    newWidth = 350;
                }
                $(this).css({ "max-width": newWidth + "px" });
            }
        }, function () {
            if ($(this).parents("li").hasClass("yOptionItem") || $(this).hasClass("yOptionItem") || $(this).hasClass("addFilter")) return;
            if ($(this).find("[id^='editName_']").length > 0) {
                $(this).css({ "max-width": "220px" });
            } else {
                $(this).css({ "max-width": "155px" });
            }
        });
    },

    SimulateFeedHover: function () {
        $(".lastActiveItemsContainer").on("focus", ".menuItem", function (e) {
            var hoveredFeed = $(e.target);
            if (hoveredFeed.hasClass("menuItem")) {
                $(".menuItem.selected").removeClass("selected");
                hoveredFeed.addClass("selected");
                if (hoveredFeed.find("[id^='editName_']").length > 0) {
                    hoveredFeed.css({ "max-width": "220px" });
                } else {
                    var newWidth = $(".sourceItemSelectedList").width() - (150 + (162 * ($(".menuItem").length - 2)));
                    if ($("#dashboardGridBody").width() > 800) {
                        newWidth = $(".sourceItemSelectedList").width() - (335 + (162 * ($(".menuItem").length - 2)));
                    }
                    if (newWidth > 350) {
                        newWidth = 350;
                    }
                    hoveredFeed.css({ "max-width": newWidth + "px" });
                }
            }
        }).on("focus", ".showDropedown", function () {
            $(".menuItem.selected").removeClass("selected");
        });
    },

    CalculateNumberOfMenuItems: function () {
        if ($("#dashboardGridBody").width() >= 800) {
            SocialTab.NumberOfVisibleFeeds = parseInt(($(".lastActiveItemsContainer .sourceItemSelectedList").width() - 415) / 155);
        } else if ($("#dashboardGridBody").width() <= 300 && (NewsTab.Modules.SectionsManager.CurrentSection.Feeds.length === 3 || NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Social)) {
            SocialTab.NumberOfVisibleFeeds = parseInt($(".lastActiveItemsContainer .sourceItemSelectedList").width() / 155);
        } else {
            SocialTab.NumberOfVisibleFeeds = parseInt(($(".lastActiveItemsContainer .sourceItemSelectedList").width() - 155) / 155);
        }
    },

    /**** Notifications ****/

    Notification_SetUpHTML_OkCancel: function (title, message, okText, cancelText, okCallback, cancelCallback) {
        var notification = document.createElement("div");
        notification.className = "notification-modal";

        var doubleModal = false;
        if ($("#simplemodal-overlay").length === 1) {
            doubleModal = true;
        }

        var html = "<h2>" + title + "</h2>";
        html += "<p>" + message + "</p>";
        html += "<div class=\"buttons\">";
        html += "<button class=\"btn cancel gray\" tabindex=\"1000\">" + cancelText + "</a>";
        html += "<button class=\"btn ok blue\" tabindex=\"1001\" onclick=\"\" >" + okText + "</a>";

        notification.innerHTML = html;
        notification.getElementsByClassName("ok")[0].addEventListener("click", okCallback);
        notification.getElementsByClassName("cancel")[0].addEventListener("click", function () {
            if (doubleModal) {
                $('#doubleModal').remove();;
            } else {
                $.modal.impl.close();
            }
            return false;
        });

        if (doubleModal) {
            var overlay = "<div id=\"doubleModal\"><div class=\"modalCell\" style=\"max-width:400px;min-width:180px;\"><div class=\"modalContent\" >";
            overlay += "</div></div></div>";

            $(".simplemodal-wrap > div").append(overlay);
            $(".simplemodal-wrap > div .modalContent").append(notification);
        }
        else {
            $.modal(notification, {
                overlayClose: true,
                autoResize: false,
                autoPosition: true,
                minWidth: "180",
                maxWidth: "400",
                onClose: function () {
                    $.modal.impl.close();
                    $(".notification-modal").remove();
                }
            });

            $(".notification-modal").closest(".simplemodal-container").addClass("heightAuto");
            $.modal.impl.setPosition();
        }
        $(".btn.gray").focus();
    },

    /**** Settings ****/

    Settings_AttacheEventHandlers: function () {
        $(".extensionLink").on("click", function () {
            if (!$(this).hasClass("active")) {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
                $(".extensionLink").addClass("active");
                $(".extensionDetails").addClass("active");
                $(".instalExtension").addClass("active");
            } else {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
            }
        });

        $(".spreadWordLink").on("click", function () {
            if (!$(this).hasClass("active")) {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
                $(".spreadWordLink").addClass("active");
                $(".spreadWordDetails").addClass("active");
            } else {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
            }
        });

        $(".appearanceSettingsLink").on("click", function () {
            if (!$(this).hasClass("active")) {
                $(".asideMenu .active").removeClass("active");
                $(".appearanceSettingsLink").addClass("active");
                $(".appearanceSettingsDetails").addClass("active");
                $(".appearanceSettingsDetails .layoutDetails").find("." + NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout).addClass("active");
                if ($(".appearanceSettingsDetails select#selectedRegion1").data("selectBox-selectBoxIt") != undefined) {
                    $(".appearanceSettingsDetails select#selectedRegion1").data("selectBox-selectBoxIt").close();
                }
            } else {
                $(".asideMenu .active").removeClass("active");
            }
        });

        $(".helpFeedbackLink").on("click", function () {
            if (!$(this).hasClass("active")) {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
                $(".helpFeedbackLink").addClass("active");
                $(".helpFeedbackDetails").addClass("active");
            } else {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
            }
        });

        $(".feedImportLink").on("click", function () {
            if (!$(this).hasClass("active")) {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
                $(".feedImportLink").addClass("active");
                $(".feedImportDetails").addClass("active");
            } else {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
            }
        });

        $(".aboutLink").on("click", function () {
            if (!$(this).hasClass("active")) {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
                $(".aboutLink").addClass("active");
                $(".aboutDetails").addClass("active");
            } else {
                $(".asideMenu .active").not("[class^='layout-']").removeClass("active");
            }
        });

        $(".settingsItemDetails .getExtension").on("click", function () {
            //if (!$(".instalExtension").hasClass("active")) {
            //    $(".rateExtension").removeClass("active");
            //    $(".instalExtension").addClass("active");
            //} else {
            //    $(".rateExtension").addClass("active");
            //    $(".instalExtension").removeClass("active");
            //}
        });

        $(".appearanceSettingsDetails .menuItemTitle").on("click", function () {
            if (!$(this).closest(".settingsDetailsItem").hasClass("active")) {
                $(this).closest(".settingsDetailsItem").addClass("active");
            } else {
                $(this).closest(".settingsDetailsItem").removeClass("active");
            }
        });

        $(".themeItem").on("click", function () {
            var value = $(this).attr("value");
            $(".themeItem").removeClass("active");
            $(this).addClass("active");
            $(this).closest(".settingsDetailsItem").find(".menuItemSelected").text($(this).find("span").html());
            switch (value) {
                case "theme-light":
                    SocialTab.Set_AppSetings_LightTheme(true, true);
                    break;
                case "theme-dark":
                    SocialTab.Set_AppSetings_LightTheme(false, true);
                    break;
                default:
                    SocialTab.Set_AppSetings_LightTheme(true, true);
                    break;
            }
        });

        $(".topBarItem").on("click", function () {
            var value = $(this).attr("value");
            $(".topBarItem").removeClass("active");
            $(this).addClass("active");
            $(this).closest(".settingsDetailsItem").find(".menuItemSelected").text($(this).find("span").html());
            if (value === "topBar-fixed") {
                SocialTab.Set_AppSetings_TopBar(true, true);
            } else {
                SocialTab.Set_AppSetings_TopBar(false, true);
            }
        });

        $(".asideMenu .layoutDetails div").on("click", function () {
            $(".confirmLayout").addClass("active");
            $(".asideMenu .layoutDetails div").removeClass("active");
            $(this).addClass("active");
            var result = "<div style=\"margin-bottom: 15px;\">";
            result += "<span>Apply " + $(this).attr("name") + " to:</span>";
            result += "</div>";
            result += "<div style=\"position: relative; height: 40px;\"><input id=\"applyFeed\" layout-type=\"2\" type=\"radio\" name=\"layout\" />";
            result += "<label for=\"applyFeed\" data-space=\"true\" tabindex=\"123\">This Feed (" + NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Name + ")</label>";
            result += "<div class=\"check active\"></div>";
            result += "</div>";
            result += "<div style=\"position: relative; height: 40px;\"><input id=\"applySection\" layout-type=\"1\" type=\"radio\" name=\"layout\" />";
            result += "<label for=\"applySection\" data-space=\"true\" tabindex=\"124\" >This Section (" + NewsTab.Modules.SectionsManager.CurrentSection.Name + ")</label>";
            result += "<div class=\"check\"></div>";
            result += "</div>";
            result += "<div style=\"position: relative; height: 40px;\"><input id=\"applySectionFeed\" layout-type=\"0\" type=\"radio\" name=\"layout\" />";
            result += "<label for=\"applySectionFeed\" data-space=\"true\" tabindex=\"125\">All Feeds and Sections</label>";
            result += "<div class=\"check\"></div>";
            result += "</div>";
            result += "<div class=\"btnContainer\">";
            result += "<a style=\"float: left;\" class=\"btn cancel\" onclick=\"SocialTab.HTML_Event_CancelLayoutClick($(this))\" tabindex=\"130\">Cancel</a>";
            result += "<a style=\"float: right;\" class=\"btn save blue add disabled\" onclick=\"SocialTab.HTML_Event_SaveLayoutClick($(this))\" tabindex=\"131\">Apply</a>";
            result += "</div>";

            $(".confirmLayout").html(result);

            $(".confirmLayout label").on("click", function () {
                $(".confirmLayout .check").removeClass("active");
                $(this).closest("div").find(".check").addClass("active");
                $(this).closest(".confirmLayout").find(".save").removeClass("disabled");
            });

            $(".confirmLayout .check").on("click", function () {
                $(this).closest(".confirmLayout").find("input[type=radio]").is(":checked");
                $(".confirmLayout .check").removeClass("active");
                $(this).addClass("active");
                $(this).closest(".confirmLayout").find(".save").removeClass("disabled");
            });

            SocialTab.MarkActiveLayout();
        });

        $(".borderItem").on("click", function () {
            var value = $(this).attr("value");
            $(".borderItem").removeClass("active");
            $(this).addClass("active");
            $(this).closest(".settingsDetailsItem").find(".menuItemSelected").text($(this).find("span").html());
            SocialTab.Set_AppSetings_BorderSytle(value, true);
        });

        $(".settingsItemDetails").on("click", ".regionBox", function () {
            if (!$(".regionBox").hasClass("active")) {
                $(".regionBox").addClass("active");
                $(".easy-autocomplete").show();
            } else {
                $(".regionBox").removeClass("active");
                $(".easy-autocomplete").hide();
            }
        });

        $(".helpFeedbackDetails .settingsDetailsItemHeader").on("click", function (e) {
            if (!$(this).closest(".settingsDetailsItem").hasClass("active")) {
                $(".settingsDetailsItem").removeClass("active");
                $(this).closest(".settingsDetailsItem").addClass("active");
                $(this).closest(".settingsDetailsItem").find(".focus").focus();
            } else {
                $(this).removeClass("active");
                $(".settingsDetailsItem").removeClass("active");
            }
        });

        $(".availibleOn .icon-googlechrome").on("click", function () {
            $(".availibleOn .dropdown-menu").toggleClass("open");
        });

        $("#showSignatureOnSharedArticles").on("change", function () {
            if (NewsTab.Modules.Sharing !== undefined) {
                NewsTab.Modules.Sharing.EnableSharingSignature($(this).is(":checked"));
                SocialTab.HTML_SaveUserSettings("DisableShareSignature", !NewsTab.Modules.Sharing.EnableCustomShareLinks);
            }
        });
        var gridSize = document.getElementById('gridSize');
        if (gridSize !== null && gridSize.noUiSlider == undefined) {
            SocialTab.HTML_RenderRange(gridSize, 3, 1, 0, 6);
            gridSize.noUiSlider.on('change', function (value) {
                SocialTab.Set_FeedItemSettings_ActiveBoxSize(parseInt(value));
            });
        }

        var fontSize = document.getElementById('fontSize');
        if (fontSize !== null && fontSize.noUiSlider == undefined) {
            SocialTab.HTML_RenderRange(fontSize, 2, 1, 0, 4);
            fontSize.noUiSlider.on('change', function (value) {
                SocialTab.Set_AppSettings_ActiveFontSize(parseInt(value));
            });
        }

        SocialTab.HTML_RenderChangeRegionEdition();
    },

    HTML_Event_CancelLayoutClick: function (sender) {
        $(sender).closest(".confirmLayout").find(".check").removeClass("active");
        $(sender).closest(".confirmLayout").removeClass("active");
        $(sender).closest(".confirmLayout").find("input[type=radio]").attr("checked", false);
        $(sender).closest(".confirmLayout").find(".save").addClass("disabled");
    },

    HTML_Event_SaveLayoutClick: function (sender) {
        var layout = $(".layoutDetails .active").attr("value");
        var type = parseInt($(".confirmLayout input[type=radio]:checked").attr("layout-type"));

        SocialTab.Set_Layout(layout, type);
        SocialTab.HTML_Event_CancelLayoutClick(sender);
    },

    Settings_UpdateHTML_FromStorage: function () {
        if (NewsTab.User) {
            var boxSize = localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveBoxSize");
            if (boxSize) {
                var gridSize = document.getElementById('gridSize');
                if (gridSize !== null) {
                    if (gridSize.noUiSlider == undefined) {
                        SocialTab.HTML_RenderRange(gridSize, boxSize, 1, 0, 6);
                    } else {
                        gridSize.noUiSlider.set(boxSize);
                    }
                    SocialTab.Set_FeedItemSettings_ActiveBoxSize(boxSize);
                }
            }

            var fontSize = localStorage.getItem("ST_" + NewsTab.User.Id + "_Settings_ItemActiveFontSize");
            if (fontSize) {
                var fontSize1 = document.getElementById('fontSize');
                if (fontSize1 !== null) {
                    if (fontSize1.noUiSlider == undefined) {
                        SocialTab.HTML_RenderRange(fontSize1, fontSize, 1, 0, 4);
                    } else {
                        fontSize1.noUiSlider.set(fontSize);
                    }
                    SocialTab.Set_AppSettings_ActiveFontSize(fontSize);
                }
            }
        }
    },

    GetColorRabgeString: function (val, min, max) {
        var color1 = "#FFF", color2 = "#333";
        var lightTheme = SocialTab.AppSettings.LightTheme;
        if (lightTheme === "true") {
            color1 = "#333";
            color2 = "#FFF";
        }
        var sizeVal = (val - min) / (max - min);
        return "-webkit-gradient(linear, left top, right top, color-stop(" + sizeVal + ", " + color1 + "), color-stop(" + sizeVal + ", " + color2 + "))";
    },

    SetupTheme: function () {
        if (SocialTab.AppSettings.LightTheme === false) {
            SocialTab.Set_AppSetings_LightTheme(false);
            $(".themeDetails").find(".themeItem[value=theme-dark]").addClass("active");
        } else {
            SocialTab.Set_AppSetings_LightTheme(true);
            $(".themeDetails").find(".themeItem[value=theme-light]").addClass("active");
        }
    },

    SetupTopBar: function () {
        if (SocialTab.AppSettings.TopBarFixed === true) {
            SocialTab.Set_AppSetings_TopBar(true);
            $(".topBarDetails").find(".topBarItem[value=topBar-fixed]").addClass("active");
        } else {
            SocialTab.Set_AppSetings_TopBar(false);
            $(".topBarDetails").find(".topBarItem[value=topBar-responsive]").addClass("active");
        }
    },

    SetupBorder: function () {
        SocialTab.Set_AppSetings_BorderSytle(SocialTab.AppSettings.BorderStyle);
        $(".borderDetails").find(".borderItem[value=" + SocialTab.AppSettings.BorderStyle + "]").addClass("active");
    },

    /**** HTML OLD ****/

    HTML_SetUpSourceList: function (skipLoad) {
        var sourceList = $(".socialTabSourceList");
        sourceList.html("");
        for (var i = 0, len = NewsTab.Modules.SectionsManager.Sections.length; i < len; i++) {
            if (NewsTab.Modules.SectionsManager.Sections[i].ShowInSourceList) {
                if (NewsTab.Modules.SectionsManager.Sections[i].IconUrl) {
                    sourceList.append("<li class=\"sourceItem\" data-section-id=\"" + NewsTab.Modules.SectionsManager.Sections[i].Id + "\"><img src=\"" + NewsTab.Modules.SectionsManager.Sections[i].IconUrl + "\" style=\"background-color:" + NewsTab.Modules.SectionsManager.Sections[i].Color + "\"/><span class=\"\">" + NewsTab.Modules.SectionsManager.Sections[i].Name + "</span></li>");
                }
                else {
                    sourceList.append("<li class=\"sourceItem\" data-section-id=\"" + NewsTab.Modules.SectionsManager.Sections[i].Id + "\"><i " + (NewsTab.Modules.SectionsManager.Sections[i].ClassName ? "class=\"icon-" + NewsTab.Modules.SectionsManager.Sections[i].ClassName + "\" " : "") + "style=\"background-color:" + NewsTab.Modules.SectionsManager.Sections[i].Color + "\">" + (NewsTab.Modules.SectionsManager.Sections[i].ClassName ? "" : NewsTab.Modules.SectionsManager.Sections[i].Name.substring(0, 2)) + "</i><span class=\"\">" + NewsTab.Modules.SectionsManager.Sections[i].Name + "</span></li>");
                }
            }
        }

        if (!skipLoad) {
            SocialTab.HTML_SetUpFeed();
        }
    },

    HTML_SetUpFeed: function (isPreview) {
        var section = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;
        if (section != null) {
            SocialTab.SetCurrentState(SocialTab.AllStates.Feeds);

            $(".userOption").removeClass("disabled");
            $(".feedsPage").removeClass("hidden");
            $(".connect-grid").addClass("hidden");
            $(".sourceItem").removeClass("active");
            $(".sourceItem[data-section-id=" + Feed.TYPES.PINWALL.Id + "]").css("color", "inherit");
            $(".sourceItem[data-section-id=" + section.Id + "]").addClass("active");
            $(".userOption").removeClass("disabled");
            SocialTab.Menu_SetUpHTML_SubmenuList();

            if (section.User) {
                $("i.srcProfilePicture").css("background-image", "url(" + section.User.ProfilePictureUrl + ")");
                $("img.srcProfilePicture").attr("src", section.User.ProfilePictureUrl);

                $("a.srcUsername").attr("title", section.User.Username);
                $("a.srcUsername").attr("href", section.ProfileEditUrl);
                $("span.srcUsername").html(section.User.Username);
                $("span.srcFullName").html(section.User.FullName);

                $("a.social-tab-user-link").attr("href", this.CurrentFeedUrl + this.CurrentSection.User.Username);
            }
            SocialTab.HTML_SetUpFeedList(false, isPreview);
        }
    },

    HTML_UpdateLastActiveSections: function (isPreview, numberOfVisibleSections) {
        if (SocialTab.LastActiveSections) {
            if (NewsTab.Modules.SectionsManager.CurrentSection) {
                SocialTab.SetActiveSectionFirst(NewsTab.Modules.SectionsManager.CurrentSection, numberOfVisibleSections);
            }

            numberOfVisibleSections = numberOfVisibleSections != undefined ? numberOfVisibleSections : SocialTab.NumberOfVisibleSections;
            if (NewsTab.Modules.SectionsManager.CurrentSection && SocialTab.LastActiveSections.indexOf(NewsTab.Modules.SectionsManager.CurrentSection.Id) >= numberOfVisibleSections && numberOfVisibleSections > 0 && NewsTab.Modules.SectionsManager.CurrentSection.ShowInSourceList === true) {
                SocialTab.PostLastActiveSections(false, numberOfVisibleSections);
            }

            SocialTab.HTML_SetUpSourceList(true);

            if (!isPreview) {
                $("#lastActiveConnectors > .sourceItem, .rightSideMenu .sourceItem").remove();
            }

            var removeItems = [];
            var i = 10;
            SocialTab.LastActiveSections.forEach(function (id) {
                var item = null;
                var connectors = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return t.Id === id; });
                if (connectors.length === 1) {
                    item = connectors[0];
                    if (item.OrderNumber >= numberOfVisibleSections) {
                        return;
                    }
                }

                if (isPreview) {
                    $(".feedPreview").find(".socialTabSourceList .sourceItem[data-section-id=" + id + "]").remove();
                } else {
                    $(".sectionsDropdown .sourceItem[data-section-id=" + id + "]").remove();
                }


                if (item && item.ShowInSourceList) {
                    var html = "<li class=\"xOption sourceItem\" data-section-id=\"" + item.Id + "\" style=\"background-color:" + item.Color + ";\" tabindex=\"" + (i++) + "\">";
                    switch (item.Id) {
                        case "1":
                        case "2":
                            html += "<i class=\"icon icon-" + item.ClassName + "\"></i>";
                            break;
                        default:
                            {
                                if (item.ClassName) {
                                    html += "<i class=\"icon-" + item.ClassName + "\"></i>";
                                }
                                else if ((item.User ? item.User.ProfilePictureUrl : item.IconUrl)) {
                                    html += "<img src=\"" + (item.User ? item.User.ProfilePictureUrl : item.IconUrl) + "\"/>";
                                } else {
                                    html += "<i>" + item.Name.substring(0, 2) + "</i>";
                                }
                            }
                    }
                    html += "<div class=\"sourceItemArrow\"></div>";
                    html += "<div class=\"sourceItemLists dropdown\"></div>";
                    html += "</li>";
                    $(".lastActivePlaceholder").before(html);
                }
                else {
                    removeItems.push(id);
                }
            });

            var sections = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return t.ShowInSourceList === true });
            if (sections.length > numberOfVisibleSections) {
                $(".sectionsDropdown.yOption.dropdown").show();
            } else {
                $(".sectionsDropdown.yOption.dropdown").hide();
            }

            SocialTab.ReorderSections();
            $(".socialTabHeader .sourceItem[data-section-id=" + SocialTab.LastActiveSections[0] + "]").mouseleave();

            removeItems.forEach(function (i) {
                NewsTab.Helpers.RemoveItemFromArray(SocialTab.LastActiveSections, i);
            });
        }
    },

    SetActiveSectionFirst: function (currentSection, numberOfVisibleSections) {
        if (SocialTab.LastActiveSections.indexOf(currentSection.Id) >= numberOfVisibleSections && currentSection.ShowInSourceList === true) {
            NewsTab.Helpers.RemoveItemFromArray(SocialTab.LastActiveSections, currentSection.Id);
            SocialTab.LastActiveSections.unshift(String(currentSection.Id));
        }

        for (var i = 0; i < SocialTab.LastActiveSections.length; i++) {
            var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (t) { return t.Id === SocialTab.LastActiveSections[i] });
            if (section.length) {
                section = section[0];
                section.OrderNumber = i;
            }
        }
        NewsTab.Modules.SectionsManager.Sections.sort(NewsTab.Helpers.Sort("OrderNumber", false, parseInt));
    },
    /* Feed List */

    HTML_SetUpFeedList: function (keepFeeds, isPreview) {
        var section = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;
        if (section) {
            SocialTab.Menu_SetUpHTML_SubmenuList();
            SocialTab.HTML_ClearFeedList(isPreview);
            $("body").css({ height: "100%" });
            //if (section.CurrentFeed != undefined && section.CurrentFeed.Type && !Feed.Linked(section.CurrentFeed.Type)) {
            //    if (section.CurrentFeed.PageNbr < 2) {
            //        SocialTab.HTML_SetUpEmptyFeedLest(isPreview);
            //    }
            //} else {
            //    if (section.CurrentFeed.Type === Feed.TYPES.TWITTER) {
            //        SocialTab.LoadSocialFeed(section.CurrentFeed);
            //    } else if (section.CurrentFeed.Type === Feed.TYPES.PINWALL) {
            //        SocialTab.LoadPinnedFeed(section.CurrentFeed);
            //    } else if (section.CurrentFeed.Type === Feed.TYPES.SOCIALTRENDING) {
            //        SocialTab.LoadSocialTrendingFeed(section.CurrentFeed);
            //    } else if (section.CurrentFeed.Type === Feed.TYPES.PUBLICPINWALL) {
            //        NewsTab.Modules.PublicDashboard.Load_PublicPinnedFeed(section.CurrentFeed);
            //    } else {
            //        SocialTab.ParseFeed(section.CurrentFeed);
            //    }
            //}
        }
    },

    HTML_ClearFeedList: function (isPreview) {
        isPreview ? $(".feedPreview").find(".socialTabItem").remove() : $(".socialTabItem").remove();
        this.ClearPlaceholders(true, isPreview);
        NewsTab.Modules.ArticleView.ListedArticles = [];
    },

    /* Loading Animation */

    LoadingAnimation_Start: function (start) {
        $(".feedsPage").find(".loadingAnimation").addClass("loading");
        if (!start) {
            if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-list") {
                if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(NewsTab.Modules.ArticleView.DEFAULT_SETTINGS, {
                    layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout
                })) {
                    $("#magicGrid").css("padding-right", 0);
                    this.HTML_InitialScroller(0, false);
                }
            } else if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-compact") {
                if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(NewsTab.Modules.ArticleView.DEFAULT_SETTINGS, {
                    layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout
                })) {
                    $("#magicGrid").css("padding-right", 0);
                    this.HTML_InitialScroller(0, false);
                }
            } else if (NewsTab.Modules.SectionsManager.CurrentSection && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed && NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout === "layout-card") {

            } else {
                if (NewsTab.Modules.ArticleView.SetUp_PreviewItem_Placeholders(NewsTab.Modules.ArticleView.DEFAULT_SETTINGS, {
                    layout: NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.Layout
                })) {
                    this.HTML_InitialScroller(0, false);
                }
            }
        }
    },

    LoadingAnimationSearch_Start: function () {
        $("#contentFeeds").find(".loadingAnimation").addClass("loading");
    },

    HTML_StopLoadingAnimation: function () {
        $(".feedsPage").find(".loadingAnimation").removeClass("loading");
    },

    HTML_StartLoadingAnimationPreview: function () {
        $("#feedPreview .feedsPage .loadingAnimation").addClass("loading");
    },

    HTML_StopLoadingAnimationPreview: function () {
        $("#feedPreview .feedsPage .loadingAnimation").removeClass("loading");
    },

    /* Placeholders */

    ClearPlaceholders: function (dontShowEmptyPanel, isPreview) {
        isPreview ? $(".feedPreview").find(".socialTabItem.empty").remove() : $(".socialTabItem.empty").remove();
        this.HTML_InitialScroller(0);
        $("body").css({ height: "100%" });
        var found = isPreview ? $(".feedPreview").find(".socialTabItem") : $(".socialTabItem");
        if (!found.length && !dontShowEmptyPanel) {
            if (NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed.PageNbr < 2) {
                this.HTML_SetUpEmptyFeedLest(isPreview);
            }
        }
    },

    /* FeedItem/FeedItemForm */

    HTML_SetUpEmptyFeedLest: function (isPreview) {
        isPreview ? $(".feedPreview").find("#noFeeds").remove() : $("#noFeeds").remove();
        var section = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;

        $("#errorFeeds").remove();
        var html = "<div id=\"noFeeds\" class=\"feedsListMessage\" style=\"background-color:" + section.Color + "\"><div class=\"verticalCenter\">";

        if (section.Id === Feed.TYPES.TWITTER.Id) {
            html += "<span class=\"iconContainer\" style=\"color:" + section.Color + "\"><i class=\"icon-" + section.ClassName + "\"></i></span>";
        } else {
            html += "<span class=\"iconContainer\" style=\"color:" + section.Color + "\">" + (section.ClassName ? "<i class=\"icon-" + section.ClassName + "\"></i>" : section.Name.substring(0, 2)) + "</span>";
        }

        if (section.CurrentFeed != undefined && section.CurrentFeed.Type != undefined && section.CurrentFeed.Type.Id === Feed.TYPES.CHROME.Id) {
            html += "<h1>Get Chrome Extension</h1>";
            html += "<p>Set NewsTab as your default new tab on Chrome and get beautiful speed dial of your top sites and history.</p>";
            html += "<a href=\"#\" class=\"btn border\">Get Extension</a>";
        } else if (section.CurrentFeed != undefined && section.CurrentFeed.Type != undefined && section.CurrentFeed.Type.Id === Feed.TYPES.TRENDING.Id) {
            html += "<h1>No stories available</h1>";
        } else if (section.CurrentFeed != undefined && section.CurrentFeed.Type != undefined && section.CurrentFeed.Type.Id === Feed.TYPES.HOME.Id) {
            html += "<h1>Home is empty</h1>";
        } else if (section.CurrentFeed != undefined && section.CurrentFeed.Type != undefined && section.CurrentFeed.Type.Id === Feed.TYPES.PINWALL.Id) {
            html += "<h1>Pinned is empty</h1>";
            html += "<p>You can save and tag news to read later or archive, by pinning it. Anything you pin shows up here.</p>";
        } else if (section.CurrentFeed != undefined && section.CurrentFeed.Type === Feed.TYPES.TWITTER && !Feed.Linked(section.CurrentFeed.Type)) {
            html += "<h1>" + section.Name + "</h1>";
            html += "<a href=\"#\" class=\"btn border\" onclick=\"SocialTab.ConnectTwitter()\">Connect to " + section.Name + "</a>";
        } else if (section.CurrentFeed && section.CurrentFeed.RateLimit === true) {
            html += "<h1>" + section.Name + " API</h1>";
            html += "<p>Rate limit exceeded. Please try again later.</p>";
        } else if (section.CurrentFeed && section.CurrentFeed.Id === "FeedPreview") {
            html += "<h1>" + section.Name + "</h1>";
            html += "<p>Feed is empty</p>";
        } else if (section.Feeds.length > 2) {
            html += "<h1>" + section.Name + "</h1>";
            html += "<p>Feed is empty</p>";
        } else if (!isPreview) {
            html += "<h1>Add feeds to " + section.Name + "</h1>";
            html += "<p>Feeds are the news sources \"feeding\" your sections. Click the button below to add feeds to this section.</p><br/>";
            html += "<button class=\"btn border addContentItem\" data-tab-select=\"#tabFeeds\" data-tab-param=\"" + section.Name + "\" tabindex=\"551\">+ Add Feeds</button>";
        } else if (isPreview) {
            html += "<h1>" + section.Name + "</h1>";
            html += "<p>Feed is empty</p>";
        }
        html += "</div></div>";
        isPreview ? $(".feedPreview").find(".gap").before(html) : $(".gap").before(html);
        $("body").css({ height: "100vh" });
    },

    HTML_SetUpErrorFeedLest: function (isPreview) {
        SocialTab.HTML_StopLoadingAnimation();
        SocialTab.ClearPlaceholders(true);
        isPreview ? $(".feedPreview").find("#errorFeeds").remove() : $("#errorFeeds").remove();
        var section = isPreview ? SocialTab.CurrentSectionPreview : NewsTab.Modules.SectionsManager.CurrentSection;
        $("#noFeeds").remove();

        var html = "<div id=\"errorFeeds\" class=\"feedsListMessage\" style=\"background-color:" + section.Color + "\"><div class=\"verticalCenter\">";

        if (section.Id === Feed.TYPES.TWITTER.Id) {
            html += "<span class=\"iconContainer\" style=\"color:" + section.Color + "\"><i class=\"icon-" + section.ClassName + "\"></i></span>";
        } else {
            html += "<span class=\"iconContainer\" style=\"color:" + section.Color + "\">" + (section.ClassName ? "<i class=\"icon-" + section.ClassName + "\"></i>" : section.Name.substring(0, 2)) + "</span>";
        }
        html += "<h1>Oops...</h1>";
        html += "<p>There was a problem!</p><br/>";
        html += "<a href=\"#\" class=\"btn border refreshFeed\" data-tab-select=\"#tabFeeds\" data-tab-param=\"" + section.Name + "\">Try Again</a>";

        html += "</div></div>";
        isPreview ? $(".feedPreview").find(".gap").before(html) : $(".gap").before(html);
    },

    // RSS Sections


    HTML_RightSideMenu: function () {
        var sideSections = $(".rightSideMenu");
        sideSections.find("ul").remove();

        var ul = "<ul>";
        ul += "<li class=\"xOption sourceItem homeSourceItem\" tabindex=\"3\">";
        ul += "<i class=\"icon-home\"></i>";
        ul += "<span>Home</span>";
        ul += "</li>";
        ul += "<li class=\"xOption sourceItem pinnedSourceItem\" tabindex=\"3\">";
        ul += "<i class=\"icon-pin\"></i>";
        ul += "<span>Pinned</span>";
        ul += "</li>";
        ul += "</ul>";

        sideSections.append(ul);

        var index = 4;
        NewsTab.Modules.SectionsManager.Sections.forEach(function (item) {
            if (item && item.ShowInSourceList) {
                var html = "<li class=\"xOption sourceItem " + ((NewsTab.Modules.SectionsManager.CurrentSection != null && NewsTab.Modules.SectionsManager.CurrentSection.Id == item.Id) ? "active" : "") + "\" data-section-id=\"" + item.Id + "\" style=\"background-color:" + item.Color + ";\" tabindex=\"" + index + "\">";
                switch (item.Id) {
                    case "1":
                    case "2":
                        html += "<i class=\"icon icon-" + item.ClassName + "\"></i>";
                        break;
                    default:
                        {
                            if (item.ClassName) {
                                html += "<i class=\"icon-" + item.ClassName + "\"></i>";
                            }
                            else if ((item.User ? item.User.ProfilePictureUrl : item.IconUrl)) {
                                html += "<img src=\"" + (item.User ? item.User.ProfilePictureUrl : item.IconUrl) + "\"/>";
                            } else {
                                html += "<i>" + item.Name.substring(0, 2) + "</i>";
                            }
                        }
                }
                html += "<span>" + item.Name + "</span>";
                html += "</li>";
                sideSections.find("ul").append(html);

                index++;
            }
        });

        if (NewsTab.Modules.SectionsManager.CurrentSection != null && $("body").width() >= 800) {
            $(".sourceItem.active").css("border", "2px solid " + SocialTab.LightenDarkenColor(NewsTab.Modules.SectionsManager.CurrentSection.Color, 70));
        }

        var homeItem = $.grep(NewsTab.User.Sections, function (x) { return x.SectionTypeId === Section.TYPES.Home; });
        if (homeItem.length) {
            $(".homeSourceItem").attr("data-section-id", homeItem[0].Id);
        }

        var pinItem = $.grep(NewsTab.User.Sections, function (x) { return x.SectionTypeId === Section.TYPES.Pinned; });
        if (pinItem.length) {
            $(".pinnedSourceItem").attr("data-section-id", pinItem[0].Id);
        }
    },


    HTML_HowToFindRssUrl: function () {
        var main = $("#contentCustom").find(".main");
        var result = main.find(".searchResults");
        result.html("");
        main.find("#noResults").hide();
        main.find(".googleNewsSections").hide();
        main.find("#contentImportOPML").hide();
        main.find("#contentExportOPML").hide();
        main.find("#contentFeedMain").show();
        $("#contentCustom").removeClass("showSideSections").removeClass("onSearch");
        NewsTab.Modules.SectionsManager.Setup_SelectedCustomLink(".iaru");
        main.find(".rssInstructions").removeClass("open").addClass("close");
        main.find(".contentFeedResults").removeClass("close").addClass("open");
        main.find("#contentBackButton").removeAttr("style");
        main.find("#contentFeedMain input.autoclear").val("");
        main.find("#contentFeedMain input").focus();
    },



    HTML_SetupCreateGoogleNewsKeyword: function () {
        var main = $("#contentCustom").find(".main");
        $("#contentCustom .searchResults").html("");
        $("#contentCustom").removeClass("onSearch");
        $("#noResults").hide();
        $("#contentFeedMain").hide();
        $("#contentImportOPML").hide();
        $("#contentExportOPML").hide();
        $("#googleNewsLctSection").hide();
        $("#googleNewsKwdSection").show();
        NewsTab.Modules.SectionsManager.Setup_SelectedCustomLink(".crf");
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnKwdRegion"), false);
        main.find(".rssInstructions").removeClass("open").addClass("close");
        main.find(".contentFeedResults").removeClass("close").addClass("open");
        main.find("#contentBackButton").removeAttr("style");
        main.find("#googleNewsKwdSection .autoclear").val("");
        main.find("#googleNewsKwdSection .createGNKwdTitle").focus();
    },

    HTML_SetupCreateGoogleNewsLocation: function () {
        var main = $("#contentCustom").find(".main");
        $("#contentCustom .searchResults").html("");
        $("#contentCustom").removeClass("onSearch");
        $("#noResults").hide();
        $("#contentFeedMain").hide();
        $("#contentImportOPML").hide();
        $("#contentExportOPML").hide();
        $("#googleNewsKwdSection").hide();
        $("#googleNewsLctSection").show();
        NewsTab.Modules.SectionsManager.Setup_SelectedCustomLink(".clf");
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnLctRegion"), false);
        main.find(".rssInstructions").removeClass("open").addClass("close");
        main.find(".contentFeedResults").removeClass("close").addClass("open");
        main.find("#contentBackButton").removeAttr("style");
        main.find("#googleNewsLctSection .autoclear").val("");
        main.find("#googleNewsLctSection .createGNLctTitle").focus();
    },

    HTML_CustomBackButton: function () {
        var main = $("#contentCustom").find(".main");
        main.find(".rssInstructions").removeClass("close");
        main.find(".contentFeedResults").removeClass("open");
        main.find("#contentBackButton").attr("style", "display: none !important");
        main.find(".searchResults").html("");
        $(".searchResults").removeClass("showSearchItems");
    },

    HTML_SetSelectedCustomLink: function (sender) {
        $(".showSideSections").removeClass("showSideSections");
        $.each($(".rssInstructions a"), function () {
            $(this).removeClass("selected");
        });
        $(sender).addClass("selected");
    },

    HTML_OpenTab: function (tab) {
        $(tab).siblings().removeClass("active");
        $(tab).addClass("active");
        $(tab).tab("show");
    },

    HTML_OpenTwitterFeedPreview: function (selector) {
        SocialTab.PreviousSection = selector.closest(".tab-pane")[0].id;
        SocialTab.LastPreviewSelector = selector;
        $(".searchItems").find(".selected").removeClass("selected");
        selector.parents("li").addClass("selected");
        var parentSelector = selector.closest("li");
        var selectedUrl = parentSelector.attr("rssUrl");
        var selectedSection = new Section();
        selectedSection.ApiUrl = NewsTab.ApiUrl_Base + "twitter/get/hashtagfeed/{count}/{min_id}/{max_id}/{special_parameter}",
            selectedSection.Color = SocialTab.ColorPalette[NewsTab.Helpers.GetRandomInt(0, 7)];
        if (selector.closest("li").attr("domain", "news.google.com")) {
            selectedSection.Id = SocialTab.NewGuid();
        } else {
            selectedSection.Id = parentSelector.data("section-id");
        }

        var isHashTag = parentSelector.attr("data-type") == "hashtag";

        selectedSection.Name = (isHashTag ? "#" : "@") + parentSelector.attr("data-value");

        parentSelector.find(".feedPreview").html('');
        parentSelector.find(".feedPreview").append(NewsTab.Modules.SectionsManager.$_CreateTwitterFeedsPreview({
            Title: selectedFeed.Name,
            EncodedTitle: encodeURIComponent(selectedFeed.Name),
            FeedUrl: selectedUrl,
            Id: selectedFeed.Id,
            Domain: selectedUrl,
            IconUrl: $("li.selected .itemImage").attr("src")
        }));

        SocialTab.PreviewConnector = selectedSection;
        SocialTab.SetCurrentSection(parentSelector.data("section-id"), true, false, true);
        $(".feedPreviewMagicGrid").find(".socialTabItem").remove();
        SocialTab.Feed_SetUpEmptyHTML_Items(true, true);

        var feed = new Feed().Init(
            {
                Id: selectedFeed.Id,
                Name: selectedFeed.Name,
                SiteUrl: "twitter.com",
                Icon: null,
                Type: Feed.TYPES.TWITTER,
                Language: "en-US",
                Count: Feed.DEFAULT_COUNT,
                OrderNumber: 0,
                Layout: "layout-grid",
                LayoutType: 0,
                ShowInList: true,
                ApiUrl: NewsTab.ApiUrl_Base + (isHashTag ? "twitter/get/hashtagfeed/{count}/{min_id}/{max_id}/{special_parameter}" : "twitter/get/usertagfeed/{count}/{min_id}/{max_id}/{special_parameter}"),
                EditMenuIcon: "icon-angle-down",
                EditMenuClass: "deleteSpecialFeed",
                SpecialParameter: selectedFeed.Name.substr(1),
                SectionId: selectedFeed.Id
            });


        feed.FeedUrlHash = selectedFeed.FeedUrlHash;
        SocialTab.PreviewConnector.Feeds = [];
        SocialTab.PreviewConnector.Feeds.push(feed);
        SocialTab.ParseTwitterFeedPreview(feed);

        $.fancybox(
            $(parentSelector.find(".feedPreview")),
            {
                width: 960,
                scrolling: "no",
                fitToView: true,
                height: "100%",
                autoSize: false,
                closeBtn: false,
                margin: [0, 0, 0, 0]
            }
        );

        SocialTab.Calculate_FeedPrevirew_ItemSize();
        //SocialTab.HTML_TwitterFeedPreviewScrool();
        $(".feedPreview .loadingAnimation span.color1").css({ "background-color": NewsTab.Modules.SectionsManager.CurrentSection.Color });
        $(".feedPreview .loadingAnimation span.color2").css({ "background-color": SocialTab.LightenDarkenColor(NewsTab.Modules.SectionsManager.CurrentSection.Color, 70) });
    },

    ParseTwitterFeedPreview: function (feed) {
        SocialTab.HTML_StartLoadingAnimationPreview();

        var invokerParams = feed.ApiUrl.replace("{count}", feed.Count).replace("{min_id}", "X").replace("{max_id}", feed.MaxId).replace("{special_parameter}", feed.SpecialParameter) + "?_cache=" + feed.Id;
        $.ajax({
            url: invokerParams,
            type: "GET",
            cache: false,
            headers: {
                Authorization: 'Bearer ' + NewsTab.Token
            },
            error: function (error) {
                $(".feedPreviewMagicGrid").find(".socialTabItem").remove();
                SocialTab.HTML_SetUpErrorFeedLest();
                console.error(error);
            }
        }).then(function (data) {
            if (feed.PageNbr < 2) {
                $(".feedPreviewMagicGrid").find(".socialTabItem").remove();
            }
            if (data.Items != null && data.Items.length) {
                var allArticles = [];
                for (var i = 0, len = data.Items.length; i < len; i++) {
                    if (allArticles.length < 20) {
                        data.Items[i]._sourceFeed = feed;
                        allArticles.push(data.Items[i]);
                    }
                }

                if (data.Items.length > 1) {
                    allArticles.sort(function (a, b) { return new Date(b.PubDate) - new Date(a.PubDate); });
                }

                if (allArticles.length > 0) {
                    if (feed.MinId === "X") {
                        feed.MinId = allArticles[0].Id;
                    }
                    feed.MaxId = allArticles[allArticles.length - 1].Id;
                } else {
                    feed.IsAtEnd = true;
                    if (NewsTab.Modules.SectionsManager.CurrentSection.SectionTypeId === Section.TYPES.Social) {
                        SocialTab.ClearPlaceholders();
                    }
                }

                SocialTab.CurrentSectionPreview.CurrentFeed = feed;
                SocialTab.Feed_SetUpHTML_Items(allArticles, false, true);
                $("body").css({ height: "100%" });
            } else {
                if (feed.PageNbr < 2) {
                    SocialTab.ClearPlaceholders(false, true);
                    SocialTab.HTML_SetUpEmptyFeedLest(true);
                }
            }
            SocialTab.HTML_StopLoadingAnimationPreview();
        });
    },

    BackgroundFeedParse: function (feed) {
        /// <summary>Request background feed parsing without any UI changes on success. (Mainly used by Importer to resolve empty "All Feeds")</summary>
        /// <param name='feed' type='Feed' >Feed to be parsed in the background</param>

        var invokerParams = "readsinglefeed?pageSize=" + 20 +
            "&currentPage=" + feed.PageNbr +
            "&feedId=" + encodeURIComponent(feed.Id) +
            "&feedUrl=" + encodeURIComponent(feed.Url);

        var customOrderBy = false;

        $.ajax({
            url: NewsTab.FeedApiUrl_Feed + invokerParams,
            type: "GET",
            cache: true,
            async: true,
            error: function (error) {
                console.error("ERROR - InvisibleParsFeed");
                console.error(error);
            }
        }).then(function (data) {
            if (data.Result != null && data.Result.length && data.Result[0].FeedArticles.length) {
                //var allArticles = [];
                //for (var i = 0, len = data.Result[0].FeedArticles.length; i < len; i++) {
                //    if (allArticles.length < 20) {
                //        data.Result[0].FeedArticles[i]._sourceFeed = feed;
                //        allArticles.push(data.Result[0].FeedArticles[i]);
                //    }
                //}

                //if (data && data.Result != undefined && data.Result.length > 1) {
                //    if (customOrderBy === true) {
                //        allArticles.sort(function (a, b) { return new parseInt(b.CustomOrder) - parseInt(a.CustomOrder); });
                //    } else {
                //        allArticles.sort(function (a, b) { return new Date(b.PubDate) - new Date(a.PubDate); });
                //    }
                //}

                //SocialTab.ParsedArticles = [];
                //SocialTab.ParsedArticles = allArticles;

                //if (feed.Id === data.Result[0].FeedId) {
                //    if (allArticles.length > 0) {
                //        if (feed.MinId === "X") {
                //            feed.MinId = allArticles[0].Id;
                //        }
                //        feed.MaxId = allArticles[allArticles.length - 1].Id;
                //    }

                //    feed.IsAtEnd = !data.MoreArticlesAvailable;
                //}
            }
        });
    },

    HTML_OpenGoogleNewsKwdPreview: function (selector) {
        SocialTab.PreviousSection = selector.closest(".tab-pane")[0].id;
        SocialTab.LastPreviewSelector = selector;
        var type = selector.closest(".googleNewsSections").attr("id");
        var url, title, term, region, location;

        if (type === "googleNewsKwdSection") {
            title = $("#" + type).find(".createGNKwdTitle").val().trim();
            term = $("#" + type).find(".createGNKwdTerm").val().trim();
            region = $("#" + type).find("#googleNewsKwdEditionValue").val() != undefined ? $("#" + type).find("#googleNewsKwdEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            url = "https://news.google.com/news/rss/headlines/section/q/" + term + "?ned=" + region.toLowerCase() + "&num=30";
        } else {
            title = $("#" + type).find(".createGNLctTitle").val().trim();
            location = $("#" + type).find(".createGNLctLocation").val().trim();
            region = $("#" + type).find("#googleNewsLctEditionValue").val() != undefined ? $("#" + type).find("#googleNewsLctEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            url = "https://news.google.com/news/rss/headlines/section/geo/" + location + "?ned=" + region.toLowerCase() + "&num=30";
        }

        var parentSelector = selector.closest(".googleNewsSections");
        var selectedFeed = new Section();
        selectedFeed.ApiUrl = SocialTab.APIRSSUrl;
        selectedFeed.Color = SocialTab.ColorPalette[NewsTab.Helpers.GetRandomInt(0, 7)];
        selectedFeed.Id = SocialTab.NewGuid();
        selectedFeed.Name = title;
        var iconUrl = "https://upload.wikimedia.org/wikipedia/commons/0/09/Google_News_Logo.png";
        var domain = "https://news.google.com";

        //parentSelector.find(".feedPreview").html('');
        //parentSelector.find(".feedPreview").append(NewsTab.Modules.AddNewContent.$_CreateFeedsPreview({
        //    Title: title,
        //    EncodedTitle: encodeURIComponent(title),
        //    FeedUrl: url,
        //    Id: selectedFeed.Id,
        //    Domain: domain,
        //    IconUrl: iconUrl
        //}));

        SocialTab.PreviewConnector = selectedFeed;
        SocialTab.SetCurrentSection(selectedFeed.Id, true, false, true);
        $(".feedPreviewMagicGrid").find(".socialTabItem").remove();
        SocialTab.Feed_SetUpEmptyHTML_Items(true, true);

        var feed = new Feed().Init(
            {
                Id: selectedFeed.Id,
                Name: selectedFeed.Name,
                Url: url,
                SiteUrl: url,
                Icon: $("li.selected .itemImage").attr("src"),
                Type: Feed.TYPES.RSS,
                Language: selectedFeed.Language,
                Count: Feed.DEFAULT_COUNT,
                OrderNumber: 0,
                Layout: "layout-grid",
                LayoutType: 0,
                ShowInList: false,
                ApiUrl: NewsTab.ApiUrl_Global,
                EditMenuIcon: "icon-more",
                EditMenuClass: "editRssFeed",
                SectionId: selectedFeed.Id
            });
        feed.FeedUrlHash = selectedFeed.FeedUrlHash;
        SocialTab.PreviewConnector.Feeds = [];
        SocialTab.PreviewConnector.Feeds.push(feed);
        SocialTab.ParseFeedPreview(feed);

        $.fancybox(
            $(parentSelector.find(".feedPreview")),
            {
                width: 960,
                scrolling: "no",
                fitToView: true,
                height: "100%",
                autoSize: false,
                closeBtn: false,
                margin: [0, 0, 0, 0]
            }
        );

        SocialTab.Calculate_FeedPrevirew_ItemSize();
        SocialTab.HTML_FeedPreviewScrool();
        $("#feedPreview .loadingAnimation span.color1").css({ "background-color": NewsTab.Modules.SectionsManager.CurrentSection.Color });
        $("#feedPreview .loadingAnimation span.color2").css({ "background-color": SocialTab.LightenDarkenColor(NewsTab.Modules.SectionsManager.CurrentSection.Color, 70) });
    },

    HTML_FeedPreviewScrool: function () {
        $(".feedPreview").find("#magicGrid").on("mousewheel DOMMouseScroll", function () {
            if ($(this).scrollTop() + $(this).innerHeight() >= this.scrollHeight - 10) {
                SocialTab.LoadMore(SocialTab.PreviewConnector.Feeds[0], false, true);
            }
        });
    },



    HTML_SetupScrollerPosition: function (selector, move) {
        setTimeout(function () {
            $("#" + selector).find(".searchResults:visible").scrollTop(0);
            $("#" + selector).find(".searchResults:visible").scrollTop($("#" + selector).find(".searchResults .searchItems:visible").find('li.selected').position().top - move);
        }, 100);
    },

    HTML_SetupSearchSection: function (sender) {
        $(sender).addClass("onSearch");
        $(sender).find(".searchItems").html("");
    },

    HTML_SeatupGoogleNewsSearchSection: function (sender) {
        sender.find(".searchItems").append("<div id=\"googleNewsItemTopic\"></div>");
        sender.find(".searchItems").append("<div id=\"googleNewsItemKeyword\"></div>");
        sender.find(".searchItems").append("<div id=\"googleNewsItemLocation\"></div>");
    },

    HTML_ShowTitleWhenExpandSections: function (show, one, two) {
        if (show) {
            $("#contentFeeds .searchResults").find(one).show();
            $("#contentFeeds .searchResults").find(two).hide();
        } else {
            $("#contentFeeds .searchResults").find(one).hide();
            $("#contentFeeds .searchResults").find(two).show();
        }
    },



    // EVENTS 

    HTML_Event_SaveSectionClick: function (sender, dontOpenSection) {
        var item = $(sender).closest(".newItem");
        var name = item.find(".newSectionName").val().trim();
        var color = item.find(".colors li.selected").attr("color") != undefined ? item.find(".colors li.selected").attr("color") : "#e91e63";

        this.AddNewSection(name, color, dontOpenSection);
        this.HTML_Event_FlipNewSectionClick($(sender));
    },

    HTML_Event_SaveSectionChangesClick: function (sender, id) {
        var item = $(sender).closest(".newItem");
        var name = item.find(".newSectionName").val().trim();
        var color = item.find(".colors li.selected").attr("color");
        this.EditSection(id, name, color);

        if ($("#doubleModal").length === 1) {
            $("#doubleModal").remove();
        }
        else {
            $.modal.impl.close();
        }
    },

    HTML_Event_SectionColorClick: function (sender) {
        $(sender).siblings().removeClass("active");
        $(sender).addClass("active");
        $(sender).closest(".newItem").find(".iconPreview").attr("style", "background-color:" + $(sender).attr("color"));
        if ($(sender).closest(".newItem").find(".newSectionName").val().trim().length > 1) {
            $(sender).closest(".newItem").find(".save").removeClass("disabled");
            $(sender).closest(".topics").find(".add").removeClass("disabled");
            $(sender).closest(".topicSidebar").find(".add").removeClass("disabled");
        } else {
            $(sender).closest(".newItem").find(".save").addClass("disabled");
            $(sender).closest(".topics").find(".add").addClass("disabled");
            $(sender).closest(".topicSidebar").find(".add").addClass("disabled");
        }
    },

    HTML_Event_SectionTag_Click: function (sender) {
        $(sender).siblings().removeClass("active");
        $(sender).addClass("active");
        //if (NewsTab.Modules.SectionsManager.CurrentSection.TagId)
        //{
        SocialTab.TagId = parseInt($(sender).attr("tag-id"));
        //}
    },

    HTML_Event_SectionLanguage_Change: function (sender) {
        $(sender).find("option:selected").each(function () {
            SocialTab.LanguageId = $(this).val();
        });
        $(sender).addClass("active");
    },

    HTML_Event_SectionName_KeyUp: function (sender) {
        setTimeout(function () {
            if ($(sender).val().length > 1 && $(sender).val().length <= 50) {
                $(sender).closest(".newItem").find(".iconPreview").html($(sender).val().substring(0, 2));
                $(sender).closest(".newItem").find(".save").removeClass("disabled");
                $(sender).closest(".topics").find(".add").removeClass("disabled");
                $(sender).closest(".topicSidebar").find(".add").removeClass("disabled");
            } else {
                $(sender).closest(".newItem").find(".iconPreview").html("");
                $(sender).closest(".newItem").find(".save").addClass("disabled");
                $(sender).closest(".topics").find(".add").addClass("disabled");
                $(sender).closest(".topicSidebar").find(".add").addClass("disabled");
            }
        }, 100);
    },

    HTML_Event_FeedName_KeyUp: function (sender) {
        setTimeout(function () {
            if ($(sender).val().length > 0 && $(sender).val().length <= 350) {
                $(sender).closest(".newItem").find(".iconPreview").html($(sender).val().substring(0, 2));
                $(sender).closest(".newItem").find(".save").removeClass("disabled");
                $(sender).closest(".topics").find(".add").removeClass("disabled");
                $(sender).closest(".topicSidebar").find(".add").removeClass("disabled");
                $(sender).closest(".newItem").find(".errorMessage").html("");
            } else {
                $(sender).closest(".newItem").find(".iconPreview").html("");
                $(sender).closest(".newItem").find(".save").addClass("disabled");
                $(sender).closest(".topics").find(".add").addClass("disabled");
                $(sender).closest(".topicSidebar").find(".add").addClass("disabled");

                if ($(sender).closest(".popularTopics").length > 0 && sender[0].className.indexOf("topicName") > -1 || (sender != undefined && sender[0].id.indexOf("editName_") > -1)) {
                    if ($(sender).val().length === 0) {
                        $(sender).closest(".newItem").find(".errorMessage").html("Name is too short.");
                    } else if ($(sender).val().length > 350) {
                        $(sender).closest(".newItem").find(".errorMessage").html("Name is too long.");
                    }
                }
            }
        }, 100);
    },

    HTML_Event_SectionName_KeyUp_NoIcon: function (sender) {
        if ($(sender).val().length > 1) {
            $(sender).closest(".newItem").find(".save").removeClass("disabled");
            $(sender).closest(".topics").find(".add").removeClass("disabled");
            $(sender).closest(".topicSidebar").find(".add").removeClass("disabled");
        } else {
            $(sender).closest(".newItem").find(".save").addClass("disabled");
            $(sender).closest(".topics").find(".add").addClass("disabled");
            $(sender).closest(".topicSidebar").find(".add").addClass("disabled");
        }
    },

    HTML_Event_GoogleNewsKwd_Blur: function (value, element) {
        var isSuccess = false;
        if (value.length > 0) {
            if (SocialTab.SearchGoogleNewsLocationXhr && SocialTab.SearchGoogleNewsLocationXhr.readystate !== 4) {
                SocialTab.SearchGoogleNewsLocationXhr.abort();
            }
            SocialTab.SearchGoogleNewsLocationXhr = $.ajax({
                url: NewsTab.ApiUrl_Global + "get/checkgooglenewslocation?location=" + value + "&edition=US",
                timeout: 25000,
                crossDomain: true,
                headers: { Authorization: "Bearer " + NewsTab.Token },
                async: false,
                error: function (error) {
                    console.error("ERROR - SearchFeedsFromUrl:");
                    console.error(error);
                }
            });
            SocialTab.SearchGoogleNewsLocationXhr.then(function (data) {
                isSuccess = data;
                if (isSuccess && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isSuccess;
            });
        } else {
            isSuccess = true;
        }
        return isSuccess;
    },

    HTML_Event_FlipNewSectionClick: function (sender, effect) {
        if (effect === "flip") {
            $(sender).closest(".newItem").find(".back").css({ "visibility": "visible" });
            $(sender).closest(".newItem").addClass("flipped");
            $(sender).closest(".flipItem").addClass("flipped");
            $(sender).closest(".newItem").find(".newSectionName").focus();
            $(sender).closest(".newItem").find(".topicName").focus();
            $(sender).closest(".newItem").find("input").val("");
            $(sender).closest(".newItem").find(".iconPreview").html("");
            var random = Math.floor(Math.random() * $(sender).closest(".newItem").find(".colors li").length);
            $(sender).closest(".newItem").find(".colors li").eq(random).trigger("click");
            if ($(sender).closest(".newItem").find("#edition_topicGnKwdRegionSelectBoxItContainer").length) {
                $(sender).closest(".newItem").find("#edition_topicGnKwdRegion").selectBoxIt("destroy");
            }
            NewsTab.Modules.RegionManager.SetUp_CountryDropdown($(sender).closest(".newItem").find("#edition_topicGnKwdRegion"), false);
        } else {
            $(sender).closest(".newItem").find("input").val("");
            $(sender).closest(".newItem").removeClass("flipped");
            $(sender).closest(".flipItem").removeClass("flipped");
            $(sender).closest(".newItem").find(".back").css({ "visibility": "hidden" });
        }
        $(".showSideSections").removeClass("showSideSections");

        $(sender).closest(".newItem").find(".front").focus();

        SocialTab.CreateGnTopicValidation();
    },

    CreateGnTopicValidation: function () {
        $("#addNewGnTopic").validate({
            rules: {
                topicName: {
                    required: true,
                    minlength: 1,
                    maxlength: 350
                },
                searchTerm: {
                    required: true,
                    minlength: 1,
                    maxlength: 50
                }
            },
            messages: {
                topicName: {
                    required: "Please provide a title",
                    minlength: "Title must be at least 1 characters long",
                    maxlength: "Title must be at maximum 350 characters long"
                },
                searchTerm: {
                    required: "Please provide a search term",
                    minlength: "Search term must be at least 1 characters long",
                    maxlength: "Search term must be at maximum 50 characters long"
                }
            },
            errorElement: "div",
            errorLabelContainer: ".errorTpc",
            onkeyup: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#topicName").val().trim().length > 0 && $("#topicName").val().trim().length <= 350 && $("#searchTerm").val().trim().length > 0 && $("#searchTerm").val().trim().length <= 350) {
                    $(element).closest("form").find(".save.disabled").removeClass("disabled");
                } else {
                    $(element).closest("form").find(".save").addClass("disabled");
                }
            },
            onfocusout: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#topicName").val().trim().length > 0 && $("#topicName").val().trim().length <= 350 && $("#searchTerm").val().trim().length > 0 && $("#searchTerm").val().trim().length <= 350) {
                    $(element).closest("form").find(".save.disabled").removeClass("disabled");
                } else {
                    $(element).closest("form").find(".save").addClass("disabled");
                }
            }
        });
    },

    HTML_Event_GetFeedsClick: function (sender, event) {
        setTimeout(function () {
            var main = $("#contentCustom").find(".main");
            main.find(".rssInstructions").addClass("close");
            main.find(".contentFeedResults").addClass("open");

            var url = $(sender).closest(".urlContainer").find("input").val();
            if (url && url.length > 2) {
                $(sender).siblings("a").removeClass("disabled");
                if (event.keyCode === 13 || (event.type !== "keyup" && event.type !== "paste")) {
                    SocialTab.GetFeedsFromUrl(sender, url);
                }
            } else {
                $(sender).siblings("a").addClass("disabled");
            }
        }, 100);
    },

    HTML_Event_SearchFeedsClick: function (sender, event) {
        setTimeout(function () {
            var url = $(sender).closest(".urlContainer").find("input").val();
            if (url && url.length > 2) {
                $(sender).siblings("a").removeClass("disabled");
                $(sender).closest(".tab-pane").find(".searchItems").html("");
                if (event.keyCode === 13 || (event.type !== "keyup" && event.type !== "paste")) {
                    sender.closest(".tab-pane").find(".searchResults").scrollTop(0);
                    sender.closest("#autocomplete").removeClass("uk-open");

                    if (url[0] === "#") {
                        SocialTab.searchType = "1";
                        url = url.substring(1);
                    } else {
                        SocialTab.searchType = "3";
                    }

                    NewsTab.Modules.AddNewContent.GetFeedsList({
                        $Container: $('#addNewContent .feedsPanel.active .gridList'),
                        Url: url,
                        Type: "ALL",
                        SkipRecords: 0,
                        Reset: true
                    });
                }
            } else {
                $(sender).siblings("a").addClass("disabled");
            }
        }, 100);
    },

    HTML_Event_SideSectionNewItemClick: function (sender) {
        var temp;
        var newSender = $(sender).parent();
        if (newSender.hasClass("newItem")) {
            newSender.addClass("selected");
            newSender.siblings().removeClass("selected");
            newSender.closest(".topicSidebar").find(".sideSections.topics li").removeClass("selected");
            newSender.closest(".topicSidebar").find(".sideSections.topics:not(.selected)").addClass("selected");

            newSender.find(".newSectionName").val("").focus();

            if (newSender.find(".newSectionName").val().trim().length > 1) {
                temp = newSender.closest(".topicSidebar");
                temp.find(".add").removeClass("disabled");
            } else {
                temp = newSender.closest(".topicSidebar");
                temp.find(".add").addClass("disabled");
            }

            if (!newSender.closest(".topicSidebar").find(".colors li").hasClass("active")) {
                var random = Math.floor(Math.random() * newSender.closest(".topicSidebar").find(".colors li").length);
                newSender.closest(".topicSidebar").find(".colors li").removeClass("active");
                newSender.closest(".topicSidebar").find(".colors li").eq(random).addClass("active");
                newSender.closest(".topicSidebar").find(".iconPreview").attr("style", "background-color:" + newSender.closest(".topicSidebar").find(".colors li.selected").attr("color"));
                newSender.closest(".topicSidebar").find(".firstItem input").val("");
                newSender.closest(".topicSidebar").find(".firstItem .iconPreview").html("");
            }
        } else {
            newSender.addClass("selected");
            newSender.siblings().removeClass("selected");
            temp = newSender.closest(".topicSidebar");
            temp.find(".add").removeClass("disabled");
            temp.find(".firstItem .topics .newItem").removeClass("selected");
            temp.find(".sideSections.topics").removeClass("selected");
            newSender.closest(".topicSidebar").find(".colors li").removeClass("active");
            newSender.closest(".topicSidebar").find(".firstItem input").val("");
            newSender.closest(".topicSidebar").find(".firstItem .iconPreview").html("");
        }
    },

    HTML_Event_SideSectionClick: function (sender) {
        var temp;

        if ($(sender).hasClass("newItem")) {
            $(sender).addClass("selected");
            $(sender).siblings().removeClass("selected");
            $(sender).closest(".topicSidebar").find(".sideSections.topics li").removeClass("selected");
            $(sender).closest(".topicSidebar").find(".sideSections.topics:not(.selected)").addClass("selected");

            $(sender).find(".newSectionName").val("").focus();

            if ($(sender).find(".newSectionName").val().trim().length > 1) {
                temp = $(sender).closest(".topicSidebar");
                temp.find(".add").removeClass("disabled");
            } else {
                temp = $(sender).closest(".topicSidebar");
                temp.find(".add").addClass("disabled");
            }

            if (!$(sender).closest(".topicSidebar").find(".colors li").hasClass("active")) {
                var random = Math.floor(Math.random() * $(sender).closest(".topicSidebar").find(".colors li").length);
                $(sender).closest(".topicSidebar").find(".colors li").removeClass("active");
                $(sender).closest(".topicSidebar").find(".colors li").eq(random).addClass("active");
                $(sender).closest(".topicSidebar").find(".iconPreview").attr("style", "background-color:" + $(sender).closest(".topicSidebar").find(".colors li.selected").attr("color"));
                $(sender).closest(".topicSidebar").find(".firstItem input").val("");
                $(sender).closest(".topicSidebar").find(".firstItem .iconPreview").html("");
            }
        } else {
            $(sender).addClass("selected");
            $(sender).siblings().removeClass("selected");
            temp = $(sender).closest(".topicSidebar");
            temp.find(".add").removeClass("disabled");
            temp.find(".firstItem .topics .newItem").removeClass("selected");
            temp.find(".sideSections.topics").removeClass("selected");
            $(sender).closest(".topicSidebar").find(".colors li").removeClass("active");
            $(sender).closest(".topicSidebar").find(".firstItem input").val("");
            $(sender).closest(".topicSidebar").find(".firstItem .iconPreview").html("");
        }
    },

    HTML_Event_RenderAdditionalInfoArrowClick: function (sender) {
        if (!sender.hasClass("open")) {
            sender.addClass("open");
            sender.closest("li").find(".additionalInfo").show();
            if (sender.closest('[id*="googleNewsItemTopic"]').length > 0) {
                sender.closest("li").removeClass("overflow");
            }
            sender.attr("data-original-title", "Less Details");
            sender.parent().find(".tooltip-inner").text("Less Details");
        } else {
            sender.removeClass("open");
            sender.closest("li").find(".additionalInfo").hide();
            if (sender.closest('[id*="googleNewsItemTopic"]').length > 0) {
                sender.closest("li").addClass("overflow");
            }
            sender.attr("data-original-title", "More Details");
            sender.parent().find(".tooltip-inner").text("More Details");
        }
    },

    HTML_Event_CreateGoogneNewsKwdAlert: function (sender) {
        var type = sender.closest(".googleNewsSections").attr("id");
        var url, title, term, region, location;

        if (type === "googleNewsKwdSection") {
            title = $("#" + type).find(".createGNKwdTitle").val().trim();
            term = $("#" + type).find(".createGNKwdTerm").val().trim();
            region = $("#googleNewsKwdEditionValue").val() != undefined ? $("#googleNewsKwdEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            url = "https://news.google.com/news/rss/search/section/q/" + term + "?ned=" + region.toLowerCase() + "&num=30";
        } else {
            title = $("#" + type).find(".createGNLctTitle").val().trim();
            location = $("#" + type).find(".createGNLctLocation").val().trim();
            region = $("#googleNewsLctEditionValue").val() != undefined ? $("#googleNewsLctEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
            url = "https://news.google.com/news/rss/headlines/section/geo/" + location + "?ned=" + region.toLowerCase() + "&num=30";
        }

        if (title.length > 350) {
            NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                Title: "Google News",
                Color: "red",
                Text: "Title is too long."
            });
            return;
        }

        NewsTab.Modules.SectionsManager.GoogleNewsAlertType = "GoogleNewsAlert";
        NewsTab.Modules.SectionsManager.GoogleNewsAlertTitle = title;
        NewsTab.Modules.SectionsManager.GoogleNewsAlertUrl = url;
        NewsTab.Modules.SectionsManager.Setup_SideSections(sender, SocialTab.NewGuid());
    },

    HTML_Event_CreateGoogneNewsKwdAlertTopic: function (sender) {
        var title = sender.closest(".newItem").find(".topicName").val().trim();
        var term = sender.closest(".newItem").find(".searchTerm").val().trim();
        var region = $("#googleNewsKwdEditionValue").val() != undefined ? $("#googleNewsKwdEditionValue").val() : NewsTab.Modules.RegionManager.AddFeedEditionGnValue;
        var url = "https://news.google.com/news/rss/search/section/q/" + term + "?ned=" + region.toLowerCase() + "&num=30";

        if (title.length > 350) {
            NewsTab.Modules.NotificationsManager.Open_ToastMessage({
                Title: "Google News",
                Color: "red",
                Text: "Title is too long."
            });
            return;
        }

        $(sender).closest(".flipItem").removeClass("flipped");

        NewsTab.Modules.SectionsManager.GoogleNewsAlertType = "GoogleNewsAlert";
        NewsTab.Modules.SectionsManager.GoogleNewsAlertTitle = title;
        NewsTab.Modules.SectionsManager.GoogleNewsAlertUrl = url;
        NewsTab.Modules.SectionsManager.Setup_SideSections(sender, SocialTab.NewGuid());
    },

    ResetArticleHover: function () {
        $(".socialTabItem.flippedItem").on("mouseover", function () {
            if (!NewsTab.Helpers.IsMobile()) {
                $(".jsHover").removeClass("jsHover");
                $(".socialTabItem.flippedItem.selected").removeClass("selected");

                //$(".socialTabItem.flippedItem:hover").addClass("selected");
                //$(".socialTabItem.flippedItem:hover .back").addClass("jsHover");
            }
        });
    },

    GridItemFocusEvent: function () {
        $("section.socialTabItem").focus(function () {
            $("#magicGrid").find(".selected").removeClass("selected");
            $("#magicGrid").find(".jsHover").removeClass("jsHover");
            $(this).addClass("selected");
            $(this).find(".back").addClass("jsHover");
        });
        $("a").focus("section.socialTabItem", function () {
            $("#magicGrid").find(".selected").removeClass("selected");
            $("#magicGrid").find(".jsHover").removeClass("jsHover");
            $(this).closest("section.socialTabItem").addClass("selected");
            $(this).closest("section.socialTabItem").find(".back").addClass("jsHover");
        });
    },

    NewGuid: function guid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
                .toString(16)
                .substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
            s4() + '-' + s4() + s4() + s4();
    },

    // Scroller

    HTML_InitialScroller: function (scrollTo, isPreview) {
        var self = $(document.body);
        if (isPreview) {
            self = $(".feedPreview:visible").find("#magicGrid");
            self.scrollTop(scrollTo + self.scrollTop());
            if (scrollTo > 0 &&
                self.length &&
                self.scrollTop() + self.innerHeight() >= self[0].scrollHeight - 10) {
                SocialTab.LoadMore(SocialTab.PreviewConnector.Feeds[0], false, true);
            }
        } else {
            if (navigator.userAgent.toLowerCase().indexOf("firefox") > -1) {
                $(window).scrollTop(scrollTo + $(window).scrollTop());
            } else {
                self.scrollTop(scrollTo + self.scrollTop());
            }
            if (NewsTab.Modules.SectionsManager.CurrentSection != undefined &&
                NewsTab.Modules.SectionsManager.CurrentSection.CurrentFeed != undefined &&
                scrollTo > 0 &&
                $(window).scrollTop() + $(window).height() >= $(document).height() - 10) {
                SocialTab.LoadMore();
            }
        }
    },

    // Other

    HTML_PopularityRating: function (number) {
        if (number === 0) {
            return "star_0";
        } else if (number > 0 && number <= 10) {
            return "star_025";
        } else if (number > 10 && number <= 100) {
            return "star_05";
        } else if (number > 100 && number <= 1000) {
            return "star_1";
        } else if (number > 1000 && number <= 10000) {
            return "star_15";
        } else if (number > 10000 && number <= 50000) {
            return "star_2";
        } else if (number > 50000 && number <= 100000) {
            return "star_25";
        } else if (number > 100000 && number <= 200000) {
            return "star_3";
        } else if (number > 200000 && number <= 300000) {
            return "star_35";
        } else if (number > 300000 && number <= 400000) {
            return "star_4";
        } else if (number > 400000 && number <= 500000) {
            return "star_45";
        } else {
            return "star_5";
        }
    },

    HTML_RemoveEmptySpace: function (str) {
        return str.split(' ').join('');
    },

    HTML_RenderMainEditionAddFeed: function (sender) {
        var selectedValue = sender.find("option:selected");
        var gnCode = selectedValue.attr("data-googlenewscode");
        NewsTab.Modules.RegionManager.AddFeedEdition = selectedValue.attr("data-countrycode");
        NewsTab.Modules.RegionManager.AddFeedEditionGnValue = selectedValue.attr("data-googlenewscode") !== "" ? selectedValue.attr("data-googlenewscode") : "US";
        if (selectedValue.attr("data-googlenewscode") === "US") {
            var options = {
                BeforeSendCallback: null,
                ErrorCallback: null,
                SuccessCallback: function () {
                    NewsTab.Modules.AddNewContent.Setup_UsStates();
                }
            };
            NewsTab.Modules.RegionManager.API_GetUsStates();
        } else {
            NewsTab.Modules.SectionsManager.API_GetPublishersByRegion(NewsTab.Modules.RegionManager.AddFeedEdition);
        }

        if ($(".searchResults.showSearchItems .searchItems:visible").length > 0 && $(".searchResults.showSearchItems .searchItems .showingResultsTitle").html().indexOf("#news.google.com") > -1) {
            $(".searchResults.showSearchItems .searchItems").html("");
            SocialTab.GetGoogleNewsCategories();
        }

        if (gnCode === "") {
            gnCode = "US";
            $(".imgEditionLabel").attr("src", "http://cdn-storage-staging.newstab.com/cdnstaging/flags/US.png");
            $(".labelEditionLabel").text("United States");
        } else {
            $(".imgEditionLabel").attr("src", $(".selectboxit-option-icon-container i#mainEditionsDropdownSelectBoxItDefaultIcon").css('background-image').replace(/^url\(["']?/, '').replace(/["']?\)$/, ''));
            $(".labelEditionLabel").text($("#mainEditionsDropdownSelectBoxItText").attr("data-val"));
        }

        SocialTab.RenderSelectEdition(sender, gnCode);

        // Render Create Google Alert edition on change edition
        $("#addNewContent #googleNewsKwdSection .inputContainer.inputContainerDropdown").html("").html("<select id=\"edition_GnKwdRegion\" name=\"edition_GnKwdRegion\" onchange=\"SocialTab.HTML_RenderMainEditionAddFeed($(this));\"></select>");
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnKwdRegion"), false);

        // Render Create Google Location edition on change edition
        $("#addNewContent #googleNewsLctSection .inputContainer.inputContainerDropdown").html("").html("<select id=\"edition_GnLctRegion\" name=\"edition_GnLctRegion\" onchange=\"SocialTab.HTML_RenderMainEditionAddFeed($(this));\"></select>");
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#edition_GnLctRegion"), false);
    },

    HTML_RenderGoogleNewsEdition: function (sender) {
        var selectedValue = sender.find("option:selected");
        if (selectedValue.attr("data-isgooglenewsedition") === "true") {
            var googleNewsEditionValue = selectedValue.attr("data-googlenewscode") != undefined ? selectedValue.attr("data-googlenewscode") : "US";
            if ($("#googleNewsKwdSection:visible").length) {
                if (sender.find("#googleNewsKwdEditionValue").length === 0) {
                    sender.append("<input id=\"googleNewsKwdEditionValue\" type=\"hidden\" value=\"" + googleNewsEditionValue + "\" />");
                } else {
                    sender.find("#googleNewsKwdEditionValue").val(googleNewsEditionValue);
                }
            } else if ($("#googleNewsLctSection:visible").length) {
                if (sender.find("#googleNewsLctEditionValue").length === 0) {
                    sender.append("<input id=\"googleNewsLctEditionValue\" type=\"hidden\" value=\"" + googleNewsEditionValue + "\" />");
                } else {
                    sender.find("#googleNewsLctEditionValue").val(googleNewsEditionValue);
                }
            }
            SocialTab.RenderSelectEdition(sender, selectedValue.attr("data-googlenewscode"));
        }
    },

    HTML_RenderChangeRegionEdition: function () {
        NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#selectedRegion1"), true, NewsTab.Modules.RegionManager.MainEdition);
        setTimeout(function () {
            NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.MainEdition;
            if (NewsTab.Modules.RegionManager.MainEditionGnValue == null || NewsTab.Modules.RegionManager.MainEditionGnValue == undefined) {
                NewsTab.Modules.RegionManager.MainEditionGnValue = ($("#selectedRegion1 option:selected").attr("data-googlenewscode") !== "" &&
                    $("#selectedRegion1 option:selected").attr("data-googlenewscode") !== undefined) ?
                    $("#selectedRegion1 option:selected").attr("data-googlenewscode") : "US";
            }

            NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;
        }, 1000);
    },

    HTML_SaveRegionSettings: function (sender) {
        var name = $(sender).closest(".regionBox").find(".selectboxit-option.selectboxit-focus").attr("data-val");
        var code = $(sender).closest(".regionBox").find(".selectboxit-option.selectboxit-focus").attr("data-countrycode");
        var gnCode = $(sender).closest(".regionBox").find(".selectboxit-option.selectboxit-focus").attr("data-googlenewscode");
        NewsTab.Modules.RegionManager.TemporaryEdition = code;

        var message = gnCode !== "" ? "Changing the region will change your default Google News feeds to <strong>" + name + "</strong>. Please note that you can find more local feeds for <strong>" + name + "</strong> in the New Feed menu, under <button class=\"addContentItem textbutton\" data-tab-select=\"#tabFeeds\" data-tab-param=\"Local\">Local Publishers</button>."
            : "Changing the region will change your default Google News feeds to <strong>United States</strong>, as local Google News feeds for " + name + " are not available. Please note that you can find local feeds for <strong>" + name + "</strong> in the New Feed menu under <button class=\"addContentItem textbutton\" data-tab-select=\"#tabFeeds\" data-tab-param=\"Local\">Local Publishers</button>.";


        SocialTab.Notification_SetUpHTML_OkCancel("Change region to <strong>" + name + "</strong>", message, "Change", "Cancel",
            function () {
                $(".notification-modal").addClass("disabled");
                $(".notification-modal .ok").html("<i class=\"icon\"><span class=\"spinner\"></span></i>Changing...");

                NewsTab.Modules.RegionManager.MainEdition = code;
                NewsTab.Modules.RegionManager.AddFeedEdition = NewsTab.Modules.RegionManager.AddFeedEdition;
                NewsTab.Modules.RegionManager.MainEditionGnValue = gnCode !== "" ? gnCode : "US";
                NewsTab.Modules.RegionManager.AddFeedEditionGnValue = NewsTab.Modules.RegionManager.MainEditionGnValue;
                NewsTab.Modules.RegionManager.TemporaryEdition = undefined;

                var county = $.grep(NewsTab.Modules.RegionManager.Countries, function (c) { return c.Name === name; });

                var callUrl = NewsTab.ApiUrl_Base + "api/ApiGlobal/SaveUserRegion?userId=" + NewsTab.User.Id + "&countryId=" + county[0].Id;
                $.ajax({
                    url: callUrl,
                    headers: { Authorization: "Bearer " + NewsTab.Token },
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                    success: function () {
                        $.ajax({
                            url: NewsTab.ApiUrl_Base + "api/global/get/sectionsbyregion/" + NewsTab.Modules.RegionManager.MainEditionGnValue + "/true",
                            headers: { Authorization: "Bearer " + NewsTab.Token },
                            type: "GET",
                            contentType: "application/json; charset=utf-8",
                            cache: false,
                            success: function () {
                                location.reload();
                            }
                        });
                    }
                });
            },
            function () {
                NewsTab.Modules.RegionManager.TemporaryEdition = undefined;
                $("#selectedRegion1").selectBoxIt("destroy");
                NewsTab.Modules.RegionManager.SetUp_CountryDropdown($("#selectedRegion1"), true, NewsTab.Modules.RegionManager.MainEdition);
            });
    },

    HTML_SaveUserSettings: function (setting, value) {
        if (NewsTab.Token && !NewsTab.Modules.Sharing.DisplayingSharedArticle) {
            var callUrl = NewsTab.ApiUrl_Base + "api/ApiGlobal/SaveUserSettings?userId=" + NewsTab.User.Id + "&setting=" + setting + "&value=" + value;
            $.ajax({
                url: callUrl,
                headers: { Authorization: "Bearer " + NewsTab.Token },
                type: "POST",
                contentType: "application/json; charset=utf-8"
            });
        }
    },

    HTML_RenderRange: function (selector, start, step, rangeStart, rangeEnd) {
        noUiSlider.create(selector, {
            start: [start],
            step: step,
            connect: "lower",
            animationDuration: 300,
            range: {
                'min': [rangeStart],
                'max': [rangeEnd]
            }
        });
    },

    /* SOCIAL */
    RenderFeedbackDropzone: function () {
        var appId = 3887;
        var key = "iCTr8XgE3AYyHmV2UzHL5JlXg0TqZpKkVF5W8ba1J5y3iFNP8dsnxlRYzOUvdk06";

        $(".getSupport .fsDropZoneTrigger, .getSupport .fsDropTriggerIcon, .getSupport .fsDropTriggerText, .getSupport .fsDropTriggerIcon i").dropzone({
            url: "https://doorbell.io/api/applications/" + appId + "/upload?key=" + key,
            maxFilesize: 10, // MB
            addRemoveLinks: true,
            dictRemoveFile: "x",
            createImageThumbnails: false,
            previewsContainer: ".getSupport .dropzone-previews",
            init: function () {
                this.on("success", function (file, response) {
                    var attachmentId = response.toString().replace(/[^\w\s]/gi, '');
                    $(file.previewElement).find(".dz-filename span").attr("data-dz-upload-id", attachmentId);
                });
            }
        });

        $(".sendFeedback .fsDropZoneTrigger, .sendFeedback .fsDropTriggerIcon, .sendFeedback .fsDropTriggerText, .sendFeedback .fsDropTriggerIcon i").dropzone({
            url: "https://doorbell.io/api/applications/" + appId + "/upload?key=" + key,
            maxFilesize: 10, // MB
            addRemoveLinks: true,
            dictRemoveFile: "x",
            createImageThumbnails: false,
            previewsContainer: ".sendFeedback .dropzone-previews",
            init: function () {
                this.on("success", function (file, response) {
                    var attachmentId = response.toString().replace(/[^\w\s]/gi, '');
                    $(file.previewElement).find(".dz-filename span").attr("data-dz-upload-id", attachmentId);
                });
            }
        });
    },

    CreateSupportTicket: function (sender) {
        var name = sender.closest(".getSupportSection").find("#gs-name");
        var email = sender.closest(".getSupportSection").find("#gs-email");
        var description = sender.closest(".getSupportSection").find("#gs-description");
        var key = "iCTr8XgE3AYyHmV2UzHL5JlXg0TqZpKkVF5W8ba1J5y3iFNP8dsnxlRYzOUvdk06";
        var appId = 3887;
        var url = "https://doorbell.io/api/applications/" + appId + "/submit";
        var attachmentsIds = [];

        $.each($(".getSupport .fsDropZoneWrapper").find(".dz-preview .dz-details .dz-filename"), function (index, data) {
            attachmentsIds.push(parseInt($(data).find("span").attr("data-dz-upload-id")));
        });

        name.val().length === 0 ? name.addClass("error") : name.removeClass("error");
        email.val().length === 0 ? email.addClass("error") : email.removeClass("error");
        description.val().length === 0 ? description.addClass("error") : description.removeClass("error");

        if (name.val().length > 0 && email.val().length > 0 && description.val().length > 0) {
            sender.addClass("showLoader");
            $.ajax({
                type: "POST",
                url: url,
                data: {
                    message: description.val(),
                    email: email.val(),
                    key: key,
                    tags: "Support,Web",
                    properties: { Application: "Support" },
                    attachments: attachmentsIds
                },
                success: function (data) {
                    sender.removeClass("showLoader");
                    if (data) {
                        name.val("");
                        description.val("");
                        $(".gs-status").html("").html("Sent!").show().delay(1500).fadeOut();
                        sender.closest(".settingsDetailsItem.active").removeClass("active");
                        $(".getSupport .fsDropZoneWrapper .dropzone-previews").html("");
                    }
                }
            }).fail(function () {
                sender.removeClass("showLoader");
                $(".gs-status").html("").html("Error!").show().delay(1500).fadeOut();
                sender.closest(".settingsDetailsItem.active").removeClass("active");
            });
        }
    },

    CancelSupportTicket: function (sender) {
        sender.closest(".settingsDetailsItem.active").removeClass("active");
    },

    SendFeedback: function (sender) {
        var name = sender.closest(".sendFeedbackSection").find("#fs-name");
        var email = sender.closest(".sendFeedbackSection").find("#fs-email");
        var description = sender.closest(".sendFeedbackSection").find("#fs-description");
        var rating = sender.closest(".sendFeedbackSection").find(".rating input:checked");
        var key = "iCTr8XgE3AYyHmV2UzHL5JlXg0TqZpKkVF5W8ba1J5y3iFNP8dsnxlRYzOUvdk06";
        var appId = 3887;
        var url = "https://doorbell.io/api/applications/" + appId + "/submit";
        var attachmentsIds = [];
        var sentiment;
        var tags;

        if (rating.val() < 3) {
            sentiment = "negative";
        } else if (rating.val() === 3 || rating.val() == undefined) {
            sentiment = "neutral";
        } else {
            sentiment = "positive";
        }

        if (rating.val() == undefined) {
            tags = "Feedback,Web";
        } else {
            tags = "Feedback,Web,Rating: " + rating.val();
        }

        $.each($(".sendFeedback .fsDropZoneWrapper").find(".dz-preview .dz-details .dz-filename"), function (index, data) {
            attachmentsIds.push(parseInt($(data).find("span").attr("data-dz-upload-id")));
        });

        name.val().length === 0 ? name.addClass("error") : name.removeClass("error");
        email.val().length === 0 ? email.addClass("error") : email.removeClass("error");
        description.val().length === 0 ? description.addClass("error") : description.removeClass("error");

        if (name.val().length > 0 && email.val().length > 0 && description.val().length > 0) {
            sender.addClass("showLoader");
            $.ajax({
                type: "POST",
                url: url,
                data: {
                    message: description.val(),
                    email: email.val(),
                    key: key,
                    sentiment: sentiment,
                    tags: tags,
                    properties: {
                        Application: "Feedback",
                        Rating: rating.val()
                    },
                    attachments: attachmentsIds
                },
                success: function (data) {
                    SocialTab.SaveFeedback(name.val(), email.val(), description.val(), rating.val());
                    sender.removeClass("showLoader");
                    name.val("");
                    description.val("");
                    $(".fs-status").html("").html(data).show().delay(1500).fadeOut();
                    rating.attr("checked", false);
                    sender.closest(".settingsDetailsItem.active").removeClass("active");
                    $(".sendFeedback .fsDropZoneWrapper .dropzone-previews").html("");
                }
            }).fail(function () {
                sender.removeClass("showLoader");
                $(".fs-status").html("").html("Error!").show().delay(1500).fadeOut();
                sender.closest(".settingsDetailsItem.active").removeClass("active");
            });
        }
    },

    SaveFeedback: function (name, email, description, rating) {
        if (rating == undefined) rating = -1;
        $.ajax({
            type: "POST",
            url: NewsTab.ApiUrl_Base + "api/ApiGlobal/SaveFeedback?name=" + name + "&email=" + email + "&description=" + description +
                "&rating=" + rating + "&device=0",
            async: true
        });
    },

    CancelSendFeedback: function (sender) {
        sender.closest(".settingsDetailsItem.active").removeClass("active");
    },

    // Firebase Cloud Messaging
    Fcm_SetMessage: function (snap) {
        var jsonObject = JSON.stringify(snap.val());
        var object = JSON.parse(jsonObject);

        if (NewsTab.User.NotificationId !== object.message.messageId) {
            NewsTab.User.NotificationCount = 0;
        }

        SocialTab.FCM_Repetitions = object.general.repeatMessage;

        if (NewsTab.User.NotificationId !== object.message.messageId || NewsTab.User.NotificationCount < object.general.repeatMessage) {
            NewsTab.User.NotificationId = object.message.messageId;
            NewsTab.User.NotificationCount = NewsTab.User.NotificationCount + 1;
            SocialTab.SaveNotification(NewsTab.User.NotificationId, NewsTab.User.NotificationCount);
            $("#cm-messages").html("").hide();
            $.when($("#cm-message-template").tmpl(object).appendTo($("#cm-messages"))).then($("#cm-messages").show("blind", {}, 500));
            $("body").removeClass("fcm").addClass("fcm");

            var cmContainer = $("#cm-container");
            var cmButton = cmContainer.find("#cm-btn");
            var closeBtn = cmContainer.find("i.cm-close-btn");
            $("#cm-container").fadeIn(1000);
            if (object.general.showMessage) {
                if (object.button != null) {
                    var data = new Object();
                    data.event = object.button.onClickEvent;
                    cmButton.attr("onclick", data.event);
                }

                if (object.general.showCloseBtn) {
                    closeBtn.on("click", function () {
                        $("#cm-messages").hide("blind", {}, 500);
                        $("body").removeClass("fcm");
                        SocialTab.SaveNotification(NewsTab.User.NotificationId, SocialTab.FCM_Repetitions);
                    });
                } else {
                    closeBtn.hide();
                }
            }
        }
    },

    SaveNotification: function (id, repeted) {
        if (NewsTab.Token) {
            $.ajax({
                url: NewsTab.ApiUrl_Global + "post/savenotification/" + id + "/" + repeted,
                type: "POST",
                headers: { Authorization: "Bearer " + NewsTab.Token }
            });
        }

    },

    TwitterPreferences: function () {
        var section = $.grep(NewsTab.Modules.SectionsManager.Sections, function (c) { return (c.Name === "Twitter"); });
        if (section.length > 0) {
            section = section[0];

            var screenWidth = 950;

            if ($(window).width() < screenWidth) {
                screenWidth = $(window).width() * 0.95;
            }

            var feedHtml = "<div class=\"twitterListPreferences\" style=\"width:100%; height:100%; overflow: hidden;\">";

            feedHtml += "<div class=\"menu\">";
            feedHtml += "<i class=\"icon-twitter\" />";
            feedHtml += "<span>Twitter <i class=\"icon-angle-right\"></i> Preferences</span>";
            feedHtml += "<i class=\"icon-close simplemodal-close\" \"></i>";
            feedHtml += "</div>";

            feedHtml += "<h3>Twitter Feeds<br/><span>Select which feed will be visible on your dashboard</span></h3>";
            var feeds = $.grep(section.Feeds, function (c) { return (c.Name !== "None"); });
            if (feeds.length > 0) {

                feedHtml += "<ul class=\"twitterFeeds\" style=\"height:" + ($(window).height() - 160) + "px\">";
                for (var i = 0, l = feeds.length; i < l; i++) {
                    feedHtml += "<li data-feed-id=\"" + feeds[i].Id + "\">";
                    if (feeds[i].Name != "Timeline") {
                        feedHtml += "<div class=\"checkContainer\">";
                        feedHtml += "<input type=\"checkbox\" id=\"twitterfeed_" + feeds[i].Id + "\" " + (feeds[i].ShowInList ? "checked=\"\"" : "") + "\"><label for=\"twitterfeed_" + feeds[i].Id + "\">" + feeds[i].Name + (feeds[i].IsList ? " [List]" : "") + "</label>";
                        feedHtml += "</div>";
                    }
                    else {
                        feedHtml += "<span>" + feeds[i].Name + "</span>";
                    }
                    feedHtml += "</li>";
                }
                feedHtml += "</ul>";
            }
            feedHtml += "<div class=\"controls\"><a class=\"simplemodal-close btn gray\">Cancel</a><a class=\"applyChanges btn blue\">Apply</a></div>";
            feedHtml += "</div>";
            $("#itemFormHolder").html(feedHtml);

            var selectedItem = $("#itemFormHolder").find(".twitterListPreferences");
            selectedItem.modal({
                maxWidth: screenWidth,
                overlayClose: true,
                autoResize: true,
                autoPosition: true
            });
        }
    }
};

Date.prototype.toDateInputValue = (function () {
    var local = new Date(this);
    local.setMinutes(this.getMinutes() - this.getTimezoneOffset());
    return local.toJSON().slice(0, 19);
});

function SetUpTabs(entry) {
    $(".tab-pane").each(function () {
        $(this).attr("id", $(this).attr("id") + "_" + entry.Id);
    });

    $(".nav-tabs a").each(function () {
        $(this).attr("href", $(this).attr("href") + "_" + entry.Id);
    });

    $(".nav-tabs a").click(function (e) {
        e.preventDefault();
        $(this).tab("show");
    });
}

function CheckItemSize(onlyNew) {
    scItem = $(".socialTabItem", "#magicGrid");
    if (scItem.width() < 280) {
        scItem.addClass("simpel");
    }
    else {
        scItem.removeClass("simpel");
    }
    var checkItems = onlyNew === true ? $(".socialTabItem.new", "#magicGrid") : $(".socialTabItem", "#magicGrid");

    checkItems.removeClass("new");
}

/*******************/

Array.prototype.pushArray = function (arr) {
    if (arr !== undefined) {
        this.push.apply(this, arr);
    }
};

$.fn.textWidth = function (text, font) {
    if (!$.fn.textWidth.fakeEl) $.fn.textWidth.fakeEl = $('<span>').hide().appendTo(document.body);
    $.fn.textWidth.fakeEl.text(text || this.val() || this.text()).css('font', font || this.css('font'));
    return $.fn.textWidth.fakeEl.width();
};

// DROPEDOWN 
+function ($) {
    "use strict";
    var backdrop = "dropdown-backdrop";
    var toggle = "[data-toggle=\"dropdown\"]";
    var dropdown = function (element) {
        $(element).on("click.dropdown", this.toggle);
    };
    dropdown.prototype.toggle = function (e) {
        var $this = $(this);

        if (!$this.is(".disabled, :disabled")) {
            var $parent = getParent($this);
            var isActive = $parent.hasClass("open");

            clearMenus();

            if (!isActive) {
                if ("ontouchstart" in document.documentElement && !$parent.closest(".navbar-nav").length) {
                    // if mobile we use a backdrop because click events don't delegate
                    $("<div class=\"" + backdrop + "\"/>").insertAfter($(this)).on("click", clearMenus);
                }

                var relatedTarget = { relatedTarget: this };
                $parent.trigger(e = $.Event("show.dropdown", relatedTarget));

                if (!e.isDefaultPrevented()) {
                    $this.trigger("focus").attr("aria-expanded", "true");
                    $parent.toggleClass("open").trigger("shown.dropdown", relatedTarget);
                }
            }
        }
        return false;
    };
    dropdown.prototype.keydown = function (e) {
        if (!/(38|40|27|32)/.test(e.which) || /input|textarea/i.test(e.target.tagName)) return;
        var $this = $(this);

        e.preventDefault();
        e.stopPropagation();

        if (!$this.is(".disabled, :disabled")) {
            var $parent = getParent($this);
            var isActive = $parent.hasClass("open");
            if ((!isActive && e.which !== 27) || (isActive && e.which === 27)) {
                if (e.which === 27) $parent.find(toggle).trigger("focus");
                return $this.trigger("click");
            }

            var desc = " li:not(.divider):visible a";
            var $items = $parent.find("[role=\"menu\"]" + desc + ", [role=\"listbox\"]" + desc);

            if ($items.length) {
                var index = $items.index(e.target);

                if (e.which === 38 && index > 0) index--; // up
                if (e.which === 40 && index < $items.length - 1) index++; // down
                if (!~index) index = 0;

                $items.eq(index).trigger("focus");
            }
        }
    };

    function clearMenus(e) {
        if (e && e.which === 3) return;
        $("." + backdrop).remove();
        $(toggle).each(function () {
            var $this = $(this);
            var $parent = getParent($this);
            var relatedTarget = { relatedTarget: this };

            if ($parent.hasClass("open")) {
                $parent.trigger(e = $.Event("hide.dropdown", relatedTarget));
                if (!e.isDefaultPrevented()) {
                    $this.attr("aria-expanded", "false");
                    $parent.removeClass("open").trigger("hidden.dropdown", relatedTarget);
                }
            }
        });
    }

    function getParent($this) {
        var selector = $this.attr("data-target");

        if (!selector) {
            selector = $this.attr("href");
            selector = selector && /#[A-Za-z]/.test(selector) && selector.replace(/.*(?=#[^\s]*$)/, ""); // strip for ie7
        }

        var $parent = selector && $(selector);
        return $parent && $parent.length ? $parent : $this.parent();
    }


    // DROPDOWN PLUGIN DEFINITION
    // ==========================
    function Plugin(option) {
        return this.each(function () {
            var $this = $(this);
            var data = $this.data("dropdown");

            if (!data) {
                $this.data("dropdown", (data = new dropdown(this)));
            }
            if (typeof option == "string") {
                data[option].call($this);
            }
        });
    }

    var old = $.fn.dropdown;

    $.fn.dropdown = Plugin;
    $.fn.dropdown.Constructor = dropdown;


    // DROPDOWN NO CONFLICT
    // ====================
    $.fn.dropdown.noConflict = function () {
        $.fn.dropdown = old;
        return this;
    }; // APPLY TO STANDARD DROPDOWN ELEMENTS
    // ===================================
    $(document)
        .on("click.dropdown.data-api", clearMenus)
        .on("click.dropdown.data-api", ".dropdown form", function (e) { e.stopPropagation(); })
        .on("click.dropdown.data-api", toggle, dropdown.prototype.toggle)
        .on("keydown.dropdown.data-api", toggle, dropdown.prototype.keydown)
        .on("keydown.dropdown.data-api", "[role=\"menu\"]", dropdown.prototype.keydown)
        .on("keydown.dropdown.data-api", "[role=\"listbox\"]", dropdown.prototype.keydown);

}(jQuery);

// TOOLTIP
+ function ($) {
    "use strict";

    // TOOLTIP PUBLIC CLASS DEFINITION
    // ===============================

    var Tooltip = function (element, options) {
        this.type =
            this.options =
            this.enabled =
            this.timeout =
            this.hoverState =
            this.$element = null;

        this.init("tooltip", element, options);
    };
    Tooltip.TRANSITION_DURATION = 150;

    Tooltip.DEFAULTS = {
        animation: true,
        placement: "top",
        selector: false,
        template: "<div class=\"tooltip\" role=\"tooltip\"><div class=\"tooltip-arrow\"></div><div class=\"tooltip-inner\"></div></div>",
        trigger: "hover",
        title: "",
        delay: 0,
        html: false,
        container: false,
        viewport: {
            selector: "body",
            padding: 0
        }
    };
    Tooltip.prototype.init = function (type, element, options) {
        this.enabled = true;
        this.type = type;
        this.$element = $(element);
        this.options = this.getOptions(options);
        //this.$viewport = this.options.viewport && $(this.options.viewport.selector || this.options.viewport);
        this.$viewport = this.options.viewport && this.$element.closest(this.options.viewport);
        //this.$viewport = this.$element.parents().filter(function () {
        //    return $(this).css('overflow') == 'hidden';
        //}).first();
        if (this.$viewport.length === 0) {
            this.$viewport = $("body");
        }

        var triggers = this.options.trigger.split(" ");

        for (var i = triggers.length; i--;) {
            var trigger = triggers[i];

            if (trigger === "click") {
                this.$element.on("click." + this.type, this.options.selector, $.proxy(this.toggle, this));
            } else if (trigger !== "manual") {
                var eventIn = trigger === "hover" ? "mouseenter" : "focusin";
                var eventOut = trigger === "hover" ? "mouseleave" : "focusout";

                this.$element.on(eventIn + "." + this.type, this.options.selector, $.proxy(this.enter, this));
                this.$element.on(eventOut + "." + this.type, this.options.selector, $.proxy(this.leave, this));
            }
        }

        this.options.selector ?
            (this._options = $.extend({}, this.options, { trigger: "manual", selector: "" })) :
            this.fixTitle();
    };
    Tooltip.prototype.getDefaults = function () {
        return Tooltip.DEFAULTS;
    };
    Tooltip.prototype.getOptions = function (options) {
        options = $.extend({}, this.getDefaults(), this.$element.data(), options);

        if (options.delay && typeof options.delay == "number") {
            options.delay = {
                show: options.delay,
                hide: options.delay
            };
        }

        return options;
    };
    Tooltip.prototype.getDelegateOptions = function () {
        var options = {};
        var defaults = this.getDefaults();

        this._options && $.each(this._options, function (key, value) {
            if (defaults[key] !== value) options[key] = value;
        });
        return options;
    };
    Tooltip.prototype.enter = function (obj) {
        var self = obj instanceof this.constructor ?
            obj : $(obj.currentTarget).data("bs." + this.type);

        if (self && self.$tip && self.$tip.is(":visible")) {
            self.hoverState = "in";
            return;
        }

        if (!self) {
            self = new this.constructor(obj.currentTarget, this.getDelegateOptions());
            $(obj.currentTarget).data("bs." + this.type, self);
        }

        clearTimeout(self.timeout);

        self.hoverState = "in";

        if (!self.options.delay || !self.options.delay.show) return self.show();

        self.timeout = setTimeout(function () {
            if (self.hoverState === "in") self.show();
        }, self.options.delay.show);
    };
    Tooltip.prototype.leave = function (obj) {
        var self = obj instanceof this.constructor ?
            obj : $(obj.currentTarget).data("bs." + this.type);

        if (!self) {
            self = new this.constructor(obj.currentTarget, this.getDelegateOptions());
            $(obj.currentTarget).data("bs." + this.type, self);
        }

        clearTimeout(self.timeout);

        self.hoverState = "out";

        if (!self.options.delay || !self.options.delay.hide) return self.hide();

        self.timeout = setTimeout(function () {
            if (self.hoverState === "out") self.hide();
        }, self.options.delay.hide);
    };
    Tooltip.prototype.show = function () {
        var e = $.Event("show.bs." + this.type);

        if (this.hasContent() && this.enabled) {
            this.$element.trigger(e);

            var inDom = $.contains(this.$element[0].ownerDocument.documentElement, this.$element[0]);
            if (e.isDefaultPrevented() || !inDom) return;
            var that = this;

            var $tip = this.tip();

            var tipId = this.getUID(this.type);

            this.setContent();
            $tip.attr("id", tipId);
            this.$element.attr("aria-describedby", tipId);

            if (this.options.animation) $tip.addClass("fade");

            var placement = typeof this.options.placement == "function" ?
                this.options.placement.call(this, $tip[0], this.$element[0]) :
                this.options.placement;

            var autoToken = /\s?auto?\s?/i;
            var autoPlace = autoToken.test(placement);
            if (autoPlace) placement = placement.replace(autoToken, "") || "top";

            $tip
                .detach()
                .css({ top: 0, left: 0, display: "block" })
                .addClass(placement)
                .data("bs." + this.type, this);

            this.options.container ? $tip.appendTo(this.options.container) : $tip.insertAfter(this.$element);

            var pos = this.getPosition();
            var actualWidth = $tip[0].offsetWidth;
            var actualHeight = $tip[0].offsetHeight;

            if (autoPlace) {
                var orgPlacement = placement;
                var $container = this.options.container ? $(this.options.container) : this.$element.parent();
                var containerDim = this.getPosition($container);

                placement = placement === "bottom" && pos.bottom + actualHeight > containerDim.bottom ? "top" :
                    placement === "top" && pos.top - actualHeight < containerDim.top ? "bottom" :
                        placement === "right" && pos.right + actualWidth > containerDim.width ? "left" :
                            placement === "left" && pos.left - actualWidth < containerDim.left ? "right" :
                                placement;

                $tip
                    .removeClass(orgPlacement)
                    .addClass(placement);
            }

            var calculatedOffset = this.getCalculatedOffset(placement, pos, actualWidth, actualHeight);

            this.applyPlacement(calculatedOffset, placement);

            var complete = function () {
                var prevHoverState = that.hoverState;
                that.$element.trigger("shown.bs." + that.type);
                that.hoverState = null;

                if (prevHoverState === "out") that.leave(that);
            };
            $.support.transition && this.$tip.hasClass("fade") ?
                $tip
                    .one("bsTransitionEnd", complete)
                    .emulateTransitionEnd(Tooltip.TRANSITION_DURATION) :
                complete();
        }
    };
    Tooltip.prototype.applyPlacement = function (offset, placement) {
        var $tip = this.tip();
        var width = $tip[0].offsetWidth;
        var height = $tip[0].offsetHeight;

        // manually read margins because getBoundingClientRect includes difference
        var marginTop = parseInt($tip.css("margin-top"), 10);
        var marginLeft = parseInt($tip.css("margin-left"), 10);

        // we must check for NaN for ie 8/9
        if (isNaN(marginTop)) marginTop = 0;
        if (isNaN(marginLeft)) marginLeft = 0;

        offset.top = offset.top + marginTop;
        offset.left = offset.left + marginLeft;

        // $.fn.offset doesn't round pixel values
        // so we use setOffset directly with our own function B-0
        $.offset.setOffset($tip[0], $.extend({
            using: function (props) {
                $tip.css({
                    top: Math.round(props.top),
                    left: Math.round(props.left)
                });
            }
        }, offset), 0);

        $tip.addClass("in");

        // check to see if placing tip in new offset caused the tip to resize itself
        var actualWidth = $tip[0].offsetWidth;
        var actualHeight = $tip[0].offsetHeight;

        if (placement === "top" && actualHeight !== height) {
            offset.top = offset.top + height - actualHeight;
        }

        var delta = this.getViewportAdjustedDelta(placement, offset, actualWidth, actualHeight);

        if (delta.left) offset.left += delta.left;
        else offset.top += delta.top;

        var isVertical = /top|bottom/.test(placement);
        var arrowDelta = isVertical ? delta.left * 2 - width + actualWidth : delta.top * 2 - height + actualHeight;
        var arrowOffsetPosition = isVertical ? "offsetWidth" : "offsetHeight";

        $tip.offset(offset);
        this.replaceArrow(arrowDelta, $tip[0][arrowOffsetPosition], isVertical);
    };
    Tooltip.prototype.replaceArrow = function (delta, dimension, isHorizontal) {
        this.arrow()
            .css(isHorizontal ? "left" : "top", 50 * (1 - delta / dimension) + "%")
            .css(isHorizontal ? "top" : "left", "");
    };
    Tooltip.prototype.setContent = function () {
        var $tip = this.tip();
        var title = this.getTitle();

        $tip.find(".tooltip-inner")[this.options.html ? "html" : "text"](title);
        $tip.removeClass("fade in top bottom left right");
    };
    Tooltip.prototype.hide = function (callback) {
        var that = this;
        var $tip = this.tip();
        var e = $.Event("hide.bs." + this.type);

        function complete() {
            if (that.hoverState !== "in") $tip.detach();
            that.$element
                .removeAttr("aria-describedby")
                .trigger("hidden.bs." + that.type);
            callback && callback();
        }

        this.$element.trigger(e);

        if (e.isDefaultPrevented()) return;
        $tip.removeClass("in");
        $.support.transition = undefined;
        $.support.transition && this.$tip.hasClass("fade") ?
            $tip
                .one("bsTransitionEnd", complete)
                .emulateTransitionEnd(Tooltip.TRANSITION_DURATION) :
            complete();

        this.hoverState = null;

        return this;
    };
    Tooltip.prototype.fixTitle = function () {
        var $e = this.$element;
        if ($e.attr("title") || typeof ($e.attr("data-original-title")) != "string") {
            $e.attr("data-original-title", $e.attr("title") || "").attr("title", "");
        }
    };
    Tooltip.prototype.hasContent = function () {
        return this.getTitle();
    };
    Tooltip.prototype.getPosition = function ($element) {
        $element = $element || this.$element;

        var el = $element[0];
        var isBody = el.tagName === "BODY";

        var elRect = el.getBoundingClientRect();
        if (elRect.width == null) {
            // width and height are missing in IE8, so compute them manually; see https://github.com/twbs/bootstrap/issues/14093
            elRect = $.extend({}, elRect, { width: elRect.right - elRect.left, height: elRect.bottom - elRect.top });
        }
        var elOffset = isBody ? { top: 0, left: 0 } : $element.offset();
        var scroll = { scroll: isBody ? document.documentElement.scrollTop || document.body.scrollTop : $element.scrollTop() };
        var outerDims = isBody ? { width: $(window).width(), height: $(window).height() } : null;

        return $.extend({}, elRect, scroll, outerDims, elOffset);
    };
    Tooltip.prototype.getCalculatedOffset = function (placement, pos, actualWidth, actualHeight) {
        return placement === "bottom" ? { top: pos.top + pos.height, left: pos.left + pos.width / 2 - actualWidth / 2 } :
            placement === "top" ? { top: pos.top - actualHeight, left: pos.left + pos.width / 2 - actualWidth / 2 } :
                placement === "left" ? { top: pos.top + pos.height / 2 - actualHeight / 2, left: pos.left - actualWidth } :
            /* placement == 'right' */ { top: pos.top + pos.height / 2 - actualHeight / 2, left: pos.left + pos.width };

    };
    Tooltip.prototype.getViewportAdjustedDelta = function (placement, pos, actualWidth, actualHeight) {
        var delta = { top: 0, left: 0 };
        if (!this.$viewport) return delta;

        var viewportPadding = this.options.viewport && this.options.viewport.padding || 0;
        var viewportDimensions = this.getPosition(this.$viewport);

        if (/right|left/.test(placement)) {
            var topEdgeOffset = pos.top - viewportPadding - viewportDimensions.scroll;
            var bottomEdgeOffset = pos.top + viewportPadding - viewportDimensions.scroll + actualHeight;
            if (topEdgeOffset < viewportDimensions.top) { // top overflow
                delta.top = viewportDimensions.top - topEdgeOffset;
            } else if (bottomEdgeOffset > viewportDimensions.top + viewportDimensions.height) { // bottom overflow
                delta.top = viewportDimensions.top + viewportDimensions.height - bottomEdgeOffset;
            }
        } else {
            var leftEdgeOffset = pos.left - viewportPadding;
            var rightEdgeOffset = pos.left + viewportPadding + actualWidth;
            if (leftEdgeOffset < viewportDimensions.left) { // left overflow
                delta.left = viewportDimensions.left - leftEdgeOffset;
            } else if (rightEdgeOffset > viewportDimensions.width) { // right overflow
                delta.left = viewportDimensions.left + viewportDimensions.width - rightEdgeOffset;
            }
        }

        return delta;
    };
    Tooltip.prototype.getTitle = function () {
        var title;
        var $e = this.$element;
        var o = this.options;

        title = $e.attr("data-original-title")
            || (typeof o.title == "function" ? o.title.call($e[0]) : o.title);

        return title;
    };
    Tooltip.prototype.getUID = function (prefix) {
        do prefix += ~~(Math.random() * 1000000);
        while (document.getElementById(prefix));
        return prefix;
    };
    Tooltip.prototype.tip = function () {
        return (this.$tip = this.$tip || $(this.options.template));
    };
    Tooltip.prototype.arrow = function () {
        return (this.$arrow = this.$arrow || this.tip().find(".tooltip-arrow"));
    };
    Tooltip.prototype.enable = function () {
        this.enabled = true;
    };
    Tooltip.prototype.disable = function () {
        this.enabled = false;
    };
    Tooltip.prototype.toggleEnabled = function () {
        this.enabled = !this.enabled;
    };
    Tooltip.prototype.toggle = function (e) {
        var self = this;
        if (e) {
            self = $(e.currentTarget).data("bs." + this.type);
            if (!self) {
                self = new this.constructor(e.currentTarget, this.getDelegateOptions());
                $(e.currentTarget).data("bs." + this.type, self);
            }
        }

        self.tip().hasClass("in") ? self.leave(self) : self.enter(self);
    };
    Tooltip.prototype.destroy = function () {
        var that = this;
        clearTimeout(this.timeout);
        this.hide(function () {
            that.$element.off("." + that.type).removeData("bs." + that.type);
        });
    }; // TOOLTIP PLUGIN DEFINITION
    // =========================

    function Plugin(option) {
        return this.each(function () {
            var $this = $(this);
            var data = $this.data("bs.tooltip");
            var options = typeof option == "object" && option;
            var selector = options && options.selector;

            if (!data && option === "destroy") return;
            if (selector) {
                if (!data) $this.data("bs.tooltip", (data = {}));
                if (!data[selector]) data[selector] = new Tooltip(this, options);
            } else {
                if (!data) $this.data("bs.tooltip", (data = new Tooltip(this, options)));
            }
            if (typeof option == "string") data[option]();
        });
    }

    var old = $.fn.tooltip;

    $.fn.tooltip = Plugin;

    $.fn.tooltip.Constructor = Tooltip;


    // TOOLTIP NO CONFLICT
    // ===================

    $.fn.tooltip.noConflict = function () {
        $.fn.tooltip = old;
        return this;
    }; // APPLY TO STANDARD DROPDOWN ELEMENTS
    // ===================================
    $("body").tooltip({
        selector: "[data-tooltip=\"tooltip\"]"
    });
}(jQuery);

// TAB
+function ($) {
    "use strict";

    // TAB CLASS DEFINITION
    // ====================

    var Tab = function (element) {
        this.element = $(element);
    };
    Tab.TRANSITION_DURATION = 150;
    Tab.prototype.show = function () {
        var $this = this.element;
        var $ul = $this.closest("ul:not(.dropdown-menu)");
        var selector = $this.data("target");
        if (!selector) {
            selector = $this.attr("href");
            selector = selector && selector.replace(/.*(?=#[^\s]*$)/, ""); // strip for ie7
        }

        if ($this.parent("li").hasClass("active")) return;
        var $previous = $ul.find(".active:last a");
        var hideEvent = $.Event("hide.bs.tab", {
            relatedTarget: $this[0]
        });
        var showEvent = $.Event("show.bs.tab", {
            relatedTarget: $previous[0]
        });
        $previous.trigger(hideEvent);
        $this.trigger(showEvent);
        if (showEvent.isDefaultPrevented() || hideEvent.isDefaultPrevented()) return;
        var $target = $(selector);
        this.activate($this.closest("li"), $ul);
        this.activate($target, $target.parent(), function () {
            $previous.trigger({
                type: "hidden.bs.tab",
                relatedTarget: $this[0]
            });
            $this.trigger({
                type: "shown.bs.tab",
                relatedTarget: $previous[0]
            });
        });
    };
    Tab.prototype.activate = function (element, container, callback) {
        var $active = container.find(" > .active");
        var transition = callback
            && $.support.transition
            && (($active.length && $active.hasClass("fade")) || !!container.find(" > .fade").length);

        function next() {
            $active
                .removeClass("active")
                .find(" > .dropdown-menu > .active")
                .removeClass("active")
                .end()
                .find("[data-toggle=\"tab\"]")
                .attr("aria-expanded", false);
            element
                .addClass("active")
                .find("[data-toggle=\"tab\"]")
                .attr("aria-expanded", true);
            if (transition) {
                element[0].offsetWidth; // reflow for transition
                element.addClass("in");
            } else {
                element.removeClass("fade");
            }

            if (element.parent(".dropdown-menu")) {
                element
                    .closest("li.dropdown")
                    .addClass("active")
                    .end()
                    .find("[data-toggle=\"tab\"]")
                    .attr("aria-expanded", true);
            }

            callback && callback();
        }

        $active.length && transition ?
            $active
                .one("bsTransitionEnd", next)
                .emulateTransitionEnd(Tab.TRANSITION_DURATION) :
            next();
        $active.removeClass("in");
    }; // TAB PLUGIN DEFINITION
    // =====================

    function Plugin(option) {
        return this.each(function () {
            var $this = $(this);
            var data = $this.data("bs.tab");
            if (!data) $this.data("bs.tab", (data = new Tab(this)));
            if (typeof option == "string") data[option]();
        });
    }

    var old = $.fn.tab;
    $.fn.tab = Plugin;
    $.fn.tab.Constructor = Tab; // TAB NO CONFLICT
    // ===============

    $.fn.tab.noConflict = function () {
        $.fn.tab = old;
        return this;
    }; // TAB DATA-API
    // ============

    var clickHandler = function (e) {
        e.preventDefault();
        Plugin.call($(this), "show");
    };
    $(document)
        .on("click.bs.tab.data-api", "[data-toggle=\"tab\"]", clickHandler)
        .on("click.bs.tab.data-api", "[data-toggle=\"pill\"]", clickHandler);
}(jQuery);

// BG Switch
(function ($) {
    'use strict';

    var first = true;

    var loadedImages = {},

        slice = Array.prototype.slice,
        toString = Object.prototype.toString,

        corners = ['Top', 'Right', 'Bottom', 'Left'],
        backgroundProperties = [
            'Attachment', 'Color', 'Image', 'Repeat',
            'Position', 'Size', 'Clip', 'Origin'
        ];

    $.fn.bgswitcher = function () {
        var args = arguments,
            instanceKey = BgSwitcher.keys.instance;

        return this.each(function () {
            var instance = $.data(this, instanceKey);

            if (!instance) {
                instance = new BgSwitcher(this);
                $.data(this, instanceKey, instance);
            }

            instance.dispatch.apply(instance, args);
        });
    };

    // Backward Compatibility
    $.fn.bgSwitcher = $.fn.bgswitcher;

    /**
     * BgSwitcher
     *
     * @param {HTMLElement} el
     * @constructor
     */
    function BgSwitcher(el) {
        this.$el = $(el);
        this.index = 0;
        this.config = $.extend({}, BgSwitcher.defaultConfig);

        this._setupBackgroundElement();
        this._listenToResize();
    }

    $.extend(BgSwitcher.prototype, {
        /**
         * Dispatch
         *
         * @param {string|Array} one
         */
        dispatch: function (one) {
            switch (toString.call(one)) {
                case '[object Object]':
                    this.setConfig(one);
                    break;
                case '[object String]':
                    this[one].apply(this, slice.call(arguments, 1));
                    break;
                default:
                    throw new Error('Please specify a Object or String');
            }
        },

        /**
         * Set config
         *
         * @param {Object} config
         */
        setConfig: function (config) {
            this.config = $.extend(this.config, config);

            if (typeof this.config.random !== 'undefined') {
                this.config.shuffle = this.config.random;
            }

            this.refresh();
        },

        /**
         * Set images
         *
         * @param {Array} images
         */
        setImages: function (images) {
            this.imageList = new this.constructor.ImageList(images);

            if (this.config.shuffle) {
                this.imageList.shuffle();
            }
        },

        /**
         * Set switch handler
         *
         * @param {Function} fn
         */
        setSwitchHandler: function (fn) {
            this.switchHandler = $.proxy(fn, this);
        },

        /**
         * Default switch handler
         *
         * @param {string} type
         * @returns {Function}
         */
        getBuiltInSwitchHandler: function (type) {
            return this.constructor.switchHandlers[type || this.config.effect];
        },

        /**
         * Refresh
         */
        refresh: function () {
            this.setImages(this.config.images);
            this.setSwitchHandler(this.getBuiltInSwitchHandler());
            this._prepareSwitching();

            if (this.config.start) {
                this.start();
            }
        },

        /**
         * Start switching
         */
        start: function () {
            if (!this._timerID) {
                this._timerID = setTimeout($.proxy(this, 'next'), this.config.interval);
            }
        },

        /**
         * Stop switching
         */
        stop: function () {
            if (this._timerID) {
                clearTimeout(this._timerID);
                this._timerID = null;
            }
        },

        /**
         * Toggle between start/stop
         */
        toggle: function () {
            if (this._timerID) {
                this.stop();
            } else {
                this.start();
            }
        },

        /**
         * Reset switching
         */
        reset: function () {
            this.index = 0;
            this._prepareSwitching();
        },

        /**
         * Go to next switching
         */
        next: function () {
            var max = this.imageList.count();

            if (!this.config.loop && this.index + 1 === max) {
                return;
            }

            if (++this.index === max) {
                this.index = 0;
            }

            this.switching();
        },

        /**
         * Go to previous switching
         */
        prev: function () {
            if (!this.config.loop && this.index === 0) {
                return;
            }

            if (--this.index === -1) {
                this.index = this.imageList.count() - 1;
            }

            this.switching();
        },

        /**
         * Select the switching at index
         *
         * @param {number} index
         */
        select: function (index) {
            if (index === -1) {
                index = this.imageList.count() - 1;
            }

            this.index = index;
            this.switching();
        },

        /**
         * Switching the background image
         */
        switching: function () {
            var started = !!this._timerID;

            if (started) {
                this.stop();
            }
            this.$bg.removeClass("fadeInAnimation");
            this._createSwitchableElement();
            this._prepareSwitching();
            this.switchHandler(this.$switchable);

            if (started) {
                this.start();
            }
        },

        /**
         * Destroy...
         */
        destroy: function () {
            this.stop();
            this._stopListeningToResize();

            if (this.$switchable) {
                this.$switchable.stop();
                this.$switchable.remove();
                this.$switchable = null;
            }

            if (this.$bg) {
                this.$bg.remove();
                this.$bg = null;
            }

            this.$el.removeAttr('style');
            this.$el.removeData(this.constructor.keys.instance);
            this.$el = null;
        },

        /**
         * Adjust rectangle
         */
        _adjustRectangle: function () {
            var corner,
                i = 0,
                length = corners.length,
                offset = this.$el.position(),
                copiedStyles = {
                    top: offset.top,
                    left: offset.left,
                    width: this.$el.innerWidth(),
                    height: this.$el.innerHeight()
                };

            for (; i < length; i++) {
                corner = corners[i];
                copiedStyles['margin' + corner] = this.$el.css('margin' + corner);
                copiedStyles['border' + corner] = this.$el.css('border' + corner);
            }

            this.$bg.css(copiedStyles);
        },

        /**
         * Setup background element
         */
        _setupBackgroundElement: function () {
            this.$bg = $(document.createElement('div'));
            this.$bg.addClass("bgSwitch");
            this.$bg.addClass("fadeInAnimation");
            this.$bg.css({
                position: 'absolute',
                zIndex: (parseInt(this.$el.css('zIndex'), 10) || 0) - 1,
                overflow: 'hidden'
            });

            this._copyBackgroundStyles();
            this._adjustRectangle();

            if (this.$el[0].tagName === 'BODY') {
                this.$el.prepend(this.$bg);
            } else {
                this.$el.before(this.$bg);
                this.$el.css('background', 'none');
            }

        },

        /**
         * Create switchable element
         */
        _createSwitchableElement: function () {
            if (this.$switchable) {
                this.$switchable.remove();
            }

            this.$switchable = this.$bg.clone();
            this.$switchable.css({ top: 0, left: 0, margin: 0, border: 'none' });
            this.$switchable.appendTo(this.$bg);
        },

        /**
         * Copy background styles
         */
        _copyBackgroundStyles: function () {
            var prop,
                copiedStyle = {},
                i = 0,
                length = backgroundProperties.length,
                backgroundPosition = 'backgroundPosition';

            for (; i < length; i++) {
                prop = 'background' + backgroundProperties[i];
                copiedStyle[prop] = this.$el.css(prop);
            }

            // For IE<=9
            if (copiedStyle[backgroundPosition] === undefined) {
                copiedStyle[backgroundPosition] = [
                    this.$el.css(backgroundPosition + 'X'),
                    this.$el.css(backgroundPosition + 'Y')
                ].join(' ');
            }

            this.$bg.css(copiedStyle);
        },

        /**
         * Listen to the resize event
         */
        _listenToResize: function () {
            var that = this;
            this._resizeHandler = function () {
                that._adjustRectangle();
            };
            $(window).on('resize', this._resizeHandler);
        },

        /**
         * Stop listening to the resize event
         */
        _stopListeningToResize: function () {
            $(window).off('resize', this._resizeHandler);
            this._resizeHandler = null;
        },

        /**
         * Prepare the Switching
         */
        _prepareSwitching: function () {
            this.$bg.css('backgroundImage', this.imageList.url(this.index));
        }
    });

    /**
     * Data Keys
     * @type {Object}
     */
    BgSwitcher.keys = {
        instance: 'bgSwitcher'
    };

    /**
     * Default Config
     * @type {Object}
     */
    BgSwitcher.defaultConfig = {
        images: [],
        interval: 5000,
        start: true,
        loop: true,
        shuffle: false,
        effect: 'fade',
        duration: 1000,
        easing: 'swing'
    };

    /**
     * Built-In switch handlers (effects)
     * @type {Object}
     */
    BgSwitcher.switchHandlers = {
        fade: function ($el) {
            $el.animate({ opacity: 0 }, this.config.duration, this.config.easing);
        },

        blind: function ($el) {
            $el.animate({ height: 0 }, this.config.duration, this.config.easing);
        },

        clip: function ($el) {
            $el.animate({
                top: parseInt($el.css('top'), 10) + $el.height() / 2,
                height: 0
            }, this.config.duration, this.config.easing);
        },

        slide: function ($el) {
            $el.animate({ top: -$el.height() }, this.config.duration, this.config.easing);
        },

        drop: function ($el) {
            $el.animate({
                left: -$el.width(),
                opacity: 0
            }, this.config.duration, this.config.easing);
        },

        hide: function ($el) {
            $el.hide();
        }
    };

    /**
     * Define effect
     *
     * @param {String} name
     * @param {Function} fn
     */
    BgSwitcher.defineEffect = function (name, fn) {
        this.switchHandlers[name] = fn;
    };

    /**
     * BgSwitcher.ImageList
     *
     * @param {Array} images
     * @constructor
     */
    BgSwitcher.ImageList = function (images) {
        this.images = images;
        this.createImagesBySequence();
        this.preload();
    };

    $.extend(BgSwitcher.ImageList.prototype, {
        /**
         * Images is sequenceable
         *
         * @returns {boolean}
         */
        isSequenceable: function () {
            return typeof this.images[0] === 'string' &&
                typeof this.images[1] === 'number' &&
                typeof this.images[2] === 'number';
        },

        /**
         * Create an images by sequence
         */
        createImagesBySequence: function () {
            if (!this.isSequenceable()) {
                return;
            }

            var images = [],
                base = this.images[0],
                min = this.images[1],
                max = this.images[2];

            do {
                images.push(base.replace(/\.\w+$/, min + '$&'));
            } while (++min <= max);

            this.images = images;
        },

        /**
         * Preload an images
         */
        preload: function () {
            var path,
                length = this.images.length,
                i = 0;

            for (; i < length; i++) {
                path = this.images[i];
                if (!loadedImages[path]) {
                    loadedImages[path] = new Image();
                    loadedImages[path].src = path;
                }
            }
        },

        /**
         * Shuffle an images
         */
        shuffle: function () {
            var j, t,
                i = this.images.length,
                original = this.images.join();

            if (!i) {
                return;
            }

            while (i) {
                j = Math.floor(Math.random() * i);
                t = this.images[--i];
                this.images[i] = this.images[j];
                this.images[j] = t;
            }

            if (this.images.join() === original) {
                this.shuffle();
            }
        },

        /**
         * Get the image from index
         *
         * @param {number} index
         * @returns {string}
         */
        get: function (index) {
            return this.images[index];
        },

        /**
         * Get the URL with function of CSS
         *
         * @param {number} index
         * @returns {string}
         */
        url: function (index) {
            return 'url(' + this.get(index) + ')';
        },

        /**
         * Count of images
         *
         * @returns {number}
         */
        count: function () {
            return this.images.length;
        }
    });

    $.BgSwitcher = BgSwitcher;
}(jQuery));

// GoogleNews Form Validation
function validation() {
    (function ($) {
        "use strict";

        $("#gnKwdForm").validate({
            rules: {
                createGNKwdTitle: {
                    required: true,
                    minlength: 1,
                    maxlength: 350
                },
                createGNKwdTerm: "required"
            },
            messages: {
                createGNKwdTitle: {
                    required: "Please provide a title",
                    minlength: "Title must be at least 1 characters long",
                    maxlength: "Title must be at maximum 350 characters long"
                },
                createGNKwdTerm: {
                    required: "Please provide a search term"
                }
            },
            errorElement: "div",
            errorLabelContainer: ".errorKwd",
            onkeyup: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNKwdTitle").val().trim().length > 0 && $("#createGNKwdTitle").val().trim().length <= 350 && $("#createGNKwdTerm").val().trim().length > 0) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
            },
            onfocusout: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNKwdTitle").val().trim().length > 0 && $("#createGNKwdTerm").val().trim().length > 0) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
            }
        });

        jQuery.validator.addMethod("createGNLctLocation", function (value, element) {
            return SocialTab.HTML_Event_GoogleNewsKwd_Blur(value, element);
        }, "Can't recognise location");

        $("#gnLctForm").validate({
            rules: {
                createGNLctTitle: {
                    required: true,
                    minlength: 1,
                    maxlength: 350
                },
                createGNLctLocation: {
                    required: true
                }
            },
            messages: {
                createGNLctTitle: {
                    required: "Please provide a title",
                    minlength: "Title must be at least 1 characters long",
                    maxlength: "Title must be at maximum 350 characters long"
                },
                createGNLctLocation: {
                    required: "Please provide a location",
                    minlength: "Can't recognise location"
                }
            },
            errorElement: "div",
            errorLabelContainer: ".errorLct",
            onkeyup: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNLctTitle").val().trim().length > 0 && $("#createGNLctTitle").val().trim().length <= 350 && $("#createGNLctLocation").val().trim().length > 0 && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isValid;
            },
            onfocusout: function (element) {
                var isValid = $(element).valid();
                if (isValid == 1 && $("#createGNLctTitle").val().trim().length > 0 && $("#createGNLctLocation").val().trim().length > 0 && SocialTab.LocationIsValid) {
                    $(element).closest(".googleNewsSections").find(".add").removeClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").removeClass("disabled");
                } else {
                    $(element).closest(".googleNewsSections").find(".add").addClass("disabled");
                    $(element).closest(".googleNewsSections").find(".preview").addClass("disabled");
                }
                SocialTab.LocationIsValid = isValid;
            }
        });
    }(jQuery));
}